// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(b) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function n(e) {
        return e.split("");
    }
    function Vn(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Wn(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function t(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function i(e, n) {
        this.message = e;
        this.defs = n;
    }
    i.prototype = Object.create(Error.prototype);
    i.prototype.constructor = i;
    i.prototype.name = "DefaultsError";
    t(i);
    function we(e, n, t) {
        if (t) for (var r in e) {
            if (nt(e, r) && !nt(n, r)) throw new i("`" + r + "` is not a supported option", n);
        }
        for (var r in e) {
            if (nt(e, r)) n[r] = e[r];
        }
        return n;
    }
    function Gn() {}
    function ln() {
        return false;
    }
    function pn() {
        return true;
    }
    function Jn() {
        return this;
    }
    function Xn() {
        return null;
    }
    var Kn = function() {
        function e(e, n) {
            var t = [];
            for (var r = 0; r < e.length; r++) {
                var i = n(e[r], r);
                if (i === a) continue;
                if (i instanceof o) {
                    t.push.apply(t, i.v);
                } else {
                    t.push(i);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Qn(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function Zn(e, r) {
        return e.replace(/\{([^{}]+)\}/g, function(e, n) {
            var t = n == "this" ? r : r[n];
            if (t instanceof mn) return t.print_to_string();
            if (t instanceof te) return t.file + ":" + t.line + "," + t.col;
            return t;
        });
    }
    function et(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function dn(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function hn(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function vn() {
        this.values = Object.create(null);
    }
    vn.prototype = {
        set: function(e, n) {
            if (e == "__proto__") {
                this.proto_value = n;
            } else {
                this.values[e] = n;
            }
            return this;
        },
        add: function(e, n) {
            var t = this.get(e);
            if (t) {
                t.push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return e == "__proto__" ? this.proto_value : this.values[e];
        },
        del: function(e) {
            if (e == "__proto__") {
                delete this.proto_value;
            } else {
                delete this.values[e];
            }
            return this;
        },
        has: function(e) {
            return e == "__proto__" ? "proto_value" in this : e in this.values;
        },
        all: function(e) {
            for (var n in this.values) if (!e(this.values[n], n)) return false;
            if ("proto_value" in this && !e(this.proto_value, "__proto__")) return false;
            return true;
        },
        each: function(e) {
            for (var n in this.values) e(this.values[n], n);
            if ("proto_value" in this) e(this.proto_value, "__proto__");
        },
        size: function() {
            return Object.keys(this.values).length + ("proto_value" in this);
        },
        map: function(e) {
            var n = [];
            for (var t in this.values) n.push(e(this.values[t], t));
            if ("proto_value" in this) n.push(e(this.proto_value, "__proto__"));
            return n;
        },
        clone: function() {
            var t = new vn();
            this.each(function(e, n) {
                t.set(n, e);
            });
            return t;
        },
        toObject: function() {
            var t = {};
            this.each(function(e, n) {
                t["$" + n] = e;
            });
            return t;
        }
    };
    vn.fromObject = function(e) {
        var n = new vn();
        for (var t in e) if (nt(e, t)) n.set(t.slice(1), e[t]);
        return n;
    };
    function nt(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function tt(e, n, t) {
        var r = e.parent(-1);
        for (var i = 0, a; a = e.parent(i++); r = a) {
            if (Et(a)) {
                return n && a.value === r;
            } else if (a instanceof Mn) {
                if (a.left === r) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === r) continue;
            } else if (a instanceof Fn) {
                if (a.condition === r) continue;
            } else if (a instanceof pr) {
                return t;
            } else if (a instanceof Dn) {
                if (a.expression === r) continue;
            } else if (a instanceof An) {
                if (a.expressions[0] === r) continue;
            } else if (a instanceof gn) {
                return true;
            } else if (a instanceof Br) {
                if (a.tag === r) continue;
            } else if (a instanceof _r) {
                if (a.expression === r) continue;
            }
            return false;
        }
    }
    function r(r, e) {
        if (e.length > 31) throw new Error("Too many properties: " + e.length + "\n" + e.join(", "));
        e.forEach(function(e, n) {
            var t = 1 << n;
            Object.defineProperty(r.prototype, e, {
                get: function() {
                    return !!(this._bits & t);
                },
                set: function(e) {
                    if (e) this._bits |= t; else this._bits &= ~t;
                }
            });
        });
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e, n, t, r) {
        if (typeof r === "undefined") r = mn;
        n = n ? n.split(/\s+/) : [];
        var i = n;
        if (r && r.PROPS) n = n.concat(r.PROPS);
        var a = [ "return function AST_", e, "(props){", "this._bits=0;", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = Object.create(r && r.prototype);
        if (t.initialize || o.initialize) a.push("this.initialize();");
        a.push("};");
        var s = new Function(a.join(""))();
        s.prototype = o;
        s.prototype.CTOR = s;
        s.prototype.TYPE = s.TYPE = e;
        if (r) {
            s.BASE = r;
            r.SUBCLASSES.push(s);
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        s.PROPS = n;
        s.SELF_PROPS = i;
        s.SUBCLASSES = [];
        for (var f in t) if (nt(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.DEFMETHOD(f, t[f]);
            }
        }
        if (typeof b !== "undefined") b["AST_" + e] = s;
        return s;
    }
    var te = e("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var mn = e("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new ei(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        equals: function(e) {
            return this.TYPE == e.TYPE && this._equals(e);
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Un(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(Zn("cannot reuse AST_{TYPE} from [{start}]", e));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    r(mn, [ "_optimized", "_squeezed", "call_only", "collapse_scanning", "defined", "evaluating", "falsy", "in_arg", "in_bool", "is_undefined", "inlined", "length_read", "nested", "new", "optional", "private", "pure", "redundant", "single_use", "static", "terminal", "truthy", "uses_eval", "uses_with" ]);
    (mn.log_function = function(n, e) {
        if (typeof n != "function") {
            mn.info = mn.warn = Gn;
            return;
        }
        var t = Object.create(null);
        mn.info = e ? function(e, n) {
            r("INFO: " + Zn(e, n));
        } : Gn;
        mn.warn = function(e, n) {
            r("WARN: " + Zn(e, n));
        };
        function r(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var a = [];
    mn.enable_validation = function() {
        mn.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!nt(n.prototype, "transform")) return;
            var r = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = r.call(this, e, n);
                if (t instanceof mn) {
                    t.validate();
                } else if (!(t === null || n && Kn.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            a.push(function() {
                n.prototype.transform = r;
            });
        })(this);
    };
    mn.disable_validation = function() {
        var e;
        while (e = a.pop()) e();
    };
    function o(e, t) {
        return e.length == t.length && hn(e, function(e, n) {
            return e.equals(t[n]);
        });
    }
    function s(e, t) {
        return e.length == t.length && hn(e, function(e, n) {
            return e == t[n];
        });
    }
    function f(e, n) {
        if (e === n) return true;
        if (e == null) return n == null;
        return e instanceof mn && n instanceof mn && e.equals(n);
    }
    var rt = e("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var it = e("Debugger", null, {
        $documentation: "Represents a debugger statement",
        _equals: pn
    }, rt);
    var at = e("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _equals: function(e) {
            return this.value == e.value;
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, rt);
    var _n = e("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)",
        _equals: pn
    }, rt);
    function ot(e) {
        return e instanceof rt && !(e instanceof Yt) && !(e instanceof kt);
    }
    function u(e, n, t, r, i) {
        t = t ? "contain" : "be";
        if (!(e instanceof mn)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof Sn) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof Nn) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Jr && !i) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof $n && !r) throw new Error(n + " cannot " + t + " AST_Spread");
        if (ot(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof qr) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function c(e, n) {
        u(e[n], n);
    }
    var gn = e("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        _equals: function(e) {
            return this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            c(this, "body");
        }
    }, rt);
    var st = e("BlockScope", "_var_names enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Dictionary/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Dictionary/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof st)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof yn)) throw new Error("must be contained within AST_Scope");
        }
    }, rt);
    function ft(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var ut = e("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        _equals: function(e) {
            return o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                ft(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!ot(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, st);
    var bn = e("BlockStatement", null, {
        $documentation: "A block statement"
    }, ut);
    var N = e("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!ot(this.body)) throw new Error("body must be AST_Statement");
        }
    }, st);
    var ct = e("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        _equals: function(e) {
            return this.label.equals(e.label) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var r = this.label;
                n.walk(new Un(function(e) {
                    if (e instanceof Kt) {
                        if (!e.label || e.label.thedef !== r) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof yn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Se)) throw new Error("label must be AST_Label");
        }
    }, N);
    var lt = e("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, N);
    var pt = e("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _equals: function(e) {
            return this.body.equals(e.body) && this.condition.equals(e.condition);
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            c(this, "condition");
        }
    }, lt);
    var dt = e("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, pt);
    var ht = e("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, pt);
    var vt = e("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        _equals: function(e) {
            return f(this.init, e.init) && f(this.condition, e.condition) && f(this.step, e.step) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof mn)) throw new Error("init must be AST_Node");
                if (ot(this.init) && !(this.init instanceof sr)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) c(this, "condition");
            if (this.step != null) c(this, "step");
        }
    }, lt);
    var mt = e("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        _equals: function(e) {
            return this.init.equals(e.init) && this.object.equals(e.object) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof sr) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                p(this.init, function(e) {
                    if (!(e instanceof Dn || e instanceof Yn)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            c(this, "object");
        }
    }, lt);
    var _t = e("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, mt);
    var xe = e("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, mt);
    var gt = e("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, xe);
    var bt = e("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression) && this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    }, N);
    var yn = e("Scope", "fn_defs may_call_this uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lambda scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: Jn,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, ut);
    var yt = e("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Dictionary/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return oi([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new ei(function(e) {
                if (e instanceof at && e.value == "$ORIG") {
                    return Kn.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return oi([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new ei(function(e) {
                if (e instanceof at && e.value == "$ORIG") {
                    return Kn.splice(t);
                }
            }));
        }
    }, yn);
    var wt = e("ClassInitBlock", null, {
        $documentation: "Value for `class` static initialization blocks"
    }, yn);
    var wn = e("Lambda", "argnames length_read rest safe_ids uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean|number/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Un(function(e) {
                if (e instanceof Sn) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof wr) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof Hn) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        _equals: function(e) {
            return f(this.rest, e.rest) && f(this.name, e.name) && f(this.value, e.value) && o(this.argnames, e.argnames) && o(this.body, e.body);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                ft(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                p(e, function(e) {
                    if (!(e instanceof Hn)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) p(this.rest, function(e) {
                if (!(e instanceof Hn)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, yn);
    var xt = e("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, wn);
    var kt = e("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, wn);
    function Et(e) {
        return e instanceof Dt || e instanceof qt;
    }
    function St(e) {
        return e instanceof qt || e instanceof Ft || e instanceof Ot || e instanceof Pt || e instanceof $t;
    }
    function Tt(e) {
        return e instanceof Pt || e instanceof $t || e instanceof Nt || e instanceof Ct;
    }
    function At(e, n) {
        if (Et(e) && e.value) {
            e.value.walk(n);
        } else {
            ft(e, n);
        }
    }
    var Dt = e("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    ft(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                c(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, kt);
    var qt = e("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    ft(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                c(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, kt);
    var Ot = e("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Fr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, kt);
    var $t = e("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Fr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, kt);
    var zt = e("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Fr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, kt);
    var Ct = e("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Fr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, kt);
    var Mt = e("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof Mr)) throw new Error("name must be AST_SymbolDefun");
        }
    }, wn);
    var Ft = e("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, Mt);
    var Pt = e("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, Mt);
    var jt = e("Defun", null, {
        $documentation: "A function definition"
    }, Mt);
    var Nt = e("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, Mt);
    var It = e("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        _equals: function(e) {
            return f(this.name, e.name) && f(this.extends, e.extends) && o(this.properties, e.properties);
        },
        resolve: function(e) {
            return e ? this : this.parent_scope.resolve();
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) c(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof Rt)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, st);
    var Ht = e("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof Ee)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, It);
    var Yt = e("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof Pr)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, It);
    var Rt = e("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node?] property name (AST_Node for computed property, null for initialization block)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        _equals: function(e) {
            return !this.private == !e.private && !this.static == !e.static && f(this.key, e.key) && f(this.value, e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof mn) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (this instanceof Wt) {
                if (this.key != null) throw new Error("key must be null");
            } else if (typeof this.key != "string") {
                if (!(this.key instanceof mn)) throw new Error("key must be string or AST_Node");
                c(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof mn)) throw new Error("value must be AST_Node");
            }
        }
    });
    var Bt = e("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) c(this, "value");
        }
    }, Rt);
    var Lt = e("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof xt)) throw new Error("value must be AST_Accessor");
        }
    }, Rt);
    var Ut = e("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof xt)) throw new Error("value must be AST_Accessor");
        }
    }, Rt);
    var Vt = e("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof kt)) throw new Error("value must be AST_LambdaExpression");
            if (Et(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, Rt);
    var Wt = e("ClassInit", null, {
        $documentation: "A `class` static initialization block",
        _validate: function() {
            if (!this.static) throw new Error("static must be true");
            if (!(this.value instanceof wt)) throw new Error("value must be AST_ClassInitBlock");
        },
        initialize: function() {
            this.static = true;
        }
    }, Rt);
    var Gt = e("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, rt);
    var Jt = e("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        _equals: function(e) {
            return f(this.value, e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, Gt);
    var xn = e("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) c(this, "value");
        }
    }, Jt);
    var Xt = e("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            c(this, "value");
        }
    }, Jt);
    var Kt = e("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        _equals: function(e) {
            return f(this.label, e.label);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Te)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, Gt);
    var Qt = e("Break", null, {
        $documentation: "A `break` statement"
    }, Kt);
    var Zt = e("Continue", null, {
        $documentation: "A `continue` statement"
    }, Kt);
    var kn = e("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        _equals: function(e) {
            return this.body.equals(e.body) && this.condition.equals(e.condition) && f(this.alternative, e.alternative);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            c(this, "condition");
            if (this.alternative != null) {
                if (!ot(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, N);
    var er = e("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression) && o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                ft(n, e);
            });
        },
        _validate: function() {
            c(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof nr)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, ut);
    var nr = e("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, ut);
    var tr = e("Default", null, {
        $documentation: "A `default` switch branch"
    }, nr);
    var rr = e("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression) && o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                ft(n, e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    }, nr);
    var ir = e("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        _equals: function(e) {
            return o(this.body, e.body) && f(this.bcatch, e.bcatch) && f(this.bfinally, e.bfinally);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                ft(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof ar)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof or)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, ut);
    var ar = e("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        _equals: function(e) {
            return f(this.argname, e.argname) && o(this.body, e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                ft(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) p(this.argname, function(e) {
                if (!(e instanceof jr)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, ut);
    var or = e("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, ut);
    var sr = e("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        _equals: function(e) {
            return o(this.definitions, e.definitions);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, rt);
    var fr = e("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof En)) throw new Error("definitions must be AST_VarDef[]");
                p(e.name, function(e) {
                    if (!(e instanceof Or)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, sr);
    var ur = e("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof En)) throw new Error("definitions must be AST_VarDef[]");
                p(e.name, function(e) {
                    if (!(e instanceof zr)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, sr);
    var cr = e("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof En)) throw new Error("definitions must be AST_VarDef[]");
                p(e.name, function(e) {
                    if (!(e instanceof Cr)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, sr);
    var En = e("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        _equals: function(e) {
            return this.name.equals(e.name) && f(this.value, e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) c(this, "value");
        }
    });
    var lr = e("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        _equals: function(e) {
            return this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof Ht || this.body instanceof sr || this.body instanceof Mt)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, rt);
    var pr = e("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        _equals: function(e) {
            return this.body.equals(e.body);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof Ht || this.body instanceof Mt)) {
                c(this, "body");
            }
        }
    }, rt);
    var ke = e("ExportForeign", "aliases keys path", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[AST_String*] array of aliases to export",
            keys: "[AST_String*] array of keys to import",
            path: "[AST_String] the path to import module"
        },
        _equals: function(e) {
            return this.path.equals(e.path) && o(this.aliases, e.aliases) && o(this.keys, e.keys);
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (!(e instanceof Bn)) throw new Error("aliases must contain AST_String");
            });
            this.keys.forEach(function(e) {
                if (!(e instanceof Bn)) throw new Error("keys must contain AST_String");
            });
            if (!(this.path instanceof Bn)) throw new Error("path must be AST_String");
        }
    }, rt);
    var dr = e("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        _equals: function(e) {
            return o(this.properties, e.properties);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Nr)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, rt);
    var hr = e("Import", "all default path properties", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[AST_String] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified"
        },
        _equals: function(e) {
            return this.path.equals(e.path) && f(this.all, e.all) && f(this.default, e.default) && !this.properties == !e.properties && (!this.properties || o(this.properties, e.properties));
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof $r)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof $r)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key.value !== "") throw new Error("invalid default key: " + this.default.key.value);
            }
            if (!(this.path instanceof Bn)) throw new Error("path must be AST_String");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof $r)) throw new Error("properties must contain AST_SymbolImport");
            });
        }
    }, rt);
    var Sn = e("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        _equals: function(e) {
            return this.name.equals(e.name) && this.value.equals(e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            c(this, "value");
        }
    });
    function l(e, n, t, r) {
        e[n].forEach(function(e) {
            u(e, n, true, t, r);
        });
    }
    var Tn = e("Call", "args expression optional pure terminal", {
        $documentation: "A function call expression",
        $propdoc: {
            args: "[AST_Node*] array of arguments",
            expression: "[AST_Node] expression to invoke as function",
            optional: "[boolean] whether the expression is optional chaining",
            pure: "[boolean/S] marker for side-effect-free call expression",
            terminal: "[boolean] whether the chain has ended"
        },
        _equals: function(e) {
            return !this.optional == !e.optional && this.expression.equals(e.expression) && o(this.args, e.args);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            c(this, "expression");
            l(this, "args", true);
        }
    });
    var vr = e("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties",
        _validate: function() {
            if (this.optional) throw new Error("optional must be false");
            if (this.terminal) throw new Error("terminal must be false");
        }
    }, Tn);
    var An = e("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        _equals: function(e) {
            return o(this.expressions, e.expressions);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            l(this, "expressions");
        }
    });
    function mr(e) {
        while (e instanceof Dn) e = e.expression;
        return e;
    }
    var Dn = e("PropAccess", "expression optional property terminal", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            optional: "[boolean] whether the expression is optional chaining",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",
            terminal: "[boolean] whether the chain has ended"
        },
        _equals: function(e) {
            return !this.optional == !e.optional && f(this.property, e.property) && this.expression.equals(e.expression);
        },
        get_property: function() {
            var e = this.property;
            if (e instanceof Rn) return e.value;
            if (e instanceof Cn && e.operator == "void" && e.expression instanceof Rn) return;
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            c(this, "expression");
        }
    });
    var qn = e("Dot", "quoted", {
        $documentation: "A dotted property access expression",
        $propdoc: {
            quoted: "[boolean] whether property is transformed from a quoted string"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Dn);
    var On = e("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            c(this, "property");
        }
    }, Dn);
    var $n = e("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    });
    var zn = e("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        _equals: function(e) {
            return this.operator == e.operator && this.expression.equals(e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            c(this, "expression");
        }
    });
    var Cn = e("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, zn);
    var _r = e("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, zn);
    var Mn = e("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        _equals: function(e) {
            return this.operator == e.operator && this.left.equals(e.left) && this.right.equals(e.right);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof Pn)) c(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            c(this, "right");
        }
    });
    var Fn = e("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        _equals: function(e) {
            return this.condition.equals(e.condition) && this.consequent.equals(e.consequent) && this.alternative.equals(e.alternative);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            c(this, "condition");
            c(this, "consequent");
            c(this, "alternative");
        }
    });
    var Pn = e("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof Nn) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                p(this.left, function(e) {
                    if (!(e instanceof Dn || e instanceof Yn)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            } else if (!(this.left instanceof Xr || this.left instanceof Wr || this.left instanceof Dn && !this.left.optional || this.left instanceof Yn || this.left instanceof Gr)) {
                throw new Error("left must be assignable");
            }
        }
    }, Mn);
    var gr = e("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        _equals: function(e) {
            return this.expression.equals(e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            c(this, "expression");
        }
    });
    var br = e("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        _equals: function(e) {
            return !this.nested == !e.nested && f(this.expression, e.expression);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                c(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var jn = e("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        _equals: function(e) {
            return o(this.elements, e.elements);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            l(this, "elements", true, true);
        }
    });
    var Nn = e("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function p(e, n, t) {
        if (e instanceof Sn && t) return p(e.name, n);
        if (e instanceof Nn) {
            if (e.rest != null) p(e.rest, n);
            if (e instanceof yr) return e.elements.forEach(function(e) {
                if (!(e instanceof Jr)) p(e, n, true);
            });
            if (e instanceof xr) return e.properties.forEach(function(e) {
                p(e.value, n, true);
            });
        }
        n(e);
    }
    var yr = e("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        _equals: function(e) {
            return f(this.rest, e.rest) && o(this.elements, e.elements);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, Nn);
    var wr = e("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        _equals: function(e) {
            return f(this.key, e.key) && this.value.equals(e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof mn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof mn)) throw new Error("key must be string or AST_Node");
                c(this, "key");
            }
            if (!(this.value instanceof mn)) throw new Error("value must be AST_Node");
        }
    });
    var xr = e("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        _equals: function(e) {
            return f(this.rest, e.rest) && o(this.properties, e.properties);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof wr)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, Nn);
    var In = e("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        _equals: function(e) {
            return o(this.properties, e.properties);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof kr || e instanceof $n)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var kr = e("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        _equals: function(e) {
            return f(this.key, e.key) && this.value.equals(e.value);
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof mn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof mn)) throw new Error("key must be string or AST_Node");
                c(this, "key");
            }
            if (!(this.value instanceof mn)) throw new Error("value must be AST_Node");
        }
    });
    var Er = e("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            c(this, "value");
        }
    }, kr);
    var Sr = e("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof kt)) throw new Error("value must be AST_LambdaExpression");
            if (Et(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of object method's lambda must be null");
        }
    }, Er);
    var Tr = e("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof xt)) throw new Error("value must be AST_Accessor");
        }
    }, kr);
    var Ar = e("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof xt)) throw new Error("value must be AST_Accessor");
        }
    }, kr);
    var Dr = e("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _equals: function(e) {
            return this.thedef ? this.thedef === e.thedef : this.name == e.name;
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var qr = e("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Dr);
    var Or = e("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, qr);
    var $r = e("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[AST_String] the original `export` name"
        },
        _equals: function(e) {
            return this.name == e.name && this.key.equals(e.key);
        },
        _validate: function() {
            if (!(this.key instanceof Bn)) throw new Error("key must be AST_String");
        }
    }, Or);
    var zr = e("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, qr);
    var Cr = e("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, qr);
    var Hn = e("SymbolFunarg", "unused", {
        $documentation: "Symbol naming a function argument"
    }, Cr);
    var Mr = e("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, qr);
    var Fr = e("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, qr);
    var Ee = e("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, Or);
    var Pr = e("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, Or);
    var jr = e("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, qr);
    var Se = e("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Dr);
    var Yn = e("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Dr);
    var Nr = e("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[AST_String] the `export` alias"
        },
        _equals: function(e) {
            return this.name == e.name && this.alias.equals(e.alias);
        },
        _validate: function() {
            if (!(this.alias instanceof Bn)) throw new Error("alias must be AST_String");
        }
    }, Yn);
    var Te = e("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Dr);
    var Ir = e("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _equals: pn,
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, Dr);
    var Hr = e("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, Ir);
    var Yr = e("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, Ir);
    var Rr = e("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, Yr);
    var Br = e("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node?] tag function, or null if absent"
        },
        _equals: function(e) {
            return f(this.tag, e.tag) && s(this.strings, e.strings) && o(this.expressions, e.expressions);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            l(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) c(this, "tag");
        }
    });
    var Rn = e("Constant", null, {
        $documentation: "Base class for all constants",
        _equals: function(e) {
            return this.value === e.value;
        },
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var Bn = e("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, Rn);
    var Ln = e("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, Rn);
    var Lr = e("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, Rn);
    var Ur = e("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _equals: function(e) {
            return "" + this.value == "" + e.value;
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, Rn);
    var y = e("Atom", null, {
        $documentation: "Base class for atoms",
        _equals: pn,
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, Rn);
    var Vr = e("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, y);
    var Wr = e("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, y);
    var Gr = e("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, y);
    var Jr = e("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, y);
    var Xr = e("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, y);
    var Kr = e("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, y);
    var Qr = e("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Kr);
    var Zr = e("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Kr);
    function Un(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Un.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Gn);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            var n;
            if (e instanceof It) {
                this.directives = Object.create(this.directives);
                n = "use strict";
            } else if (e instanceof at) {
                n = e.value;
            } else if (e instanceof wn) {
                this.directives = Object.create(this.directives);
            }
            if (n && !this.directives[n]) this.directives[n] = e;
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof It || e instanceof wn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length - 1; --t >= 0; ) {
                var r = n[t];
                if (r instanceof e) return r;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof yn) {
                for (var r = 0; r < t.body.length; ++r) {
                    var i = t.body[r];
                    if (!(i instanceof at)) break;
                    if (i.value == e) return i;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof ct && r.label.name == e.label.name) return r.body;
            } else for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof lt || e instanceof Qt && r instanceof er) return r;
            }
        },
        in_boolean_context: function() {
            for (var e = true, n = 0, t, r = this.self(); t = this.parent(n++); r = t) {
                if (t instanceof Mn) switch (t.operator) {
                  case "&&":
                  case "||":
                    if (t.left === r) e = false;
                    continue;

                  default:
                    return false;
                }
                if (t instanceof Fn) {
                    if (t.condition === r) return true;
                    continue;
                }
                if (t instanceof pt) return t.condition === r;
                if (t instanceof vt) return t.condition === r;
                if (t instanceof kn) return t.condition === r;
                if (t instanceof xn) {
                    if (t.in_bool) return true;
                    while (t = this.parent(n++)) {
                        if (t instanceof wn) {
                            if (t.name) return false;
                            t = this.parent(n++);
                            if (t.TYPE != "Call") return false;
                            break;
                        }
                    }
                }
                if (t instanceof An) {
                    if (t.tail_node() === r) continue;
                    return e ? "d" : true;
                }
                if (t instanceof gn) return e ? "d" : true;
                if (t instanceof Cn) return t.operator == "!";
                return false;
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ei(e, n) {
        Un.call(this);
        this.before = e;
        this.after = n;
    }
    ei.prototype = new Un();
    (function(e) {
        function t(e, n) {
            return Kn(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(mn, Gn);
        e(ct, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(gn, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(ut, function(e, n) {
            e.body = t(e.body, n);
        });
        e(dt, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(ht, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(vt, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(mt, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(bt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(Jt, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Kt, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(kn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(er, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(rr, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(ir, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(ar, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(sr, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(En, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Sn, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(wn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(Dt, n);
        e(qt, n);
        e(It, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(Rt, function(e, n) {
            if (e.key instanceof mn) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(Tn, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(An, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(gr, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(br, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(qn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(On, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e($n, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(zn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(Mn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(Fn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(jn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(yr, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(wr, function(e, n) {
            if (e.key instanceof mn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(xr, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(In, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(kr, function(e, n) {
            if (e.key instanceof mn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(lr, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(pr, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(dr, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(hr, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(Br, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, i) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, r;
            e.push(this);
            if (e.before) t = e.before(this, i, n);
            if (typeof t === "undefined") {
                t = this;
                i(t, e);
                if (e.after) {
                    r = e.after(t, n);
                    if (typeof r !== "undefined") t = r;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var Ae = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof new return switch throw try typeof var void while with";
    var C = "false null true";
    var I = [ "abstract async await boolean byte char double enum export final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", C, Ae ].join(" ");
    var M = "return new delete throw else case";
    Ae = dn(Ae);
    I = dn(I);
    M = dn(M);
    C = dn(C);
    var d = /^0b([01]+)$/i;
    var h = /^0x([0-9a-f]+)$/i;
    var v = /^0o?([0-7]+)$/i;
    var F = dn([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var P = "\n\r\u2028\u2029";
    var j = "+-*&%=<>!?|~^";
    var m = "[{(";
    var _ = ",;:";
    var g = ")}]";
    var De = _ + g;
    var H = m + _;
    var Y = H + "`" + g;
    var R = P + "  \t\f\v​             　\ufeff";
    var B = dn(n("./'\"#" + j + Y + R));
    P = dn(n(P));
    j = dn(n(j));
    De = dn(n(De));
    H = dn(n(H));
    Y = dn(n(Y));
    R = dn(n(R));
    function re(e) {
        return e >= 55296 && e <= 56319;
    }
    function ie(e) {
        return e >= 56320 && e <= 57343;
    }
    function L(e) {
        return e >= 48 && e <= 57;
    }
    function ae(e) {
        return !B[e];
    }
    function ni(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function ti(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = d.exec(e)) return parseInt(n[1], 2);
        if (n = h.exec(e)) return parseInt(n[1], 16);
        if (n = v.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function ri(e, n, t, r, i) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = r;
        this.pos = i;
    }
    ri.prototype = Object.create(Error.prototype);
    ri.prototype.constructor = ri;
    ri.prototype.name = "SyntaxError";
    t(ri);
    function qe(e, n, t, r, i) {
        throw new ri(e, n, t, r, i);
    }
    function Oe(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function $e(i, a, o, s) {
        var f = {
            text: i,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: Object.create(null),
            read_template: n("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = r();
                    switch (t) {
                      case "\\":
                        t += r();
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (c() == "{") {
                            l();
                            e.push(n);
                            f.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
                function r() {
                    var e = l(true, true);
                    return e == "\r" ? "\n" : e;
                }
            })
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw V;
            if (P[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function h() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (P[e[n]]) return n;
            }
            return -1;
        }
        function r(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function v() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !ii[n] || e == "keyword" && M[n] || e == "punc" && H[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var r = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                r.raw = i.substring(r.pos, r.endpos);
            }
            if (!t) {
                r.comments_before = f.comments_before;
                r.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new te(r);
        }
        function _() {
            while (R[c()]) l();
        }
        function g(e) {
            var n = "", t;
            while ((t = c()) && e(t, n)) n += l();
            return n;
        }
        function b(e) {
            qe(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function y(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function w(e) {
            var t = false, r = false, i = false, a = e == ".";
            var n = g(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return i ? false : i = true;

                  case "e":
                  case "E":
                    return i ? true : t ? false : t = r = true;

                  case "+":
                  case "-":
                    return r;

                  case r = false, ".":
                    return a || t || i || y(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (y(n)) {
                if (z.has_directive("use strict")) b("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(i ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) b("Invalid syntax: " + n);
            if (a || t || c() != "n") return m("num", o);
            return m("bigint", n.toLowerCase() + l());
        }
        function x(e) {
            var n = l(true, e);
            if (n >= "0" && n <= "7") return k(n);
            if (n == "u") {
                var t = l(true, e);
                n += t;
                if (t != "{") {
                    n += l(true, e) + l(true, e) + l(true, e);
                } else do {
                    t = l(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += l(true, e) + l(true, e);
            }
            var r = ti(n);
            if (typeof r != "string") b("Invalid escape sequence: \\" + n);
            return r;
        }
        function k(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && z.has_directive("use strict")) b("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var E = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var r = l(true, true);
                if (r == "\\") r = x(true); else if (P[r]) b("Unterminated string constant"); else if (r == n) break;
                t += r;
            }
            var i = m("string", t);
            i.quote = e;
            return i;
        });
        function S(e) {
            var n = f.regex_allowed;
            var t = h(), r;
            if (t == -1) {
                r = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                r = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, r, true));
            f.regex_allowed = n;
            return z;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = r("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return z;
        });
        function T() {
            var e = false, n, t = false, r = c() == "#" ? l() : "";
            while (n = c()) {
                if (!e) {
                    if (n == "\\") t = e = true, l(); else if (ae(n)) r += l(); else break;
                } else {
                    if (n != "u") b("Expecting UnicodeEscapeSequence -- uXXXX");
                    n = x();
                    if (!ae(n)) b("Unicode char: " + n.charCodeAt(0) + " is not valid in identifier");
                    r += n;
                    e = false;
                }
            }
            if (Ae[r] && t) {
                var i = r.charCodeAt(0).toString(16).toUpperCase();
                r = "\\u" + "0000".substr(i.length) + i + r.slice(1);
            }
            return r;
        }
        var A = n("Unterminated regular expression", function(e) {
            var n = false, t, r = false;
            while (t = l(true)) if (P[t]) {
                b("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                r = true;
                e += t;
            } else if (t == "]" && r) {
                r = false;
                e += t;
            } else if (t == "/" && !r) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var i = T();
            try {
                var a = new RegExp(e, i);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                b(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (F[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function q() {
            l();
            switch (c()) {
              case "/":
                l();
                return S("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? A("") : D("/");
        }
        function O() {
            l();
            if (d("..")) return m("operator", "." + l() + l());
            return L(c().charCodeAt(0)) ? w(".") : m("punc", ".");
        }
        function $() {
            var e = T();
            if (u) return m("name", e);
            return C[e] ? m("atom", e) : !Ae[e] ? m("name", e) : F[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) b(n); else throw e;
                }
            };
        }
        function z(e) {
            if (e != null) return A(e);
            if (s && f.pos == 0 && d("#!")) {
                v();
                p(2);
                S("comment5");
            }
            for (;;) {
                _();
                v();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        S("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        S("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return E(n);

                  case 46:
                    return O();

                  case 47:
                    var r = q();
                    if (r === z) continue;
                    return r;
                }
                if (L(t)) return w();
                if (Y[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (j[n]) return D();
                if (t == 35 || t == 92 || !B[n]) return $();
                break;
            }
            b("Unexpected character '" + n + "'");
        }
        z.context = function(e) {
            if (e) f = e;
            return f;
        };
        z.add_directive = function(e) {
            f.directives[e] = true;
        };
        z.push_directives_stack = function() {
            f.directives = Object.create(f.directives);
        };
        z.pop_directives_stack = function() {
            f.directives = Object.getPrototypeOf(f.directives);
        };
        z.has_directive = function(e) {
            return !!f.directives[e];
        };
        return z;
    }
    var ze = dn("typeof void delete -- ++ ! ~ - +");
    var ii = dn("-- ++");
    var Ce = dn("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var ai = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var r = e[t++];
            for (var i = 0; i < r.length; i++) {
                n[r[i]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Me = dn("atom bigint num regexp string");
    function oi(t, l) {
        l = we(l, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            module: false,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof t == "string" ? $e(t, l.filename, l.html5_comments, l.shebang) : t,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return Oe(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function s(e, n, t, r) {
            var i = _.input.context();
            qe(e, i.filename, n != null ? n : i.tokline, t != null ? t : i.tokcol, r != null ? r : i.tokpos);
        }
        function o(e, n) {
            s(n, e.line, e.col);
        }
        function r(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            o(e, "Unexpected token: " + r(e.type, e.value));
        }
        function f(e, n) {
            if (g(e, n)) return b();
            o(_.token, "Unexpected token: " + r(_.token.type, _.token.value) + ", expected: " + r(e, n));
        }
        function x(e) {
            return f("punc", e);
        }
        function u(e) {
            return e.nlb || !hn(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function c() {
            return !l.strict && (g("eof") || g("punc", "}") || u(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !c()) x(";");
        }
        function d() {
            x("(");
            var e = N();
            x(")");
            return e;
        }
        function e(r) {
            return function() {
                var e = _.token;
                var n = r.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function E() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var h = e(function(e) {
            E();
            switch (_.token.type) {
              case "string":
                var n = _.in_directives;
                var t = N();
                if (n) {
                    if (t instanceof Bn) {
                        var r = t.start.raw.slice(1, -1);
                        _.input.add_directive(r);
                        t.value = r;
                    } else {
                        _.in_directives = n = false;
                    }
                }
                k();
                return n ? new at(t) : new gn({
                    body: t
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return v();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if (Oe(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return A(Ft);
                        b();
                        return A(Pt);
                    }
                    break;

                  case "await":
                    if (_.in_async) return v();
                    break;

                  case "export":
                    if (!e && l.module !== "") w();
                    b();
                    return W();

                  case "import":
                    var i = p();
                    if (i.type == "punc" && /^[(.]$/.test(i.value)) break;
                    if (!e && l.module !== "") w();
                    b();
                    return X();

                  case "let":
                    if (ee()) {
                        b();
                        var a = te();
                        k();
                        return a;
                    }
                    break;

                  case "yield":
                    if (_.in_generator) return v();
                    break;
                }
                return Oe(p(), "punc", ":") ? H() : v();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new bn({
                        start: _.token,
                        body: q(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return v();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new _n();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return Y(Qt);

                  case "class":
                    b();
                    return m(Ht);

                  case "const":
                    b();
                    var a = ne();
                    k();
                    return a;

                  case "continue":
                    b();
                    return Y(Zt);

                  case "debugger":
                    b();
                    k();
                    return new it();

                  case "do":
                    b();
                    var t = I(h);
                    f("keyword", "while");
                    var o = d();
                    k(true);
                    return new dt({
                        body: t,
                        condition: o
                    });

                  case "while":
                    b();
                    return new ht({
                        condition: d(),
                        body: I(h)
                    });

                  case "for":
                    b();
                    return B();

                  case "function":
                    b();
                    if (!g("operator", "*")) return A(jt);
                    b();
                    return A(Nt);

                  case "if":
                    b();
                    return L();

                  case "return":
                    if (_.in_function == 0 && !l.bare_returns) s("'return' outside of function");
                    b();
                    var r = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!c()) {
                        r = N();
                        k();
                    }
                    return new xn({
                        value: r
                    });

                  case "switch":
                    b();
                    return new er({
                        expression: d(),
                        body: I(K)
                    });

                  case "throw":
                    b();
                    if (u(_.token)) s("Illegal newline after 'throw'");
                    var r = N();
                    k();
                    return new Xt({
                        value: r
                    });

                  case "try":
                    b();
                    return Q();

                  case "var":
                    b();
                    var a = re();
                    k();
                    return a;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        s("Strict mode may not include a with statement");
                    }
                    b();
                    return new bt({
                        expression: d(),
                        body: h()
                    });
                }
            }
            w();
        });
        function H() {
            var n = z(Se);
            if (!hn(_.labels, function(e) {
                return e.name != n.name;
            })) {
                s("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = h();
            _.labels.pop();
            if (!(e instanceof lt)) {
                n.references.forEach(function(e) {
                    if (e instanceof Zt) {
                        o(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new ct({
                body: e,
                label: n
            });
        }
        function v() {
            var e = N();
            k();
            return new gn({
                body: e
            });
        }
        function Y(e) {
            var n = null, t;
            if (!c()) {
                n = z(Te, true);
            }
            if (n != null) {
                t = Wn(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) o(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) s(e.TYPE + " not inside a loop or switch");
            k();
            var r = new e({
                label: n
            });
            if (t) t.references.push(r);
            return r;
        }
        function R(e, n) {
            if (!g("name", e)) return;
            var t = p();
            if (!t) return;
            if (Oe(t, "operator", "=")) return;
            if (t.type == "punc" && /^[(;}]$/.test(t.value)) return;
            if (n && u(t)) return;
            return b();
        }
        function m(e) {
            var n = _.in_async;
            var t = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var r;
            if (e === Ht) {
                r = z(Ee);
            } else {
                r = z(Pr, true);
            }
            var i = null;
            if (g("keyword", "extends")) {
                b();
                E();
                i = oe(true);
            }
            x("{");
            var a = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var o = _.token;
                var s = !!R("static");
                var f = R("async", true);
                if (g("operator", "*")) {
                    b();
                    var u = g("name") && /^#/.test(_.token.value);
                    var c = $();
                    var l = _.token;
                    var p = A(f ? $t : Ct);
                    p.start = l;
                    p.end = y();
                    a.push(new Vt({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: p,
                        end: y()
                    }));
                    continue;
                }
                if (s && g("punc", "{")) {
                    a.push(new Wt({
                        start: o,
                        value: new wt({
                            start: o,
                            body: q(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                var u = g("name") && /^#/.test(_.token.value);
                var c = $();
                if (g("punc", "(")) {
                    var d = _.token;
                    var h = A(f ? Ot : zt);
                    h.start = d;
                    h.end = y();
                    a.push(new Vt({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: h,
                        end: y()
                    }));
                    continue;
                }
                if (f) w(f);
                var v = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    v = j();
                    _.in_generator = t;
                    _.in_async = n;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var m = null;
                    switch (c) {
                      case "get":
                        m = Lt;
                        break;

                      case "set":
                        m = Ut;
                        break;
                    }
                    if (m) {
                        a.push(new m({
                            start: o,
                            static: s,
                            private: g("name") && /^#/.test(_.token.value),
                            key: $(),
                            value: fe(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                a.push(new Bt({
                    start: o,
                    static: s,
                    private: u,
                    key: c,
                    value: v,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = t;
            _.in_async = n;
            return new e({
                extends: i,
                name: r,
                properties: a
            });
        }
        function B() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), ne(true)) : g("name", "let") && ee() ? (b(), 
                te(true)) : g("keyword", "var") ? (b(), re(true)) : N(true);
                var t;
                if (e) {
                    f("name", "of");
                    t = gt;
                } else if (g("operator", "in")) {
                    b();
                    t = _t;
                } else if (g("name", "of")) {
                    b();
                    t = xe;
                }
                if (t) {
                    if (n instanceof sr) {
                        if (n.definitions.length > 1) {
                            o(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== _t && n.definitions[0].value) {
                            o(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(F(n) || (n = P(n)) instanceof Nn)) {
                        o(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return a(t, n);
                }
            }
            return i(n);
        }
        function i(e) {
            x(";");
            var n = g("punc", ";") ? null : N();
            x(";");
            var t = g("punc", ")") ? null : N();
            x(")");
            return new vt({
                init: e,
                condition: n,
                step: t,
                body: I(h)
            });
        }
        function a(e, n) {
            E();
            var t = N();
            x(")");
            return new e({
                init: n,
                object: t,
                body: I(h)
            });
        }
        function S(e) {
            if (e instanceof jn) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof $n) {
                    n = S(e.elements.pop().expression);
                }
                return new yr({
                    start: e.start,
                    elements: e.elements.map(S),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Pn) return new Sn({
                start: e.start,
                name: S(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof Sn) {
                e.name = S(e.name);
                return e;
            }
            if (e instanceof yr) {
                e.elements = e.elements.map(S);
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof xr) {
                e.properties.forEach(function(e) {
                    e.value = S(e.value);
                });
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof Jr) return e;
            if (e instanceof In) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof $n) {
                    n = S(e.properties.pop().expression);
                }
                return new xr({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof Er)) o(e.start, "Invalid destructuring assignment");
                        return new wr({
                            start: e.start,
                            key: e.key,
                            value: S(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Hn) return e;
            if (e instanceof Yn) return new Hn(e);
            if (e instanceof br) return new Hn({
                start: e.start,
                name: "yield",
                end: e.end
            });
            o(e.start, "Invalid arrow parameter");
        }
        function T(e, n, t) {
            var r = _.in_async;
            var i = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var o = e.map(S);
            var s = e.rest || null;
            if (s) s = S(s);
            _.in_funarg = a;
            x("=>");
            var f, u;
            var c = _.in_loop;
            var l = _.labels;
            ++_.in_function;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                _.in_directives = true;
                f = q();
                u = null;
            } else {
                f = [];
                E();
                u = j();
            }
            var p = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = c;
            _.labels = l;
            _.in_generator = i;
            _.in_async = r;
            var d = new (t ? qt : Dt)({
                start: n,
                argnames: o,
                rest: s,
                body: f,
                value: u,
                end: y()
            });
            if (p) d.each_argname(pe);
            return d;
        }
        var A = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var r;
            if (/Defun$/.test(e.TYPE)) {
                r = z(Mr);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                r = z(Fr, true);
            }
            if (r && e !== xt && !(r instanceof qr)) w(y());
            x("(");
            var i = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = O(")", !l.strict, false, function() {
                return de(Hn);
            });
            _.in_funarg = i;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = q();
            var u = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            var c = new e({
                name: r,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
            if (u) {
                if (r) pe(r);
                c.each_argname(pe);
            }
            return c;
        };
        function L() {
            var e = d(), n = h(), t = null;
            if (g("keyword", "else")) {
                b();
                t = h();
            }
            return new kn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function U() {
            return g("name") || g("string") || ni(_.token.value);
        }
        function D(e) {
            return new Bn({
                start: e,
                quote: e.quote,
                value: e.value,
                end: e
            });
        }
        function V() {
            var e = _.token;
            f("string");
            k();
            return D(e);
        }
        function W() {
            if (g("operator", "*")) {
                var e = _.token;
                var n = e;
                b();
                if (g("name", "as")) {
                    b();
                    if (!U()) f("name");
                    n = _.token;
                    b();
                }
                f("name", "from");
                return new ke({
                    aliases: [ D(n) ],
                    keys: [ D(e) ],
                    path: V()
                });
            }
            if (g("punc", "{")) {
                b();
                var r = [];
                var t = [];
                while (U()) {
                    var e = _.token;
                    b();
                    t.push(e);
                    if (g("name", "as")) {
                        b();
                        if (!U()) f("name");
                        r.push(_.token);
                        b();
                    } else {
                        r.push(e);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    return new ke({
                        aliases: r.map(D),
                        keys: t.map(D),
                        path: V()
                    });
                }
                k();
                return new dr({
                    properties: t.map(function(e, n) {
                        if (!Oe(e, "name")) o(e, "Name expected");
                        var t = le(Nr, e);
                        t.alias = D(r[n]);
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var i = _.token;
                var a = G();
                if (a) {
                    a.start = i;
                    a.end = y();
                } else {
                    E();
                    a = N();
                    k();
                }
                return new pr({
                    body: a
                });
            }
            return new lr({
                body: J()
            });
        }
        function n(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === Ht ? Ee : Mr)(n.name);
            }
            return n;
        }
        function G() {
            if (g("name", "async")) {
                if (!Oe(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return n(Ft, A(Ot));
                b();
                return n(Pt, A($t));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return n(Ht, m(Yt));

              case "function":
                b();
                if (!g("operator", "*")) return n(jt, A(zt));
                b();
                return n(Nt, A(Ct));
            }
        }
        var J = e(function() {
            if (g("name")) switch (_.token.value) {
              case "async":
                b();
                f("keyword", "function");
                if (!g("operator", "*")) return A(Ft);
                b();
                return A(Pt);

              case "let":
                b();
                var e = te();
                k();
                return e;
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return m(Ht);

              case "const":
                b();
                var e = ne();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return A(jt);
                b();
                return A(Nt);

              case "var":
                b();
                var e = re();
                k();
                return e;
            }
            w();
        });
        function X() {
            var e = null;
            var n = z($r, true);
            var t = null;
            var r;
            if (n) {
                n.key = new Bn({
                    start: n.start,
                    value: "",
                    end: n.end
                });
                if (r = g("punc", ",")) b();
            } else {
                r = !g("string");
            }
            if (r) {
                if (g("operator", "*")) {
                    var i = _.token;
                    b();
                    f("name", "as");
                    e = z($r);
                    e.key = D(i);
                } else {
                    x("{");
                    t = [];
                    while (U()) {
                        var a;
                        if (Oe(p(), "name", "as")) {
                            var i = _.token;
                            b();
                            b();
                            a = z($r);
                            a.key = D(i);
                        } else {
                            a = z($r);
                            a.key = new Bn({
                                start: a.start,
                                value: a.name,
                                end: a.end
                            });
                        }
                        t.push(a);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) f("name", "from");
            return new hr({
                all: e,
                default: n,
                path: V(),
                properties: t
            });
        }
        function q() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(h());
            }
            b();
            return e;
        }
        function K() {
            x("{");
            var e = [], n, t, r, i;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new rr({
                        start: (i = _.token, b(), i),
                        expression: N(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (r) s("More than one default clause in switch statement");
                    t = [];
                    n = new tr({
                        start: (i = _.token, b(), x(":"), i),
                        body: t
                    });
                    e.push(n);
                    r = n;
                } else {
                    if (!t) w();
                    t.push(h());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function Q() {
            var e = q(), n = null, t = null;
            if (g("keyword", "catch")) {
                var r = _.token;
                b();
                var i = null;
                if (g("punc", "(")) {
                    b();
                    i = C(jr);
                    x(")");
                }
                n = new ar({
                    start: r,
                    argname: i,
                    body: q(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var r = _.token;
                b();
                t = new or({
                    start: r,
                    body: q(),
                    end: y()
                });
            }
            if (!n && !t) s("Missing catch/finally blocks");
            return new ir({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function Z(e, n) {
            var t = [];
            for (;;) {
                var r = _.token;
                var i = C(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = j(n);
                } else if (!n && (e === Or || i instanceof Nn)) {
                    s("Missing initializer in declaration");
                }
                t.push(new En({
                    start: r,
                    name: i,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        function ee() {
            var e = p();
            return Oe(e, "name") || Oe(e, "punc", "[") || Oe(e, "punc", "{");
        }
        var ne = function(e) {
            return new fr({
                start: y(),
                definitions: Z(Or, e),
                end: y()
            });
        };
        var te = function(e) {
            return new ur({
                start: y(),
                definitions: Z(zr, e),
                end: y()
            });
        };
        var re = function(e) {
            return new cr({
                start: y(),
                definitions: Z(Cr, e),
                end: y()
            });
        };
        var ie = function(e) {
            var n = _.token;
            f("operator", "new");
            var t;
            if (g("punc", ".") && Oe(p(), "name", "target")) {
                b();
                b();
                t = new Rr();
            } else {
                var r = oe(false), i;
                if (g("punc", "(")) {
                    b();
                    i = O(")", !l.strict);
                } else {
                    i = [];
                }
                t = new vr({
                    expression: r,
                    args: i
                });
            }
            t.start = n;
            t.end = y();
            return M(t, e);
        };
        function ae() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new Ln({
                        value: t
                    });
                } else {
                    e = new Xr();
                    if (t < 0) e = new Cn({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new Lr({
                    value: t
                });
                break;

              case "string":
                e = new Bn({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new Ur({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new Qr();
                    break;

                  case "true":
                    e = new Zr();
                    break;

                  case "null":
                    e = new Vr();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var oe = function(e) {
            if (g("operator", "new")) {
                return ie(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    return M(he(null), e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return T([], n);
                    }
                    var t = N(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var i = n.comments_before[0];
                        if (!i.nlb) {
                            i.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    x(")");
                    var a = y();
                    a.comments_before = t.end.comments_before;
                    a.comments_after.forEach(function(e) {
                        t.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (g("punc", "=>")) return T(t instanceof An ? t.expressions : [ t ], n);
                    return M(t, e);

                  case "[":
                    return M(se(), e);

                  case "{":
                    return M(ue(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var o = m(Yt);
                o.start = n;
                o.end = y();
                return M(o, e);

              case "function":
                b();
                var s;
                if (g("operator", "*")) {
                    b();
                    s = A(Ct);
                } else {
                    s = A(zt);
                }
                s.start = n;
                s.end = y();
                return M(s, e);
            }
            if (g("name")) {
                var f = le(Yn, n);
                b();
                if (f.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var s;
                        if (g("operator", "*")) {
                            b();
                            s = A($t);
                        } else {
                            s = A(Ot);
                        }
                        s.start = n;
                        s.end = y();
                        return M(s, e);
                    }
                    if (g("name") && Oe(p(), "punc", "=>")) {
                        n = _.token;
                        f = le(Yn, n);
                        b();
                        return T([ f ], n, true);
                    }
                    if (g("punc", "(")) {
                        var u = M(f, e);
                        if (!g("punc", "=>")) return u;
                        var c = u.args;
                        if (c[c.length - 1] instanceof $n) {
                            c.rest = c.pop().expression;
                        }
                        return T(c, n, true);
                    }
                }
                return g("punc", "=>") ? T([ f ], n) : M(f, e);
            }
            if (Me[_.token.type]) {
                return M(ae(), e);
            }
            w();
        };
        function O(e, n, t, r) {
            if (!r) r = j;
            var i = true, a = [];
            while (!g("punc", e)) {
                if (i) i = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new Jr({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(r());
                } else if (r === j) {
                    a.push(new $n({
                        start: _.token,
                        expression: (b(), r()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = r();
                    if (a.rest instanceof Sn) o(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var se = e(function() {
            x("[");
            return new jn({
                elements: O("]", !l.strict, true)
            });
        });
        var fe = e(function() {
            return A(xt);
        });
        var ue = e(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!l.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var r = $();
                    var i = _.token;
                    var a = A(Ct);
                    a.start = i;
                    a.end = y();
                    n.push(new Sr({
                        start: t,
                        key: r,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new $n({
                        start: t,
                        expression: j(),
                        end: y()
                    }));
                    continue;
                }
                if (Oe(p(), "operator", "=")) {
                    var o = z(Yn);
                    b();
                    n.push(new Er({
                        start: t,
                        key: t.value,
                        value: new Pn({
                            start: t,
                            left: o,
                            operator: "=",
                            right: j(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if (Oe(p(), "punc", ",") || Oe(p(), "punc", "}")) {
                    n.push(new Er({
                        start: t,
                        key: t.value,
                        value: z(Yn),
                        end: y()
                    }));
                    continue;
                }
                var r = $();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = A(zt);
                    f.start = s;
                    f.end = y();
                    n.push(new Sr({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new Er({
                        start: t,
                        key: r,
                        value: j(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (r) {
                  case "async":
                    var u = g("operator", "*") && b();
                    r = $();
                    var s = _.token;
                    var f = A(u ? $t : Ot);
                    f.start = s;
                    f.end = y();
                    n.push(new Sr({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new Ar({
                        start: t,
                        key: $(),
                        value: fe(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new Tr({
                        start: t,
                        key: $(),
                        value: fe(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new In({
                properties: n
            });
        });
        function $() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!Ae[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = j();
                x("]");
                return n;

              default:
                w();
            }
        }
        function ce() {
            var e = _.token.value;
            f("name");
            return e;
        }
        function le(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = Hr;
                break;

              case "this":
                e = Yr;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function pe(e) {
            if (e.name == "arguments" || e.name == "eval" || e.name == "let") o(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function z(e, n) {
            if (!g("name")) {
                if (!n) s("Name expected");
                return null;
            }
            var t = le(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof qr) {
                pe(t);
            }
            b();
            return t;
        }
        function C(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = O("]", !l.strict, true, function() {
                    return de(e);
                });
                return new yr({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var r = true, i = [], a = null;
                while (!g("punc", "}")) {
                    if (r) r = false; else x(",");
                    if (!l.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || Oe(p(), "punc", ":")) {
                        var s = $();
                        x(":");
                        i.push(new wr({
                            start: o,
                            key: s,
                            value: de(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = C(e);
                        break;
                    }
                    var f = z(e);
                    if (g("operator", "=")) {
                        b();
                        f = new Sn({
                            start: f.start,
                            name: f,
                            value: j(),
                            end: y()
                        });
                    }
                    i.push(new wr({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new xr({
                    start: n,
                    properties: i,
                    rest: a,
                    end: y()
                });
            }
            return z(e);
        }
        function de(e) {
            var n = _.token;
            var t = C(e);
            if (!g("operator", "=")) return t;
            b();
            return new Sn({
                start: n,
                name: t,
                value: j(),
                end: y()
            });
        }
        function he(e) {
            var n = e ? e.start : _.token;
            var t = _.input.context().read_template;
            var r = [];
            var i = [];
            while (t(r)) {
                b();
                i.push(N());
                if (!g("punc", "}")) w();
            }
            b();
            return new Br({
                start: n,
                expressions: i,
                strings: r,
                tag: e,
                end: y()
            });
        }
        function M(e, n) {
            var t = e.start;
            var r = null;
            while (true) {
                if (g("operator", "?") && Oe(p(), "punc", ".")) {
                    b();
                    b();
                    r = e;
                }
                if (g("punc", "[")) {
                    b();
                    var i = N();
                    x("]");
                    e = new On({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: i,
                        end: y()
                    });
                } else if (n && g("punc", "(")) {
                    b();
                    e = new Tn({
                        start: t,
                        optional: r === e,
                        expression: e,
                        args: O(")", !l.strict),
                        end: y()
                    });
                } else if (r === e || g("punc", ".")) {
                    if (r !== e) b();
                    e = new qn({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: ce(),
                        end: y()
                    });
                } else if (g("punc", "`")) {
                    if (r) s("Invalid template on optional chain");
                    e = he(e);
                } else {
                    break;
                }
            }
            if (r) e.terminal = true;
            if (e instanceof Tn && !e.pure) {
                var t = e.start;
                var a = t.comments_before;
                var o = nt(t, "comments_before_length") ? t.comments_before_length : a.length;
                while (--o >= 0) {
                    if (/[@#]__PURE__/.test(a[o].value)) {
                        e.pure = true;
                        break;
                    }
                }
            }
            return e;
        }
        function ve(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) s("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new gr({
                    start: n,
                    expression: ve(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) s("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var r = false;
                if (g("operator", "*")) {
                    b();
                    t = j(e);
                    r = true;
                } else if (g("punc") ? !De[_.token.value] : !c()) {
                    t = j(e);
                }
                return new br({
                    start: n,
                    expression: t,
                    nested: r,
                    end: y()
                });
            }
            if (g("operator") && ze[n.value]) {
                b();
                E();
                var i = me(Cn, n, ve(e));
                i.start = n;
                i.end = y();
                return i;
            }
            var a = oe(true);
            while (g("operator") && ii[_.token.value] && !u(_.token)) {
                a = me(_r, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function me(e, n, t) {
            var r = n.value;
            switch (r) {
              case "++":
              case "--":
                if (!F(t)) o(n, "Invalid use of " + r + " operator");
                break;

              case "delete":
                if (t instanceof Yn && _.input.has_directive("use strict")) o(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: r,
                expression: t
            });
        }
        var _e = function(e, n, t) {
            var r = g("operator") ? _.token.value : null;
            if (r == "in" && t) r = null;
            var i = r != null ? ai[r] : null;
            if (i != null && i > n) {
                b();
                var a = _e(ve(t), r == "**" ? i - 1 : i, t);
                return _e(new Mn({
                    start: e.start,
                    left: e,
                    operator: r,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function ge(e) {
            return _e(ve(e), 0, e);
        }
        var be = function(e) {
            var n = _.token;
            var t = ge(e);
            if (g("operator", "?")) {
                b();
                var r = j();
                x(":");
                return new Fn({
                    start: n,
                    condition: t,
                    consequent: r,
                    alternative: j(e),
                    end: y()
                });
            }
            return t;
        };
        function F(e) {
            return e instanceof Dn && !e.optional || e instanceof Yn;
        }
        function P(e) {
            if (e instanceof jn) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof $n) {
                    n = P(e.elements.pop().expression);
                    if (!(n instanceof Nn || F(n))) return e;
                }
                var t = e.elements.map(P);
                return hn(t, function(e) {
                    return e instanceof Sn || e instanceof Nn || e instanceof Jr || F(e);
                }) ? new yr({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof Pn) {
                var r = P(e.left);
                return r instanceof Nn || F(r) ? new Sn({
                    start: e.start,
                    name: r,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof In)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof $n) {
                n = P(e.properties.pop().expression);
                if (!(n instanceof Nn || F(n))) return e;
            }
            var i = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof Er)) return e;
                var s = P(o.value);
                if (!(s instanceof Sn || s instanceof Nn || F(s))) {
                    return e;
                }
                i.push(new wr({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new xr({
                start: e.start,
                properties: i,
                rest: n,
                end: e.end
            });
        }
        function j(e) {
            var n = _.token;
            var t = be(e), r = _.token.value;
            if (g("operator") && Ce[r]) {
                if (F(t) || r == "=" && (t = P(t)) instanceof Nn) {
                    b();
                    return new Pn({
                        start: n,
                        left: t,
                        operator: r,
                        right: j(e),
                        end: y()
                    });
                }
                s("Invalid assignment");
            }
            return t;
        }
        function N(e, n) {
            var t = _.token;
            var r = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    r.rest = C(Hn);
                    break;
                }
                r.push(j(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && Oe(p(), "punc", "=>")) break;
            }
            return r.length == 1 && !r.rest ? r[0] : new An({
                start: t,
                expressions: r,
                end: y()
            });
        }
        function I(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (l.expression) {
            E();
            var ye = N();
            f("eof");
            return ye;
        }
        return function() {
            var e = _.token;
            var n = [];
            if (l.module) {
                _.in_async = true;
                _.input.add_directive("use strict");
            }
            _.input.push_directives_stack();
            while (!g("eof")) n.push(h(true));
            _.input.pop_directives_stack();
            var t = y() || e;
            var r = l.toplevel;
            if (r) {
                r.body = r.body.concat(n);
                r.end = t;
            } else {
                r = new yt({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return r;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function w(e, n, t, r) {
        this._bits = 0;
        this.defun = undefined;
        this.eliminated = 0;
        this.id = e;
        this.init = r;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.safe_ids = undefined;
        this.scope = n;
    }
    w.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            if (this.mangled_name) return;
            var n = this.global && e.cache && e.cache.props;
            if (n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (this.unmangleable(e)) {
                E(this.scope, e).set(this.name, true);
            } else {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = S(this, e);
                }
                if (n) n.set(this.name, this.mangled_name);
            }
        },
        redefined: function() {
            var e = this;
            var n = e.defun;
            if (!n) return;
            var t = e.name;
            var r = n.variables.get(t) || n instanceof yt && n.globals.get(t) || e.orig[0] instanceof Or && Wn(function(e) {
                return e.name == t;
            }, n.enclosed);
            if (r && r !== e) return r.redefined() || r;
        },
        unmangleable: function(e) {
            if (this.exported) return true;
            if (this.undeclared) return true;
            if (!e.eval && this.scope.pinned()) return true;
            if (e.keep_fargs && si(this)) return true;
            if (e.keep_fnames) {
                var n = this.orig[0];
                if (n instanceof Pr) return true;
                if (n instanceof Ee) return true;
                if (n instanceof Mr) return true;
                if (n instanceof Fr) return true;
            }
            if (!e.toplevel && this.global) return true;
            return false;
        }
    };
    r(w, [ "const_redefs", "cross_loop", "direct_access", "exported", "global", "undeclared" ]);
    function si(e) {
        return e.orig[0] instanceof Hn || e.orig[1] instanceof Hn;
    }
    var fi = dn("delete ++ --");
    function ui(e, n) {
        if (n instanceof Pn) return n.left === e && e;
        if (n instanceof Sn) return n.name === e && e;
        if (n instanceof Nn) return e;
        if (n instanceof wr) return e;
        if (n instanceof mt) return n.init === e && e;
        if (n instanceof zn) return fi[n.operator] && n.expression;
    }
    yt.DEFMETHOD("figure_out_scope", function(c) {
        c = we(c, {
            cache: null,
            ie: false
        });
        var l = this;
        var o = null;
        var s = false;
        var t = 0;
        var f = l.parent_scope = null;
        var p = new Un(function(r, e) {
            if (r instanceof Ht) {
                var n = s;
                s = p.parent() instanceof lr;
                r.name.walk(p);
                s = n;
                a(function() {
                    if (r.extends) r.extends.walk(p);
                    r.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (r instanceof sr) {
                var n = s;
                s = p.parent() instanceof lr;
                e();
                s = n;
                return true;
            }
            if (r instanceof Mt) {
                var n = s;
                s = p.parent() instanceof lr;
                r.name.walk(p);
                s = n;
                a(function() {
                    r.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (r.rest) r.rest.walk(p);
                    ft(r, p);
                });
                return true;
            }
            if (r instanceof nr) {
                r.init_vars(f);
                e();
                return true;
            }
            if (r instanceof ir) {
                a(function() {
                    ft(r, p);
                });
                if (r.bcatch) r.bcatch.walk(p);
                if (r.bfinally) r.bfinally.walk(p);
                return true;
            }
            if (r instanceof bt) {
                var t = f;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (r instanceof st) {
                a(e);
                return true;
            }
            if (r instanceof Dr) {
                r.scope = f;
            }
            if (r instanceof Se) {
                r.thedef = r;
                r.references = [];
            }
            if (r instanceof jr) {
                f.def_variable(r).defun = o;
            } else if (r instanceof Or) {
                var i = f.def_variable(r);
                i.defun = o;
                if (s) i.exported = true;
            } else if (r instanceof Mr) {
                var i = o.def_function(r, p.parent());
                if (s) i.exported = true;
            } else if (r instanceof Hn) {
                o.def_variable(r);
            } else if (r instanceof Fr) {
                var i = o.def_function(r, r.name == "arguments" ? undefined : o);
                if (c.ie && r.name != "arguments") i.defun = o.parent_scope.resolve();
            } else if (r instanceof zr) {
                var i = f.def_variable(r);
                if (s) i.exported = true;
            } else if (r instanceof Cr) {
                var i = o.def_variable(r, r instanceof $r ? undefined : null);
                if (s) i.exported = true;
            }
            function a(e) {
                r.init_vars(f);
                var n = o;
                var t = f;
                if (r instanceof yn) o = r;
                f = r;
                e();
                f = t;
                o = n;
            }
        });
        l.make_def = function(e, n) {
            return new w(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new vn();
        var d = [];
        var p = new Un(function(e) {
            if (e instanceof ar) {
                if (!(e.argname instanceof Nn)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                ft(e, p);
                return true;
            }
            if (e instanceof wn) {
                d.push(e);
                if (e.name) e.name.walk(p);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                At(e, p);
                return true;
            }
            if (e instanceof Kt) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof qr) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof jr) {
                    var t = n.redefined();
                    if (t) for (var r = e.scope; r; r = r.parent_scope) {
                        if (!Qn(r.enclosed, t)) break;
                        if (r === t.scope) break;
                    }
                } else if (e instanceof Or) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                } else if (n.scope !== e.scope && (e instanceof Mr || e instanceof Hn || e instanceof Cr)) {
                    e.mark_enclosed(c);
                    var t = e.scope.find_variable(e.name);
                    if (e.thedef !== t) {
                        e.thedef = t;
                        t.orig.push(e);
                        e.mark_enclosed(c);
                    }
                }
                if (e.name != "arguments") return true;
                var i = e instanceof Cr && p.parent();
                if (i instanceof En && !i.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && h(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof Yn) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof jr || f instanceof Hn || f instanceof Fr) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && h(a)) {
                    var i = p.parent();
                    if (ui(e, i)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(i instanceof Dn && i.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var i = p.parent();
                    if (i.TYPE == "Call" && i.expression === e) {
                        var r = e.scope;
                        do {
                            r = r.resolve();
                            if (r.uses_eval) break;
                            r.uses_eval = true;
                        } while (r = r.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof Mt && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie) l.walk(new Un(function(e) {
            if (e instanceof jr) {
                var n = e.thedef;
                var t = n.defun;
                if (n.name != "arguments" && t.name instanceof Fr && t.name.name == n.name) {
                    t = t.parent_scope.resolve();
                }
                r(e, t);
                return true;
            }
            if (e instanceof Fr) {
                var n = e.thedef;
                if (!r(e, e.scope.parent_scope.resolve())) {
                    n.defun = undefined;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (n.init) {
                    e.thedef.init = n.init;
                }
                return true;
            }
        }));
        function h(e) {
            return e.orig[0] instanceof Hn && !(e.orig[1] instanceof Hn || e.orig[2] instanceof Hn) && !Et(e.scope);
        }
        function r(e, n) {
            var t = e.name;
            var r = e.thedef;
            if (!hn(r.orig, function(e) {
                return !(e instanceof Or || e instanceof zr);
            })) return false;
            var i = n.find_variable(t);
            if (i) {
                var a = i.redefined();
                if (a) i = a;
            } else {
                i = l.globals.get(t);
            }
            if (i) {
                i.orig.push(e);
            } else {
                i = n.def_variable(e);
            }
            if (i.undeclared) l.variables.set(t, i);
            if (t == "arguments" && h(r) && e instanceof Fr) return true;
            r.defun = i.scope;
            r.forEach(function(e) {
                e.redef = r;
                e.thedef = i;
                e.reference(c);
            });
            return true;
        }
    });
    yt.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var r = this.make_def(e);
            r.undeclared = true;
            r.global = true;
            n.set(t, r);
            return r;
        }
    });
    function x(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new vn();
        e.variables = new vn();
        if (n) e.make_def = n.make_def;
    }
    function k(e, n) {
        x(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    st.DEFMETHOD("init_vars", function(e) {
        x(this, e);
    });
    yn.DEFMETHOD("init_vars", function(e) {
        k(this, e);
    });
    Dt.DEFMETHOD("init_vars", function(e) {
        k(this, e);
        return this;
    });
    qt.DEFMETHOD("init_vars", function(e) {
        k(this, e);
    });
    wn.DEFMETHOD("init_vars", function(e) {
        k(this, e);
        this.uses_arguments = false;
        this.def_variable(new Hn({
            name: "arguments",
            scope: this,
            start: this.start,
            end: this.end
        }));
        return this;
    });
    Dr.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            if (!Qn(t.enclosed, n)) break;
            if (!e) {
                t._var_names = undefined;
            } else {
                if (e.keep_fargs && t instanceof wn) t.each_argname(function(e) {
                    Qn(n.scope.enclosed, e.definition());
                });
                if (e.keep_fnames) t.functions.each(function(e) {
                    Qn(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Dr.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    st.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    st.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof Mt) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    st.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof kt) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function E(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = new vn();
            var r = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t.set(e.name, true);
                if (e.global && r && r.has(e.name)) {
                    t.set(r.get(e.name), true);
                }
            });
        }
        return t;
    }
    function S(e, t) {
        var n = e.scope;
        var r = E(n, t);
        var i = n.cname_holes;
        var a = new vn();
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (Vn(n, o)) break;
                E(n, t).each(function(e, n) {
                    a.set(n, e);
                });
                o.push(n);
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < i.length; f++) {
            s = A(i[f]);
            if (a.has(s)) continue;
            i.splice(f, 1);
            r.set(s, true);
            return s;
        }
        while (true) {
            s = A(++n.cname);
            if (r.has(s) || I[s] || t.reserved.has[s]) continue;
            if (!a.has(s)) break;
            i.push(n.cname);
        }
        r.set(s, true);
        return s;
    }
    Dr.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Se.DEFMETHOD("unmangleable", ln);
    Dr.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function T(e) {
        e = we(e, {
            eval: false,
            ie: false,
            keep_fargs: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Qn(e.reserved, "arguments");
        e.reserved.has = dn(e.reserved);
        return e;
    }
    yt.DEFMETHOD("mangle_names", function(s) {
        s = T(s);
        if (s.cache && s.cache.props) {
            var n = E(this, s);
            s.cache.props.each(function(e) {
                n.set(e, true);
            });
        }
        var f = 36;
        var u = -1;
        var a = [];
        var c = new Un(function(e, n) {
            var t;
            if (e instanceof st) {
                if (e instanceof ct) t = u;
                if (s.webkit && e instanceof lt && e.init instanceof ur) {
                    e.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof zr)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var r = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(r);
                            n.redefined = function() {
                                return r;
                            };
                        });
                    }, true);
                }
                var r = e.to_mangle = [];
                e.variables.each(function(e) {
                    if (!p(e)) r.push(e);
                });
                n();
                if (s.cache && e instanceof yt) {
                    e.globals.each(l);
                }
                if (e instanceof jt && c.has_directive("use asm")) {
                    var i = new Yn(e.name);
                    i.scope = e;
                    i.reference(s);
                }
                if (r.length > f) {
                    var a = r.map(function(e, n) {
                        return n;
                    }).sort(function(e, n) {
                        return r[n].references.length - r[e].references.length || e - n;
                    });
                    r = a.slice(0, f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }).concat(a.slice(f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }));
                }
                r.forEach(l);
                if (e instanceof ct && !(s.v8 && d(c))) u = t;
                return true;
            }
            if (e instanceof Se) {
                var o;
                do {
                    o = A(++u);
                } while (I[o]);
                e.mangled_name = o;
                return true;
            }
        });
        this.walk(c);
        a.forEach(l);
        function l(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function p(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof Or)) return false;
                var r = n.scope.resolve();
                if (n.scope === r) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = r.def_variable(e);
                r.to_mangle.push(t);
            }
            a.push(n);
            n.references.forEach(i);
            if (e instanceof jr || e instanceof Or) {
                i(e);
                n.redefined = function() {
                    return t;
                };
            }
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
        function d(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof ut) return t instanceof yt && !s.toplevel;
                if (t instanceof ct) return true;
            }
        }
    });
    yt.DEFMETHOD("find_colliding_names", function(t) {
        var r = t.cache && t.cache.props;
        var n = Object.create(I);
        t.reserved.forEach(i);
        this.globals.each(a);
        this.walk(new Un(function(e) {
            if (e instanceof st) e.variables.each(a);
        }));
        return n;
        function i(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && r && r.has(n)) n = r.get(n); else if (!e.unmangleable(t)) return;
            i(n);
        }
    });
    yt.DEFMETHOD("expand_names", function(r) {
        A.reset();
        A.sort();
        r = T(r);
        var n = this.find_colliding_names(r);
        var t = 0;
        this.globals.each(a);
        this.walk(new Un(function(e) {
            if (e instanceof st) e.variables.each(a);
        }));
        function i() {
            var e;
            do {
                e = A(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && r.cache) return;
            if (n.unmangleable(r)) return;
            if (r.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : i();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    mn.DEFMETHOD("tail_node", Jn);
    An.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    yt.DEFMETHOD("compute_char_frequency", function(e) {
        e = T(e);
        A.reset();
        var n = Dr.prototype.add_source_map;
        try {
            Dr.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) A.consider(this.name, -1);
            };
            if (e.properties) {
                qn.prototype.add_source_map = function() {
                    A.consider(this.property, -1);
                };
                On.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            A.consider(this.print_to_string(), 1);
        } finally {
            Dr.prototype.add_source_map = n;
            delete qn.prototype.add_source_map;
            delete On.prototype.add_source_map;
        }
        A.sort();
        function t(e) {
            if (e instanceof Bn) {
                A.consider(e.value, -1);
            } else if (e instanceof Fn) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof An) {
                t(e.tail_node());
            }
        }
    });
    var A = function() {
        var i = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var r = e[t];
                n.push(r);
                i[r] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var r, a;
        function o() {
            r = null;
            a = Object.create(i);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            r = t.sort(s).concat(n).sort(s);
        };
        f.reset = o;
        o();
        function f(e) {
            var n = t[e % 54];
            for (e = Math.floor(e / 54); --e >= 0; e >>= 6) {
                n += r[e & 63];
            }
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function ci(e, n) {
        if (!(this instanceof ci)) return new ci(e, n);
        ei.call(this, this.before, this.after);
        this.options = we(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            module: false,
            negate_iife: !n,
            objects: !n,
            optional_chains: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && (e["module"] || e["top_retain"])),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            webkit: false,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var r = this.options["global_defs"];
        if (typeof r == "object") for (var i in r) {
            if (/^@/.test(i) && nt(r, i)) {
                r[i.slice(1)] = oi(r[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 4;
        this.drop_fargs = this.options["keep_fargs"] ? ln : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var r = t.definition();
            if (r.direct_access) return false;
            var i = r.escaped;
            return i && i.depth != 1;
        };
        if (this.options["module"]) this.directives["use strict"] = true;
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Tn) {
                    n = e.expression;
                } else if (e instanceof Br) {
                    n = e.tag;
                }
                return !(n && a === n.print_to_string());
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof Tn) {
                    n = e.expression;
                } else if (e instanceof Br) {
                    n = e.tag;
                }
                return !(n && Vn(n.print_to_string(), a));
            };
        } else {
            this.pure_funcs = pn;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return Vn(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    ci.prototype = new ei(function(e, n, t) {
        if (e._squeezed) return e;
        var r = e instanceof yn;
        if (r) {
            if (this.option("arrows") && Et(e) && e.value) {
                e.body = [ e.first_statement() ];
                e.value = null;
            }
            e.hoist_properties(this);
            e.hoist_declarations(this);
            e.process_returns(this);
        }
        n(e, this);
        n(e, this);
        var i = e.optimize(this);
        if (r && i === e && !this.has_directive("use asm") && !i.pinned()) {
            i.drop_unused(this);
            if (i.merge_variables(this)) i.drop_unused(this);
            n(i, this);
        }
        if (i === e) i._squeezed = true;
        return i;
    });
    ci.prototype.option = function(e) {
        return this.options[e];
    };
    ci.prototype.exposed = function(e) {
        if (e.exported) return true;
        if (e.undeclared) return true;
        if (!(e.global || e.scope.resolve() instanceof yt)) return false;
        var n = this.toplevel;
        return !hn(e.orig, function(e) {
            return n[e instanceof Mr ? "funcs" : "vars"];
        });
    };
    ci.prototype.compress = function(e) {
        e = e.resolve_defines(this);
        e.hoist_exports(this);
        if (this.option("expression")) e.process_expression(true);
        var n = this.options.merge_vars;
        var t = +this.options.passes || 1;
        var r = 1 / 0;
        var i = false;
        var a = {
            ie: this.option("ie")
        };
        for (var o = 0; o < t; o++) {
            e.figure_out_scope(a);
            if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
            this.options.merge_vars = n && (i || o == t - 1);
            e = e.transform(this);
            if (t > 1) {
                var s = 0;
                e.walk(new Un(function() {
                    s++;
                }));
                mn.info("pass {pass}: last_count: {min_count}, count: {count}", {
                    pass: o,
                    min_count: r,
                    count: s
                });
                if (s < r) {
                    r = s;
                    i = false;
                } else if (i) {
                    break;
                } else {
                    i = true;
                }
            }
        }
        if (this.option("expression")) e.process_expression(false);
        return e;
    };
    (function(e) {
        e(mn, function(e, n) {
            return e;
        });
        yt.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var r = 0; r < n.length; r++) {
                var i = n[r];
                if (i instanceof lr) {
                    n[r] = i = i.body;
                    if (i instanceof sr) {
                        i.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(i.name);
                    }
                } else if (i instanceof dr) {
                    n.splice(r--, 1);
                    [].push.apply(t, i.properties);
                }
            }
            if (t.length) n.push(Fe(dr, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof qr)) return;
                var n = Fe(Nr, e);
                n.alias = Fe(Bn, n, {
                    value: n.name
                });
                t.push(n);
            }
        });
        yn.DEFMETHOD("process_expression", function(i, a) {
            var o = this;
            var s = new ei(function(e) {
                if (i) {
                    if (e instanceof at) e = Fe(gn, e, {
                        body: Fe(Bn, e)
                    });
                    if (e instanceof gn) {
                        return a ? a(e) : Fe(xn, e, {
                            value: e.body
                        });
                    }
                } else if (e instanceof xn) {
                    if (a) return a(e);
                    var n = e.value;
                    if (n instanceof Bn) return Fe(at, n);
                    return Fe(gn, e, {
                        body: n || Fe(Cn, e, {
                            operator: "void",
                            expression: Fe(Ln, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof ut) {
                    if (e instanceof wn) {
                        if (e !== o) return e;
                    } else if (i === "awaits" && e instanceof ir) {
                        if (e.bfinally) return e;
                    }
                    for (var t = e.body.length; --t >= 0; ) {
                        var r = e.body[t];
                        if (!B(r, true)) {
                            e.body[t] = r.transform(s);
                            break;
                        }
                    }
                } else if (e instanceof kn) {
                    e.body = e.body.transform(s);
                    if (e.alternative) e.alternative = e.alternative.transform(s);
                } else if (e instanceof bt) {
                    e.body = e.body.transform(s);
                }
                return e;
            });
            o.transform(s);
        });
        yt.DEFMETHOD("unwrap_expression", function() {
            var e = this;
            switch (e.body.length) {
              case 0:
                return Fe(Cn, e, {
                    operator: "void",
                    expression: Fe(Ln, e, {
                        value: 0
                    })
                });

              case 1:
                var n = e.body[0];
                if (n instanceof at) return Fe(Bn, n);
                if (n instanceof gn) return n.body;

              default:
                return Fe(Tn, e, {
                    expression: Fe(zt, e, {
                        argnames: [],
                        body: e.body
                    }).init_vars(e),
                    args: []
                });
            }
            return e;
        });
        mn.DEFMETHOD("wrap_expression", function() {
            var e = this;
            if (!ot(e)) e = Fe(gn, e, {
                body: e
            });
            if (!(e instanceof yt)) e = Fe(yt, e, {
                body: [ e ]
            });
            return e;
        });
        function $(e, n) {
            var t = n.get_property();
            if (t instanceof mn) return;
            var r;
            if (e instanceof jn) {
                var i = e.elements;
                if (t == "length") return fe(i.length, e);
                if (typeof t == "number" && t in i) r = i[t];
            } else if (e instanceof wn) {
                if (t == "length") {
                    e.length_read = true;
                    return fe(e.argnames.length, e);
                }
            } else if (e instanceof In) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!on(s)) return;
                    if (!r && a[o].key === t) r = a[o].value;
                }
            }
            return r instanceof Yn && r.fixed_value() || r;
        }
        function p(e, n) {
            if (e instanceof Kr) return b.Boolean[n];
            if (e instanceof Ln) return b.Number[n];
            if (e instanceof Bn) return b.String[n];
            if (n == "valueOf") return false;
            if (e instanceof jn) return b.Array[n];
            if (e instanceof wn) return b.Function[n];
            if (e instanceof In) return b.Object[n];
            if (e instanceof Ur) return b.RegExp[n] && !e.value.global;
        }
        function $e(e, n, t, r, i, a, o) {
            var s = n.parent(i);
            if (e.option("unsafe") && s instanceof qn && p(r, s.property)) {
                return;
            }
            var f = ui(t, s);
            if (f) return f;
            if (i == 0 && r && r.is_constant()) return;
            if (s instanceof jn) return $e(e, n, s, s, i + 1);
            if (s instanceof Pn) switch (s.operator) {
              case "=":
                return $e(e, n, s, r, i + 1, a, o);

              case "&&=":
              case "||=":
              case "??=":
                return $e(e, n, s, s, i + 1);

              default:
                return;
            }
            if (s instanceof Mn) {
                if (!He[s.operator]) return;
                return $e(e, n, s, s, i + 1);
            }
            if (s instanceof Tn) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(r instanceof kt) || !(s instanceof vr) && r.contains_this());
            }
            if (s instanceof Fn) {
                if (s.condition === t) return;
                return $e(e, n, s, s, i + 1);
            }
            if (s instanceof mt) return s.init === t;
            if (s instanceof Er) {
                if (s.value !== t) return;
                var u = n.parent(i + 1);
                return $e(e, n, u, u, i + 2);
            }
            if (s instanceof Dn) {
                if (s.expression !== t) return;
                var c = $(r, s);
                return (!a || o) && $e(e, n, s, c, i + 1);
            }
            if (s instanceof An) {
                if (s.tail_node() !== t) return;
                return $e(e, n, s, r, i + 1, a, o);
            }
        }
        function z(e) {
            return e instanceof It || e instanceof wn;
        }
        function Re(e) {
            return e instanceof It || e instanceof jt || e instanceof zt;
        }
        function ze(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function ne(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof yn) return true;
            } while (n = n.parent_scope);
        }
        function Ce(e, n, t) {
            var r = e.redef || e.definition();
            if (e.in_arg && si(r)) return false;
            return hn(r.orig, function(e) {
                if (e instanceof Or || e instanceof zr) {
                    if (e instanceof $r) return true;
                    return n && ee(n, e);
                }
                return !(t && e instanceof Fr);
            });
        }
        function Be(e, n, t, r) {
            if (r instanceof Pn) return r.operator == "=" && r.right === t;
            if (r instanceof Tn) return r.expression !== t || r instanceof vr;
            if (r instanceof Jt) return r.value === t && n.resolve() !== e.scope.resolve();
            if (r instanceof En) return r.value === t;
        }
        var P = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(mn, Gn);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_return = 0;
                t.drop_return = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof kt && t.init !== t.scope) && t.init;
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                });
            }
            function d(t, r, i) {
                i.fn_defs = [];
                i.variables.each(function(e) {
                    a(t, r, e);
                    var n = e.init;
                    if (n instanceof Mt) {
                        i.fn_defs.push(n);
                        n.safe_ids = null;
                    }
                    if (e.fixed === null) {
                        e.safe_ids = t.safe_ids;
                        g(t, e);
                    } else if (e.fixed) {
                        t.loop_ids[e.id] = t.in_loop;
                        g(t, e);
                    }
                });
                i.may_call_this = function() {
                    i.may_call_this = i.contains_this() ? pn : ln;
                };
                if (i.uses_arguments) i.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (r.option("ie")) i.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function o(e, n) {
                var t = n.safe_ids;
                return t === undefined || t === e.safe_ids;
            }
            function f(e, n) {
                var t = e.fn_scanning;
                e.fn_scanning = n;
                n.walk(e);
                e.fn_scanning = t;
            }
            function u(t, r) {
                r.enclosed.forEach(function(e) {
                    if (r.variables.get(e.name) === e) return;
                    if (y(t, e)) return;
                    e.single_use = false;
                    var n = e.fixed;
                    if (typeof n == "function") n = n();
                    if (n instanceof wn && n.safe_ids !== undefined) return;
                    e.fixed = false;
                });
            }
            function h(e, n, t) {
                var r = t.safe_ids;
                if (r === undefined) return;
                if (r === false) return;
                if (t.parent_scope.resolve().may_call_this === pn) {
                    if (Vn(t, e.fn_visited)) u(e, t);
                } else if (r) {
                    var i = Vn(t, e.fn_visited);
                    if (r === e.safe_ids) {
                        if (!i) f(e, t);
                    } else if (i) {
                        u(e, t);
                    } else {
                        t.safe_ids = false;
                    }
                } else if (e.fn_scanning && e.fn_scanning !== n.scope.resolve()) {
                    t.safe_ids = false;
                } else {
                    t.safe_ids = e.safe_ids;
                    f(e, t);
                }
            }
            function v(n, e) {
                var t = e.fn_defs;
                var r = e.may_call_this === pn ? t : t.filter(function(e) {
                    if (e.safe_ids === false) return true;
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                    return false;
                });
                _(n);
                r.forEach(function(e) {
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                });
                t.forEach(function(e) {
                    e.safe_ids = undefined;
                });
                e.fn_defs = undefined;
                e.may_call_this = undefined;
            }
            function m(e, n) {
                var t = Object.create(e.safe_ids);
                if (!n) t.seq = {};
                e.safe_ids = t;
            }
            function _(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function g(e, n) {
                e.safe_ids[n.id] = {};
            }
            function b(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function y(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    var r = nt(e.safe_ids, n.id);
                    if (!r) {
                        var i = e.safe_ids.seq;
                        if (!t.read) {
                            t.read = i;
                        } else if (t.read !== i) {
                            t.read = true;
                        }
                    }
                    if (n.fixed == null) {
                        if (ze(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = Fe(Gr, n.orig[0]);
                        if (r) n.safe_ids = undefined;
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof Mt;
            }
            function w(e, n, t) {
                if (!t) {
                    if (si(n) && n.scope.uses_arguments && !e.has_directive("use strict")) return false;
                    if (!hn(n.orig, function(e) {
                        return !(e instanceof Or);
                    })) return false;
                }
                if (n.fixed === undefined) return t || hn(n.orig, function(e) {
                    return !(e instanceof zr);
                });
                if (n.fixed === false || n.fixed === 0) return false;
                var r = e.safe_ids[n.id];
                if (n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    n.safe_ids = undefined;
                    return n.fixed === null || nt(e.safe_ids, n.id) && !r.read;
                }
                if (!nt(e.safe_ids, n.id)) {
                    if (!r) return false;
                    if (r.read || e.in_loop) {
                        var i = e.find_parent(st);
                        if (i instanceof It) return false;
                        if (n.scope.resolve() !== i.resolve()) return false;
                    }
                    r.assign = r.assign && r.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && r.read) {
                    if (r.read !== e.safe_ids.seq) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return y(e, n) && hn(n.orig, function(e) {
                    return !(e instanceof Fr);
                });
            }
            function x(e, n) {
                var t = Fe(Yn, e);
                t.fixed = n || Fe(Gr, e);
                return t;
            }
            function k(t, r) {
                return function() {
                    var e = x(t, r);
                    var n = t.definition();
                    n.references.push(e);
                    n.replaced++;
                    return e;
                };
            }
            function c(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(si(n) && n.scope.uses_arguments);
            }
            function E(e) {
                if (!e) return false;
                if (e instanceof Pn) {
                    var n = e.operator;
                    return n == "=" ? E(e.right) : !He[n.slice(0, -1)];
                }
                if (e instanceof An) return E(e.tail_node());
                return e.is_constant() || z(e) || e instanceof Ir;
            }
            function l(e, n) {
                if (n instanceof jn) return true;
                if (n instanceof Mn) return He[n.operator];
                if (n instanceof Fn) return n.condition !== e;
                if (n instanceof An) return n.tail_node() === e;
                if (n instanceof $n) return true;
            }
            function S(e, n, t, r, i, a, o) {
                var s = e.parent(a);
                if (i && i.is_constant()) return;
                if (Be(n, t, r, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(i && i.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    if (n.scope.resolve() !== t.resolve()) n.escaped.cross_scope = true;
                    if (n.fixed) n.fixed.escaped = n.escaped;
                    return;
                } else if (l(r, s)) {
                    S(e, n, t, s, s, a + 1, o);
                } else if (s instanceof Er && s.value === r) {
                    var f = e.parent(a + 1);
                    S(e, n, t, f, f, a + 2, o);
                } else if (s instanceof Dn && s.expression === r) {
                    i = $(i, s);
                    S(e, n, t, s, i, a + 1, o + 1);
                    if (i) return;
                }
                if (a > 0) return;
                if (s instanceof Tn && s.expression === r) return;
                if (s instanceof An && s.tail_node() !== r) return;
                if (s instanceof gn) return;
                if (s instanceof zn && !fi[s.operator]) return;
                n.direct_access = true;
                if (n.fixed) n.fixed.direct_access = true;
            }
            function T(e) {
                if (!(e instanceof On)) return;
                var n = e.expression;
                if (!(n instanceof Yn)) return;
                var t = n.definition();
                if (!ze(t)) return;
                var r = e.property;
                if (r.is_constant()) r = r.value;
                if (!(r instanceof mn) && !P.test(r)) return;
                t.reassigned++;
                (r instanceof mn ? t.scope.argnames : [ t.scope.argnames[r] ]).forEach(function(e) {
                    if (e instanceof Hn) e.definition().fixed = false;
                });
            }
            function p(n, t) {
                var r, i;
                return function() {
                    var e = n();
                    if (r !== e) {
                        r = e;
                        i = t(e);
                    }
                    return i;
                };
            }
            function A(t, r, i) {
                var a, o;
                return function() {
                    if (o === r) return r;
                    var e = i();
                    var n = M(t, e, true);
                    if (n instanceof mn) {
                        o = r;
                    } else if (a !== e) {
                        a = e;
                        o = n === undefined ? Pe(r, [ e, r.value ]) : e;
                    }
                    return o;
                };
            }
            function D(a, n, e, o, t) {
                var s = new Un(function(r) {
                    if (r instanceof Sn) {
                        O(r);
                        m(a, true);
                        r.value.walk(a);
                        _(a);
                        var e = o;
                        if (e) o = A(n, r, e);
                        r.name.walk(s);
                        o = e;
                        return true;
                    }
                    if (r instanceof yr) {
                        O(r);
                        var e = o;
                        r.elements.forEach(function(n, t) {
                            if (n instanceof Jr) return O(n);
                            if (e) o = p(e, function(e) {
                                return Fe(On, n, {
                                    expression: e,
                                    property: Fe(Ln, n, {
                                        value: t
                                    })
                                });
                            });
                            n.walk(s);
                        });
                        if (r.rest) {
                            var i;
                            if (e) o = n.option("rests") && p(e, function(e) {
                                if (!(e instanceof jn)) return r;
                                for (var n = 0, t = r.elements.length; n < t; n++) {
                                    if (e.elements[n] instanceof $n) return r;
                                }
                                if (!i) i = Fe(jn, r, {});
                                i.elements = e.elements.slice(t);
                                return i;
                            });
                            r.rest.walk(s);
                        }
                        o = e;
                        return true;
                    }
                    if (r instanceof xr) {
                        O(r);
                        var e = o;
                        r.properties.forEach(function(r) {
                            O(r);
                            if (r.key instanceof mn) {
                                m(a);
                                r.key.walk(a);
                                _(a);
                            }
                            if (e) o = p(e, function(e) {
                                var n = r.key;
                                var t = On;
                                if (typeof n == "string") {
                                    if (ni(n)) {
                                        t = qn;
                                    } else {
                                        n = fe(n, r);
                                    }
                                }
                                return Fe(t, r, {
                                    expression: e,
                                    property: n
                                });
                            });
                            r.value.walk(s);
                        });
                        if (r.rest) {
                            o = false;
                            r.rest.walk(s);
                        }
                        o = e;
                        return true;
                    }
                    t(r, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        r.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                e.walk(s);
            }
            function q(i, e, n) {
                var a = this;
                a.inlined = false;
                var o = i.parent();
                var t = !St(a) && !Tt(a);
                var r = !t;
                var s = false;
                a.walk(new Un(function(e) {
                    if (r) return s = true;
                    if (e instanceof xn) return r = true;
                    if (e instanceof yn && e !== a) return true;
                }));
                if (s) m(i, t);
                d(i, n, a);
                var f = !a.uses_arguments || i.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var r = o.args[e];
                    D(i, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? r : o.args[e];
                        if (n instanceof An && n.expressions.length < 2) n = n.expressions[0];
                        return n || Fe(Gr, o);
                    }, p);
                });
                var u = a.rest, c;
                if (u) D(i, n, u, n.option("rests") && function() {
                    if (a.rest !== u) return u;
                    if (!c) c = Fe(jn, a, {});
                    c.elements = o.args.slice(a.argnames.length);
                    return c;
                }, p);
                At(a, i);
                var l = i.safe_ids;
                v(i, a);
                if (!s) i.safe_ids = l;
                return true;
                function p(e, n) {
                    var t = e.definition();
                    if (n && f && t.fixed === undefined) {
                        g(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(Pn, function(a, e, n) {
                var o = this;
                var s = o.left;
                var f = o.right;
                var t = s instanceof Yn && s.definition();
                var r = t || s instanceof Nn;
                switch (o.operator) {
                  case "=":
                    if (s.equals(f) && !s.has_side_effects(n)) {
                        f.walk(a);
                        l(s);
                        o.redundant = true;
                        return true;
                    }
                    if (t && f instanceof kt) {
                        p();
                        f.parent_scope.resolve().fn_defs.push(f);
                        f.safe_ids = null;
                        if (!t.fixed || !o.write_only) h(a, t, f);
                        return true;
                    }
                    if (r) {
                        f.walk(a);
                        p();
                        return true;
                    }
                    T(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    var i = true;

                  default:
                    if (!r) {
                        T(s);
                        return d();
                    }
                    t.assignments++;
                    var u = t.fixed;
                    if ($e(n, a, o, o, 0)) {
                        t.fixed = false;
                        return d();
                    }
                    var c = y(a, t);
                    if (i) m(a, true);
                    f.walk(a);
                    if (i) _(a);
                    if (c && !s.in_arg && w(a, t)) {
                        b(t, s);
                        g(a, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return Fe(Mn, o, {
                                operator: o.operator.slice(0, -1),
                                left: x(s, u),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !u || !u.assigns ? [ t.orig[0] ] : u.assigns.slice();
                        s.fixed.assigns.push(o);
                        s.fixed.to_binary = k(s, u);
                    } else {
                        s.walk(a);
                        t.fixed = false;
                    }
                    return true;
                }
                function l(e) {
                    O(e);
                    if (e instanceof qn) {
                        l(e.expression);
                    } else if (e instanceof On) {
                        l(e.expression);
                        e.property.walk(a);
                    } else if (e instanceof Yn) {
                        var n = e.definition();
                        b(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(a);
                    }
                }
                function p() {
                    var e = t && Ke(a, t);
                    var i = $e(n, a, o, f, 0, E(f), e);
                    D(a, n, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof Yn)) {
                            T(e);
                            t();
                            return;
                        }
                        var r = e.definition();
                        r.assignments++;
                        if (!n || e.in_arg || !w(a, r)) {
                            t();
                            r.fixed = false;
                        } else {
                            b(r, e);
                            g(a, r);
                            if (s instanceof Nn || r.orig.length == 1 && r.orig[0] instanceof Mr) {
                                r.single_use = false;
                            }
                            a.loop_ids[r.id] = a.in_loop;
                            r.fixed = i ? 0 : n;
                            e.fixed = n;
                            e.fixed.assigns = [ o ];
                            S(a, r, e.scope, o, f, 0, 1);
                        }
                    });
                }
                function d() {
                    if (!i) return;
                    s.walk(a);
                    m(a, true);
                    f.walk(a);
                    _(a);
                    return true;
                }
            });
            e(Mn, function(e) {
                if (!He[this.operator]) return;
                this.left.walk(e);
                m(e, true);
                this.right.walk(e);
                _(e);
                return true;
            });
            e(st, function(e, n, t) {
                s(e, t, this);
            });
            e(Tn, function(n, e) {
                var t = this;
                var r = t.expression;
                if (r instanceof kt) {
                    var i = Ve(t);
                    t.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof $n) i = false;
                    });
                    if (i) r.reduce_vars = q;
                    r.walk(n);
                    if (i) delete r.reduce_vars;
                    return true;
                }
                if (t.TYPE == "Call") switch (n.in_boolean_context()) {
                  case "d":
                    var a = true;

                  case true:
                    f(r, a);
                }
                r.walk(n);
                var o = t.optional;
                if (o) m(n, true);
                t.args.forEach(function(e) {
                    e.walk(n);
                });
                if (o) _(n);
                var s = r instanceof Yn && r.fixed_value();
                if (s instanceof wn) {
                    h(n, r.definition(), s);
                } else {
                    n.find_parent(yn).may_call_this();
                }
                return true;
                function f(e, n) {
                    if (e instanceof Pn) {
                        if (e.operator != "=") return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof Mn) {
                        if (!He[e.operator]) return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof Fn) {
                        f(e.consequent, n);
                        f(e.alternative, n);
                    } else if (e instanceof Yn) {
                        var t = e.definition();
                        t.bool_return++;
                        if (n) t.drop_return++;
                    }
                }
            });
            e(It, function(n, e, t) {
                var r = this;
                s(n, t, r);
                if (r.extends) r.extends.walk(n);
                var i = r.properties.filter(function(e) {
                    O(e);
                    if (e.key instanceof mn) e.key.walk(n);
                    return e.value;
                });
                if (r.name) {
                    var a = r.name.definition();
                    var o = n.parent();
                    if (o instanceof lr || o instanceof pr) a.single_use = false;
                    if (w(n, a, true)) {
                        g(n, a);
                        n.loop_ids[a.id] = n.in_loop;
                        a.fixed = function() {
                            return r;
                        };
                        a.fixed.assigns = [ r ];
                        if (!Ye(a)) a.single_use = false;
                    } else {
                        a.fixed = false;
                    }
                }
                i.forEach(function(e) {
                    if (!e.static || te(e) && e.value.contains_this()) {
                        m(n);
                        e.value.walk(n);
                        _(n);
                    } else {
                        e.value.walk(n);
                    }
                });
                return true;
            });
            e(wt, function(e, n, t) {
                var r = this;
                m(e, true);
                d(e, t, r);
                n();
                v(e, r);
                return true;
            });
            e(Fn, function(e) {
                this.condition.walk(e);
                m(e, true);
                this.consequent.walk(e);
                _(e);
                m(e, true);
                this.alternative.walk(e);
                _(e);
                return true;
            });
            e(Sn, function(e) {
                m(e, true);
                this.value.walk(e);
                _(e);
                this.name.walk(e);
                return true;
            });
            e(dt, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                m(e);
                this.body.walk(e);
                if (H(this, e.parent())) {
                    _(e);
                    m(e);
                }
                this.condition.walk(e);
                _(e);
                e.in_loop = n;
                return true;
            });
            e(vt, function(e, n, t) {
                var r = this;
                s(e, t, r);
                if (r.init) r.init.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                m(e);
                if (r.condition) r.condition.walk(e);
                r.body.walk(e);
                if (r.step) {
                    if (H(r, e.parent())) {
                        _(e);
                        m(e);
                    }
                    r.step.walk(e);
                }
                _(e);
                e.in_loop = i;
                return true;
            });
            e(mt, function(e, n, t) {
                var r = this;
                s(e, t, r);
                r.object.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                m(e);
                var a = r.init;
                if (a instanceof sr) {
                    a.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof qr) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, e);
                } else if (a instanceof Nn || a instanceof Yn) {
                    a.mark_symbol(function(e) {
                        if (e instanceof Yn) {
                            var n = e.definition();
                            b(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, e);
                } else {
                    a.walk(e);
                }
                r.body.walk(e);
                _(e);
                e.in_loop = i;
                return true;
            });
            e(kn, function(e) {
                this.condition.walk(e);
                m(e, true);
                this.body.walk(e);
                _(e);
                if (this.alternative) {
                    m(e, true);
                    this.alternative.walk(e);
                    _(e);
                }
                return true;
            });
            e(ct, function(e) {
                m(e, true);
                this.body.walk(e);
                _(e);
                return true;
            });
            e(wn, function(e, n, t) {
                var r = this;
                if (!o(e, r)) return true;
                if (!Qn(e.fn_visited, r)) return true;
                r.inlined = false;
                m(e);
                d(e, t, r);
                n();
                v(e, r);
                if (r.name) S(e, r.name.definition(), r, r.name, r, 0, 1);
                return true;
            });
            e(Mt, function(e, n, t) {
                var r = this;
                var i = r.name.definition();
                var a = e.parent();
                if (a instanceof lr || a instanceof pr) i.single_use = false;
                if (!o(e, r)) return true;
                if (!Qn(e.fn_visited, r)) return true;
                r.inlined = false;
                m(e);
                d(e, t, r);
                n();
                v(e, r);
                return true;
            });
            e(On, function(e) {
                if (!this.optional) return;
                this.expression.walk(e);
                m(e, true);
                this.property.walk(e);
                _(e);
                return true;
            });
            e(er, function(n, e, t) {
                var r = this;
                s(n, t, r);
                r.expression.walk(n);
                var i = true;
                r.body.forEach(function(e) {
                    if (e instanceof tr) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        m(n, true);
                    }
                });
                if (!i) _(n);
                ft(r, n);
                return true;
            });
            e(nr, function(e) {
                m(e, true);
                ft(this, e);
                _(e);
                return true;
            });
            e(jr, function() {
                this.definition().fixed = false;
            });
            e($r, function() {
                this.definition().fixed = false;
            });
            e(Yn, function(r, e, n) {
                var t = this;
                var i = t.definition();
                var a = i.fixed || i.last_ref && i.last_ref.fixed;
                b(i, t);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof Mr) {
                    r.loop_ids[i.id] = r.in_loop;
                }
                var o = Ke(r, i);
                if (o) o.enclosed.forEach(function(e) {
                    if (i === e) return;
                    if (e.scope.resolve() === o) return;
                    var n = e.fixed && e.fixed.assigns;
                    if (!n) return;
                    if (n[n.length - 1] instanceof En) return;
                    var t = r.safe_ids[e.id];
                    if (!t) return;
                    t.assign = true;
                });
                if (i.single_use == "m" && i.fixed) {
                    i.fixed = 0;
                    i.single_use = false;
                }
                switch (i.fixed) {
                  case 0:
                    if (!y(r, i)) i.fixed = false;

                  case false:
                    var s = i.redefined();
                    if (s && ne(i.scope, t.scope)) s.single_use = false;
                    break;

                  case undefined:
                    i.fixed = false;
                    break;

                  default:
                    if (!y(r, i)) {
                        i.fixed = false;
                        break;
                    }
                    if (t.in_arg && i.orig[0] instanceof Fr) t.fixed = i.scope;
                    var f = t.fixed_value();
                    if (o) {
                        i.recursive_refs++;
                    } else if (f && c(n, i)) {
                        i.in_loop = r.loop_ids[i.id] !== r.in_loop;
                        i.single_use = z(f) && !f.pinned() && (!i.in_loop || r.parent() instanceof Tn) || !i.in_loop && i.scope === t.scope.resolve() && f.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if ($e(n, r, t, f, 0, E(f), o)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = 0;
                        }
                    }
                    if (i.fixed && r.loop_ids[i.id] !== r.in_loop) i.cross_loop = true;
                    S(r, i, t.scope, t, f, 0, 1);
                    break;
                }
                if (!t.fixed) t.fixed = i.fixed === 0 ? a : i.fixed;
                var u;
                if (f instanceof wn && !((u = r.parent()) instanceof Tn && u.expression === t)) {
                    h(r, i, f);
                }
            });
            e(Br, function(n, e) {
                var t = this;
                var r = t.tag;
                if (!r) return;
                if (r instanceof kt) {
                    t.expressions.forEach(function(e) {
                        e.walk(n);
                    });
                    r.walk(n);
                    return true;
                }
                r.walk(n);
                t.expressions.forEach(function(e) {
                    e.walk(n);
                });
                var i = r instanceof Yn && r.fixed_value();
                if (i instanceof wn) {
                    h(n, r.definition(), i);
                } else {
                    n.find_parent(yn).may_call_this();
                }
                return true;
            });
            e(yt, function(n, e, t) {
                var r = this;
                r.globals.each(function(e) {
                    a(n, t, e);
                });
                m(n, true);
                d(n, t, r);
                e();
                v(n, r);
                return true;
            });
            e(ir, function(e, n, t) {
                var r = this;
                s(e, t, r);
                m(e, true);
                ft(r, e);
                _(e);
                if (r.bcatch) {
                    m(e, true);
                    r.bcatch.walk(e);
                    _(e);
                }
                if (r.bfinally) r.bfinally.walk(e);
                return true;
            });
            e(zn, function(e, n) {
                var t = this;
                if (!ii[t.operator]) return;
                var r = t.expression;
                if (!(r instanceof Yn)) {
                    T(r);
                    return;
                }
                var i = r.definition();
                i.assignments++;
                var a = i.fixed;
                if (y(e, i) && !r.in_arg && w(e, i)) {
                    b(i, r);
                    g(e, i);
                    if (i.single_use) i.single_use = false;
                    i.fixed = function() {
                        return Fe(Mn, t, {
                            operator: t.operator.slice(0, -1),
                            left: Fe(Cn, t, {
                                operator: "+",
                                expression: x(r, a)
                            }),
                            right: Fe(Ln, t, {
                                value: 1
                            })
                        });
                    };
                    i.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    i.fixed.assigns.push(t);
                    if (t instanceof Cn) {
                        r.fixed = i.fixed;
                    } else {
                        r.fixed = function() {
                            return Fe(Cn, t, {
                                operator: "+",
                                expression: x(r, a)
                            });
                        };
                        r.fixed.assigns = a && a.assigns;
                        r.fixed.to_prefix = k(r, i.fixed);
                    }
                } else {
                    r.walk(e);
                    i.fixed = false;
                }
                return true;
            });
            e(En, function(r, e, n) {
                var i = this;
                var t = i.value;
                if (t instanceof kt && i.name instanceof qr) {
                    o();
                    t.parent_scope.resolve().fn_defs.push(t);
                    t.safe_ids = null;
                    var a = i.name.definition();
                    if (!a.fixed) h(r, a, t);
                } else if (t) {
                    t.walk(r);
                    o();
                } else if (r.parent() instanceof ur) {
                    o();
                }
                return true;
                function o() {
                    D(r, n, i.name, function() {
                        return i.value || Fe(Gr, i);
                    }, function(e, n) {
                        var t = e.definition();
                        if (n && w(r, t, true)) {
                            g(r, t);
                            r.loop_ids[t.id] = r.in_loop;
                            t.fixed = n;
                            t.fixed.assigns = [ i ];
                            if (e instanceof Or && t.redefined() || !(Ce(e) || Ye(t))) {
                                t.single_use = false;
                            }
                        } else {
                            t.fixed = false;
                        }
                    });
                }
            });
            e(ht, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                m(e);
                n();
                _(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function O(e) {
            e._squeezed = false;
            e._optimized = false;
            if (e instanceof st) e._var_names = undefined;
            if (e instanceof Yn) e.fixed = undefined;
        }
        yt.DEFMETHOD("reset_opt_flags", function(t) {
            var r = new Un(t.option("reduce_vars") ? function(e, n) {
                O(e);
                return e.reduce_vars(r, n, t);
            } : O);
            r.fn_scanning = null;
            r.fn_visited = [];
            r.in_loop = null;
            r.loop_ids = Object.create(null);
            r.safe_ids = Object.create(null);
            r.safe_ids.seq = {};
            this.walk(r);
        });
        Dr.DEFMETHOD("fixed_value", function(e) {
            var n = this.definition();
            var t = n.fixed;
            if (t) {
                if (this.fixed) t = this.fixed;
                return (t instanceof mn ? t : t()).tail_node();
            }
            t = t === 0 && this.fixed;
            if (!t) return t;
            var r = (t instanceof mn ? t : t()).tail_node();
            if (e && n.escaped.depth != 1 && F(r, true)) return r;
            if (r.is_constant()) return r;
        });
        Yn.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            if (!(e.orig[0] instanceof Fr)) return false;
            if (e.orig.length == 1) return true;
            if (!this.in_arg) return false;
            return !(e.orig[1] instanceof Hn);
        });
        mn.DEFMETHOD("convert_symbol", Gn);
        function t(t, r) {
            return this.transform(new ei(function(e, n) {
                if (e instanceof Sn) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof Nn) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof wr) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, r);
            }));
        }
        Sn.DEFMETHOD("convert_symbol", t);
        Nn.DEFMETHOD("convert_symbol", t);
        function r(e, n) {
            var t = Fe(e, this);
            return n(t, this) || t;
        }
        qr.DEFMETHOD("convert_symbol", r);
        Yn.DEFMETHOD("convert_symbol", r);
        function j(e) {
            var n = e.definition();
            n.assignments++;
            n.references.push(e);
        }
        function i(n, t) {
            var r = new Un(function(e) {
                if (e instanceof Sn) {
                    e.value.walk(t);
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof wr) {
                    if (e.key instanceof mn) e.key.walk(t);
                    e.value.walk(r);
                    return true;
                }
                return n(e);
            });
            this.walk(r);
        }
        Sn.DEFMETHOD("mark_symbol", i);
        Nn.DEFMETHOD("mark_symbol", i);
        function a(e) {
            return e(this);
        }
        qr.DEFMETHOD("mark_symbol", a);
        Yn.DEFMETHOD("mark_symbol", a);
        mn.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        function o(n, t) {
            var r = false;
            var i = new Un(function(e) {
                if (r) return true;
                if (e instanceof Sn) {
                    if (!t) return r = true;
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof wr) {
                    if (!t && e.key instanceof mn) return r = true;
                    e.value.walk(i);
                    return true;
                }
                if (n(e)) return r = true;
            });
            this.walk(i);
            return r;
        }
        Sn.DEFMETHOD("match_symbol", o);
        Nn.DEFMETHOD("match_symbol", o);
        function Y(e) {
            return e instanceof Pt || e instanceof $t;
        }
        function Me(e) {
            var n = 0, t = e.self();
            do {
                if (t.variables) return t;
            } while (t = e.parent(n++));
        }
        function Le(e, n, t, r, i, a) {
            for (var o; o = e.parent(n++); t = o) {
                if (o === r) return false;
                if (a && o instanceof wn) {
                    if (o.name || St(o) || Tt(o)) return true;
                } else if (o instanceof ir) {
                    if (o.bfinally && o.bfinally !== t) return true;
                    if (i && o.bcatch && o.bcatch !== t) return true;
                }
            }
            return false;
        }
        var me = dn("Infinity NaN undefined");
        function Ue(e, n) {
            if (e instanceof Ir) return true;
            if (e instanceof Dn) {
                if (e.property === "__proto__") return true;
                e = e.expression;
                if (e instanceof Yn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.tail_node().is_constant()) return true;
                return Ue(e, n);
            }
            if (e instanceof Yn) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && me[t.name];
            }
            return false;
        }
        function Fe(e, n, t) {
            if (t) {
                t.start = n.start;
                t.end = n.end;
            } else {
                t = n;
            }
            return new e(t);
        }
        function Pe(e, n) {
            if (n.length == 1) return n[0];
            return Fe(An, e, {
                expressions: n.reduce(k, [])
            });
        }
        function fe(e, n) {
            switch (typeof e) {
              case "string":
                return Fe(Bn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return Fe(Wr, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? Fe(Cn, n, {
                        operator: "-",
                        expression: Fe(Ln, n, {
                            value: -e
                        })
                    }) : Fe(Ln, n, {
                        value: e
                    });
                }
                return e < 0 ? Fe(Cn, n, {
                    operator: "-",
                    expression: Fe(Xr, n)
                }) : Fe(Xr, n);

              case "boolean":
                return Fe(e ? Zr : Qr, n);

              case "undefined":
                return Fe(Gr, n);

              default:
                if (e === null) {
                    return Fe(Vr, n);
                }
                if (e instanceof RegExp) {
                    return Fe(Ur, n, {
                        value: e
                    });
                }
                throw new Error(Zn("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function _e(e) {
            return e instanceof Dn || Ne(e) && e.name == "eval";
        }
        function je(e, n, t) {
            var r = false;
            if (e.TYPE == "Call") {
                r = e.expression === n && _e(t);
            } else if (e instanceof Br) {
                r = e.tag === n && _e(t);
            } else if (e instanceof Cn) {
                r = e.operator == "delete" || e.operator == "typeof" && Ne(t);
            }
            return r ? Pe(n, [ Fe(Ln, n, {
                value: 0
            }), t ]) : t;
        }
        function R(e, n) {
            var r = new vn();
            e.walk(new Un(function(e) {
                if (!(e instanceof Yn)) return;
                var n = e.definition();
                var t = e.fixed;
                if (!t || !r.has(n.id)) {
                    r.set(n.id, t);
                } else if (r.get(n.id) !== t) {
                    r.set(n.id, false);
                }
            }));
            if (r.size() > 0) n.walk(new Un(function(e) {
                if (!(e instanceof Yn)) return;
                var n = e.definition();
                var t = e.fixed;
                if (!t || !r.has(n.id)) return;
                if (r.get(n.id) !== t) e.fixed = false;
            }));
            return n;
        }
        function k(e, n) {
            if (n instanceof An) {
                [].push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function V(e) {
            return e instanceof fr || e instanceof Ht || e instanceof ur;
        }
        function S(e) {
            if (e instanceof Mt) {
                var n = e.name.definition();
                var t = e.name.scope;
                return n.scope === t || hn(n.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !V(e);
        }
        function W(e) {
            if (e === null) return [];
            if (e instanceof bn) return hn(e.body, S) ? e.body : [ e ];
            if (e instanceof _n) return [];
            if (ot(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function ue(e) {
            if (e === null) return true;
            if (e instanceof _n) return true;
            if (e instanceof bn) return e.body.length == 0;
            return false;
        }
        function E(e) {
            return hn(e.body, function(e) {
                return ue(e) || e instanceof jt || e instanceof cr && ce(e);
            });
        }
        function G(e) {
            if (e instanceof lt) {
                return e.body instanceof bn ? e.body : e;
            }
            return e;
        }
        function ge(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof Dn);
            return e instanceof kt ? !Et(e) : ge(e);
        }
        function Ve(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof vr)) return true;
            var t = false;
            n.walk(new Un(function(e) {
                if (t) return true;
                if (e instanceof Rr) return t = true;
                if (e instanceof yn && e !== n) return true;
            }));
            return !t;
        }
        function Ne(e) {
            return e instanceof Yn && e.definition().undeclared;
        }
        var We = dn("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Map Math Number parseFloat parseInt RangeError ReferenceError RegExp Object Set setInterval setTimeout String SyntaxError TypeError unescape URIError WeakMap WeakSet");
        Yn.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && We[this.name];
        });
        function te(e) {
            return e.static && e.value && (e instanceof Bt || e instanceof Wt);
        }
        function ce(e) {
            return hn(e.definitions, function(e) {
                return !e.value;
            });
        }
        function B(e, n) {
            if (e instanceof Ht) return n && !e.extends && hn(e.properties, function(e) {
                if (e.key instanceof mn) return false;
                return !te(e);
            });
            if (e instanceof sr) return (n || e instanceof cr) && ce(e);
            if (e instanceof lr) return B(e.body, n);
            if (e instanceof pr) return B(e.body, n);
            return e instanceof Mt;
        }
        function T(e, n) {
            var t = e.lastIndexOf(n);
            if (t < 0) return false;
            while (++t < e.length) {
                if (!B(e[t], true)) return false;
            }
            return true;
        }
        function Ge(e, n) {
            var t;
            if (e.init instanceof bn) {
                t = e.init;
                e.init = t.body.pop();
                t.body.push(e);
            }
            if (e.init instanceof jt) {
                if (!t) t = Fe(bn, e, {
                    body: [ e ]
                });
                t.body.splice(-1, 0, e.init);
                e.init = null;
            } else if (e.init instanceof gn) {
                e.init = e.init.body;
            } else if (ue(e.init)) {
                e.init = null;
            }
            if (!t) return;
            return n ? Kn.splice(t.body) : t;
        }
        function l(e, s) {
            var I = H(s, function(e) {
                return e instanceof wn;
            });
            var Se, Te, Ae, De, qe, Oe;
            i();
            var n, t, r = 10;
            do {
                t = n;
                n = 0;
                if (o(e)) n = 1;
                if (!n && t == 1) break;
                if (s.option("dead_code")) {
                    if (u(e, s)) n = 2;
                    if (!n && t == 2) break;
                }
                if (s.option("if_return")) {
                    if (f(e, s)) n = 3;
                    if (!n && t == 3) break;
                }
                if (s.option("awaits") && s.option("side_effects")) {
                    if (c(e, s)) n = 4;
                    if (!n && t == 4) break;
                }
                if (s.option("inline") >= 4) {
                    if (l(e, s)) n = 5;
                    if (!n && t == 5) break;
                }
                if (s.sequences_limit > 0) {
                    if (p(e, s)) n = 6;
                    if (!n && t == 6) break;
                    if (h(e, s)) n = 7;
                    if (!n && t == 7) break;
                }
                if (s.option("join_vars")) {
                    if (w(e)) n = 8;
                    if (!n && t == 8) break;
                }
                if (s.option("collapse_vars")) {
                    if (a(e, s)) n = 9;
                }
            } while (n && r-- > 0);
            return e;
            function H(e, n) {
                var t = e.self(), r = 0, i;
                do {
                    if (t instanceof ar) {
                        t = e.parent(r++);
                    } else if (t instanceof ct) {
                        t = t.body;
                    } else if (t instanceof nr) {
                        var a = e.parent(r);
                        if (a.body[a.body.length - 1] === t || o(t.body)) {
                            r++;
                            t = a;
                        }
                    }
                    do {
                        i = t;
                        if (n(i)) return i;
                        t = e.parent(r++);
                    } while (t instanceof kn);
                } while (i && (t instanceof bn || t instanceof ar || t instanceof yn || t instanceof nr || t instanceof ir) && T(t.body, i));
                function o(e) {
                    for (var n = e.length; --n >= 0; ) {
                        if (e[n] instanceof Qt) return true;
                    }
                    return false;
                }
            }
            function i() {
                var e = s.self(), n = 0;
                do {
                    if (!Se && e.variables) Se = e;
                    if (e instanceof ar) {
                        if (s.parent(n).bfinally) {
                            if (!qe) qe = {};
                            qe.bfinally = true;
                        }
                        n++;
                    } else if (e instanceof or) {
                        n++;
                    } else if (e instanceof lt) {
                        De = true;
                    } else if (e instanceof yn) {
                        Oe = e;
                        break;
                    } else if (e instanceof ir) {
                        if (!qe) qe = {};
                        if (e.bcatch) qe.bcatch = true;
                        if (e.bfinally) qe.bfinally = true;
                    }
                } while (e = s.parent(n++));
            }
            function a(i, d) {
                if (Oe.pinned()) return;
                var h;
                var j = new vn();
                var v = [];
                var N = false;
                var p = new vn();
                var I;
                var a = i.length;
                var m = new ei(function(e, n) {
                    if (D) return e;
                    if (!A) {
                        if (e !== _[g]) return e;
                        g++;
                        if (g < _.length) return z(e, m);
                        A = true;
                        y = (b ? F : ie)(e, 0);
                        if (y === e) D = true;
                        return e;
                    }
                    var t = m.parent();
                    if (!w && ne(e, t)) {
                        w = t;
                    }
                    if (R && Y && O && !w && e instanceof Pn && e.operator != "=" && e.left.equals(x)) {
                        q++;
                        N = true;
                        mn.info("Cascading {this} [{start}]", e);
                        O = false;
                        S = _e(x);
                        e.right.transform(m);
                        he(f);
                        var r;
                        if (D) {
                            r = f;
                        } else {
                            D = true;
                            r = Fe(Mn, f, {
                                operator: R,
                                left: x.fixed && x.definition().fixed ? x.fixed.to_binary() : x,
                                right: T
                            });
                        }
                        return Fe(Pn, e, {
                            operator: "=",
                            left: e.left,
                            right: Fe(Mn, e, {
                                operator: e.operator.slice(0, -1),
                                left: r,
                                right: e.right
                            })
                        });
                    }
                    if (Z(e, t)) {
                        D = true;
                        return e;
                    }
                    if (e.single_use) return e;
                    var i;
                    if (!(e instanceof qr) && (Y && x.equals(e) || E && (i = E(e, this)))) {
                        if (!O || w && (i || !J || !K)) {
                            if (!i && !b) D = true;
                            return e;
                        }
                        if (ui(e, t)) {
                            if (b && !i) c = true;
                            return e;
                        }
                        if (!i && H && e.fixed !== x.fixed) {
                            D = true;
                            return e;
                        }
                        if (b) {
                            if (w && u == 0) u = l - q;
                            if (!i) q++;
                            return e;
                        }
                        q++;
                        N = D = true;
                        mn.info("Collapsing {this} [{start}]", e);
                        if (f.TYPE == "Binary") {
                            ve(f, e);
                            return Fe(Pn, f, {
                                operator: "=",
                                left: f.right.left,
                                right: f.operator == "&&" ? Fe(Fn, f, {
                                    condition: f.left,
                                    consequent: f.right.right,
                                    alternative: e
                                }) : Fe(Fn, f, {
                                    condition: f.left,
                                    consequent: e,
                                    alternative: f.right.right
                                })
                            });
                        }
                        if (f instanceof _r) return Fe(Cn, f, {
                            operator: f.operator,
                            expression: x.fixed && x.definition().fixed ? x.fixed.to_prefix() : x
                        });
                        if (f instanceof Cn) {
                            he(f);
                            return f;
                        }
                        ve(T, e);
                        if (f instanceof En) {
                            var a = f.name.definition();
                            if (a.references.length - a.replaced == 1 && !d.exposed(a)) {
                                a.replaced++;
                                return je(t, e, T);
                            }
                            return Fe(Pn, f, {
                                operator: "=",
                                left: e,
                                right: T
                            });
                        }
                        he(T);
                        var o = f.clone();
                        o.right = T;
                        return o;
                    }
                    if (ee(e, t)) {
                        D = true;
                        return e;
                    }
                    if (te(e, t) || L(e)) {
                        y = e;
                        if (e instanceof yn) D = true;
                    }
                    if (e instanceof xt) {
                        var s = O;
                        O = false;
                        n(e, m);
                        O = s;
                        return $(e);
                    }
                    if (e instanceof Nn) {
                        var s = O;
                        O = false;
                        n(e, m);
                        O = s;
                        return $(e);
                    }
                    if (e instanceof Sn) {
                        e.name = e.name.transform(m);
                        var s = O;
                        O = false;
                        e.value = e.value.transform(m);
                        O = s;
                        return $(e);
                    }
                    if (e instanceof st && !(e instanceof yn) && !(e.variables && e.variables.all(function(e) {
                        return !W.has(e.name) && !S.has(e.name);
                    }))) {
                        var s = O;
                        O = false;
                        if (!z(e, m)) n(e, m);
                        O = s;
                        return $(e);
                    }
                    if (z(e, m)) return $(e);
                }, $);
                var r = new ei(function(e) {
                    if (D) return e;
                    if (!A) {
                        if (e !== _[g]) return e;
                        g++;
                        switch (_.length - g) {
                          case 0:
                            A = true;
                            if (c) return e;
                            if (e !== f) return e;
                            if (e instanceof En) return e;
                            s.replaced++;
                            var n = r.parent();
                            if (n instanceof An && n.tail_node() !== e) {
                                b.replaced++;
                                if (T === o) return Kn.skip;
                                return Pe(o, o.expressions.slice(0, -1));
                            }
                            return T;

                          case 1:
                            if (!c && e.body === f) {
                                A = true;
                                s.replaced++;
                                b.replaced++;
                                return null;
                            }

                          default:
                            return z(e, r);
                        }
                    }
                    if (e instanceof Yn && e.definition() === s) {
                        if (ui(e, r.parent())) return e;
                        if (!--q) D = true;
                        mn.info("Replacing {this} [{start}]", e);
                        var t = T.clone();
                        t.scope = e.scope;
                        t.reference();
                        if (q == u) {
                            D = true;
                            return Fe(Pn, f, {
                                operator: "=",
                                left: e,
                                right: t
                            });
                        }
                        s.replaced++;
                        return t;
                    }
                    if (e instanceof tr || e instanceof yn) return e;
                }, function(e) {
                    return be(e, r);
                });
                while (--a >= 0) {
                    if (a == 0 && d.option("unused")) re();
                    var _ = [];
                    M(i[a]);
                    while (v.length > 0) {
                        _ = v.pop();
                        var g = 0;
                        var f = _[_.length - 1];
                        var u = -1;
                        var c = false;
                        var H = false;
                        var l;
                        var b = null;
                        var y = null;
                        var w = null;
                        var x = ue(f);
                        var k = x && x.has_side_effects(d);
                        var Y = x && (!k || x instanceof Yn) && !Ue(x, d);
                        var E = pe(f);
                        if (!Y && !E) continue;
                        var R = f instanceof Pn && f.operator.slice(0, -1);
                        var B = f.name instanceof Hn;
                        var L = ln;
                        if (f.may_throw(d)) {
                            if (B && St(Oe)) continue;
                            L = qe ? function(e) {
                                return e.has_side_effects(d);
                            } : t;
                        }
                        var U = false;
                        var V = false;
                        var W = new vn();
                        var G = true;
                        var S = _e(f);
                        var J = ye(x);
                        var o = ce(f);
                        var T = o;
                        if (!k) {
                            if (!R && T instanceof An) T = T.tail_node();
                            k = we();
                        }
                        var X = qe || !J ? function(e) {
                            return e instanceof Nn;
                        } : ln;
                        var K = xe(f);
                        var A = B;
                        var D = false;
                        var q = 0;
                        var O = !h || !A;
                        if (!O) {
                            for (var n = f.arg_index + 1; !D && n < h.length; n++) {
                                if (h[n]) h[n].transform(m);
                            }
                            O = true;
                        }
                        for (var e = a; !D && e < i.length; e++) {
                            i[e].transform(m);
                        }
                        if (b) {
                            if (!q || l > q + c) {
                                v.push(_);
                                I = true;
                                continue;
                            }
                            if (q == u) c = true;
                            var s = x.definition();
                            D = false;
                            g = 0;
                            A = B;
                            for (var e = a; !D && e < i.length; e++) {
                                if (!i[e].transform(r)) i.splice(e--, 1);
                            }
                            q = f instanceof En && f === _[_.length - 1] && s.references.length == s.replaced && !d.exposed(s);
                            b.last_ref = false;
                            b.single_use = false;
                            N = true;
                        }
                        if (q) ge(f);
                    }
                }
                return N;
                function $(e) {
                    if (D) return e;
                    if (y === e) D = true;
                    if (w === e) w = null;
                    return e;
                }
                function z(e, n) {
                    if (!(e instanceof st)) return;
                    if (e instanceof yn) return e;
                    if (e instanceof It) {
                        if (e.name) e.name = e.name.transform(n);
                        if (!D && e.extends) e.extends = e.extends.transform(n);
                        var t = [], r = [];
                        for (var i = 0; !D && i < e.properties.length; i++) {
                            var a = e.properties[i];
                            if (a.key instanceof mn) a.key = a.key.transform(n);
                            if (!a.static) continue;
                            if (a instanceof Bt) {
                                if (a.value) t.push(a);
                            } else if (a instanceof Wt) {
                                [].push.apply(r, a.value.body);
                            }
                        }
                        for (var i = 0; !D && i < r.length; i++) {
                            r[i].transform(n);
                        }
                        for (var i = 0; !D && i < t.length; i++) {
                            var a = t[i];
                            a.value = a.value.transform(n);
                        }
                        return e;
                    }
                    if (e instanceof mt) {
                        e.object = e.object.transform(n);
                        D = true;
                        return e;
                    }
                    if (e instanceof er) {
                        e.expression = e.expression.transform(n);
                        for (var i = 0; !D && i < e.body.length; i++) {
                            var o = e.body[i];
                            if (o instanceof rr) {
                                if (!A) {
                                    if (o !== _[g]) continue;
                                    g++;
                                }
                                o.expression = o.expression.transform(n);
                                if (!K) break;
                                E = false;
                            }
                        }
                        D = true;
                        return e;
                    }
                }
                function Q(e, n) {
                    if (n instanceof Pn) return n.operator == "=" && n.left === e;
                    if (n instanceof Sn) return n.name === e;
                    if (n instanceof yr) return true;
                    if (n instanceof wr) return n.value === e;
                }
                function Z(e, n) {
                    if (e === T) return true;
                    if (n instanceof vt) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof Pn) {
                        return e.operator != "=" && x.equals(e.left);
                    }
                    if (e instanceof Tn) {
                        if (!(x instanceof Dn)) return false;
                        if (!x.equals(e.expression)) return false;
                        return !(T instanceof kt && !T.contains_this());
                    }
                    if (e instanceof It) return !d.has_directive("use strict");
                    if (e instanceof it) return true;
                    if (e instanceof jt) return B && x.name === e.name.name;
                    if (e instanceof wr) return e.key instanceof mn;
                    if (e instanceof pt) return true;
                    if (e instanceof Kt) return true;
                    if (e instanceof ir) return true;
                    if (e instanceof bt) return true;
                    return false;
                }
                function ee(e, n) {
                    if (!(e instanceof Yn)) return false;
                    if (e.is_declared(d)) {
                        if (e.fixed_value()) return false;
                        if (Ce(e)) {
                            return !(n instanceof Dn && n.expression === e) && ze(e.definition());
                        }
                    } else if (Q(e, n)) {
                        return false;
                    }
                    if (!K) return true;
                    E = false;
                    return false;
                }
                function ne(e, n) {
                    if (n instanceof Pn) return n.left !== e && He[n.operator.slice(0, -1)];
                    if (n instanceof Mn) return n.left !== e && He[n.operator];
                    if (n instanceof Tn) return n.optional && n.expression !== e;
                    if (n instanceof rr) return n.expression !== e;
                    if (n instanceof Fn) return n.condition !== e;
                    if (n instanceof kn) return n.condition !== e;
                    if (n instanceof On) return n.optional && n.expression !== e;
                }
                function te(e, n) {
                    if (e instanceof gr) return true;
                    if (e.TYPE == "Binary") return !Xe(e.operator, e.right, d);
                    if (e instanceof Tn) {
                        var t, r = e.expression;
                        if (r instanceof Yn) {
                            t = r.definition();
                            r = r.fixed_value();
                        }
                        if (!(r instanceof wn)) return !e.is_expr_pure(d);
                        if (t && Ke(d, t, r)) return true;
                        if (r.collapse_scanning) return false;
                        r.collapse_scanning = true;
                        var i = O;
                        O = false;
                        var a = y;
                        var o = w;
                        for (var s = 0; !D && s < r.argnames.length; s++) {
                            if (C(p, r.argnames[s], e.args[s])) D = true;
                        }
                        if (!D) {
                            if (r.rest && C(p, r.rest, Fe(jn, e, {
                                elements: e.args.slice(s)
                            }))) {
                                D = true;
                            } else if (Et(r) && r.value) {
                                r.value.transform(m);
                            } else for (var s = 0; !D && s < r.body.length; s++) {
                                var f = r.body[s];
                                if (f instanceof xn) {
                                    if (f.value) f.value.transform(m);
                                    break;
                                }
                                f.transform(m);
                            }
                        }
                        w = o;
                        y = a;
                        O = i;
                        r.collapse_scanning = false;
                        if (!D) return false;
                        D = false;
                        return true;
                    }
                    if (e instanceof It) {
                        if (!qe) return false;
                        var u = e.extends;
                        if (!u) return false;
                        if (u instanceof Yn) u = u.fixed_value();
                        return !Re(u);
                    }
                    if (e instanceof Jt) {
                        if (qe) {
                            if (qe.bfinally) return true;
                            if (qe.bcatch && e instanceof Xt) return true;
                        }
                        return k || x instanceof Dn || Ee(x);
                    }
                    if (e instanceof zt) {
                        return d.option("ie") && e.name && S.has(e.name.name);
                    }
                    if (e instanceof Ir) return ke(e, n);
                    if (e instanceof Dn) {
                        if (k) return true;
                        var c = e.expression;
                        if (c instanceof Yn && ze(c.definition())) return true;
                        if (d.option("unsafe")) {
                            if (Ne(c) && We[c.name]) return false;
                            if (Je(c)) return false;
                        }
                        if (!G) return true;
                        if (b) return false;
                        if (!qe && J) return false;
                        if (e.optional) return false;
                        return c.may_throw_on_access(d);
                    }
                    if (e instanceof $n) return true;
                    if (e instanceof Yn) {
                        if (ke(e, n)) return !Q(e, n);
                        if (k && Ee(e)) return true;
                        var t = e.definition();
                        return (qe || t.scope.resolve() !== Oe) && !Ce(e);
                    }
                    if (e instanceof Br) return !e.is_expr_pure(d);
                    if (e instanceof En) {
                        if (X(e.name)) return true;
                        return (e.value || n instanceof ur) && e.name.match_symbol(function(e) {
                            return e instanceof qr && (S.has(e.name) || k && Ee(e));
                        }, true);
                    }
                    if (e instanceof br) return true;
                    var l = ui(e.left, e);
                    if (!l) return false;
                    if (l instanceof Dn) return true;
                    if (X(l)) return true;
                    return l.match_symbol(function(e) {
                        return e instanceof Yn && (S.has(e.name) || U && d.exposed(e.definition()));
                    }, true);
                    function p(e) {
                        e.transform(m);
                        return D;
                    }
                }
                function C(t, e, r) {
                    if (e instanceof Sn) {
                        return t(e.value) || C(t, e.name, e.value) || !Ie(r) && C(t, e.name, r);
                    }
                    if (!r) return !(e instanceof Dr);
                    if (e instanceof Nn) {
                        if (e.rest && C(t, e.rest)) return true;
                        if (e instanceof yr) {
                            if (r instanceof jn) return !hn(e.elements, function(e, n) {
                                return !C(t, e, r[n]);
                            });
                            if (!r.is_string(d)) return true;
                            return !hn(e.elements, function(e) {
                                return !C(t, e);
                            });
                        }
                        if (e instanceof xr) {
                            if (r.may_throw_on_access(d)) return true;
                            return !hn(e.properties, function(e) {
                                if (e.key instanceof mn && t(e.key)) return false;
                                return !C(t, e.value);
                            });
                        }
                    }
                }
                function re() {
                    if (Ae === false) return;
                    var e = d.parent(), i = d.self();
                    if (Ae === undefined) {
                        if (!(i instanceof kt) || Tt(i) || i.uses_arguments || i.pinned() || !(e instanceof Tn) || e.expression !== i || !hn(e.args, function(e) {
                            return !(e instanceof $n);
                        })) {
                            Ae = false;
                            return;
                        }
                        if (!Ve(e)) return;
                        Ae = true;
                    }
                    var a = i.in_strict_mode(d) && !i.parent_scope.resolve(true).in_strict_mode(d);
                    var o;
                    if (St(i)) {
                        o = function(e) {
                            return e instanceof Dr && e.name == "await";
                        };
                        Te = true;
                    } else {
                        o = function(e) {
                            return e instanceof gr && !n.find_parent(yn);
                        };
                        if (Te === undefined) Te = Le(d, 1, e, null, true, true);
                    }
                    var s = null;
                    var n = new Un(function(e, n) {
                        if (!c) return true;
                        if (o(e) || e instanceof br) {
                            c = null;
                            return true;
                        }
                        if (e instanceof Ir) {
                            if (a || !s) c = null;
                            return true;
                        }
                        if (e instanceof Yn) {
                            var t;
                            if (e.in_arg && !Ye(e.definition()) || (t = i.variables.get(e.name)) && t !== e.definition()) {
                                c = null;
                            }
                            return true;
                        }
                        if (e instanceof yn && !Et(e)) {
                            var r = s;
                            s = e;
                            n();
                            s = r;
                            return true;
                        }
                    });
                    h = e.args.slice();
                    var t = h.length;
                    var r = new vn();
                    for (var f = i.argnames.length; --f >= 0; ) {
                        var u = i.argnames[f];
                        var c = h[f];
                        var l = null;
                        if (u instanceof Sn) {
                            l = u.value;
                            u = u.name;
                            h[t + f] = l;
                        }
                        if (u instanceof Nn) {
                            if (Te && C(function(e) {
                                return e.has_side_effects(d);
                            }, u, c)) {
                                v.length = 0;
                                break;
                            }
                            h[t + f] = i.argnames[f];
                            continue;
                        }
                        if (r.has(u.name)) continue;
                        r.set(u.name, true);
                        if (l) c = Ie(c) ? l : null;
                        if (!c && !l) {
                            c = Fe(Gr, u).transform(d);
                        } else if (c instanceof wn && c.pinned()) {
                            c = null;
                        } else if (c) {
                            c.walk(n);
                        }
                        if (!c) continue;
                        var p = Fe(En, u, {
                            name: u,
                            value: c
                        });
                        p.name_index = f;
                        p.arg_index = l ? t + f : f;
                        v.unshift([ p ]);
                    }
                    if (i.rest) h.push(i.rest);
                }
                function M(e, n) {
                    _.push(e);
                    if (e instanceof jn) {
                        e.elements.forEach(function(e) {
                            M(e, n);
                        });
                    } else if (e instanceof Pn) {
                        var t = e.left;
                        if (!(t instanceof Nn)) v.push(_.slice());
                        M(t);
                        M(e.right);
                        if (t instanceof Yn && e.operator == "=") {
                            j.set(t.name, (j.get(t.name) || 0) + 1);
                        }
                    } else if (e instanceof gr) {
                        M(e.expression, n);
                    } else if (e instanceof Mn) {
                        var r = He[e.operator];
                        if (n && r && e.operator != "??" && e.right instanceof Pn && e.right.operator == "=" && !(e.right.left instanceof Nn)) {
                            v.push(_.slice());
                        }
                        M(e.left, !r && n);
                        M(e.right, n);
                    } else if (e instanceof Tn) {
                        M(e.expression);
                        e.args.forEach(M);
                    } else if (e instanceof rr) {
                        M(e.expression);
                    } else if (e instanceof Fn) {
                        M(e.condition);
                        M(e.consequent, n);
                        M(e.alternative, n);
                    } else if (e instanceof sr) {
                        e.definitions.forEach(M);
                    } else if (e instanceof qn) {
                        M(e.expression);
                    } else if (e instanceof pt) {
                        M(e.condition);
                        if (!(e.body instanceof ut)) {
                            M(e.body);
                        }
                    } else if (e instanceof Jt) {
                        if (e.value) M(e.value);
                    } else if (e instanceof vt) {
                        if (e.init) M(e.init, true);
                        if (e.condition) M(e.condition);
                        if (e.step) M(e.step, true);
                        if (!(e.body instanceof ut)) {
                            M(e.body);
                        }
                    } else if (e instanceof mt) {
                        M(e.object);
                        if (!(e.body instanceof ut)) {
                            M(e.body);
                        }
                    } else if (e instanceof kn) {
                        M(e.condition);
                        if (!(e.body instanceof ut)) {
                            M(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof ut)) {
                            M(e.alternative);
                        }
                    } else if (e instanceof In) {
                        e.properties.forEach(function(e) {
                            _.push(e);
                            if (e.key instanceof mn) M(e.key);
                            if (e instanceof Er) M(e.value, n);
                            _.pop();
                        });
                    } else if (e instanceof An) {
                        var i = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            M(e, n < i);
                        });
                    } else if (e instanceof gn) {
                        M(e.body, true);
                    } else if (e instanceof $n) {
                        M(e.expression);
                    } else if (e instanceof On) {
                        M(e.expression);
                        M(e.property);
                    } else if (e instanceof er) {
                        M(e.expression);
                        e.body.forEach(M);
                    } else if (e instanceof zn) {
                        if (ii[e.operator]) {
                            v.push(_.slice());
                        } else {
                            M(e.expression);
                        }
                    } else if (e instanceof En) {
                        if (e.name instanceof Cr) {
                            if (e.value) {
                                var a = e.name.definition();
                                if (a.references.length > a.replaced) {
                                    v.push(_.slice());
                                }
                            } else {
                                p.set(e.name.name, (p.get(e.name.name) || 0) + 1);
                            }
                        }
                        if (e.value) M(e.value);
                    } else if (e instanceof br) {
                        if (e.expression) M(e.expression);
                    }
                    _.pop();
                }
                function ie(e, n) {
                    var t = m.parent(n);
                    if (t instanceof jn) return e;
                    if (t instanceof Pn) return e;
                    if (t instanceof gr) return e;
                    if (t instanceof Mn) return e;
                    if (t instanceof Tn) return e;
                    if (t instanceof rr) return e;
                    if (t instanceof Fn) return e;
                    if (t instanceof sr) return P(t, n + 1);
                    if (t instanceof Jt) return e;
                    if (t instanceof kn) return e;
                    if (t instanceof lt) return e;
                    if (t instanceof kr) return e;
                    if (t instanceof Dn) return e;
                    if (t instanceof An) {
                        return (t.tail_node() === e ? ie : P)(t, n + 1);
                    }
                    if (t instanceof gn) return P(t, n + 1);
                    if (t instanceof $n) return e;
                    if (t instanceof er) return e;
                    if (t instanceof zn) return e;
                    if (t instanceof En) return e;
                    if (t instanceof br) return e;
                    return null;
                }
                function ae(e, n, t) {
                    var r;
                    do {
                        r = e;
                        e = m.parent(++t);
                    } while (e instanceof Pn && e.operator.slice(0, -1) == n || e instanceof Mn && e.operator == n);
                    return r;
                }
                function oe(e, n, t, r, i) {
                    var a = O;
                    O = false;
                    var o = y;
                    var s = w;
                    var f = m.stack;
                    m.stack = [ r ];
                    e.transform(m);
                    m.stack = f;
                    w = s;
                    y = o;
                    O = a;
                    if (D) {
                        D = false;
                        return t;
                    }
                    return n(r, i + 1);
                }
                function F(e, n) {
                    var t = m.parent(n);
                    if (t instanceof jn) return F(t, n + 1);
                    if (t instanceof Pn) {
                        if (L(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof Yn && (x.name == e.name || b.name == e.name);
                        })) return e;
                        var r;
                        if (t.left === e || !He[r = t.operator.slice(0, -1)]) {
                            return F(t, n + 1);
                        }
                        return ae(t, r, n);
                    }
                    if (t instanceof gr) return F(t, n + 1);
                    if (t instanceof Mn) {
                        var r;
                        if (t.left === e || !He[r = t.operator]) {
                            return F(t, n + 1);
                        }
                        return ae(t, r, n);
                    }
                    if (t instanceof Tn) return t;
                    if (t instanceof rr) {
                        if (t.expression !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof Fn) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof sr) return P(t, n + 1);
                    if (t instanceof dt) return e;
                    if (t instanceof Jt) return P(t, n + 1);
                    if (t instanceof vt) {
                        if (t.init !== e && t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof mt) {
                        if (t.init !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof kn) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof kr) {
                        var i = m.parent(n + 1);
                        return hn(i.properties, function(e) {
                            return e instanceof Er;
                        }) ? F(i, n + 2) : i;
                    }
                    if (t instanceof Dn) {
                        var a = t.expression;
                        return a === e ? F(t, n + 1) : e;
                    }
                    if (t instanceof An) {
                        return (t.tail_node() === e ? F : P)(t, n + 1);
                    }
                    if (t instanceof gn) return P(t, n + 1);
                    if (t instanceof $n) return F(t, n + 1);
                    if (t instanceof er) {
                        if (t.expression !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof zn) {
                        if (t.operator == "delete") return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof En) return t.name.match_symbol(function(e) {
                        return e instanceof qr && (x.name == e.name || b.name == e.name);
                    }) ? e : F(t, n + 1);
                    if (t instanceof ht) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof br) return F(t, n + 1);
                    return null;
                }
                function P(n, t) {
                    var r = m.parent(t);
                    if (te(n, r)) return n;
                    if (ne(n, r)) return n;
                    if (r instanceof jn) return P(r, t + 1);
                    if (r instanceof Pn) return a(r.left);
                    if (r instanceof gr) return n;
                    if (r instanceof Mn) return P(r, t + 1);
                    if (r instanceof Tn) return P(r, t + 1);
                    if (r instanceof rr) return P(r, t + 1);
                    if (r instanceof Fn) return P(r, t + 1);
                    if (r instanceof sr) return P(r, t + 1);
                    if (r instanceof Jt) return P(r, t + 1);
                    if (r instanceof kn) return P(r, t + 1);
                    if (r instanceof lt) return n;
                    if (r instanceof kr) {
                        var e = m.parent(t + 1);
                        return hn(e.properties, function(e) {
                            return e instanceof Er;
                        }) ? P(e, t + 2) : e;
                    }
                    if (r instanceof Dn) {
                        var i = r.expression;
                        if (i === n) return P(r, t + 1);
                        return oe(i, P, n, r, t);
                    }
                    if (r instanceof An) return P(r, t + 1);
                    if (r instanceof gn) return P(r, t + 1);
                    if (r instanceof $n) return n;
                    if (r instanceof er) return P(r, t + 1);
                    if (r instanceof zn) return P(r, t + 1);
                    if (r instanceof En) return a(r.name);
                    if (r instanceof br) return n;
                    return null;
                    function a(e) {
                        if (L(r)) return n;
                        if (e !== n && e instanceof Nn) {
                            return oe(e, P, n, r, t);
                        }
                        return P(r, t + 1);
                    }
                }
                function se(e) {
                    if (I) {
                        I = false;
                        return;
                    }
                    if (l < 1) return;
                    e = e.tail_node();
                    var n = e instanceof Pn && e.operator == "=" ? e.left : e;
                    if (!(n instanceof Yn)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if (ze(t)) return;
                    if (n !== e) {
                        if (Ue(n, d)) return;
                        var r = t.references.length - t.replaced;
                        if (r < 2) return;
                        var i = f.clone();
                        i[i instanceof Pn ? "right" : "value"] = n;
                        if (f.name_index >= 0) {
                            i.name_index = f.name_index;
                            i.arg_index = f.arg_index;
                        }
                        f = i;
                    }
                    return b = t;
                }
                function fe(e) {
                    return e.references.length - e.replaced - (j.get(e.name) || 0);
                }
                function ue(t) {
                    if (t instanceof Pn) {
                        var r = t.left;
                        if (!(r instanceof Yn)) return r;
                        var e = r.definition();
                        if (Oe.uses_arguments && si(e)) return r;
                        if (d.exposed(e)) return r;
                        l = fe(e);
                        if (e.fixed && r.fixed) {
                            var n = e.references.filter(function(e) {
                                return e.fixed === r.fixed;
                            }).length - 1;
                            if (n < l) {
                                l = n;
                                u = 0;
                                H = true;
                            }
                        }
                        if (t.operator == "=") se(t.right);
                        return r;
                    }
                    if (t instanceof Mn) return t.right.left;
                    if (t instanceof zn) return t.expression;
                    if (t instanceof En) {
                        var r = t.name;
                        var e = r.definition();
                        if (e.const_redefs) return;
                        if (!Vn(r, e.orig)) return;
                        if (Oe.uses_arguments && si(e)) return;
                        var i = e.orig.length - e.eliminated - (p.get(e.name) || 0);
                        l = fe(e);
                        if (e.fixed) l = Math.min(l, e.references.filter(function(e) {
                            if (!e.fixed) return true;
                            if (!e.fixed.assigns) return true;
                            var n = e.fixed.assigns[0];
                            return n === r || ce(n) === t.value;
                        }).length);
                        if (i > 1 && !(r instanceof Hn)) {
                            se(t.value);
                            return Fe(Yn, r);
                        }
                        if (se(t.value) || l == 1 && !d.exposed(e)) {
                            return Fe(Yn, r);
                        }
                        return;
                    }
                }
                function ce(e) {
                    if (e instanceof Pn) return e.right;
                    if (e instanceof Mn) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof En) return e.value;
                }
                function le(e) {
                    if (e instanceof jn) return false;
                    if (e instanceof Mn && He[e.operator]) {
                        return le(e.left) && le(e.right);
                    }
                    if (e instanceof Tn) return false;
                    if (e instanceof Fn) {
                        return le(e.consequent) && le(e.alternative);
                    }
                    if (e instanceof In) return false;
                    return !e.has_side_effects(d);
                }
                function pe(n) {
                    if (n instanceof Pn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Un(function(e) {
                        if (e instanceof Yn) t[e.definition().id] = true;
                    });
                    while (n instanceof Pn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof Ir) return o;
                    if (n instanceof Yn) {
                        var r = n.evaluate(d);
                        if (r === n) return o;
                        return de(r, o);
                    }
                    if (n.is_truthy()) return de(true, ln);
                    if (n.is_constant()) {
                        var i = n.evaluate(d);
                        if (!(i instanceof mn)) return de(i, o);
                    }
                    if (!(x instanceof Yn)) return false;
                    if (!le(n)) return false;
                    var a;
                    n.walk(new Un(function(e) {
                        if (a) return true;
                        if (e instanceof Yn && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equals(e);
                    }
                }
                function de(r, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (r && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof mn)) return !t == !r;
                            }
                        }
                        return i(e);
                    };
                }
                function he(e) {
                    while (e.write_only) {
                        e.write_only = false;
                        if (!(e instanceof Pn)) break;
                        e = e.right;
                    }
                }
                function ve(e, n) {
                    var t = n.scope || Me(m) || Se;
                    e.walk(new Un(function(e) {
                        if (e instanceof st) return true;
                        if (e instanceof Dr) e.scope = t;
                    }));
                }
                function me(e) {
                    if (e instanceof Yn) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Pn) return e.operator == "=" && me(e.right);
                    return e instanceof Dn || e instanceof Ir;
                }
                function _e(f) {
                    var u = new vn();
                    if (f instanceof En) {
                        if (!f.name.definition().fixed) G = false;
                        u.add(f.name.name, x);
                    }
                    var c = Oe.uses_arguments && !d.has_directive("use strict");
                    var l = Oe instanceof yt;
                    var p = new Un(function(n) {
                        var e;
                        if (n instanceof Yn) {
                            e = n.fixed_value();
                            if (!e) {
                                e = n;
                                var t = n.definition();
                                var r = n.fixed && n.fixed.escaped || t.escaped;
                                if (!t.undeclared && (t.assignments || !r || r.cross_scope) && (Be(t, n.scope, n, p.parent()) || !Qe(t))) {
                                    G = false;
                                }
                            }
                        } else if (n instanceof Ir) {
                            e = n;
                        }
                        if (e) {
                            u.add(n.name, $e(d, p, n, e, 0));
                        } else if (n instanceof wn) {
                            for (var i = 0, a, o = n; a = p.parent(i++); o = a) {
                                if (a instanceof Pn) {
                                    if (a.left === o) break;
                                    if (a.operator == "=") continue;
                                    if (He[a.operator.slice(0, -1)]) continue;
                                    break;
                                }
                                if (a instanceof Mn) {
                                    if (He[a.operator]) continue;
                                    break;
                                }
                                if (a instanceof Tn) return;
                                if (a instanceof yn) return;
                                if (a instanceof An) {
                                    if (a.tail_node() === o) continue;
                                    break;
                                }
                                if (a instanceof Br) {
                                    if (a.tag) return;
                                    break;
                                }
                            }
                            n.enclosed.forEach(function(e) {
                                if (e.scope !== n) W.set(e.name, true);
                            });
                            return true;
                        } else if (c && n instanceof On) {
                            Oe.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    if (!e.definition().fixed) G = false;
                                    u.add(e.name, true);
                                }
                            });
                            c = false;
                        }
                        if (!l) return;
                        if (n.TYPE == "Call") {
                            if (V) return;
                            var s = n.expression;
                            if (s instanceof Dn) return;
                            if (s instanceof kt && !s.contains_this()) return;
                            V = true;
                        } else if (n instanceof Dn && me(n.expression)) {
                            if (n === x && !(f instanceof zn)) {
                                V = true;
                            } else {
                                U = true;
                            }
                        }
                    });
                    f.walk(p);
                    return u;
                }
                function ge(e) {
                    var f = T === o ? null : Pe(o, o.expressions.slice(0, -1));
                    var n = e.name_index;
                    if (n >= 0) {
                        var t, r = Oe.argnames[n];
                        if (r instanceof Sn) {
                            Oe.argnames[n] = r = r.clone();
                            r.value = f || Fe(Ln, r, {
                                value: 0
                            });
                        } else if ((t = d.parent().args)[n]) {
                            Oe.argnames[n] = r.clone();
                            t[n] = f || Fe(Ln, t[n], {
                                value: 0
                            });
                        }
                        return;
                    }
                    var u = _.length - 1;
                    var c = _[u];
                    if (c instanceof En || _[u - 1].body === c) u--;
                    var l = new ei(function(e, n, t) {
                        if (A) return e;
                        if (e !== _[g]) return e;
                        g++;
                        if (g <= u) return z(e, l);
                        A = true;
                        if (e instanceof sr) {
                            p.set(c.name.name, (p.get(c.name.name) || 0) + 1);
                            if (b) b.replaced++;
                            var r = e.definitions;
                            var i = r.indexOf(c);
                            var a = c.clone();
                            a.value = null;
                            if (!f) {
                                e.definitions[i] = a;
                                return e;
                            }
                            var o = [ Fe(gn, f, {
                                body: f
                            }) ];
                            if (i > 0) {
                                var s = e.clone();
                                s.definitions = r.slice(0, i);
                                o.unshift(s);
                                e = e.clone();
                                e.definitions = r.slice(i);
                            }
                            o.push(e);
                            e.definitions[0] = a;
                            return t ? Kn.splice(o) : Fe(bn, e, {
                                body: o
                            });
                        }
                        if (!f) return t ? Kn.skip : null;
                        return ot(e) ? Fe(gn, f, {
                            body: f
                        }) : f;
                    }, function(e, n) {
                        if (e instanceof vt) return Ge(e, n);
                        return be(e, l);
                    });
                    D = false;
                    A = false;
                    g = 0;
                    if (!(i[a] = i[a].transform(l))) i.splice(a, 1);
                }
                function be(e, n) {
                    if (e instanceof An) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return je(n.parent(), e, e.expressions[0]);
                    }
                }
                function ye(e) {
                    var n = mr(e);
                    if (!(n instanceof Yn)) return false;
                    if (n.definition().scope.resolve() !== Oe) return false;
                    if (!De) return true;
                    if (R) return false;
                    if (f instanceof zn) return false;
                    var t = S.get(n.name);
                    return !t || t[0] === e;
                }
                function we() {
                    if (f instanceof zn) return false;
                    return T.has_side_effects(d);
                }
                function xe(e) {
                    if (e instanceof zn) return false;
                    if (k) return false;
                    if (b) return true;
                    if (!(x instanceof Yn)) return false;
                    var n;
                    if (e instanceof En) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = x.definition();
                    if (t.references.length - t.replaced == n) return true;
                    if (!t.fixed) return false;
                    if (!x.fixed) return false;
                    var r = x.fixed.assigns;
                    var i = 0;
                    if (!hn(t.references, function(e, n) {
                        var t = e.fixed;
                        if (!t) return false;
                        if (t.to_binary || t.to_prefix) return false;
                        if (t === x.fixed) {
                            i++;
                            return true;
                        }
                        return r && t.assigns && r[0] !== t.assigns[0];
                    })) return false;
                    if (i != n) return false;
                    H = true;
                    return true;
                }
                function ke(e, n) {
                    var t = S.get(e.name);
                    if (!t || hn(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== x) return true;
                    E = false;
                }
                function Ee(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof Mr) return false;
                    if (n.scope.resolve() !== Oe) return true;
                    if (V && d.exposed(n)) return true;
                    return !hn(n.references, function(e) {
                        return e.scope.resolve(true) === Oe;
                    });
                }
                function t(e, n) {
                    if (e instanceof Pn) return t(e.left, true);
                    if (e instanceof zn) return t(e.expression, true);
                    if (e instanceof En) return e.value && t(e.value);
                    if (n) {
                        if (e instanceof qn) return t(e.expression, true);
                        if (e instanceof On) return t(e.expression, true);
                        if (e instanceof Yn) return e.definition().scope.resolve() !== Oe;
                    }
                    return false;
                }
            }
            function o(e) {
                var n = false, t = [];
                for (var r = 0; r < e.length; ) {
                    var i = e[r];
                    if (i instanceof bn) {
                        if (hn(i.body, S)) {
                            n = true;
                            o(i.body);
                            [].splice.apply(e, [ r, 1 ].concat(i.body));
                            r += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof at) {
                        if (Vn(i.value, t)) {
                            n = true;
                            e.splice(r, 1);
                            continue;
                        }
                        t.push(i.value);
                    }
                    if (i instanceof _n) {
                        n = true;
                        e.splice(r, 1);
                        continue;
                    }
                    r++;
                }
                return n;
            }
            function f(s, r) {
                var o = false;
                var i = r.parent();
                var a = r.self();
                var f, u, c;
                var e = I && i && i.TYPE == "Call" && i.expression === a;
                var n = I && r.option("conditionals") && r.option("sequences");
                var t = P(s);
                for (var l = s.length; --l >= 0; ) {
                    var p = s[l];
                    var d = M(l);
                    var h = s[d];
                    if (I && f && !h && p instanceof xn && !(a instanceof nr) && !(qe && qe.bfinally && Y(I))) {
                        var v = p.value;
                        if (!v) {
                            o = true;
                            s.splice(l, 1);
                            continue;
                        }
                        var m = v.tail_node();
                        if (Ie(m)) {
                            o = true;
                            if (v instanceof Cn) {
                                v = v.expression;
                            } else if (m instanceof Cn) {
                                v = v.clone();
                                v.expressions[v.expressions.length - 1] = m.expression;
                            }
                            s[l] = Fe(gn, p, {
                                body: v
                            });
                            continue;
                        }
                    }
                    if (p instanceof kn) {
                        var _ = L(p.body);
                        if (q(_)) {
                            if (_.label) et(_.label.thedef.references, _);
                            o = true;
                            p = p.clone();
                            p.body = Fe(bn, p, {
                                body: z(p.body, _)
                            });
                            p.alternative = Fe(bn, p, {
                                body: W(p.alternative).concat(O(c, u))
                            });
                            C(_.value, c);
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        if (_ && !p.alternative && h instanceof Gt) {
                            var g = p.condition;
                            var b = l + 1 == d && p.body instanceof bn;
                            g = le(g, g.negate(r), b);
                            if (g !== p.condition) {
                                o = true;
                                p = p.clone();
                                p.condition = g;
                                var v = p.body;
                                p.body = Fe(bn, h, {
                                    body: O(true, null, d + 1)
                                });
                                s.splice(l, 1, p, v);
                                if (!I || a instanceof ut && a.body === s) {
                                    s[l] = p.transform(r);
                                }
                                continue;
                            }
                        }
                        var y = L(p.alternative);
                        if (q(y)) {
                            if (y.label) et(y.label.thedef.references, y);
                            o = true;
                            p = p.clone();
                            p.body = Fe(bn, p.body, {
                                body: W(p.body).concat(O(c, u))
                            });
                            p.alternative = Fe(bn, p.alternative, {
                                body: z(p.alternative, y)
                            });
                            C(y.value, c);
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        if (r.option("typeofs")) {
                            if (_ && !y) {
                                var w = Fe(bn, a, {
                                    body: s.slice(l + 1)
                                });
                                U(p.condition, null, w);
                            }
                            if (!_ && y) {
                                var w = Fe(bn, a, {
                                    body: s.slice(l + 1)
                                });
                                U(p.condition, w);
                            }
                        }
                    }
                    if (p instanceof kn && p.body instanceof xn) {
                        var x = p.body.value;
                        var k = p.body.in_bool || h instanceof xn && h.in_bool;
                        if (!p.alternative && h instanceof xn) {
                            o = true;
                            p = p.clone();
                            p.alternative = Fe(bn, h, {
                                body: O(true, null, d + 1)
                            });
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        if (I && f && !h && !p.alternative && (k || x && t || x instanceof Fn && (Ie(x.consequent, r) || Ie(x.alternative, r)))) {
                            o = true;
                            p = p.clone();
                            p.alternative = Fe(xn, p, {
                                value: null
                            });
                            s[l] = p;
                            s[l] = p.transform(r);
                            continue;
                        }
                        var E, S;
                        if (n && !p.alternative && (!(S = s[E = N(l)]) && e || S instanceof kn && S.body instanceof xn) && (!h ? !f : h instanceof gn && M(d) == s.length)) {
                            o = true;
                            var T = [];
                            p = p.clone();
                            T.push(p.condition);
                            p.condition = Pe(p, T);
                            p.alternative = Fe(bn, a, {
                                body: O().concat(Fe(xn, a, {
                                    value: null
                                }))
                            });
                            s[l] = p.transform(r);
                            l = E + 1;
                            continue;
                        }
                    }
                    if (p instanceof Qt || p instanceof Jt) {
                        u = p;
                        continue;
                    }
                    if (f && u && u === h) F(p);
                }
                return o;
                function P(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var r = e[t];
                        if (r instanceof kn && r.body instanceof xn) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function A(n) {
                    return H(r, function(e) {
                        return e === n;
                    });
                }
                function D(e, n) {
                    if (!u) return false;
                    if (u.TYPE != e.TYPE) return false;
                    var t = e.value;
                    if (!t) return false;
                    var r = u.equals(e);
                    if (!r && t instanceof An) {
                        t = t.tail_node();
                        if (u.value && u.value.equals(t)) r = 2;
                    }
                    if (!r && !n && u.value instanceof An) {
                        if (u.value.tail_node().equals(t)) r = 3;
                    }
                    return r;
                }
                function j(e) {
                    if (e instanceof Jt) {
                        if (c = D(e)) return true;
                        if (!I) return false;
                        if (!(e instanceof xn)) return false;
                        var n = e.value;
                        if (n && !Ie(n.tail_node())) return false;
                        if (!(a instanceof nr)) return true;
                        if (!u) return false;
                        if (u instanceof Jt && u.value) return false;
                        c = 4;
                        return true;
                    }
                    if (!(e instanceof Kt)) return false;
                    if (u && a instanceof nr) {
                        if (u instanceof Jt) {
                            if (!I) return false;
                            if (u.value) return false;
                        } else if (r.loopcontrol_target(u) !== i) {
                            return false;
                        }
                        c = true;
                    }
                    var t = r.loopcontrol_target(e);
                    if (e instanceof Zt) return A(G(t));
                    if (t instanceof lt) return false;
                    return A(t);
                }
                function q(e) {
                    c = false;
                    if (!j(e)) return false;
                    for (var n = s.length; --n > l; ) {
                        var t = s[n];
                        if (t instanceof Ht) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof fr || t instanceof ur) {
                            if (!hn(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof qr && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function O(e, n, t) {
                    var r = [];
                    var i = false;
                    var a = l + 1;
                    if (!e) {
                        t = s.length;
                        u = null;
                    } else if (n) {
                        t = s.lastIndexOf(n);
                    } else {
                        n = s[t];
                        if (n !== u) u = null;
                    }
                    var o = s.splice(a, t - a).filter(function(e) {
                        if (e instanceof Mt) {
                            r.push(e);
                            return false;
                        }
                        if (V(e)) i = true;
                        return true;
                    });
                    if (e === 3) {
                        o.push(Fe(gn, n.value, {
                            body: Pe(n.value, n.value.expressions.slice(0, -1))
                        }));
                        n.value = n.value.tail_node();
                    }
                    [].push.apply(i ? o : s, r);
                    return o;
                }
                function $(e, n) {
                    if (e) switch (n) {
                      case 4:
                        return e;

                      case 3:
                        if (!(e instanceof An)) break;

                      case 2:
                        return Pe(e, e.expressions.slice(0, -1));
                    }
                }
                function z(e, n) {
                    var t = W(e);
                    var r = t, i;
                    while ((i = r[r.length - 1]) !== n) {
                        r = i.body;
                    }
                    r.pop();
                    var a = n.value;
                    if (c) a = $(a, c);
                    if (a) r.push(Fe(gn, a, {
                        body: a
                    }));
                    return t;
                }
                function C(e, n) {
                    if (!n) return;
                    if (!e) return;
                    switch (n) {
                      case 4:
                        return;

                      case 3:
                      case 2:
                        e = e.tail_node();
                    }
                    R(e, u.value);
                }
                function M(e) {
                    f = true;
                    for (var n = e; ++n < s.length; ) {
                        var t = s[n];
                        if (B(t)) continue;
                        if (t instanceof cr) {
                            f = false;
                            continue;
                        }
                        break;
                    }
                    return n;
                }
                function N(e) {
                    for (var n = e; --n >= 0; ) {
                        var t = s[n];
                        if (t instanceof cr) continue;
                        if (B(t)) continue;
                        break;
                    }
                    return n;
                }
                function F(e, n, t) {
                    if (e instanceof Jt) {
                        var r = !(n && e instanceof Xt) && D(e, true);
                        if (r) {
                            o = true;
                            var i = $(e.value, r);
                            if (i) return Fe(gn, i, {
                                body: i
                            });
                            return t ? null : Fe(_n, e);
                        }
                    } else if (e instanceof kn) {
                        e.body = F(e.body, n);
                        if (e.alternative) e.alternative = F(e.alternative, n);
                    } else if (e instanceof ct) {
                        e.body = F(e.body, n);
                    } else if (e instanceof ir) {
                        if (!e.bfinally || !u.value || u.value.is_constant()) {
                            if (e.bcatch) F(e.bcatch, n);
                            var a = F(e.body.pop(), true, true);
                            if (a) e.body.push(a);
                        }
                    } else if (e instanceof ut && !(e instanceof yn || e instanceof er)) {
                        var a = F(e.body.pop(), n, true);
                        if (a) e.body.push(a);
                    }
                    return e;
                }
            }
            function u(n, t) {
                var e;
                var r = t.self();
                if (r instanceof ar) {
                    r = t.parent();
                } else if (r instanceof ct) {
                    r = r.body;
                }
                for (var i = 0, a = 0, o = n.length; i < o; i++) {
                    var s = n[i];
                    if (s instanceof Kt) {
                        var f = t.loopcontrol_target(s);
                        if (G(f) !== r || s instanceof Qt && f instanceof lt) {
                            n[a++] = s;
                        } else if (s.label) {
                            et(s.label.thedef.references, s);
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (L(s)) {
                        e = n.slice(i + 1);
                        break;
                    }
                }
                n.length = a;
                if (e) e.forEach(function(e) {
                    C(t, e, n);
                });
                return n.length != o;
            }
            function c(e, n) {
                if (!I || qe && qe.bfinally) return;
                var t = false;
                for (var r = e.length; --r >= 0; ) {
                    var i = e[r];
                    if (!(i instanceof gn)) break;
                    var a = i.body;
                    if (!(a instanceof gr)) break;
                    var o = a.expression;
                    if (!x(n, o)) break;
                    t = true;
                    o = o.drop_side_effect_free(n, true);
                    if (o) {
                        i.body = o;
                        break;
                    }
                }
                e.length = r + 1;
                return t;
            }
            function l(e, n) {
                var t = false;
                var r = e.length - 1;
                if (I && r >= 0) {
                    var i = qe && qe.bfinally && Y(Oe);
                    var a = e[r].try_inline(n, Se, i);
                    if (a) {
                        e[r--] = a;
                        t = true;
                    }
                }
                var o = De && qe && qe.bfinally ? "try" : De;
                for (;r >= 0; r--) {
                    var a = e[r].try_inline(n, Se, true, o);
                    if (!a) continue;
                    e[r] = a;
                    t = true;
                }
                return t;
            }
            function p(n, e) {
                if (n.length < 2) return;
                var t = [], r = 0;
                function i() {
                    if (!t.length) return;
                    var e = Pe(t[0], t);
                    n[r++] = Fe(gn, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof gn) {
                        if (t.length >= e.sequences_limit) i();
                        k(t, s.body);
                    } else if (B(s)) {
                        n[r++] = s;
                    } else {
                        i();
                        n[r++] = s;
                    }
                }
                i();
                n.length = r;
                return r != o;
            }
            function d(e, n) {
                if (!(e instanceof bn)) return e;
                var t = null;
                for (var r = 0; r < e.body.length; r++) {
                    var i = e.body[r];
                    if (i instanceof cr && ce(i)) {
                        n.push(i);
                    } else if (t || V(i)) {
                        return false;
                    } else {
                        t = i;
                    }
                }
                return t;
            }
            function h(e, n) {
                var t = false, r = 0, i;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (i) {
                        if (o instanceof Jt) {
                            if (o.value || !Y(Oe)) {
                                o.value = p(o.value || Fe(Gr, o)).optimize(n);
                            }
                        } else if (o instanceof vt) {
                            if (!(o.init instanceof sr)) {
                                var s = false;
                                i.body.walk(new Un(function(e) {
                                    if (s || e instanceof yn) return true;
                                    if (e instanceof Mn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = p(o.init); else {
                                        o.init = i.body;
                                        r--;
                                        t = true;
                                    }
                                }
                            }
                        } else if (o instanceof _t) {
                            if (!V(o.init)) o.object = p(o.object);
                        } else if (o instanceof kn) {
                            o.condition = p(o.condition);
                        } else if (o instanceof er) {
                            o.expression = p(o.expression);
                        } else if (o instanceof bt) {
                            o.expression = p(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof kn) {
                        var f = [];
                        var u = d(o.body, f);
                        var c = d(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(Fe(kn, o, {
                                condition: o.condition,
                                body: u || Fe(_n, o.body),
                                alternative: c
                            }));
                            f.unshift(r, 1);
                            [].splice.apply(e, f);
                            a += l;
                            r += l + 1;
                            i = null;
                            t = true;
                            continue;
                        }
                    }
                    e[r++] = o;
                    i = o instanceof gn ? o : null;
                }
                e.length = r;
                return t;
                function p(e) {
                    r--;
                    t = true;
                    var n = i.body;
                    return Pe(n, [ n, e ]);
                }
            }
            function v(e) {
                if (e instanceof Pn) return [ e ];
                if (e instanceof An) return e.expressions.slice();
            }
            function m(e, n, t) {
                var r = v(n);
                if (!r) return;
                t = t || 0;
                var i = false;
                for (var a = r.length - t; --a >= 0; ) {
                    var o = r[a];
                    if (!c(o)) continue;
                    var s;
                    if (o.left instanceof Yn) {
                        s = r.slice(a + 1);
                    } else if (o.left instanceof Dn && c(o.left.expression)) {
                        s = r.slice(a + 1);
                        var f = o.clone();
                        o = o.left.expression;
                        f.left = f.left.clone();
                        f.left.expression = o.left.clone();
                        s.unshift(f);
                    } else {
                        continue;
                    }
                    if (s.length == 0) continue;
                    if (!y(o.left, o.right, s)) continue;
                    i = true;
                    r = r.slice(0, a).concat(o, s);
                }
                if (e instanceof sr) {
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var u = e.definitions[a];
                        if (!u.value) continue;
                        if (y(u.name, u.value, r)) i = true;
                        if (g(u, r, t)) i = true;
                        break;
                    }
                    if (e instanceof cr && b(e.definitions, r, t)) i = true;
                }
                return i && r;
                function c(e) {
                    return e instanceof Pn && e.operator == "=";
                }
            }
            function _(e, n) {
                if (!(e instanceof gn)) return;
                if (ce(n)) return;
                var t = v(e.body);
                if (!t) return;
                var r = [];
                if (!b(r, t.reverse(), 0)) return;
                n.definitions = r.reverse().concat(n.definitions);
                return t.reverse();
            }
            function g(e, n, t) {
                if (!s.option("conditionals")) return;
                if (e.name instanceof Nn) return;
                var r = false;
                var i = e.name.definition();
                while (n.length > t) {
                    var a = ae(s, i, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function b(e, n, t) {
                var r = false;
                while (n.length > t) {
                    var i = n[0];
                    if (!(i instanceof Pn)) break;
                    if (i.operator != "=") break;
                    var a = i.left;
                    if (!(a instanceof Yn)) break;
                    if (Ne(a)) break;
                    if (a.scope.resolve() !== Oe) break;
                    var o = a.definition();
                    if (o.scope !== Oe) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = Fe(Cr, a);
                    e.push(Fe(En, i, {
                        name: s,
                        value: i.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function y(e, i, n) {
                var a = new vn();
                a.set(e.name, true);
                while (i instanceof Pn && i.operator == "=") {
                    if (i.left instanceof Yn) a.set(i.left.name, true);
                    i = i.right;
                }
                if (!(i instanceof In)) return;
                var t = false;
                do {
                    if (!o(n[0])) break;
                    n.shift();
                    t = true;
                } while (n.length);
                return t;
                function o(e) {
                    if (!(e instanceof Pn)) return;
                    if (e.operator != "=") return;
                    if (!(e.left instanceof Dn)) return;
                    var n = e.left.expression;
                    if (!(n instanceof Yn)) return;
                    if (!a.has(n.name)) return;
                    if (!e.right.is_constant_expression(Oe)) return;
                    var t = e.left.property;
                    if (t instanceof mn) {
                        if (o(t)) t = e.left.property = t.right.clone();
                        t = t.evaluate(s);
                    }
                    if (t instanceof mn) return;
                    t = "" + t;
                    var r = t == "__proto__" || s.has_directive("use strict") ? function(e) {
                        var n = e.key;
                        return typeof n == "string" && n != t && n != "__proto__";
                    } : function(e) {
                        var n = e.key;
                        if (e instanceof Ar || e instanceof Tr) {
                            return typeof n == "string" && n != t;
                        }
                        return n !== "__proto__";
                    };
                    if (!hn(i.properties, r)) return;
                    i.properties.push(Fe(Er, e, {
                        key: t,
                        value: e.right
                    }));
                    return true;
                }
            }
            function w(e) {
                var i = false, a;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var r = e[n];
                    var o = e[t];
                    if (r instanceof sr) {
                        if (o && o.TYPE == r.TYPE) {
                            o.definitions = o.definitions.concat(r.definitions);
                            i = true;
                        } else if (a && a.TYPE == r.TYPE && ce(r)) {
                            a.definitions = a.definitions.concat(r.definitions);
                            i = true;
                        } else if (r instanceof cr) {
                            var s = _(o, r);
                            if (s) {
                                if (s.length) {
                                    o.body = Pe(o, s);
                                    t++;
                                }
                                i = true;
                            } else {
                                t++;
                            }
                            e[t] = a = r;
                        } else {
                            e[++t] = r;
                        }
                        continue;
                    } else if (r instanceof Jt) {
                        r.value = c(r.value);
                    } else if (r instanceof vt) {
                        var s = m(o, r.init);
                        if (s) {
                            i = true;
                            r.init = s.length ? Pe(r.init, s) : null;
                        } else if (o instanceof cr && (!r.init || r.init.TYPE == o.TYPE)) {
                            if (r.init) {
                                o.definitions = o.definitions.concat(r.init.definitions);
                            }
                            r = r.clone();
                            a = r.init = o;
                            e[t] = l(r);
                            i = true;
                            continue;
                        } else if (a && r.init && a.TYPE == r.init.TYPE && ce(r.init)) {
                            a.definitions = a.definitions.concat(r.init.definitions);
                            r.init = null;
                            i = true;
                        } else if (r.init instanceof cr) {
                            a = r.init;
                            s = _(o, r.init);
                            if (s) {
                                i = true;
                                if (s.length == 0) {
                                    e[t] = l(r);
                                    continue;
                                }
                                o.body = Pe(o, s);
                            }
                        }
                    } else if (r instanceof mt) {
                        if (a && a.TYPE == r.init.TYPE) {
                            var f = a.definitions.slice();
                            r.init = r.init.definitions[0].name.convert_symbol(Yn, function(e, n) {
                                f.push(Fe(En, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            a.definitions = f;
                            i = true;
                        }
                        r.object = c(r.object);
                    } else if (r instanceof kn) {
                        r.condition = c(r.condition);
                    } else if (r instanceof gn) {
                        var s = m(o, r.body), u;
                        if (s) {
                            i = true;
                            if (!s.length) continue;
                            r.body = Pe(r.body, s);
                        } else if (o instanceof sr && (u = e[n + 1]) && o.TYPE == u.TYPE && (u = u.definitions[0]).value) {
                            i = true;
                            u.value = Pe(r, [ r.body, u.value ]);
                            continue;
                        }
                    } else if (r instanceof er) {
                        r.expression = c(r.expression);
                    } else if (r instanceof bt) {
                        r.expression = c(r.expression);
                    }
                    e[++t] = a ? l(r) : r;
                }
                e.length = t + 1;
                return i;
                function c(e) {
                    var n = m(o, e, 1);
                    if (!n) return e;
                    i = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return Pe(e, n);
                }
                function l(e) {
                    return e.transform(new ei(function(e, n, t) {
                        if (e instanceof sr) {
                            if (a === e) return e;
                            if (a.TYPE != e.TYPE) return e;
                            var r = this.parent();
                            if (r instanceof mt && r.init === e) return e;
                            if (!ce(e)) return e;
                            a.definitions = a.definitions.concat(e.definitions);
                            i = true;
                            if (r instanceof vt && r.init === e) return null;
                            return t ? Kn.skip : Fe(_n, e);
                        }
                        if (e instanceof lr) return e;
                        if (e instanceof yn) return e;
                        if (!ot(e)) return e;
                    }));
                }
            }
        }
        function C(i, a, o) {
            var s;
            var f = false;
            a.walk(new Un(function(e, n) {
                if (e instanceof Ht) {
                    e.extends = null;
                    e.properties = [];
                    u(e);
                    return true;
                }
                if (e instanceof sr) {
                    var t = [];
                    if (e.remove_initializers(i, t)) {
                        mn.warn("Dropping initialization in unreachable code [{start}]", e);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        u(e);
                    }
                    return true;
                }
                if (e instanceof Mt) {
                    u(e);
                    return true;
                }
                if (e instanceof yn) return true;
                if (e instanceof st) {
                    var r = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(Fe(bn, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = r;
                    return true;
                }
                if (!(e instanceof Kt)) f = true;
            }));
            if (f) mn.warn("Dropping unreachable code [{start}]", a);
            function u(e) {
                if (s) {
                    s.push(e);
                    if (!S(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function Ie(e, n) {
            return e == null || e.is_undefined || e instanceof Gr || e instanceof Cn && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(It, pn);
            e(yn, function(e) {
                var n = this.body;
                for (var t = 0; t < n.length; t++) {
                    var r = n[t];
                    if (!(r instanceof at)) break;
                    if (r.value == "use strict") return true;
                }
                var i = this.parent_scope;
                if (!i) return e.option("module");
                return i.resolve(true).in_strict_mode(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("in_strict_mode", n);
        });
        (function(e) {
            e(mn, ln);
            e(jn, pn);
            e(Pn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(wn, pn);
            e(In, pn);
            e(Ur, pn);
            e(An, function() {
                return this.tail_node().is_truthy();
            });
            e(Yn, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = ln;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(mn, pn);
            e(jn, ln);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof Rn) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(Pn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(Mn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(Rn, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(wn, ln);
            e(In, ln);
            e(Ur, ln);
            e(An, function() {
                return this.tail_node().is_negative_zero();
            });
            e(Yn, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = pn;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e(Cn, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            mn.DEFMETHOD("may_throw_on_access", function(e, n) {
                return !e.option("pure_getters") || this._dot_throw(e, n);
            });
            function i(e, n) {
                return n || /strict/.test(e.option("pure_getters"));
            }
            e(mn, i);
            e(jn, ln);
            e(Pn, function(e) {
                var n = this.operator;
                var t = this.left;
                var r = this.right;
                if (n != "=") {
                    return He[n.slice(0, -1)] && (t._dot_throw(e) || r._dot_throw(e));
                }
                if (!r._dot_throw(e)) return false;
                if (!(t instanceof Yn)) return true;
                if (r instanceof Mn && r.operator == "||" && t.name == r.left.name) {
                    return r.right._dot_throw(e);
                }
                return true;
            });
            e(Mn, function(e) {
                return He[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(It, function(e, n) {
                return i(e, n) && !hn(this.properties, function(e) {
                    if (e.private) return true;
                    if (!e.static) return true;
                    return !(e instanceof Lt || e instanceof Ut);
                });
            });
            e(Fn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(Rn, ln);
            e(qn, function(e, n) {
                if (!i(e, n)) return false;
                var t = this.expression;
                if (t instanceof Yn) t = t.fixed_value();
                return !(this.property == "prototype" && z(t));
            });
            e(wn, ln);
            e(Vr, pn);
            e(In, function(n, t) {
                return i(n, t) && !hn(this.properties, function(e) {
                    if (e instanceof Ar || e instanceof Tr) return false;
                    return !(e.key === "__proto__" && e.value._dot_throw(n, t));
                });
            });
            e(Ir, function(e, n) {
                return i(e, n) && !this.scope.resolve().new;
            });
            e(An, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(Yn, function(e, n) {
                if (this.is_undefined) return true;
                if (!i(e, n)) return false;
                if (Ne(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var t = this.definition();
                if (ze(t) && !t.scope.rest && hn(t.scope.argnames, function(e) {
                    return e instanceof Hn;
                })) return t.scope.uses_arguments > 2;
                var r = this.fixed_value(true);
                if (!r) return true;
                this._dot_throw = pn;
                if (r._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = ln;
                return false;
            });
            e(Cn, function() {
                return this.operator == "void";
            });
            e(_r, ln);
            e(Gr, pn);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(mn, ln);
            e(jn, pn);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(Pn, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(Mn, function(e) {
                return t(e, this.operator, this);
            });
            e(Fn, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(Rn, pn);
            e(Jr, ln);
            e(wn, pn);
            e(In, pn);
            e(An, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(Yn, function(e) {
                if (this.is_undefined) return false;
                if (Ne(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = ln;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e(Cn, function() {
                return this.operator != "void";
            });
            e(_r, pn);
            e(Gr, ln);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(mn, ln);
            e(Pn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = dn("in instanceof == != === !== < <= >= >");
            e(Mn, function(e) {
                return n[this.operator] || He[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Kr, pn);
            var t = dn("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(Tn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof qn && (t[n.property] || n.property == "test" && n.expression instanceof Ur);
            });
            e(Fn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(vr, ln);
            e(An, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(Yn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = ln;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var r = dn("! delete");
            e(Cn, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(mn, ln);
            var n = dn("- * / % ** & | ^ << >> >>>");
            e(Pn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(Mn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = dn([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear" ]);
            e(Tn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof qn && (t[n.property] || Ne(n.expression) && n.expression.name == "Math");
            });
            e(Fn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(vr, ln);
            e(Ln, pn);
            e(An, function(e) {
                return this.tail_node().is_number(e);
            });
            e(Yn, function(e, n) {
                var t = this.fixed_value();
                if (!t) return false;
                if (n && t instanceof Cn && t.operator == "+" && t.expression.equals(this)) {
                    return false;
                }
                this.is_number = ln;
                var r = t.is_number(e);
                delete this.is_number;
                return r;
            });
            var r = dn("+ - ~ ++ --");
            e(zn, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(mn, ln);
            e(Pn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(Mn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = dn([ "charAt", "substr", "substring", "toExponential", "toFixed", "toLowerCase", "toPrecision", "toString", "toUpperCase", "trim" ]);
            e(Tn, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof qn && t[n.property];
            });
            e(Fn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(An, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Bn, pn);
            e(Yn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = ln;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Br, function(e) {
                return !this.tag || Oe(e, this.tag);
            });
            e(Cn, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var He = dn("&& || ??");
        (function(e) {
            function i(e, n) {
                if (e instanceof mn) return e.clone(true);
                if (Array.isArray(e)) return Fe(jn, n, {
                    elements: e.map(function(e) {
                        return i(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var r in e) if (nt(e, r)) {
                        t.push(Fe(Er, n, {
                            key: r,
                            value: i(e[r], n)
                        }));
                    }
                    return Fe(In, n, {
                        properties: t
                    });
                }
                return fe(e, n);
            }
            function o(e) {
                mn.warn("global_defs {this} redefined [{start}]", e);
            }
            yt.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie: a.option("ie")
                });
                return this.transform(new ei(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, r = e, i;
                    while (i = this.parent(t++)) {
                        if (!(i instanceof Dn)) break;
                        if (i.expression !== r) break;
                        r = i;
                    }
                    if (ui(r, i)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(mn, Gn);
            e(qn, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(qr, function(e) {
                if (!this.definition().global) return;
                if (nt(e.option("global_defs"), this.name)) o(this);
            });
            e(Yn, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var r = this.name + n;
                if (nt(t, r)) return i(t[r], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function le(e, n, t) {
            var r = n.print_to_string().length - e.print_to_string().length;
            return r < (t || 0) ? n : e;
        }
        function A(e, n, t) {
            return le(Fe(gn, e, {
                body: e
            }), Fe(gn, n, {
                body: n
            }), t).body;
        }
        function pe(e, n, t, r) {
            return (tt(e) ? A : le)(n, t, r);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = dn(n[e]);
            });
            return t;
        }
        function f(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof at)) return t;
            }
        }
        function u() {
            if (this.value) return Fe(xn, this.value, {
                value: this.value
            });
            return f(this.body);
        }
        Dt.DEFMETHOD("first_statement", u);
        qt.DEFMETHOD("first_statement", u);
        wn.DEFMETHOD("first_statement", function() {
            return f(this.body);
        });
        wn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof Sn) break;
            }
            return n;
        });
        function de(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = fe(t, n).optimize(e);
            return pe(e, n, t, e.eval_threshold);
        }
        var n = [ "constructor", "toString", "valueOf" ];
        var b = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(n),
            Boolean: n,
            Function: n,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(n),
            Object: n,
            RegExp: [ "exec", "test" ].concat(n),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(n)
        });
        var w = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode", "raw" ]
        });
        function Je(e) {
            if (!(e instanceof qn)) return false;
            var n = e.expression;
            if (!Ne(n)) return false;
            var t = w[n.name];
            return t && (t[e.property] || n.name == "Math" && e.property == "random");
        }
        (function(e) {
            e(mn, ln);
            e(Rn, pn);
            e(Ur, ln);
            var n = dn("! ~ - + void");
            e(Cn, function() {
                return n[this.operator] && this.expression instanceof Rn;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            mn.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var r = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return r;
                if (!r || r instanceof RegExp) return r;
                if (typeof r == "function" || typeof r == "object") return this;
                return r;
            });
            var m = new Un(function(e) {
                if (e instanceof Pn) u(e.left);
                if (e instanceof mt) u(e.init);
                if (e instanceof zn && ii[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof yr) {
                    e.elements.forEach(u);
                } else if (e instanceof xr) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof Dn) {
                    u(e.expression);
                } else if (e instanceof Yn) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(rt, function() {
                throw new Error(Zn("Cannot evaluate a statement [{start}]", this));
            });
            e(xt, Jn);
            e(Lr, Jn);
            e(It, Jn);
            e(mn, Jn);
            e(Rn, function() {
                return this.value;
            });
            e(Pn, function(e, n, t, r) {
                var i = this.left;
                if (!n) {
                    if (!(i instanceof Yn)) return this;
                    if (!nt(i, "_eval")) {
                        if (!i.fixed) return this;
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                        if (a.single_use == "m") return this;
                        if (this.right.has_side_effects(e)) return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!nt(i, "_eval") && i instanceof Yn && i.fixed && i.definition().fixed) {
                    s = i;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = Fe(Mn, this, {
                        operator: o.slice(0, -1),
                        left: i,
                        right: this.right
                    });
                }
                i.walk(m);
                var f = s._eval(e, n, t, r);
                if (typeof f == "object") return this;
                u(i);
                return f;
            });
            e(An, function(e, n, t, r) {
                if (!n) return this;
                var i = this.expressions;
                for (var a = 0, o = i.length - 1; a < o; a++) {
                    i[a].walk(m);
                }
                var s = i[o];
                var f = s._eval(e, n, t, r);
                return f === s ? this : f;
            });
            e(wn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(jn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Jr) return this;
                        var s = o._eval(e, n, t, r);
                        if (o === s) return this;
                        i.push(s);
                    }
                    return i;
                }
                return this;
            });
            e(In, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof Er)) return this;
                        var s = o.key;
                        if (s instanceof mn) {
                            s = s._eval(e, n, t, r);
                            if (s === o.key) return this;
                        }
                        switch (s) {
                          case "__proto__":
                          case "toString":
                          case "valueOf":
                            return this;
                        }
                        i[s] = o.value._eval(e, n, t, r);
                        if (i[s] === o.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var f = dn("! typeof void");
            e(Cn, function(e, n, t, r) {
                var i = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (i instanceof wn || i instanceof Yn && i.fixed_value() instanceof wn)) {
                    return typeof function() {};
                }
                var o = i instanceof Yn && i.definition();
                if (!f[a] && !(o && o.fixed)) r++;
                i.walk(m);
                var s = i._eval(e, n, t, r);
                if (s === i) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== i) return this;
                    }
                    if (nt(i, "_eval")) s = +(a[0] + 1) + +s;
                    u(i);
                    return s;
                }
                return this;
            });
            e(_r, function(e, n, t, r) {
                var i = this.expression;
                if (!(i instanceof Yn)) {
                    if (!n) return this;
                } else if (!nt(i, "_eval")) {
                    if (!i.fixed) return this;
                    if (!n) {
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                    }
                }
                if (!(i instanceof Yn && i.definition().fixed)) r++;
                i.walk(m);
                var o = i._eval(e, n, t, r);
                if (o === i) return this;
                u(i);
                return +o;
            });
            var c = dn("&& || === !==");
            e(Mn, function(e, n, t, r) {
                if (!c[this.operator]) r++;
                var i = this.left._eval(e, n, t, r);
                if (i === this.left) return this;
                if (this.operator == (i ? "||" : "&&")) return i;
                var a = n && !(i && typeof i == "object");
                var o = this.right._eval(e, a, t, r);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = i && o;
                    break;

                  case "||":
                    s = i || o;
                    break;

                  case "??":
                    s = i == null ? o : i;
                    break;

                  case "|":
                    s = i | o;
                    break;

                  case "&":
                    s = i & o;
                    break;

                  case "^":
                    s = i ^ o;
                    break;

                  case "+":
                    s = i + o;
                    break;

                  case "-":
                    s = i - o;
                    break;

                  case "*":
                    s = i * o;
                    break;

                  case "/":
                    s = i / o;
                    break;

                  case "%":
                    s = i % o;
                    break;

                  case "<<":
                    s = i << o;
                    break;

                  case ">>":
                    s = i >> o;
                    break;

                  case ">>>":
                    s = i >>> o;
                    break;

                  case "==":
                    s = i == o;
                    break;

                  case "===":
                    s = i === o;
                    break;

                  case "!=":
                    s = i != o;
                    break;

                  case "!==":
                    s = i !== o;
                    break;

                  case "<":
                    s = i < o;
                    break;

                  case "<=":
                    s = i <= o;
                    break;

                  case ">":
                    s = i > o;
                    break;

                  case ">=":
                    s = i >= o;
                    break;

                  case "**":
                    s = Math.pow(i, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && nt(o, i)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(bt) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(i), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e[^e]+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(Fn, function(e, n, t, r) {
                var i = this.condition._eval(e, n, t, r);
                if (i === this.condition) return this;
                var a = i ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, r);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var r = false;
                    t[0].walk(new Un(function(e) {
                        if (r) return true;
                        if (e === n) return r = true;
                        if (e instanceof yn) return true;
                    }));
                    return r;

                  default:
                    return e <= t.depth;
                }
            }
            e(Yn, function(e, n, t, r) {
                var i = this.fixed_value();
                if (!i) return this;
                var a;
                if (nt(i, "_eval")) {
                    a = i._eval();
                } else {
                    this._eval = Jn;
                    a = i._eval(e, n, t, r);
                    delete this._eval;
                    if (a === i) return this;
                    i._eval = function() {
                        return a;
                    };
                    t.push(i);
                }
                return a && typeof a == "object" && !o(this, r) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = dn("global ignoreCase multiline source");
            e(Dn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i;
                    var a = this.expression;
                    if (!Ne(a)) {
                        i = a._eval(e, n, t, r + 1);
                        if (i == null || i === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof mn) {
                        o = o._eval(e, n, t, r);
                        if (o === this.property) return this;
                    }
                    if (i === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        i = _[a.name];
                    } else if (i instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof i == "object") {
                        if (!nt(i, o)) return this;
                    } else if (typeof i == "function") switch (o) {
                      case "name":
                        return i.node.name ? i.node.name.name : "";

                      case "length":
                        return i.node.length();

                      default:
                        return this;
                    }
                    return i[o];
                }
                return this;
            });
            function g(e, n, t, r, i) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, r, i);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(Tn, function(r, i, a, o) {
                var e = this.expression;
                var n = e instanceof Yn ? e.fixed_value() : e;
                if (n instanceof Dt || n instanceof jt || n instanceof zt) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(r)) return this;
                    var s = g(this.args, r, i, a, o);
                    if (!hn(n.argnames, function(e, n) {
                        if (e instanceof Sn) {
                            if (!s) return false;
                            if (s[n] === undefined) {
                                var t = e.value._eval(r, i, a, o);
                                if (t === e.value) return false;
                                s[n] = t;
                            }
                            e = e.name;
                        }
                        return !(e instanceof Nn);
                    })) return this;
                    if (n.rest instanceof Nn) return this;
                    if (!s && !i) return this;
                    var t = n.first_statement();
                    if (!(t instanceof xn)) {
                        if (i) {
                            n.walk(m);
                            var f = false;
                            n.evaluating = true;
                            ft(n, new Un(function(e) {
                                if (f) return true;
                                if (e instanceof xn) {
                                    if (e.value && e.value._eval(r, true, a, o) !== undefined) {
                                        f = true;
                                    }
                                    return true;
                                }
                                if (e instanceof yn && e !== n) return true;
                            }));
                            n.evaluating = false;
                            if (!f) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!s || hn(n.argnames, function(e, n) {
                        return v(e, s[n]);
                    }) && !(n.rest && !v(n.rest, s.slice(n.argnames.length))) || i) {
                        if (i) n.argnames.forEach(function(e) {
                            if (e instanceof Sn) e.value.walk(m);
                        });
                        n.evaluating = true;
                        u = u._eval(r, i, a, o);
                        n.evaluating = false;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (r.option("unsafe") && e instanceof Dn) {
                    var l = e.property;
                    if (l instanceof mn) {
                        l = l._eval(r, i, a, o);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (Ne(p)) {
                        var d = w[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(r, i, a, o + 1);
                        if (u == null || u === p) return this;
                        var h = b[u.constructor.name];
                        if (!h || !h[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof Ur)) return this;
                    }
                    var s = g(this.args, r, i, a, o);
                    if (!s) return this;
                    if (l == "replace" && typeof s[1] == "function") return this;
                    try {
                        return u[l].apply(u, s);
                    } catch (e) {
                        mn.warn("Error evaluating {this} [{start}]", this);
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function v(e, n) {
                    if (e instanceof Sn) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var r = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return r;
                        };
                        c.push(e);
                    });
                    return true;
                }
            });
            e(vr, Jn);
            e(Br, function(e, n, t, r) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Oe(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var i = g(this.expressions, e, n, t, r);
                if (!i) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < i.length; s++) {
                    o += i[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = Jn;
                return this;
                function f(e) {
                    e = Ze(e);
                    if (typeof e != "string") a = true;
                    return e;
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function i(e) {
                return Fe(Cn, e, {
                    operator: "!",
                    expression: e
                });
            }
            function a(e, n, t) {
                var r = i(e);
                if (t) return le(r, Fe(gn, n, {
                    body: n
                })) === r ? r : n;
                return le(r, n);
            }
            e(mn, function() {
                return i(this);
            });
            e(rt, function() {
                throw new Error("Cannot negate a statement");
            });
            e(Mn, function(e, n) {
                var t = this.clone(), r = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (r) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (r) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return a(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return a(this, t, n);
                }
                return i(this);
            });
            e(Yt, function() {
                return i(this);
            });
            e(Fn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return a(this, t, n);
            });
            e(kt, function() {
                return i(this);
            });
            e(An, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return Pe(this, n);
            });
            e(Cn, function() {
                if (this.operator == "!") return this.expression;
                return i(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var c = dn("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        var d = dn("Map Set WeakMap WeakSet");
        Tn.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (Ne(n)) {
                    if (c[n.name]) return true;
                    if (this instanceof vr && d[n.name]) return true;
                }
                if (Je(n)) return true;
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        Br.DEFMETHOD("is_expr_pure", function(e) {
            var n = this.tag;
            if (!n) return true;
            if (e.option("unsafe")) {
                if (Ne(n) && c[n.name]) return true;
                if (n instanceof qn && Ne(n.expression)) {
                    var t = w[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return !e.pure_funcs(this);
        });
        mn.DEFMETHOD("is_call_pure", ln);
        Tn.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof qn)) return false;
            var t = n.expression;
            var r;
            var i = n.property;
            if (t instanceof jn) {
                r = b.Array;
            } else if (t.is_boolean(e)) {
                r = b.Boolean;
            } else if (t.is_number(e)) {
                r = b.Number;
            } else if (t instanceof Ur) {
                r = b.RegExp;
            } else if (t.is_string(e)) {
                r = b.String;
                if (i == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                r = b.Object;
            }
            return r && r[i];
        });
        (function(e) {
            e(mn, ln);
            e(jn, pn);
            e(Pn, function() {
                switch (this.operator) {
                  case "=":
                    return this.right.safe_to_spread();

                  case "&&=":
                  case "||=":
                  case "??=":
                    return this.left.safe_to_spread() && this.right.safe_to_spread();
                }
                return true;
            });
            e(Mn, function() {
                return !He[this.operator] || this.left.safe_to_spread() && this.right.safe_to_spread();
            });
            e(Rn, pn);
            e(wn, pn);
            e(In, function() {
                return hn(this.properties, function(e) {
                    return !(e instanceof Ar || e instanceof $n);
                });
            });
            e(An, function() {
                return this.tail_node().safe_to_spread();
            });
            e(Yn, function() {
                var e = this.fixed_value();
                return e && e.safe_to_spread();
            });
            e(zn, pn);
        })(function(e, n) {
            e.DEFMETHOD("safe_to_spread", n);
        });
        (function(e) {
            function t(e, n, t) {
                return !hn(e, t ? function(e) {
                    return e instanceof $n ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                var t = e.expression;
                return !t.is_string(n) || t.has_side_effects(n);
            }
            e(mn, pn);
            e(jn, function(e) {
                return t(this.elements, e, n);
            });
            e(Pn, function(e) {
                var n = this.left;
                if (!(n instanceof Dn)) return true;
                var t = n.expression;
                return !(t instanceof Ir) || !t.scope.resolve().new || n instanceof On && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(Mn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || !Xe(this.operator, this.right, e);
            });
            e(ut, function(e) {
                return t(this.body, e);
            });
            e(Tn, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(rr, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(It, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof Yn) n = n.fixed_value();
                    if (!Re(n)) return true;
                }
                return t(this.properties, e);
            });
            e(Rt, function(e) {
                return this.key instanceof mn && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(Fn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(Rn, ln);
            e(sr, function(e) {
                return t(this.definitions, e);
            });
            e(yr, function(e) {
                return t(this.elements, e);
            });
            e(wr, function(e) {
                return this.key instanceof mn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(xr, function(e) {
                return t(this.properties, e);
            });
            e(qn, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(_n, ln);
            e(kn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(ct, function(e) {
                return this.body.has_side_effects(e);
            });
            e(wn, ln);
            e(In, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return !t.safe_to_spread() || t.has_side_effects(n);
                });
            });
            e(Ir, ln);
            e(kr, function(e) {
                return this.key instanceof mn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(An, function(e) {
                return t(this.expressions, e);
            });
            e(gn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(On, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(er, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(qr, ln);
            e(Yn, function(e) {
                return !this.is_declared(e) || !Ce(this, e);
            });
            e(Br, function(e) {
                return !this.is_expr_pure(e) || t(this.expressions, e);
            });
            e(ir, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(zn, function(e) {
                return fi[this.operator] || this.expression.has_side_effects(e);
            });
            e(En, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(mn, pn);
            e(Rn, ln);
            e(_n, ln);
            e(wn, ln);
            e(Ir, ln);
            e(qr, ln);
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            function r(e, n) {
                if (e.may_throw(n)) return true;
                if (e instanceof Yn) e = e.fixed_value();
                if (!(e instanceof wn)) return true;
                if (t(e.argnames, n)) return true;
                if (t(e.body, n)) return true;
                return Et(e) && e.value && e.value.may_throw(n);
            }
            e(jn, function(e) {
                return t(this.elements, e);
            });
            e(Pn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof Yn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(gr, function(e) {
                return this.expression.may_throw(e);
            });
            e(Mn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || !Xe(this.operator, this.right, e);
            });
            e(ut, function(e) {
                return t(this.body, e);
            });
            e(Tn, function(e) {
                if (t(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                this.may_throw = pn;
                var n = r(this.expression, e);
                delete this.may_throw;
                return n;
            });
            e(rr, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Fn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(Sn, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
            e(sr, function(e) {
                return t(this.definitions, e);
            });
            e(qn, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(mt, function(e) {
                if (this.init.may_throw(e)) return true;
                var n = this.object;
                if (n.may_throw(e)) return true;
                n = n.tail_node();
                if (!(n instanceof jn || n.is_string(e))) return true;
                return this.body.may_throw(e);
            });
            e(kn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(ct, function(e) {
                return this.body.may_throw(e);
            });
            e(In, function(e) {
                return t(this.properties, e);
            });
            e(kr, function(e) {
                return this.value.may_throw(e) || this.key instanceof mn && this.key.may_throw(e);
            });
            e(xn, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(An, function(e) {
                return t(this.expressions, e);
            });
            e(gn, function(e) {
                return this.body.may_throw(e);
            });
            e(On, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(er, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Yn, function(e) {
                return !this.is_declared(e) || !Ce(this, e);
            });
            e(Br, function(e) {
                if (t(this.expressions, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (!this.tag) return false;
                this.may_throw = pn;
                var n = r(this.tag, e);
                delete this.may_throw;
                return n;
            });
            e(ir, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : t(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(zn, function(e) {
                return this.expression.may_throw(e) && !(this.operator == "typeof" && this.expression instanceof Yn);
            });
            e(En, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(mn, ln);
            e(jn, function(e) {
                return t(this.elements, e);
            });
            e(Mn, function(e) {
                return this.left.is_constant_expression(e) && this.right.is_constant_expression(e) && Xe(this.operator, this.right);
            });
            e(It, function(e) {
                var n = this.extends;
                if (n && !Re(n)) return false;
                return t(this.properties, e);
            });
            e(Rt, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(Rn, pn);
            e(wn, function(i) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Un(function(e, n) {
                    if (!o) return true;
                    if (e instanceof st) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Yn) {
                        if (a.inlined || e.redef || e.in_arg) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Vn(t.scope, s)) return true;
                        if (i && !t.redefined()) {
                            var r = i.find_variable(e.name);
                            if (r ? r === t : t.undeclared) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof Ir) {
                        if (Et(a) && hn(s, function(e) {
                            return !(e instanceof yn) || Et(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(In, function(e) {
                return t(this.properties, e);
            });
            e(kr, function(e) {
                return typeof this.key == "string" && this.value.is_constant_expression(e);
            });
            e(zn, function(e) {
                return this.expression.is_constant_expression(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function L(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(rt, Xn);
            e(Gt, Jn);
            function n() {
                var e = this.body.length;
                return e > 0 && L(this.body[e - 1]);
            }
            e(bn, n);
            e(nr, n);
            e(kn, function() {
                return this.alternative && L(this.body) && L(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var h = dn([ "use asm", "use strict" ]);
        e(at, function(e, n) {
            if (n.option("directives") && (!h[e.value] || n.has_directive(e.value) !== e)) {
                return Fe(_n, e);
            }
            return e;
        });
        e(it, function(e, n) {
            if (n.option("drop_debugger")) return Fe(_n, e);
            return e;
        });
        e(ct, function(e, n) {
            if (e.body instanceof kn || e.body instanceof Qt) {
                var t = l([ e.body ], n);
                switch (t.length) {
                  case 0:
                    e.body = Fe(_n, e);
                    break;

                  case 1:
                    e.body = t[0];
                    break;

                  default:
                    e.body = Fe(bn, e, {
                        body: t
                    });
                    break;
                }
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Kt, function(e, n) {
            if (!n.option("dead_code")) return e;
            var t = e.label;
            if (t) {
                var r = n.loopcontrol_target(e);
                e.label = null;
                if (n.loopcontrol_target(e) === r) {
                    et(t.thedef.references, e);
                } else {
                    e.label = t;
                }
            }
            return e;
        });
        e(ut, function(e, n) {
            e.body = l(e.body, n);
            return e;
        });
        function q(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? Kn.skip : Fe(_n, e);

              case 1:
                var r = e.body[0];
                if (!S(r)) return e;
                if (n instanceof lt && r instanceof Mt) return e;
                return r;
            }
            return e;
        }
        e(bn, function(e, n) {
            e.body = l(e.body, n);
            return q(e, n.parent());
        });
        function v(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof yr)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = e.rest.rest;
        }
        e(wn, function(e, n) {
            v(e, n);
            e.body = l(e.body, n);
            return e;
        });
        function m(e, n) {
            if (!n.option("arrows")) return e;
            v(e, n);
            if (e.value) e.body = [ e.first_statement() ];
            var t = l(e.body, n);
            switch (t.length) {
              case 1:
                var r = t[0];
                if (r instanceof xn) {
                    e.body.length = 0;
                    e.value = r.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(Dt, m);
        e(qt, m);
        e(zt, function(n, e) {
            v(n, e);
            n.body = l(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var r = 0; r < n.body.length; r++) {
                var i = n.body[r];
                if (i instanceof at) continue;
                if (i instanceof xn) {
                    if (r != n.body.length - 1) break;
                    var a = i.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression, s;
                    if (!(o instanceof Yn)) {
                        s = o;
                    } else if (n.name && n.name.definition() === o.definition()) {
                        break;
                    } else {
                        s = o.fixed_value();
                    }
                    if (!(s instanceof jt || s instanceof zt)) break;
                    if (s.rest) break;
                    if (s.uses_arguments) break;
                    if (s === o) {
                        if (s.parent_scope !== n) break;
                        if (!hn(s.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if ((s !== o || s.name) && (t instanceof Vt || t instanceof Sr) && t.value === e.self()) break;
                    if (s.contains_this()) break;
                    var f = s.argnames.length;
                    if (f > 0 && e.option("inline") < 2) break;
                    if (f > n.argnames.length) break;
                    if (!hn(n.argnames, function(e) {
                        return e instanceof Hn;
                    })) break;
                    if (!hn(a.args, function(e) {
                        return !(e instanceof $n);
                    })) break;
                    for (var u = 0; u < f; u++) {
                        var c = a.args[u];
                        if (!(c instanceof Yn)) break;
                        if (c.definition() !== n.argnames[u].definition()) break;
                    }
                    if (u < f) break;
                    for (;u < a.args.length; u++) {
                        if (a.args[u].has_side_effects(e)) break;
                    }
                    if (u < a.args.length) break;
                    if (f < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(s, a)) break;
                        do {
                            s.argnames.push(s.make_var(Hn, s, "argument_" + f));
                        } while (++f < n.argnames.length);
                    }
                    return o;
                }
                break;
            }
            return n;
        });
        var N = dn("arguments await yield");
        yn.DEFMETHOD("merge_variables", function(d) {
            if (!d.option("merge_vars")) return;
            var h = [], v, m, _ = {}, g = this;
            var s = [], f = [], u = 0;
            var b = new vn();
            var y = Object.create(null);
            var c = Object.create(null);
            var w = new Un(function(t, e) {
                if (t instanceof Pn) {
                    var n = t.left;
                    var r = t.right;
                    if (n instanceof Nn) {
                        r.walk(w);
                        E(Yn, S, n);
                        return true;
                    }
                    if (He[t.operator.slice(0, -1)]) {
                        n.walk(w);
                        x();
                        r.walk(w);
                        if (n instanceof Yn) S(n);
                        k();
                        return true;
                    }
                    if (n instanceof Yn) {
                        if (t.operator != "=") S(n, true);
                        r.walk(w);
                        S(n);
                        return true;
                    }
                    return;
                }
                if (t instanceof Mn) {
                    if (!He[t.operator]) return;
                    p(t);
                    return true;
                }
                if (t instanceof Qt) {
                    var i = w.loopcontrol_target(t);
                    if (!(i instanceof lt)) T(i);
                    return true;
                }
                if (t instanceof Tn) {
                    var a = t.expression;
                    if (a instanceof kt) {
                        t.args.forEach(function(e) {
                            e.walk(w);
                        });
                        a.walk(w);
                    } else {
                        e();
                        l(a);
                    }
                    return true;
                }
                if (t instanceof It) {
                    if (t.name) t.name.walk(w);
                    if (t.extends) t.extends.walk(w);
                    t.properties.filter(function(e) {
                        if (e.key instanceof mn) e.key.walk(w);
                        return e.value;
                    }).forEach(function(e) {
                        if (e.static) {
                            e.value.walk(w);
                        } else {
                            x();
                            _.block = t;
                            e.value.walk(w);
                            k();
                        }
                    });
                    return true;
                }
                if (t instanceof Fn) {
                    p(t.condition, t.consequent, t.alternative);
                    return true;
                }
                if (t instanceof Zt) {
                    var i = w.loopcontrol_target(t);
                    if (i instanceof dt) T(i);
                    return true;
                }
                if (t instanceof dt) {
                    x();
                    _.block = t;
                    _.loop = true;
                    var o = _;
                    t.body.walk(w);
                    if (_.inserted === t) _ = o;
                    t.condition.walk(w);
                    k();
                    return true;
                }
                if (t instanceof vt) {
                    if (t.init) t.init.walk(w);
                    x();
                    _.block = t;
                    _.loop = true;
                    if (t.condition) t.condition.walk(w);
                    t.body.walk(w);
                    if (t.step) t.step.walk(w);
                    k();
                    return true;
                }
                if (t instanceof mt) {
                    t.object.walk(w);
                    x();
                    _.block = t;
                    _.loop = true;
                    t.init.walk(w);
                    t.body.walk(w);
                    k();
                    return true;
                }
                if (t instanceof kn) {
                    p(t.condition, t.body, t.alternative);
                    return true;
                }
                if (t instanceof ct) {
                    x();
                    _.block = t;
                    var o = _;
                    t.body.walk(w);
                    if (_.inserted === t) _ = o;
                    k();
                    return true;
                }
                if (t instanceof yn) {
                    x();
                    _.block = t;
                    if (t === g) m = _;
                    if (t instanceof wn) {
                        if (t.name) y[t.name.definition().id] = false;
                        var s = t.uses_arguments && !w.has_directive("use strict") ? function(e) {
                            y[e.definition().id] = false;
                        } : function(e) {
                            S(e);
                        };
                        h.push(t);
                        t.argnames.forEach(function(e) {
                            E(Hn, s, e);
                        });
                        if (t.rest) E(Hn, s, t.rest);
                        h.pop();
                    }
                    At(t, w);
                    k();
                    return true;
                }
                if (t instanceof On) {
                    var a = t.expression;
                    if (t.optional) {
                        a.walk(w);
                        x();
                        t.property.walk(w);
                        k();
                    } else {
                        e();
                    }
                    l(a);
                    return true;
                }
                if (t instanceof er) {
                    t.expression.walk(w);
                    var o = _;
                    t.body.forEach(function(e) {
                        if (e instanceof tr) return;
                        e.expression.walk(w);
                        if (o === _) x();
                    });
                    _ = o;
                    t.body.forEach(function(e) {
                        x();
                        _.block = t;
                        var n = _;
                        ft(e, w);
                        if (_.inserted === t) _ = n;
                        k();
                    });
                    return true;
                }
                if (t instanceof Or || t instanceof zr) {
                    y[t.definition().id] = false;
                    return true;
                }
                if (t instanceof Yn) {
                    S(t, true);
                    return true;
                }
                if (t instanceof ir) {
                    var f = v;
                    v = t;
                    ft(t, w);
                    if (t.bcatch) {
                        if (t.bcatch.argname) t.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof jr) {
                                var n = e.definition();
                                y[n.id] = false;
                                if (n = n.redefined()) y[n.id] = false;
                            }
                        }, w);
                        if (t.bfinally || (v = f)) {
                            ft(t.bcatch, w);
                        } else {
                            x();
                            ft(t.bcatch, w);
                            k();
                        }
                    }
                    v = f;
                    if (t.bfinally) t.bfinally.walk(w);
                    return true;
                }
                if (t instanceof zn) {
                    if (!ii[t.operator]) return;
                    var u = t.expression;
                    if (!(u instanceof Yn)) return;
                    S(u, true);
                    return true;
                }
                if (t instanceof En) {
                    var c = t.value;
                    if (c) {
                        c.walk(w);
                    } else {
                        c = _.block instanceof mt && _.block.init === w.parent();
                    }
                    E(qr, c ? function(e) {
                        if (e instanceof Cr) {
                            S(e);
                        } else {
                            e.walk(w);
                        }
                    } : function(e) {
                        if (e instanceof Cr) {
                            var n = e.definition().id;
                            var t = y[n];
                            if (t) {
                                t.push(e);
                            } else if (!(n in y)) {
                                b.add(n, e);
                            }
                        } else {
                            e.walk(w);
                        }
                    }, t.name);
                    return true;
                }
                if (t instanceof ht) {
                    x();
                    _.block = t;
                    _.loop = true;
                    e();
                    k();
                    return true;
                }
                function l(e) {
                    if (!d.option("ie")) return;
                    var n = mr(e);
                    if (n instanceof Yn) n.walk(w);
                }
                function p(e, n, t) {
                    var r = _;
                    var i = [ r, r ];
                    if (e instanceof Mn) switch (e.operator) {
                      case "&&":
                        i[0] = p(e.left, e.right)[0];
                        break;

                      case "||":
                      case "??":
                        i[1] = p(e.left, null, e.right)[1];
                        break;

                      default:
                        e.walk(w);
                        break;
                    } else if (e instanceof Fn) {
                        p(e.condition, e.consequent, e.alternative);
                    } else {
                        e.walk(w);
                    }
                    _ = i[0];
                    if (n) {
                        x();
                        n.walk(w);
                    }
                    i[0] = _;
                    _ = i[1];
                    if (t) {
                        x();
                        t.walk(w);
                    }
                    i[1] = _;
                    _ = r;
                    return i;
                }
            });
            w.directives = Object.create(d.directives);
            g.walk(w);
            var e = false;
            var n = Object.create(null);
            while (s.length && f.length) {
                var t = f.shift();
                if (!t) continue;
                var r = t.definition;
                var i = y[r.id];
                if (!i) continue;
                i = {
                    end: i.end
                };
                while (r.id in n) r = n[r.id];
                i.start = y[r.id].start;
                var a = [];
                do {
                    var o = s.shift();
                    if (t.index > o.index) continue;
                    var l = o.definition.id;
                    if (!(l in c)) continue;
                    var p = y[l];
                    if (!p) continue;
                    if (p.start.block !== i.start.block || !D(p, i) || (p.start.loop || !Qe(r)) && !D(i, p) || d.option("webkit") && si(r) !== si(o.definition) || o.definition.const_redefs || !hn(p.scopes, function(e) {
                        return e.find_variable(r.name) === r;
                    })) {
                        a.push(o);
                        continue;
                    }
                    p.forEach(function(e) {
                        e.thedef = r;
                        e.name = r.name;
                        if (e instanceof Yn) {
                            r.references.push(e);
                        } else {
                            r.orig.push(e);
                        }
                    });
                    if (!o.definition.fixed) r.fixed = false;
                    n[l] = r;
                    e = true;
                    break;
                } while (s.length);
                if (a.length) s = a.concat(s);
            }
            return e;
            function x() {
                _ = Object.create(_);
            }
            function k() {
                _ = Object.getPrototypeOf(_);
            }
            function E(n, t, e) {
                var r = new Un(function(e) {
                    if (e instanceof Nn) return;
                    if (e instanceof Sn) {
                        x();
                        e.value.walk(w);
                        k();
                        e.name.walk(r);
                    } else if (e instanceof wr) {
                        if (!(e.key instanceof mn)) {
                            e.value.walk(r);
                        } else if (e.value instanceof Dn) {
                            x();
                            _.block = e;
                            e.key.walk(w);
                            e.value.walk(r);
                            k();
                        } else {
                            e.key.walk(w);
                            e.value.walk(r);
                        }
                    } else if (e instanceof n) {
                        t(e);
                    } else {
                        e.walk(w);
                    }
                    return true;
                });
                e.walk(r);
            }
            function S(n, e) {
                var t = n.definition(), r;
                if (e && !hn(h, function(e) {
                    r = e.variables.get(n.name);
                    if (!r) return true;
                    if (!si(r)) return true;
                    return r !== t && !t.undeclared && e.parent_scope.find_variable(n.name) !== t;
                })) return y[t.id] = y[r.id] = false;
                var i = _;
                if (v) {
                    x();
                    i = _;
                    k();
                }
                if (t.id in y) {
                    var a = y[t.id];
                    if (!a) return;
                    if (a.start.block !== i.block) return y[t.id] = false;
                    o(n);
                    a.end = i;
                    if (t.id in c) {
                        f[c[t.id]] = null;
                    } else if (!e) {
                        return;
                    }
                } else if ((r = g.variables.get(t.name)) !== t) {
                    if (r && m === i) y[r.id] = false;
                    return y[t.id] = false;
                } else if (d.exposed(t) || N[n.name]) {
                    return y[t.id] = false;
                } else {
                    var a = b.get(t.id) || [];
                    a.scopes = [];
                    o(n);
                    y[t.id] = a;
                    if (!e) {
                        a.start = i;
                        return s.push({
                            index: u++,
                            definition: t
                        });
                    }
                    if (i.block !== g) return y[t.id] = false;
                    a.start = m;
                }
                c[t.id] = f.length;
                f.push({
                    index: u++,
                    definition: t
                });
                function o(e) {
                    a.push(e);
                    Qn(a.scopes, e.scope);
                    var n = Me(w);
                    if (n !== e.scope) Qn(a.scopes, n);
                }
            }
            function T(e) {
                var n = [];
                while (true) {
                    if (nt(_, "block")) {
                        var t = _.block;
                        if (t instanceof ct) t = t.body;
                        if (t === e) break;
                    }
                    n.push(_);
                    k();
                }
                _.inserted = _.block;
                x();
                while (n.length) {
                    var r = n.pop();
                    x();
                    if (nt(r, "block")) _.block = r.block;
                    if (nt(r, "loop")) _.loop = r.loop;
                }
            }
            function A(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function D(e, n) {
                return A(e.start, e.end) || A(e.start, n.start);
            }
        });
        function be(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = Fe(Jr, e);
            }
        }
        function re(e, n) {
            var t = Fe(Yt, e);
            if (t.name) t.name = n ? null : Fe(Pr, t.name);
            return t;
        }
        function ye(e, n) {
            var t;
            switch (e.CTOR) {
              case Ft:
                t = Ot;
                break;

              case Pt:
                t = $t;
                break;

              case jt:
                t = zt;
                break;

              case Nt:
                t = Ct;
                break;
            }
            var r = Fe(t, e);
            r.name = n ? null : Fe(Fr, e.name);
            return r;
        }
        yn.DEFMETHOD("drop_unused", function(z) {
            if (!z.option("unused")) return;
            var C = this;
            var M = !(C instanceof yt) || z.toplevel.funcs;
            var F = !(C instanceof yt) || z.toplevel.vars;
            var P = /keep_assign/.test(z.option("unused")) ? ln : function(e, n) {
                var t, i = false;
                if (e instanceof Pn) {
                    if (e.write_only || e.operator == "=") t = a(e.left, n);
                } else if (e instanceof zn) {
                    if (e.write_only) t = a(e.expression, n);
                }
                if (!(t instanceof Yn)) return;
                var r = t.definition();
                if (o[r.id]) return;
                if (z.exposed(r)) return;
                if (!Ce(t, z, i)) return;
                return t;
                function a(e, n) {
                    if (e instanceof Dn) {
                        var t = e.expression;
                        if (!t.may_throw_on_access(z, true)) {
                            i = true;
                            if (n && e instanceof On) n.unshift(e.property);
                            return a(t, n);
                        }
                    } else if (e instanceof Pn && e.operator == "=") {
                        e.write_only = "p";
                        var r = a(e.right);
                        if (!n) return r;
                        n.assign = e;
                        return r instanceof Yn ? r : e.left;
                    }
                    return e;
                }
            };
            var j = Object.create(null);
            var o = Object.create(null);
            var v = function(e) {
                v = a(C, 0, Gn);
                return v(e);
                function a(e, n, r) {
                    var i = z.parent(n);
                    if (!i) return r;
                    var t = i instanceof wn && Vn(e, i.argnames);
                    return a(i, n + 1, t ? function(e) {
                        var n = r(e);
                        if (n) return n;
                        n = i.variables.get(e);
                        if (n) {
                            var t = n.orig[0];
                            if (t instanceof Hn || t instanceof Fr) return n;
                        }
                    } : i.variables ? function(e) {
                        return r(e) || i.variables.get(e);
                    } : r);
                }
            };
            var N = Object.create(null);
            var m = [];
            var I = Object.create(null);
            var _ = Object.create(null);
            var g = Object.create(null);
            var b = Object.create(null);
            var H = Object.create(null);
            if (C instanceof yt && z.top_retain) {
                C.variables.each(function(e) {
                    if (z.top_retain(e) && !(e.id in I)) {
                        mn.info("Retaining variable {name}", e);
                        I[e.id] = true;
                        m.push(e);
                    }
                });
            }
            var y = new vn();
            var w = new vn();
            var Y = this;
            var x = new Un(function(s, e) {
                if (s instanceof wn && s.uses_arguments && !x.has_directive("use strict")) {
                    s.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                    });
                }
                if (s === C) return;
                if (Y === C) {
                    if (s instanceof Ht) {
                        var n = s.name.definition();
                        var t = M && !n.exported;
                        if (!t && !(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        var r = x.parent() instanceof pr;
                        if (r) {
                            o[n.id] = true;
                        } else if (t && !(n.id in _)) {
                            _[n.id] = 1;
                        }
                        if (s.extends) s.extends.walk(x);
                        var i = [];
                        s.properties.forEach(function(e) {
                            if (e.key instanceof mn) e.key.walk(x);
                            var n = e.value;
                            if (!n) return;
                            if (te(e)) {
                                if (!r && n.contains_this()) r = true;
                                a(n);
                            } else {
                                i.push(n);
                            }
                        });
                        i.forEach(t && r ? a : function(e) {
                            w.add(n.id, e);
                        });
                        return true;
                    }
                    if (s instanceof Mt) {
                        var n = s.name.definition();
                        var t = M && !n.exported;
                        if (!t && !(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        w.add(n.id, s);
                        if (x.parent() instanceof pr) {
                            o[n.id] = true;
                            return f(s, e, true);
                        }
                        if (t && !(n.id in _)) _[n.id] = 1;
                        return true;
                    }
                    if (s instanceof sr) {
                        s.definitions.forEach(function(r) {
                            var i = r.value;
                            var a = i && (r.name instanceof Nn || i.has_side_effects(z));
                            var o = a && i.tail_node().operator == "=";
                            r.name.mark_symbol(function(e) {
                                if (!(e instanceof qr)) return;
                                var n = e.definition();
                                H[n.id] = (H[n.id] || 0) + 1;
                                if (s instanceof cr && n.orig[0] instanceof jr) {
                                    var t = n.redefined();
                                    if (t) H[t.id] = (H[t.id] || 0) + 1;
                                }
                                if (!(n.id in I) && (!F || n.exported || (s instanceof fr ? n.redefined() : n.const_redefs) || !(s instanceof cr || Ye(n)))) {
                                    I[n.id] = true;
                                    m.push(n);
                                }
                                if (i) {
                                    if (!a) {
                                        w.add(n.id, i);
                                    } else if (o) {
                                        S(n, e, b[n.id]);
                                    }
                                    y.add(n.id, r);
                                }
                                T(n);
                                return true;
                            }, x);
                            if (a) i.walk(x);
                        });
                        return true;
                    }
                    if (s instanceof Hn) {
                        var n = s.definition();
                        H[n.id] = (H[n.id] || 0) + 1;
                        y.add(n.id, s);
                        return true;
                    }
                    if (s instanceof $r) {
                        var n = s.definition();
                        if (!(n.id in I) && (!F || !Ye(n))) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        return true;
                    }
                }
                return f(s, e, true);
                function a(e) {
                    var n = Y;
                    Y = s;
                    e.walk(x);
                    Y = n;
                }
            });
            x.directives = Object.create(z.directives);
            C.walk(x);
            var R = z.option("keep_fnames") ? ln : z.option("ie") ? function(e) {
                return !z.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in I)) return true;
                if (e.orig.length - e.eliminated < 2) return false;
                if (e.orig[1] instanceof Hn) return true;
                return hn(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            if (z.option("ie")) w.each(function(e, n) {
                if (n in I) return;
                e.forEach(function(e) {
                    e.walk(new Un(function(e) {
                        if (e instanceof zt && e.name && !R(e.name.definition())) {
                            e.walk(x);
                            return true;
                        }
                        if (e instanceof yn) return true;
                    }));
                });
            });
            x = new Un(f);
            for (var e = 0; e < m.length; e++) {
                var n = w.get(m[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(x);
                });
            }
            Object.keys(j).forEach(function(e) {
                var t = j[e];
                if (!t) {
                    delete j[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Qn(n, e);
                    });
                    return n;
                }, []);
                var n = (y.get(e) || []).filter(function(n) {
                    return Wn(n instanceof zn ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof zn) return false;
                        return r(e) === r(n);
                    }, t);
                });
                if (t.length == n.length) {
                    j[e] = n;
                } else {
                    delete j[e];
                }
            });
            var B = [];
            var L = [];
            var U = new ei(function(r) {
                if (r instanceof Sn) return D(U, r);
                if (r instanceof Nn && r.rest) r.rest = r.rest.transform(U);
                if (r instanceof yr) {
                    var e = !r.rest;
                    for (var n = r.elements.length; --n >= 0; ) {
                        var t = r.elements[n].transform(U);
                        if (t) {
                            r.elements[n] = t;
                            e = false;
                        } else if (e) {
                            r.elements.pop();
                        } else {
                            r.elements[n] = Fe(Jr, r.elements[n]);
                        }
                    }
                    return r;
                }
                if (r instanceof xr) {
                    var i = [];
                    r.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof mn) {
                            e.key = e.key.transform(V);
                            n = e.key.has_side_effects(z);
                        }
                        if ((n || r.rest) && a(e.value)) {
                            e.value = e.value.transform(V);
                            i.push(e);
                        } else {
                            var t = e.value.transform(U);
                            if (!t && r.rest) {
                                if (e.value instanceof yr) {
                                    t = Fe(yr, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = Fe(xr, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                i.push(e);
                            }
                        }
                    });
                    r.properties = i;
                    return r;
                }
                if (r instanceof qr) return X(r);
            });
            var V = new ei(function(_, n, e) {
                var g = V.parent();
                if (F) {
                    var t = [], r = P(_, t);
                    if (r) {
                        var i;
                        if (Z(r, _)) {
                            if (_ instanceof Pn) {
                                i = ee(_);
                                if (_.write_only === true) i = i.drop_side_effect_free(z);
                            }
                            if (!i) i = Fe(Ln, _, {
                                value: 0
                            });
                        }
                        if (i) {
                            if (t.assign) {
                                var a = t.assign.drop_side_effect_free(z);
                                if (a) {
                                    a.write_only = true;
                                    t.unshift(a);
                                }
                            }
                            if (!(g instanceof An) || g.tail_node() === _ || i.has_side_effects(z)) {
                                t.push(i);
                            }
                            switch (t.length) {
                              case 0:
                                return Kn.skip;

                              case 1:
                                return je(g, _, t[0].transform(V));

                              default:
                                return Pe(_, t.map(function(e) {
                                    return e.transform(V);
                                }));
                            }
                        }
                    } else if (_ instanceof _r && _.expression instanceof Yn && J(_.expression.definition(), _) < 0) {
                        return Fe(Cn, _, {
                            operator: "+",
                            expression: _.expression
                        });
                    }
                }
                if (_ instanceof Mn && _.operator == "instanceof") {
                    var r = _.right;
                    if (!(r instanceof Yn)) return;
                    if (r.definition().id in I) return;
                    var o = _.left.drop_side_effect_free(z);
                    var i = Fe(Qr, _).optimize(z);
                    return o ? Pe(_, [ o, i ]) : i;
                }
                if (_ instanceof Tn) {
                    B.push(_);
                    _.args = _.args.map(function(e) {
                        return e.transform(V);
                    });
                    _.expression = _.expression.transform(V);
                    return _;
                }
                if (Y !== C) return;
                if (M && _ !== C && _ instanceof Ht) {
                    var s = _.name.definition();
                    if (!(s.id in I)) {
                        W(_.name, "Dropping unused class {name}");
                        s.eliminated++;
                        n(_, V);
                        var f = re(_, true);
                        if (g instanceof pr) return f;
                        f = f.drop_side_effect_free(z, true);
                        if (f) return Fe(gn, _, {
                            body: f
                        });
                        return e ? Kn.skip : Fe(_n, _);
                    }
                }
                if (_ instanceof Yt && _.name && R(_.name.definition())) {
                    _.name = null;
                }
                if (_ instanceof wn) {
                    if (M && _ !== C && _ instanceof Mt) {
                        var s = _.name.definition();
                        if (!(s.id in I)) {
                            W(_.name, "Dropping unused function {name}");
                            s.eliminated++;
                            if (g instanceof pr) {
                                $();
                                return ye(_, true);
                            }
                            return e ? Kn.skip : Fe(_n, _);
                        }
                    }
                    if (_ instanceof kt && _.name && R(_.name.definition())) {
                        _.name = null;
                    }
                    if (!(_ instanceof xt)) {
                        var u, c, l = z.drop_fargs(_, g);
                        if (l && g instanceof Tn && g.expression === _) {
                            u = g.args;
                            for (c = 0; c < u.length; c++) {
                                if (u[c] instanceof $n) break;
                            }
                        }
                        var p = _.argnames;
                        var d = _.rest;
                        var h = false, v = false;
                        if (d) {
                            v = true;
                            if (!u || c < p.length || d instanceof Hn) {
                                d = d.transform(U);
                            } else {
                                var f = K(d, Fe(jn, g, {
                                    elements: u.slice(p.length)
                                }), X, !_.uses_arguments, d);
                                d = f.name;
                                u.length = p.length;
                                if (f.value.elements.length) [].push.apply(u, f.value.elements);
                            }
                            if (d instanceof Nn && !d.rest) {
                                if (d instanceof yr) {
                                    if (d.elements.length == 0) d = null;
                                } else if (d.properties.length == 0) {
                                    d = null;
                                }
                            }
                            _.rest = d;
                            if (d) {
                                l = false;
                                h = true;
                            }
                        }
                        var m = l ? -1 : _.length();
                        var b = u && !_.uses_arguments && g !== z.parent();
                        for (var y = p.length; --y >= 0; ) {
                            var r = p[y];
                            if (r instanceof Hn) {
                                var s = r.definition();
                                if (s.id in I) {
                                    l = false;
                                    if (J(s, r) < 0) r.unused = null;
                                } else if (l) {
                                    W(r, "Dropping unused function argument {name}");
                                    p.pop();
                                    s.eliminated++;
                                    r.unused = true;
                                } else {
                                    r.unused = true;
                                }
                            } else {
                                v = true;
                                var w;
                                if (!u || c < y) {
                                    w = r.transform(U);
                                } else {
                                    var f = K(r, u[y], X, b, r);
                                    w = f.name;
                                    if (f.value) u[y] = f.value;
                                }
                                if (w) {
                                    l = false;
                                    p[y] = w;
                                    if (!h) h = !(w instanceof Hn);
                                } else if (l) {
                                    G(r, "Dropping unused default argument {name}");
                                    p.pop();
                                } else if (y > m) {
                                    G(r, "Dropping unused default argument assignment {name}");
                                    if (r.name instanceof Hn) {
                                        r.name.unused = true;
                                    } else {
                                        h = true;
                                    }
                                    p[y] = r.name;
                                } else {
                                    G(r, "Dropping unused default argument value {name}");
                                    p[y] = r = r.clone();
                                    r.value = Fe(Ln, r, {
                                        value: 0
                                    });
                                    h = true;
                                }
                            }
                        }
                        if (v && !h && _.uses_arguments && !V.has_directive("use strict")) {
                            _.rest = Fe(yr, _, {
                                elements: []
                            });
                        }
                        L.push(_);
                    }
                }
                if (_ instanceof ar && _.argname instanceof Nn) {
                    _.argname.transform(U);
                }
                if (_ instanceof sr && !(g instanceof mt && g.init === _)) {
                    var x = [], k = [], E = [];
                    var S = [];
                    var T = 0;
                    var A = _ instanceof cr;
                    _.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(V);
                        var e = t.value;
                        if (t.name instanceof Nn) {
                            var n = K(t.name, e, function(e) {
                                if (!F) return e;
                                if (e.definition().id in I) return e;
                                if (v(e)) return e;
                                if (A && !Ce(e)) return e;
                                return null;
                            }, true);
                            if (n.name) {
                                t = Fe(En, t, {
                                    name: n.name,
                                    value: e = n.value
                                });
                                m();
                            } else if (n.value) {
                                S.push(n.value);
                            }
                            return;
                        }
                        var a = t.name.definition();
                        var r = A ? Ce(t.name) : Ye(a);
                        if (!r || !F || a.id in I) {
                            var i;
                            if (e && ((i = J(a, t)) < 0 || l(e.tail_node()))) {
                                t = t.clone();
                                e = e.drop_side_effect_free(z);
                                if (e) mn.warn("Side effects in definition of variable {name} [{start}]", t.name);
                                if (_ instanceof fr) {
                                    t.value = e || Fe(Ln, t, {
                                        value: 0
                                    });
                                } else {
                                    t.value = null;
                                    if (e) S.push(e);
                                }
                                e = null;
                                if (i >= 0) j[a.id][i] = t;
                            }
                            var o, s;
                            if (!e && !(_ instanceof ur)) {
                                if (g instanceof lr) {
                                    m();
                                } else if (r && H[a.id] > 1) {
                                    mn.info("Dropping declaration of variable {name} [{start}]", t.name);
                                    H[a.id]--;
                                    a.eliminated++;
                                } else {
                                    k.push(t);
                                }
                            } else if (z.option("functions") && !z.option("ie") && r && e && H[a.id] == 1 && a.assignments == 0 && (s = e.tail_node()) instanceof kt && !ze(a) && !Et(s) && p(s, a.references) && d(s) && (o = h(s, t.name.name)) !== false) {
                                mn.warn("Declaring {name} as function [{start}]", t.name);
                                var f;
                                switch (s.CTOR) {
                                  case Ot:
                                    f = Ft;
                                    break;

                                  case $t:
                                    f = Pt;
                                    break;

                                  case zt:
                                    f = jt;
                                    break;

                                  case Ct:
                                    f = Nt;
                                    break;
                                }
                                var u = Fe(f, s);
                                u.name = Fe(Mr, t.name);
                                var c = t.name.scope.resolve().def_function(u.name);
                                if (o) o.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference();
                                });
                                x.push(u);
                                if (e !== s) [].push.apply(S, e.expressions.slice(0, -1));
                            } else {
                                if (r && H[a.id] > 1 && !(g instanceof lr) && a.orig.indexOf(t.name) > a.eliminated) {
                                    H[a.id]--;
                                    T++;
                                }
                                m();
                            }
                        } else if (v(t.name)) {
                            e = e && e.drop_side_effect_free(z);
                            if (e) S.push(e);
                            if (H[a.id] > 1) {
                                mn.warn("Dropping duplicated declaration of variable {name} [{start}]", t.name);
                                H[a.id]--;
                                a.eliminated++;
                            } else {
                                t.value = null;
                                k.push(t);
                            }
                        } else {
                            e = e && e.drop_side_effect_free(z);
                            if (e) {
                                mn.warn("Side effects in initialization of unused variable {name} [{start}]", t.name);
                                S.push(e);
                            } else {
                                W(t.name, "Dropping unused variable {name}");
                            }
                            a.eliminated++;
                        }
                        function l(e) {
                            return e instanceof Yn && e.definition() === a;
                        }
                        function p(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return hn(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function d(e) {
                            if (!A || z.has_directive("use strict") || !(e instanceof zt)) {
                                return g instanceof yn;
                            }
                            return g instanceof ut || g instanceof vt && g.init === _ || g instanceof kn;
                        }
                        function h(t, r) {
                            if (!t.name) return null;
                            var e = t.name.definition();
                            if (e.orig.length > 1) return null;
                            if (e.assignments > 0) return false;
                            if (e.name == r) return e;
                            if (z.option("keep_fnames")) return false;
                            var i;
                            switch (r) {
                              case "await":
                                i = St;
                                break;

                              case "yield":
                                i = Tt;
                                break;
                            }
                            return hn(e.references, function(e) {
                                var n = e.scope;
                                if (n.find_variable(r) !== a) return false;
                                if (i) do {
                                    n = n.resolve();
                                    if (i(n)) return false;
                                } while (n !== t && (n = n.parent_scope));
                                return true;
                            }) && e;
                        }
                        function v(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof jr && n.scope.resolve() === e.scope.resolve();
                        }
                        function m() {
                            if (S.length > 0) {
                                if (E.length == 0) {
                                    x.push(Fe(gn, _, {
                                        body: Pe(_, S)
                                    }));
                                } else if (e) {
                                    S.push(e);
                                    t.value = Pe(e, S);
                                } else {
                                    t.value = Fe(Cn, t, {
                                        operator: "void",
                                        expression: Pe(t, S)
                                    });
                                }
                                S = [];
                            }
                            E.push(t);
                        }
                    });
                    switch (k.length) {
                      case 0:
                        if (E.length == 0) break;
                        if (E.length == T) {
                            [].unshift.apply(S, E.map(function(e) {
                                mn.info("Dropping duplicated definition of variable {name} [{start}]", e.name);
                                var n = e.name.definition();
                                var t = Fe(Yn, e.name);
                                n.references.push(t);
                                var r = Fe(Pn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var i = J(n, e);
                                if (i >= 0) j[n.id][i] = r;
                                n.assignments++;
                                n.eliminated++;
                                return r;
                            }));
                            break;
                        }

                      case 1:
                        if (E.length == 0) {
                            var D = k[0].name.definition().id;
                            if (D in N) {
                                _.definitions = k;
                                N[D].init = _;
                                break;
                            }
                        }

                      default:
                        var q;
                        if (E.length > 0 && (q = E[0].value) instanceof An) {
                            E[0].value = q.tail_node();
                            x.push(Fe(gn, _, {
                                body: Pe(q, q.expressions.slice(0, -1))
                            }));
                        }
                        _.definitions = k.concat(E);
                        x.push(_);
                    }
                    if (S.length > 0) {
                        x.push(Fe(gn, _, {
                            body: Pe(_, S)
                        }));
                    }
                    return Q(x, _, e);
                }
                if (_ instanceof Pn) {
                    n(_, V);
                    if (!(_.left instanceof Nn)) return _;
                    var f = K(_.left, _.right, function(e) {
                        return e;
                    }, _.write_only === true);
                    if (f.name) return Fe(Pn, _, {
                        operator: _.operator,
                        left: f.name,
                        right: f.value
                    });
                    if (f.value) return f.value;
                    if (g instanceof An && g.tail_node() !== _) return Kn.skip;
                    return Fe(Ln, _, {
                        value: 0
                    });
                }
                if (_ instanceof ct && _.body instanceof vt) {
                    n(_, V);
                    if (_.body instanceof bn) {
                        var O = _.body;
                        _.body = O.body.pop();
                        O.body.push(_);
                        return e ? Kn.splice(O.body) : O;
                    }
                    return _;
                }
                if (_ instanceof yn) {
                    $();
                    return _;
                }
                if (_ instanceof $r) {
                    if (!z.option("imports") || _.definition().id in I) return _;
                    return e ? Kn.skip : null;
                }
                function $() {
                    var e = Y;
                    Y = _;
                    n(_, V);
                    Y = e;
                }
            }, function(e, n) {
                if (e instanceof bn) return q(e, V.parent(), n);
                if (e instanceof lr) {
                    var t = e.body;
                    if (!(t instanceof bn)) return;
                    e.body = t.body.pop();
                    t.body.push(e);
                    return n ? Kn.splice(t.body) : t;
                }
                if (e instanceof vt) return Ge(e, n);
                if (e instanceof _t) {
                    if (!F || !z.option("loops")) return;
                    if (!ue(e.body)) return;
                    var r = A(e);
                    if (!r) return;
                    var i = r.definition();
                    if (i.id in I) return;
                    W(r, "Dropping unused loop variable {name}");
                    if (N[i.id] === e) delete N[i.id];
                    var a = [];
                    var o = e.object.drop_side_effect_free(z);
                    if (o) {
                        mn.warn("Side effects in object of for-in loop [{start}]", o);
                        a.push(Fe(gn, e, {
                            body: o
                        }));
                    }
                    if (e.init instanceof sr && i.orig[0] instanceof jr) {
                        a.push(e.init);
                    }
                    return Q(a, e, n);
                }
                if (e instanceof hr) {
                    if (e.properties && e.properties.length == 0) e.properties = null;
                    return e;
                }
                if (e instanceof An) {
                    if (e.expressions.length > 1) return;
                    return je(V.parent(), e, e.expressions[0]);
                }
            });
            V.push(z.parent());
            V.directives = Object.create(z.directives);
            C.transform(V);
            if (C instanceof wn && C.body.length == 1 && C.body[0] instanceof at && C.body[0].value == "use strict") {
                C.body.length = 0;
            }
            B.forEach(function(e) {
                ke(e, z, L);
            });
            function W(e, n) {
                mn[e.definition().references.length > 0 ? "info" : "warn"](n + " [{start}]", e);
            }
            function G(e, n) {
                if (e.name instanceof Hn) {
                    W(e.name, n);
                } else {
                    mn.info(n + " [{start}]", e);
                }
            }
            function r(e) {
                return e[e instanceof Pn ? "right" : "value"];
            }
            function Q(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? Kn.skip : Fe(_n, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? Kn.splice(e) : Fe(bn, n, {
                        body: e
                    });
                }
            }
            function k(e, n) {
                if (e.scope.resolve() !== C) return false;
                if (!e.fixed || !n.fixed) j[e.id] = false;
                return j[e.id] !== false;
            }
            function E(e, n) {
                if (!j[e.id]) j[e.id] = [];
                if (n.fixed.assigns) Qn(j[e.id], n.fixed.assigns);
            }
            function J(e, n) {
                var t = j[e.id];
                return t && t.indexOf(n);
            }
            function T(e) {
                if (_[e.id] > 1 && !(e.id in I)) {
                    I[e.id] = true;
                    m.push(e);
                }
                _[e.id] = 0;
            }
            function S(e, n, t) {
                if (e.id in I) return;
                if (n && t) {
                    I[e.id] = n;
                    m.push(e);
                } else {
                    g[e.id] = n;
                    b[e.id] = t;
                }
            }
            function Z(e, n) {
                var t = e.definition();
                var r = I[t.id];
                if (!r) return true;
                if (n[n instanceof Pn ? "left" : "expression"] !== e) return false;
                return r === e && t.references.length - t.replaced == 1 || J(t, n) < 0;
            }
            function ee(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof Mn && He[n.operator])) return n;
                if (!(n.left instanceof Yn)) return n;
                if (!(e.left instanceof Yn)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(z)) return n;
                if (k(t, n.left)) E(t, n.left);
                return n.right;
            }
            function A(e) {
                var n = e.init;
                if (n instanceof sr) {
                    n = n.definitions[0].name;
                    return n instanceof qr && n;
                }
                while (n instanceof Dn) n = n.expression.tail_node();
                if (n instanceof Yn) return n;
            }
            function f(e, n, t) {
                if (e instanceof Pn && e.left instanceof Yn) {
                    var r = e.left.definition();
                    if (r.scope.resolve() === C) y.add(r.id, e);
                }
                if (e instanceof Yn && e.in_arg) H[e.definition().id] = 0;
                if (e instanceof zn && e.expression instanceof Yn) {
                    var r = e.expression.definition();
                    if (r.scope.resolve() === C) y.add(r.id, e);
                }
                var i = [], a = P(e, i);
                if (a) {
                    var o = a.definition();
                    if (o.scope.resolve() !== C && C.variables.get(a.name) !== o) return;
                    if (ze(o) && !hn(C.argnames, function(e) {
                        return !e.match_symbol(function(e) {
                            if (e instanceof Hn) {
                                var n = e.definition();
                                return n.references.length > n.replaced;
                            }
                        }, true);
                    })) return;
                    if (e.write_only === "p" && e.right.may_throw_on_access(z, true)) return;
                    var s = i.assign;
                    if (s) {
                        s.write_only = true;
                        s.walk(x);
                    }
                    i.forEach(function(e) {
                        e.walk(x);
                    });
                    if (e instanceof Pn) {
                        var f = ee(e), u = false;
                        if (t && e.write_only === true && !f.has_side_effects(z)) {
                            w.add(o.id, f);
                        } else {
                            f.walk(x);
                            u = f.tail_node().operator == "=";
                        }
                        if (e.left === a) {
                            if (!e.write_only || u) {
                                S(o, a, b[o.id]);
                            }
                        } else {
                            var c = a.fixed_value();
                            if (!c || !c.is_constant()) {
                                S(o, g[o.id], true);
                            }
                        }
                    }
                    if (k(o, a) && ui(a, e) !== a) E(o, a);
                    T(o);
                    return true;
                }
                if (e instanceof Mn) {
                    if (e.operator != "instanceof") return;
                    var a = e.right;
                    if (!(a instanceof Yn)) return;
                    var l = a.definition().id;
                    if (!_[l]) return;
                    e.left.walk(x);
                    _[l]++;
                    return true;
                }
                if (e instanceof _t) {
                    if (e.init instanceof Yn && Y === C) {
                        var l = e.init.definition().id;
                        if (!(l in N)) N[l] = e;
                    }
                    if (!F || !z.option("loops")) return;
                    if (!ue(e.body)) return;
                    if (e.init.has_side_effects(z)) return;
                    var a = A(e);
                    if (!a) return;
                    var r = a.definition();
                    if (r.scope.resolve() !== C) {
                        var p = v(a.name);
                        if (p === r || p && p.redefined() === r) return;
                    }
                    e.object.walk(x);
                    return true;
                }
                if (e instanceof Yn) {
                    var o = e.definition();
                    if (!(o.id in I)) {
                        I[o.id] = true;
                        m.push(o);
                    }
                    if (ne(o.scope, e.scope)) {
                        var d = o.redefined();
                        if (d && !(d.id in I)) {
                            I[d.id] = true;
                            m.push(d);
                        }
                    }
                    if (k(o, e)) E(o, e);
                    return true;
                }
                if (e instanceof yn) {
                    var h = Y;
                    Y = e;
                    n();
                    Y = h;
                    return true;
                }
            }
            function a(e) {
                return (e instanceof Sn ? e.name : e) instanceof qr;
            }
            function X(e) {
                if (e.definition().id in I) return e;
                if (e instanceof Hn) e.unused = true;
                return null;
            }
            function D(e, n) {
                n.value = n.value.transform(V);
                var t = n.name.transform(e);
                if (!t) {
                    if (n.name instanceof Nn) return null;
                    var r = n.value.drop_side_effect_free(z);
                    if (!r) return null;
                    W(n.name, "Side effects in default value of unused variable {name}");
                    n = n.clone();
                    n.name.unused = null;
                    n.value = r;
                }
                return n;
            }
            function K(e, _, g, b, y) {
                var w = new ei(function(a) {
                    if (a instanceof Sn) {
                        if (!(z.option("default_values") && _ && _.is_defined(z))) {
                            var e = b;
                            b = false;
                            var n = D(w, a);
                            b = e;
                            if (!n && b && _) _ = _.drop_side_effect_free(z);
                            return n;
                        } else if (a === y) {
                            y = a = a.name;
                        } else {
                            a = a.name;
                        }
                    }
                    if (a instanceof yr) {
                        var e = b;
                        var t = _;
                        if (_ instanceof Yn) {
                            b = false;
                            _ = _.fixed_value();
                        }
                        var r, i;
                        if (_ instanceof jn) {
                            r = true;
                            i = _.elements;
                        } else {
                            r = _ && _.is_string(z);
                            i = false;
                        }
                        var o = [], s = b && [], f = 0;
                        a.elements.forEach(function(e, n) {
                            _ = i && i[n];
                            if (_ instanceof Jr) {
                                _ = null;
                            } else if (_ instanceof $n) {
                                if (b) {
                                    s.length = f;
                                    be(t, s);
                                    [].push.apply(s, i.slice(n));
                                    t.elements = s;
                                }
                                _ = i = false;
                            }
                            e = e.transform(w);
                            if (e) o[f] = e;
                            if (b && _) s[f] = _;
                            if (e || _ || !b || !i) f++;
                        });
                        _ = i && Fe(jn, t, {
                            elements: i.slice(a.elements.length)
                        });
                        if (a.rest) {
                            var u = b;
                            b = false;
                            a.rest = a.rest.transform(z.option("rests") ? w : V);
                            b = u;
                            if (a.rest) o.length = f;
                        }
                        if (b) {
                            if (_ && !a.rest) _ = _.drop_side_effect_free(z);
                            if (_ instanceof jn) {
                                _ = _.elements;
                            } else if (_ instanceof An) {
                                _ = _.expressions;
                            } else if (_) {
                                _ = [ _ ];
                            }
                            if (_ && _.length) {
                                s.length = f;
                                [].push.apply(s, _);
                            }
                        }
                        _ = t;
                        b = e;
                        if (i && s) {
                            be(_, s);
                            _ = _.clone();
                            _.elements = s;
                        }
                        if (!r) {
                            o.length = a.elements.length;
                        } else if (!a.rest) switch (o.length) {
                          case 0:
                            if (a === y) break;
                            if (b) _ = _.drop_side_effect_free(z);
                            return null;

                          case 1:
                            if (!b) break;
                            if (a === y) break;
                            var c = o[0];
                            if (c.has_side_effects(z)) break;
                            if (_.has_side_effects(z) && c.match_symbol(function(e) {
                                return e instanceof Dn;
                            })) break;
                            _ = Fe(On, a, {
                                expression: _,
                                property: Fe(Ln, a, {
                                    value: 0
                                })
                            });
                            return c;
                        }
                        be(a, o);
                        a.elements = o;
                        return a;
                    }
                    if (a instanceof xr) {
                        var e = b;
                        var t = _;
                        if (_ instanceof Yn) {
                            b = false;
                            _ = _.fixed_value();
                        }
                        var l, p, i;
                        if (_ instanceof In) {
                            l = [];
                            p = new vn();
                            i = _.properties.map(function(e, n) {
                                e = e.clone();
                                if (e instanceof $n) {
                                    p = false;
                                } else {
                                    var t = e.key;
                                    if (t instanceof mn) t = t.evaluate(z, true);
                                    if (t instanceof mn) {
                                        p = false;
                                    } else if (p && !(e instanceof Tr)) {
                                        p.set(t, e);
                                    }
                                    l[n] = t;
                                }
                                return e;
                            });
                        }
                        if (a.rest) {
                            _ = false;
                            a.rest = a.rest.transform(z.option("rests") ? w : V);
                        }
                        var d = new vn();
                        var h = b && new vn();
                        var v = [];
                        a.properties.map(function(e) {
                            var n = e.key;
                            if (n instanceof mn) {
                                e.key = n = n.transform(V);
                                n = n.evaluate(z, true);
                            }
                            if (n instanceof mn) {
                                h = false;
                            } else {
                                d.set(n, !d.has(n));
                            }
                            return n;
                        }).forEach(function(e, n) {
                            var t = a.properties[n], r;
                            if (e instanceof mn) {
                                b = false;
                                _ = false;
                                r = t.value.transform(w) || k(t.value);
                            } else {
                                b = h && d.get(e);
                                var i = p && p.get(e);
                                if (i) {
                                    _ = i.value;
                                    if (_ instanceof xt) _ = false;
                                } else {
                                    _ = false;
                                }
                                r = t.value.transform(w);
                                if (!r) {
                                    if (a.rest || x(t)) r = k(t.value);
                                    if (h && !h.has(e)) {
                                        if (i) {
                                            h.set(e, i);
                                            if (_ === null) {
                                                p.set(e, x(i) && Fe(Er, i, {
                                                    key: i.key,
                                                    value: Fe(Ln, i, {
                                                        value: 0
                                                    })
                                                }));
                                            }
                                        } else {
                                            h.set(e, true);
                                        }
                                    }
                                } else if (h) {
                                    h.set(e, false);
                                }
                                if (_) i.value = _;
                            }
                            if (r) {
                                t.value = r;
                                v.push(t);
                            }
                        });
                        _ = t;
                        b = e;
                        if (h && l) {
                            _ = _.clone();
                            _.properties = Kn(i, function(e, n) {
                                if (e instanceof $n) return e;
                                var t = l[n];
                                if (t instanceof mn) return e;
                                if (h.has(t)) {
                                    var r = h.get(t);
                                    if (!r) return e;
                                    if (r === e) return p.get(t) || Kn.skip;
                                } else if (a.rest) {
                                    return e;
                                }
                                var i = e.value.drop_side_effect_free(z);
                                if (i) {
                                    e.value = i;
                                    return e;
                                }
                                return x(e) ? Fe(Er, e, {
                                    key: e.key,
                                    value: Fe(Ln, e, {
                                        value: 0
                                    })
                                }) : Kn.skip;
                            });
                        }
                        if (_ && !a.rest) switch (v.length) {
                          case 0:
                            if (a === y) break;
                            if (_.may_throw_on_access(z, true)) break;
                            if (b) _ = _.drop_side_effect_free(z);
                            return null;

                          case 1:
                            if (!b) break;
                            if (a === y) break;
                            var m = v[0];
                            if (m.key instanceof mn) break;
                            if (m.value.has_side_effects(z)) break;
                            if (_.has_side_effects(z) && m.value.match_symbol(function(e) {
                                return e instanceof Dn;
                            })) break;
                            _ = Fe(On, a, {
                                expression: _,
                                property: fe(m.key, m)
                            });
                            return m.value;
                        }
                        a.properties = v;
                        return a;
                    }
                    if (a instanceof Jr) {
                        a = null;
                    } else {
                        a = g(a);
                    }
                    if (!a && b && _) _ = _.drop_side_effect_free(z);
                    return a;
                });
                return {
                    name: e.transform(w),
                    value: _
                };
                function x(e) {
                    return e.key instanceof mn && e.key.has_side_effects(z);
                }
                function n(e) {
                    if (e instanceof Pn) {
                        e.write_only = false;
                        n(e.right);
                    } else if (e instanceof Mn) {
                        if (!He[e.operator]) return;
                        n(e.left);
                        n(e.right);
                    } else if (e instanceof Fn) {
                        n(e.consequent);
                        n(e.alternative);
                    } else if (e instanceof An) {
                        n(e.tail_node());
                    } else if (e instanceof zn) {
                        e.write_only = false;
                    }
                }
                function k(e) {
                    if (e instanceof Sn) return k(e.name);
                    if (e instanceof Nn) {
                        if (_ === null) {
                            _ = Fe(Ln, e, {
                                value: 0
                            });
                        } else if (_) {
                            if (_.may_throw_on_access(z, true)) {
                                _ = Fe(jn, e, {
                                    elements: _ instanceof An ? _.expressions : [ _ ]
                                });
                            } else {
                                n(_);
                            }
                        }
                        return Fe(xr, e, {
                            properties: []
                        });
                    }
                    e.unused = null;
                    return e;
                }
            }
        });
        yn.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Un(function(e) {
                    if (n > 1) return true;
                    if (e instanceof lr) return true;
                    if (e instanceof yn && e !== u) return true;
                    if (e instanceof cr) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = new vn();
            var l = [];
            var p = [];
            var d = new vn();
            var h = new ei(function(e, n, t) {
                if (e === u) return;
                if (e instanceof at) {
                    l.push(e);
                    return t ? Kn.skip : Fe(_n, e);
                }
                if (e instanceof Mt) {
                    if (!s) return e;
                    var r = h.parent();
                    if (r instanceof lr) return e;
                    if (r instanceof pr) return e;
                    if (r !== u && o.has_directive("use strict")) return e;
                    p.push(e);
                    return t ? Kn.skip : Fe(_n, e);
                }
                if (e instanceof cr) {
                    if (!f) return e;
                    var r = h.parent();
                    if (r instanceof lr) return e;
                    if (!hn(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof Cr && !c.has(n.name) && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        d.set(e.name.name, e);
                    });
                    var i = e.to_assignments();
                    if (r instanceof mt && r.init === e) {
                        if (i) return i;
                        var a = e.definitions[0].name;
                        return Fe(Yn, a);
                    }
                    if (r instanceof vt && r.init === e) return i;
                    if (!i) return t ? Kn.skip : Fe(_n, e);
                    return Fe(gn, e, {
                        body: i
                    });
                }
                if (e instanceof yn) return e;
                if (e instanceof Or) {
                    c.set(e.name, true);
                    return e;
                }
            });
            u.transform(h);
            if (d.size() > 0) {
                var t = [];
                if (u instanceof wn) u.each_argname(function(e) {
                    if (hn(e.definition().references, function(e) {
                        return !e.in_arg;
                    })) d.del(e.name);
                });
                d.each(function(e, n) {
                    e = e.clone();
                    e.name = e.name.clone();
                    e.value = null;
                    t.push(e);
                    d.set(n, e);
                    e.name.definition().orig.unshift(e.name);
                });
                if (t.length > 0) p.push(Fe(cr, u, {
                    definitions: t
                }));
            }
            u.body = l.concat(p, u.body);
        });
        function y(n, t) {
            n.walk(new Un(function(e) {
                if (e instanceof xn) {
                    t(e);
                    return true;
                }
                if (e instanceof yn && e !== n) return true;
            }));
        }
        function _(e) {
            var r = Object.create(null);
            y(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof Yn) {
                    var t = n.definition().id;
                    r[t] = (r[t] || 0) + 1;
                }
            });
            return r;
        }
        function g(e, n, t) {
            if (t.exposed(e)) return false;
            switch (e.references.length - e.replaced - (n[e.id] || 0)) {
              case e.drop_return:
                return "d";

              case e.bool_return:
                return true;
            }
        }
        function D(e, r) {
            y(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = M(r, n);
                    if (!t) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Pe(e.value, [ n, Fe(Ln, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof mn)) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Pe(e.value, [ n, Fe(Ln, e.value, {
                            value: 1
                        }) ]) : Fe(Ln, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        yn.DEFMETHOD("process_returns", Gn);
        jt.DEFMETHOD("process_returns", function(e) {
            if (!e.option("booleans")) return;
            if (e.parent() instanceof pr) return;
            switch (g(this.name.definition(), _(this), e)) {
              case "d":
                I(e, this, true);
                break;

              case true:
                D(this, e);
                break;
            }
        });
        zt.DEFMETHOD("process_returns", function(n) {
            if (!n.option("booleans")) return;
            var t = true;
            var r = _(this);
            if (this.name && !c(this.name.definition())) return;
            var e = n.parent();
            if (e instanceof Pn) {
                if (e.operator != "=") return;
                var i = e.left;
                if (!(i instanceof Yn)) return;
                if (!c(i.definition())) return;
            } else if (e instanceof Tn && e.expression !== this) {
                var a = e.expression;
                if (a instanceof Yn) a = a.fixed_value();
                if (!(a instanceof wn)) return;
                if (a.uses_arguments || a.pinned()) return;
                var o = e.args, i;
                for (var s = 0; s < o.length; s++) {
                    var f = o[s];
                    if (f === this) {
                        i = a.argnames[s];
                        if (!i && a.rest) return;
                        break;
                    }
                    if (f instanceof $n) return;
                }
                if (i instanceof Sn) i = i.name;
                if (i instanceof Hn && !c(i.definition())) return;
            } else if (e.TYPE == "Call") {
                n.pop();
                var u = n.in_boolean_context();
                n.push(this);
                switch (u) {
                  case true:
                    t = false;

                  case "d":
                    break;

                  default:
                    return;
                }
            } else return;
            if (t) {
                I(n, this, true);
            } else {
                D(this, n);
            }
            function c(e) {
                switch (g(e, r, n)) {
                  case true:
                    t = false;

                  case "d":
                    return true;
                }
            }
        });
        st.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = new vn();
                this.enclosed.forEach(function(e) {
                    t.set(e.name, true);
                });
                this.variables.each(function(e, n) {
                    t.set(n, true);
                });
            }
            return t;
        });
        yn.DEFMETHOD("make_var", function(e, n, t) {
            var r = [ this ];
            if (n instanceof qr) n.definition().references.forEach(function(e) {
                var n = e.scope;
                do {
                    if (!Qn(r, n)) return;
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/^[^a-z_$]|[^a-z0-9_$]/gi, "_");
            var i = t;
            for (var a = 0; !hn(r, function(e) {
                return !e.var_names().has(i);
            }); a++) i = t + "$" + a;
            var o = Fe(e, n, {
                name: i,
                scope: this
            });
            var s = this.def_variable(o);
            r.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names().set(i, true);
            });
            return o;
        });
        yn.DEFMETHOD("hoist_properties", function(a) {
            if (!a.option("hoist_props") || a.has_directive("use asm")) return;
            var u = this;
            if (Et(u) && u.value) return;
            var o = u instanceof yt && a.top_retain || ln;
            var c = Object.create(null);
            var l = new ei(function(r, e) {
                if (r instanceof Pn) {
                    if (r.operator != "=") return;
                    if (!r.write_only) return;
                    if (!p(r.left, r.right, 1)) return;
                    e(r, l);
                    var i = new vn();
                    var a = [];
                    var o = [];
                    r.right.properties.forEach(function(e) {
                        var n = f(Cr, r.left, e.key);
                        o.push(Fe(En, r, {
                            name: n,
                            value: null
                        }));
                        var t = Fe(Yn, r, {
                            name: n.name,
                            scope: u,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(Fe(Pn, r, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    i.value = r.right;
                    c[r.left.definition().id] = i;
                    u.body.splice(u.body.indexOf(l.stack[1]) + 1, 0, Fe(cr, r, {
                        definitions: o
                    }));
                    return Pe(r, a);
                }
                if (r instanceof yn) {
                    if (r === u) return;
                    var n = l.parent();
                    if (n.TYPE == "Call" && n.expression === r) return;
                    return r;
                }
                if (r instanceof En) {
                    if (!p(r.name, r.value, 0)) return;
                    e(r, l);
                    var i = new vn();
                    var t = [];
                    var s = r.clone();
                    s.value = r.name instanceof Or ? Fe(Ln, r, {
                        value: 0
                    }) : null;
                    t.push(s);
                    r.value.properties.forEach(function(e) {
                        t.push(Fe(En, r, {
                            name: f(r.name.CTOR, r.name, e.key),
                            value: e.value
                        }));
                    });
                    i.value = r.value;
                    c[r.name.definition().id] = i;
                    return Kn.splice(t);
                }
                function f(e, n, t) {
                    var r = u.make_var(e, n, n.name + "_" + t);
                    i.set(t, r.definition());
                    return r;
                }
            });
            u.transform(l);
            u.transform(new ei(function(e, n) {
                if (e instanceof Dn) {
                    if (!(e.expression instanceof Yn)) return;
                    var t = c[e.expression.definition().id];
                    if (!t) return;
                    if (e.expression.fixed_value() !== t.value) return;
                    var r = t.get(e.get_property());
                    var i = Fe(Yn, e, {
                        name: r.name,
                        scope: e.expression.scope,
                        thedef: r
                    });
                    i.reference();
                    return i;
                }
                if (e instanceof Yn) {
                    var t = c[e.definition().id];
                    if (!t) return;
                    if (e.fixed_value() !== t.value) return;
                    return Fe(In, e, {
                        properties: []
                    });
                }
            }));
            function p(e, n, t) {
                if (!(e instanceof Dr)) return;
                var r = e.definition();
                if (r.assignments != t) return;
                if (r.references.length - r.replaced == t) return;
                if (r.single_use) return;
                if (u.find_variable(e.name) !== r) return;
                if (o(r)) return;
                if (e.fixed_value() !== n) return;
                var i = e.fixed || r.fixed;
                if (i.direct_access) return;
                if (i.escaped && i.escaped.depth == 1) return;
                return n instanceof In && n.properties.length > 0 && Ce(e, a) && hn(n.properties, function(e) {
                    return on(e) && e.key !== "__proto__";
                });
            }
        });
        function we(e, n) {
            if (!e.name || !n.option("ie")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return hn(t.references, function(e) {
                return !(e instanceof Yn);
            });
        }
        function I(o, n, e) {
            if (!(n instanceof wn)) return;
            var t = Et(n);
            var r = St(n);
            var s = false;
            var i = false;
            if (t && o.option("arrows")) {
                if (!n.value) {
                    i = true;
                } else if (!r || x(o, n.value)) {
                    var a = n.value.drop_side_effect_free(o);
                    if (a !== n.value) {
                        s = true;
                        n.value = a;
                    }
                }
            } else if (!Tt(n)) {
                if (!e && n.name) {
                    var f = n.name.definition();
                    i = f.references.length == f.replaced;
                } else {
                    i = true;
                }
            }
            if (i) {
                n.process_expression(false, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return e;
                        n = n.drop_side_effect_free(o, true);
                    }
                    s = true;
                    if (!n) return Fe(_n, e);
                    return Fe(gn, e, {
                        body: n
                    });
                });
                y(n, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return;
                        var t = n.drop_side_effect_free(o);
                        if (t !== n) {
                            s = true;
                            if (t && r && !x(o, t)) {
                                t = t.negate(o);
                            }
                            e.value = t;
                        }
                    }
                });
            }
            if (r && o.option("awaits")) {
                if (i) n.process_expression("awaits", function(e) {
                    var n = e.body;
                    if (n instanceof gr) {
                        if (x(o, n.expression)) {
                            s = true;
                            n = n.expression.drop_side_effect_free(o, true);
                            if (!n) return Fe(_n, e);
                            e.body = n;
                        }
                    } else if (n instanceof An) {
                        var t = n.expressions;
                        for (var r = t.length; --r >= 0; ) {
                            var i = t[r];
                            if (!(i instanceof gr)) break;
                            var a = i.expression;
                            if (!x(o, a)) break;
                            s = true;
                            if (t[r] = a.drop_side_effect_free(o)) break;
                        }
                        switch (r) {
                          case -1:
                            return Fe(_n, e);

                          case 0:
                            e.body = t[0];
                            break;

                          default:
                            t.length = r + 1;
                            break;
                        }
                    }
                    return e;
                });
                var u = !i && n.name || t && n.value && !x(o, n.value);
                var c = new Un(function(e) {
                    if (u) return true;
                    if (c.parent() === n && e.may_throw(o)) return u = true;
                    if (e instanceof gr) return u = true;
                    if (e instanceof gt) return u = true;
                    if (e instanceof xn) {
                        if (e.value && !x(o, e.value)) return u = true;
                        return;
                    }
                    if (e instanceof yn && e !== n) return true;
                });
                n.walk(c);
                if (!u) {
                    var l;
                    switch (n.CTOR) {
                      case qt:
                        l = Dt;
                        break;

                      case Ot:
                        l = zt;
                        break;

                      case $t:
                        l = Ct;
                        break;
                    }
                    return Fe(l, n);
                }
            }
            return s && n.clone();
        }
        (function(e) {
            function d(e, n, t, r) {
                var i = e.length;
                var a = [], o = false;
                for (var s = 0; s < i; s++) {
                    var f = e[s];
                    var u;
                    if (r && f instanceof $n) {
                        u = r(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function c(e, n, t) {
                var r = e.expression;
                if (!r.is_string(n)) return e;
                return r.drop_side_effect_free(n, t);
            }
            function l(e) {
                return e instanceof $n ? Fe(jn, e, {
                    elements: [ e ]
                }) : e;
            }
            e(mn, Jn);
            e(xt, Xn);
            e(jn, function(e, n) {
                var t = d(this.elements, e, n, c);
                if (!t) return null;
                if (t === this.elements && hn(t, function(e) {
                    return e instanceof $n;
                })) return this;
                return Pe(this, t.map(l));
            });
            e(Pn, function(e) {
                var n = this.left;
                if (n instanceof Dn) {
                    var t = n.expression;
                    if (t.may_throw_on_access(e, true)) return this;
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                if (He[this.operator.slice(0, -1)]) return this;
                this.write_only = true;
                if (!mr(n).is_constant_expression(e.find_parent(yn))) return this;
                return this.right.drop_side_effect_free(e);
            });
            e(gr, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!x(e, n)) return this;
                if (n instanceof Cn && n.operator == "!") n = n.expression;
                var t = n.drop_side_effect_free(e);
                if (t === n) return this;
                if (!t) {
                    t = Fe(Ln, n, {
                        value: 0
                    });
                } else if (!x(e, t)) {
                    t = t.negate(e);
                }
                var r = this.clone();
                r.expression = t;
                return r;
            });
            e(Mn, function(e, n) {
                var t = this.left;
                var r = this.right;
                var i = this.operator;
                if (!Xe(i, r, e)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || Fe(Ln, t, {
                        value: 0
                    });
                    return o;
                }
                var s = r.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if (He[i] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== r) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (i == "??") return o;
                    var f = o.clone();
                    f.operator = i == "&&" ? "||" : "&&";
                    f.left = t.negate(e, n);
                    if (f.operator == f.right.operator) qe(f);
                    var u = n ? A : le;
                    return i == "&&" ? u(o, f) : u(f, o);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return Pe(this, [ a, s ]);
            });
            function p(e, n) {
                e.new = true;
                var t = hn(e.body, function(e) {
                    return !e.has_side_effects(n);
                }) && hn(e.argnames, function(e) {
                    return !e.match_symbol(ln);
                }) && !(e.rest && e.rest.match_symbol(ln));
                e.new = false;
                return t;
            }
            e(Tn, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    if (t.pure) mn.warn("Dropping __PURE__ call [{start}]", t);
                    var r = d(t.args, e, n, c);
                    return r && Pe(t, r.map(l));
                }
                var i = t.expression;
                if (t.is_call_pure(e)) {
                    var a = t.args.slice();
                    a.unshift(i.expression);
                    a = d(a, e, n, c);
                    return a && Pe(t, a.map(l));
                }
                if (e.option("yields") && Tt(i)) {
                    var o = t.clone();
                    o.expression = Fe(zt, i);
                    o.expression.body = [];
                    var s = o.transform(e);
                    if (s !== o) return s.drop_side_effect_free(e, n);
                }
                var f = I(e, i);
                if (f) {
                    t = t.clone();
                    t.expression = f;
                    if (i._squeezed) t.expression._squeezed = true;
                }
                if (t instanceof vr) {
                    var u = i;
                    if (u instanceof Yn) u = u.fixed_value();
                    if (u instanceof wn) {
                        if (p(u, e)) {
                            var a = t.args.slice();
                            a.unshift(i);
                            a = d(a, e, n, c);
                            return a && Pe(t, a.map(l));
                        }
                        if (!u.contains_this()) {
                            t = Fe(Tn, t);
                            t.expression = t.expression.clone();
                            t.args = t.args.slice();
                        }
                    }
                }
                t.call_only = true;
                return t;
            });
            e(Yt, function(e, n) {
                var t = this;
                var r = [], i = [], a = 0;
                var o = t.properties;
                for (var s = 0; s < o.length; s++) {
                    var f = o[s];
                    if (f.key instanceof mn) r.push(f.key);
                    if (!te(f)) continue;
                    var u = f.value;
                    if (!u.has_side_effects(e)) continue;
                    if (u.contains_this()) return t;
                    if (f instanceof Wt) {
                        a++;
                        i.push(f);
                    } else {
                        i.push(u);
                    }
                }
                var c = t.extends;
                if (c) {
                    if (c instanceof Yn) c = c.fixed_value();
                    c = !Re(c);
                    if (!c) r.unshift(t.extends);
                }
                r = d(r, e, n);
                if (r) n = false;
                i = d(i, e, n);
                if (!r) {
                    if (!c && !i && !t.name) return null;
                    r = [];
                }
                if (c || t.name || !e.has_directive("use strict")) {
                    var l = re(t);
                    if (!c) l.extends = null;
                    l.properties = [];
                    if (i) {
                        if (i.length == a) {
                            if (r.length) i.unshift(Fe(Bt, t, {
                                key: Pe(t, r),
                                value: null
                            }));
                            l.properties = i;
                        } else l.properties.push(Fe(Bt, t, {
                            static: true,
                            key: r.length ? Pe(t, r) : "c",
                            value: p()
                        }));
                    } else if (r.length) l.properties.push(Fe(Vt, t, {
                        key: Pe(t, r),
                        value: Fe(zt, t, {
                            argnames: [],
                            body: []
                        }).init_vars(l)
                    }));
                    return l;
                }
                if (i) r.push(Fe(Tn, t, {
                    expression: Fe(Dt, t, {
                        argnames: [],
                        body: [],
                        value: p()
                    }).init_vars(t.parent_scope),
                    args: []
                }));
                return Pe(t, r);
                function p() {
                    return Pe(t, i.map(function(e) {
                        if (!(e instanceof Wt)) return e;
                        var n = Fe(Dt, e.value);
                        n.argnames = [];
                        return Fe(Tn, e, {
                            expression: n,
                            args: []
                        });
                    }));
                }
            });
            e(Fn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var r;
                if (e.option("ie")) {
                    r = [];
                    if (n instanceof zt) {
                        r.push(n);
                        n = null;
                    }
                    if (t instanceof zt) {
                        r.push(t);
                        t = null;
                    }
                }
                var i;
                if (!n) {
                    i = t ? Fe(Mn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    i = Fe(Mn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    i = this.clone();
                    i.consequent = n;
                    i.alternative = t;
                }
                if (!r) return i;
                if (i) r.push(i);
                return r.length == 0 ? null : Pe(this, r);
            });
            e(Rn, Xn);
            e(qn, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(zt, function(e) {
                return we(this, e) ? null : this;
            });
            e(kt, Xn);
            e(In, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof $n) {
                        t.push(e);
                    } else {
                        if (e.key instanceof mn) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var r = d(t, e, n, function(e, n, t) {
                    var r = e.expression;
                    return r.safe_to_spread() ? r.drop_side_effect_free(n, t) : e;
                });
                if (!r) return null;
                if (r === t && !hn(r, function(e) {
                    return !(e instanceof $n);
                })) return this;
                return Pe(this, r.map(function(e) {
                    return e instanceof $n ? Fe(In, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(Ir, Xn);
            e(An, function(e, n) {
                var t = d(this.expressions, e, n);
                if (!t) return null;
                var r = t.length - 1;
                var i = t[r];
                if (e.option("awaits") && r > 0 && i instanceof gr && i.expression.is_constant()) {
                    t = t.slice(0, -1);
                    r--;
                    var a = t[r];
                    i.expression = x(e, a) ? a : a.negate(e);
                    t[r] = i;
                }
                var o, s, f;
                if (e.option("conditionals") && r > 0 && (o = t[r - 1]) instanceof Pn && o.operator == "=" && (f = o.left) instanceof Yn && (s = ae(e, f.definition(), o.right, i))) {
                    o = o.clone();
                    o.right = s;
                    t = t.slice(0, -2);
                    t.push(o.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : Pe(this, t);
            });
            e(On, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                var r = this.property;
                t = t.drop_side_effect_free(e, n);
                if (!t) return r.drop_side_effect_free(e, n);
                r = r.drop_side_effect_free(e);
                if (!r) return t;
                return Pe(this, [ t, r ]);
            });
            e(Yn, function(e) {
                return this.is_declared(e) && Ce(this, e) ? null : this;
            });
            e(Br, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    var r = t.expressions;
                    if (r.length == 0) return null;
                    return Pe(t, r).drop_side_effect_free(e, n);
                }
                var i = t.tag;
                var a = I(e, i);
                if (a) {
                    t = t.clone();
                    t.tag = a;
                    if (i._squeezed) t.tag._squeezed = true;
                }
                return t;
            });
            e(zn, function(e, n) {
                var t = this.expression;
                if (fi[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof Yn && Ce(t, e)) {
                    return null;
                }
                var r = t.drop_side_effect_free(e, n);
                if (n && r && ge(r)) {
                    if (r === t && this.operator == "!") return this;
                    return r.negate(e, n);
                }
                return r;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(gn, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var r = t.drop_side_effect_free(n, true);
                if (!r) {
                    mn.warn("Dropping side-effect-free statement [{start}]", e);
                    return Fe(_n, e);
                }
                if (r !== t) {
                    return Fe(gn, e, {
                        body: r
                    });
                }
            }
            return e;
        });
        e(ht, function(e, n) {
            return n.option("loops") ? Fe(vt, e).optimize(n) : e;
        });
        function H(n, e, t) {
            if (!t) t = Kt;
            var r = false;
            var i = new Un(function(e) {
                if (r || e instanceof yn) return true;
                if (e instanceof t && i.loopcontrol_target(e) === n) {
                    return r = true;
                }
            });
            if (e instanceof ct) i.push(e);
            i.push(n);
            n.body.walk(i);
            return r;
        }
        e(dt, function(t, e) {
            if (!e.option("loops")) return t;
            var n = M(e, t.condition);
            if (!(n instanceof mn)) {
                if (n && !H(t, e.parent(), Zt)) return Fe(vt, t, {
                    body: Fe(bn, t.body, {
                        body: [ t.body, Fe(gn, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!H(t, e.parent())) return Fe(bn, t.body, {
                    body: [ t.body, Fe(gn, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof bn && !H(t, e.parent(), Zt)) {
                var r = t.body.body;
                for (var i = r.length; --i >= 0; ) {
                    var a = r[i];
                    if (a instanceof kn && !a.alternative && a.body instanceof Qt && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = Fe(Mn, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        r.splice(i, 1);
                    } else if (a instanceof gn) {
                        if (o(a.body)) break;
                        t.condition = Pe(t, [ a.body, t.condition ]);
                        r.splice(i, 1);
                    } else if (!B(a, true)) {
                        break;
                    }
                }
                t.body = q(t.body, e.parent());
            }
            if (t.body instanceof _n) return Fe(vt, t).optimize(e);
            if (t.body instanceof gn) return Fe(vt, t, {
                condition: Pe(t.condition, [ t.body.body, t.condition ]),
                body: Fe(_n, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Un(function(e) {
                    if (n) return true;
                    if (e instanceof Yn) {
                        if (!Vn(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function J(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof Qt || e instanceof Zt && s(e) || e instanceof Jt)) {
                var r = [];
                if (ot(n.init)) {
                    r.push(n.init);
                } else if (n.init) {
                    r.push(Fe(gn, n.init, {
                        body: n.init
                    }));
                }
                var i = s(e) || e instanceof Jt;
                if (n.condition && i) {
                    r.push(Fe(kn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    r.push(Fe(gn, n.condition, {
                        body: n.condition
                    }));
                } else if (i) {
                    r.push(e);
                }
                C(t, n.body, r);
                return Fe(bn, n, {
                    body: r
                });
            }
            if (e instanceof kn) {
                var a = o(e.body);
                if (a instanceof Qt && !s(a)) {
                    if (n.condition) {
                        n.condition = Fe(Mn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var r = W(e.alternative);
                    C(t, e.body, r);
                    return f(r);
                }
                a = o(e.alternative);
                if (a instanceof Qt && !s(a)) {
                    if (n.condition) {
                        n.condition = Fe(Mn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var r = W(e.body);
                    C(t, e.alternative, r);
                    return f(r);
                }
            }
            return n;
            function o(e) {
                return e instanceof bn ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof bn) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = Fe(bn, n.body, {
                        body: e
                    }).transform(t);
                }
                return J(n, t);
            }
        }
        e(vt, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = M(n, e.condition);
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (ot(e.init)) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(Fe(gn, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(Fe(gn, e.condition, {
                            body: e.condition
                        }));
                        C(n, e.body, r);
                        return Fe(bn, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (!(t instanceof mn)) {
                    e.body = Fe(bn, e.body, {
                        body: [ Fe(gn, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return J(e, n);
        });
        e(mt, function(e, t) {
            if (t.option("varify") && V(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof Nn || n instanceof zr) && !n.match_symbol(function(e) {
                    if (e instanceof qr) {
                        var n = e.definition();
                        return !Qe(n) || Q(t, n);
                    }
                }, true)) {
                    e.init = Z(e.init);
                }
            }
            return e;
        });
        function U(e, n, t) {
            if (e instanceof An) e = e.tail_node();
            if (!(e instanceof Mn)) return;
            if (!(e.left instanceof Bn)) {
                switch (e.operator) {
                  case "&&":
                    U(e.left, n);
                    U(e.right, n);
                    break;

                  case "||":
                    U(p(e.left), t);
                    U(p(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof Cn)) return;
            if (e.right.operator != "typeof") return;
            var r = e.right.expression;
            if (!Ne(r)) return;
            var i;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                i = a ? t : n;
                break;

              case "!=":
                i = a ? n : t;
                break;

              default:
                return;
            }
            if (!i) return;
            var o = false;
            var s = r.definition();
            var f;
            var u = [];
            var c = [];
            var l = new Un(function(e, n) {
                if (o) return true;
                if (e instanceof Pn) {
                    var t = e.left;
                    if (!(t instanceof Yn && t.definition() === s)) return;
                    e.right.walk(l);
                    switch (e.operator) {
                      case "=":
                      case "&&=":
                        o = true;
                    }
                    return true;
                }
                if (e instanceof Tn) {
                    n();
                    f = e.expression.tail_node();
                    var r;
                    if (f instanceof Yn) {
                        f = f.fixed_value();
                        r = u.length;
                    }
                    if (!(f instanceof wn)) {
                        o = true;
                    } else if (Qn(c, f)) {
                        f.walk(l);
                    }
                    if (r >= 0) u.length = r;
                    return true;
                }
                if (e instanceof pt) {
                    var r = u.length;
                    n();
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof vt) {
                    if (e.init) e.init.walk(l);
                    var r = u.length;
                    if (e.condition) e.condition.walk(l);
                    e.body.walk(l);
                    if (e.step) e.step.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof mt) {
                    e.object.walk(l);
                    var r = u.length;
                    e.init.walk(l);
                    e.body.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof yn) {
                    if (e === f) return;
                    return true;
                }
                if (e instanceof Yn) {
                    if (e.definition() === s) u.push(e);
                    return true;
                }
            });
            i.walk(l);
            u.forEach(function(e) {
                e.defined = true;
            });
            function p(e) {
                if (!(e instanceof Mn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        function M(e, n, t) {
            if (n.truthy) return true;
            if (Ie(n)) return undefined;
            if (n.falsy && !t) return false;
            if (n.is_truthy()) return true;
            return n.evaluate(e, true);
        }
        function X(e, n) {
            var t;
            var r = 0;
            var i = false;
            var a = e.self();
            if (!ot(a)) while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof Mn) {
                    switch (t) {
                      case a.left:
                        if (He[a.operator]) continue;
                        break;

                      case a.right:
                        if (s(a.left)) switch (a.operator) {
                          case "&&":
                            n[i ? "falsy" : "truthy"] = true;
                            break;

                          case "||":
                          case "??":
                            n[i ? "truthy" : "falsy"] = true;
                            break;
                        }
                        break;
                    }
                } else if (a instanceof Fn) {
                    var o = a.condition;
                    if (o === t) continue;
                    if (s(o)) switch (t) {
                      case a.consequent:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof Jt) {
                    break;
                } else if (a instanceof kn) {
                    break;
                } else if (a instanceof An) {
                    if (a.expressions[0] === t) continue;
                } else if (a instanceof gn) {
                    break;
                }
                return;
            }
            while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof bn) {
                    if (a.body[0] === t) continue;
                } else if (a instanceof kn) {
                    if (s(a.condition)) switch (t) {
                      case a.body:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                }
                return;
            }
            function s(e) {
                if (n.equals(e)) return true;
                if (!(e instanceof Cn)) return false;
                if (e.operator != "!") return false;
                if (!n.equals(e.expression)) return false;
                i = true;
                return true;
            }
        }
        e(kn, function(e, u) {
            if (ue(e.alternative)) e.alternative = null;
            if (!u.option("conditionals")) return e;
            if (u.option("booleans") && !e.condition.has_side_effects(u)) {
                X(u, e.condition);
            }
            if (u.option("dead_code")) {
                var n = M(u, e.condition);
                if (!n) {
                    mn.warn("Condition always false [{start}]", e.condition);
                    var t = [ Fe(gn, e.condition, {
                        body: e.condition
                    }).transform(u) ];
                    C(u, e.body, t);
                    if (e.alternative) t.push(e.alternative);
                    return Fe(bn, e, {
                        body: t
                    }).optimize(u);
                } else if (!(n instanceof mn)) {
                    mn.warn("Condition always true [{start}]", e.condition);
                    var t = [ Fe(gn, e.condition, {
                        body: e.condition
                    }).transform(u), e.body ];
                    if (e.alternative) C(u, e.alternative, t);
                    return Fe(bn, e, {
                        body: t
                    }).optimize(u);
                }
            }
            var r = e.condition.negate(u);
            var i = e.condition.print_to_string().length;
            var a = r.print_to_string().length;
            var o = a < i;
            if (e.alternative && o) {
                o = false;
                e.condition = r;
                var s = e.body;
                e.body = e.alternative;
                e.alternative = ue(s) ? null : s;
            }
            var f = [];
            var c = [];
            var l = [];
            var p = z(e.body, f, c, l);
            var d = [];
            var h = [];
            var v = [];
            var m = z(e.alternative, d, h, v);
            if (p instanceof bn || m instanceof bn) {
                var t = [], _ = [];
                if (p) {
                    [].push.apply(t, f);
                    [].push.apply(_, c);
                    if (p instanceof bn) {
                        e.body = p;
                    } else if (p.length == 0) {
                        e.body = Fe(_n, e.body);
                    } else {
                        e.body = Fe(gn, e.body, {
                            body: Pe(e.body, p)
                        });
                    }
                    l.forEach(j);
                }
                if (m) {
                    [].push.apply(t, d);
                    [].push.apply(_, h);
                    if (m instanceof bn) {
                        e.alternative = m;
                    } else if (m.length == 0) {
                        e.alternative = null;
                    } else {
                        e.alternative = Fe(gn, e.alternative, {
                            body: Pe(e.alternative, m)
                        });
                    }
                    v.forEach(j);
                }
                if (_.length > 0) t.push(Fe(cr, e, {
                    definitions: _
                }));
                if (t.length > 0) {
                    t.push(e.transform(u));
                    return Fe(bn, e, {
                        body: t
                    }).optimize(u);
                }
            } else if (p && m) {
                var t = f.concat(d);
                if (c.length > 0 || h.length > 0) t.push(Fe(cr, e, {
                    definitions: c.concat(h)
                }));
                if (p.length == 0) {
                    t.push(Fe(gn, e.condition, {
                        body: m.length > 0 ? Fe(Mn, e, {
                            operator: "||",
                            left: e.condition,
                            right: Pe(e.alternative, m)
                        }).transform(u) : e.condition.clone()
                    }).optimize(u));
                } else if (m.length == 0) {
                    if (i === a && !o && e.condition instanceof Mn && e.condition.operator == "||") {
                        o = true;
                    }
                    t.push(Fe(gn, e, {
                        body: Fe(Mn, e, {
                            operator: o ? "||" : "&&",
                            left: o ? r : e.condition,
                            right: Pe(e.body, p)
                        }).transform(u)
                    }).optimize(u));
                } else {
                    t.push(Fe(gn, e, {
                        body: Fe(Fn, e, {
                            condition: e.condition,
                            consequent: Pe(e.body, p),
                            alternative: Pe(e.alternative, m)
                        })
                    }).optimize(u));
                }
                l.forEach(j);
                v.forEach(j);
                return Fe(bn, e, {
                    body: t
                }).optimize(u);
            }
            if (ue(e.body)) e = Fe(kn, e, {
                condition: r,
                body: e.alternative,
                alternative: null
            });
            if (e.alternative instanceof Jt && e.body.TYPE == e.alternative.TYPE) {
                var g = Fe(e.body.CTOR, e, {
                    value: Fe(Fn, e, {
                        condition: e.condition,
                        consequent: e.body.value || Fe(Gr, e.body).transform(u),
                        alternative: e.alternative.value || Fe(Gr, e.alternative).transform(u)
                    })
                });
                if (g instanceof xn) g.in_bool = e.body.in_bool || e.alternative.in_bool;
                return g;
            }
            if (e.body instanceof kn && !e.body.alternative && !e.alternative) {
                e = Fe(kn, e, {
                    condition: Fe(Mn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (L(e.body) && e.alternative) {
                var b = e.alternative;
                e.alternative = null;
                return Fe(bn, e, {
                    body: [ e, b ]
                }).optimize(u);
            }
            if (L(e.alternative)) {
                var t = e.body;
                e.body = e.alternative;
                e.condition = o ? r : e.condition.negate(u);
                e.alternative = null;
                return Fe(bn, e, {
                    body: [ e, t ]
                }).optimize(u);
            }
            if (e.alternative) {
                var y = q(e.body);
                var w = O(y);
                var x = q(e.alternative);
                var k = O(x);
                for (var E = []; w >= 0 && k >= 0; ) {
                    var S = y[w];
                    var T = x[k];
                    if (S.equals(T)) {
                        y.splice(w--, 1);
                        x.splice(k--, 1);
                        E.unshift(R(S, T));
                    } else {
                        if (!(S instanceof gn)) break;
                        if (!(T instanceof gn)) break;
                        var A = S.body.tail_node();
                        var D = T.body.tail_node();
                        if (!A.equals(D)) break;
                        w = $(y, S.body, w);
                        k = $(x, T.body, k);
                        E.unshift(Fe(gn, A, {
                            body: R(A, D)
                        }));
                    }
                }
                if (E.length > 0) {
                    e.body = y.length > 0 ? Fe(bn, e, {
                        body: y
                    }) : Fe(_n, e);
                    e.alternative = x.length > 0 ? Fe(bn, e, {
                        body: x
                    }) : null;
                    E.unshift(e);
                    return Fe(bn, e, {
                        body: E
                    }).optimize(u);
                }
            }
            if (u.option("typeofs")) U(e.condition, e.body, e.alternative);
            return e;
            function q(e) {
                return e instanceof bn ? e.body : [ e ];
            }
            function O(e) {
                for (var n = e.length; --n >= 0; ) {
                    if (!B(e[n], true)) break;
                }
                return n;
            }
            function $(e, n, t) {
                if (n instanceof An) {
                    e[t] = Fe(gn, n, {
                        body: Pe(n, n.expressions.slice(0, -1))
                    });
                } else {
                    e.splice(t--, 1);
                }
                return t;
            }
            function z(e, n, t, r) {
                if (e == null) return [];
                if (e instanceof bn) {
                    var i = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof _n) continue;
                        if (o instanceof Jt) {
                            if (a == 0) return;
                            if (i.length > 0) {
                                o = o.clone();
                                i.push(o.value || Fe(Gr, o).transform(u));
                                o.value = Pe(e, i);
                            }
                            var s = e.clone();
                            s.body = s.body.slice(a + 1);
                            s.body.unshift(o);
                            return s;
                        }
                        if (o instanceof Mt) {
                            n.push(o);
                        } else if (o instanceof gn) {
                            if (!u.option("sequences") && i.length > 0) return;
                            i.push(o.body);
                        } else if (o instanceof cr) {
                            if (!u.option("sequences") && i.length > 0) return;
                            o.remove_initializers(u, t);
                            o.definitions.forEach(f);
                        } else {
                            return;
                        }
                    }
                    return i;
                }
                if (e instanceof Mt) {
                    n.push(e);
                    return [];
                }
                if (e instanceof _n) return [];
                if (e instanceof gn) return [ e.body ];
                if (e instanceof cr) {
                    var i = [];
                    e.remove_initializers(u, t);
                    e.definitions.forEach(f);
                    return i;
                }
                function f(e) {
                    if (!e.value) return;
                    i.push(Fe(Pn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(Yn, function(e) {
                            r.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(er, function(r, t) {
            if (!t.option("switches")) return r;
            if (!t.option("dead_code")) return r;
            var e = [];
            var n;
            var i = [];
            var a;
            var o;
            var s = [];
            for (var f = 0, u = r.body.length; f < u; f++) {
                n = r.body[f];
                if (n instanceof tr) {
                    var c = e[e.length - 1];
                    if (a || w(n.body[0], t) && (!c || L(c))) {
                        k(n, c);
                        continue;
                    } else {
                        a = n;
                    }
                } else {
                    var l = n.expression;
                    var p = Fe(Mn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }).evaluate(t, true);
                    if (!p) {
                        if (l.has_side_effects(t)) s.push(l);
                        k(n, e[e.length - 1]);
                        continue;
                    }
                    if (!(p instanceof mn)) {
                        if (a) {
                            var d = e.indexOf(a);
                            e.splice(d, 1);
                            k(a, e[d - 1]);
                            a = null;
                        }
                        if (l.has_side_effects(t)) {
                            o = n;
                        } else {
                            a = n = Fe(tr, n);
                        }
                        while (++f < u) k(r.body[f], n);
                    }
                }
                if (f + 1 >= u || L(n)) {
                    var c = e[e.length - 1];
                    var h = n.body;
                    if (L(c)) switch (c.body.length - h.length) {
                      case 1:
                        var v = c.body[c.body.length - 1];
                        if (!w(v, t)) break;
                        h = h.concat(v);

                      case 0:
                        var m = Fe(bn, c);
                        var _ = Fe(bn, n, {
                            body: h
                        });
                        if (m.equals(_)) c.body = [];
                    }
                }
                if (s.length) {
                    if (n instanceof tr) {
                        e.push(Fe(rr, r, {
                            expression: Pe(r, s),
                            body: []
                        }));
                    } else {
                        s.push(n.expression);
                        n.expression = Pe(r, s);
                    }
                    s = [];
                }
                e.push(n);
            }
            if (s.length && !o) {
                e.push(Fe(rr, r, {
                    expression: Pe(r, s),
                    body: []
                }));
            }
            while (n = e[e.length - 1]) {
                var v = n.body[n.body.length - 1];
                if (w(v, t)) n.body.pop();
                if (n === a) {
                    if (!E(n)) break;
                } else if (n.expression.has_side_effects(t)) {
                    break;
                } else if (a) {
                    if (!E(a)) break;
                    if (e[e.length - 2] !== a) break;
                    a.body = a.body.concat(n.body);
                    n.body = [];
                } else if (!E(n)) break;
                k(n);
                if (e.pop() === a) a = null;
            }
            if (!n) {
                i.push(Fe(gn, r.expression, {
                    body: r.expression
                }));
                if (s.length) i.push(Fe(gn, r, {
                    body: Pe(r, s)
                }));
                return Fe(bn, r, {
                    body: i
                }).optimize(t);
            }
            if (n === a) while (n = e[e.length - 2]) {
                if (n instanceof tr) break;
                if (!E(n)) break;
                var l = n.expression;
                if (l.has_side_effects(t)) {
                    var c = e[e.length - 3];
                    if (c && !L(c)) break;
                    a.body.unshift(Fe(gn, r, {
                        body: l
                    }));
                }
                k(n);
                e.splice(-2, 1);
            }
            e[0].body = i.concat(e[0].body);
            r.body = e;
            if (t.option("conditionals")) switch (e.length) {
              case 1:
                if (!x(e[0])) break;
                var l = e[0].expression;
                var h = e[0].body.slice();
                if (e[0] !== a && e[0] !== o) return Fe(kn, r, {
                    condition: Fe(Mn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }),
                    body: Fe(bn, r, {
                        body: h
                    }),
                    alternative: null
                }).optimize(t);
                if (l) h.unshift(Fe(gn, l, {
                    body: l
                }));
                h.unshift(Fe(gn, r.expression, {
                    body: r.expression
                }));
                return Fe(bn, r, {
                    body: h
                }).optimize(t);

              case 2:
                if (!Vn(a, e) || !x(e[1])) break;
                var h = e[0].body.slice();
                var g = h.length && w(h[h.length - 1], t);
                if (g) h.pop();
                if (!hn(h, x)) break;
                var b = e[1].body.length && Fe(bn, e[1]);
                var y = Fe(kn, r, {
                    condition: Fe(Mn, r, e[0] === a ? {
                        operator: "!==",
                        left: r.expression,
                        right: e[1].expression
                    } : {
                        operator: "===",
                        left: r.expression,
                        right: e[0].expression
                    }),
                    body: Fe(bn, e[0], {
                        body: h
                    }),
                    alternative: g && b || null
                });
                if (!g && b) y = Fe(bn, r, {
                    body: [ y, b ]
                });
                return y.optimize(t);
            }
            return r;
            function w(e, n) {
                return e instanceof Qt && n.loopcontrol_target(e) === r;
            }
            function x(e) {
                var n = false;
                var t = new Un(function(e) {
                    if (n || e instanceof wn || e instanceof gn) return true;
                    if (w(e, t)) n = true;
                });
                t.push(r);
                e.walk(t);
                return !n;
            }
            function k(e, n) {
                if (n && !L(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    C(t, e, i);
                }
            }
        });
        e(ir, function(e, n) {
            e.body = l(e.body, n);
            if (n.option("dead_code")) {
                if (E(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof jr && !Ce(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        C(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof cr)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(Fe(bn, e).optimize(n));
                    if (e.bfinally) {
                        t.push(Fe(bn, e.bfinally).optimize(n));
                    }
                    return Fe(bn, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && E(e.bfinally)) {
                    var t = Fe(bn, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return Fe(bn, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function K(i) {
            return function(n, t) {
                var r = false;
                this.definitions.forEach(function(e) {
                    if (e.value) r = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof qr) t.push(Fe(En, e, {
                            name: e,
                            value: i(n, e)
                        }));
                    }, true);
                });
                return r;
            };
        }
        fr.DEFMETHOD("remove_initializers", K(function(e, n) {
            return Fe(Gr, n).optimize(e);
        }));
        ur.DEFMETHOD("remove_initializers", K(Xn));
        cr.DEFMETHOD("remove_initializers", K(Xn));
        sr.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, t) {
                var r = t.name.definition();
                var n = t.value;
                if (n) {
                    if (n instanceof An) n = n.clone();
                    var i = Fe(Yn, t.name);
                    var a = Fe(Pn, t, {
                        operator: "=",
                        left: i,
                        right: n
                    });
                    e.push(a);
                    var o = function() {
                        return a.right;
                    };
                    o.assigns = [ a ];
                    o.direct_access = r.direct_access;
                    o.escaped = r.escaped;
                    i.fixed = o;
                    r.references.forEach(function(e) {
                        if (!e.fixed) return;
                        var n = e.fixed.assigns;
                        if (!n) return;
                        if (n[0] !== t) return;
                        if (n.length > 1 || e.fixed.to_binary || e.fixed.to_prefix) {
                            n[0] = a;
                        } else {
                            e.fixed = o;
                            if (r.fixed === e.fixed) r.fixed = o;
                        }
                    });
                    r.references.push(i);
                }
                r.assignments++;
                r.eliminated++;
                r.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return Pe(this, e);
        });
        function Ye(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof Fr ? 3 : 2);
        }
        function Q(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var r = n.scope; r !== t; ) {
                r = r.parent_scope;
                if (r.var_names().has(n.name)) return true;
            }
        }
        function Z(e) {
            return Fe(cr, e, {
                definitions: e.definitions.map(function(e) {
                    return Fe(En, e, {
                        name: e.name.convert_symbol(Cr, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var r = t.scope.resolve();
                            if (t.scope === r) return;
                            t.scope = r;
                            r.variables.set(t.name, t);
                            r.enclosed.push(t);
                            r.var_names().set(t.name, true);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function ee(e, n) {
            var t = n.definition();
            return (t.fixed || t.fixed === 0) && Ye(t) && Qe(t) && !Q(e, t);
        }
        function ie(e, n) {
            return n.option("varify") && hn(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof qr) return !ee(n, e);
                }, true);
            }) ? Z(e) : e;
        }
        e(fr, ie);
        e(ur, ie);
        function xe(e, n) {
            if (!n.option("optional_chains")) return;
            if (e.terminal) do {
                var t = e.expression;
                if (e.optional) {
                    var r = M(n, t, true);
                    if (r == null) return Fe(Cn, e, {
                        operator: "void",
                        expression: t
                    }).optimize(n);
                    if (!(r instanceof mn)) e.optional = false;
                }
                e = t;
            } while ((e.TYPE == "Call" || e instanceof Dn) && !e.terminal);
        }
        function he(e, n) {
            var t = e.expression;
            if (!(t instanceof An)) return e;
            var r = t.expressions.slice();
            var i = e.clone();
            i.expression = r.pop();
            r.push(i);
            return Pe(e, r);
        }
        function ke(e, t, n) {
            var r = e.expression;
            var i = r instanceof Yn ? r.fixed_value() : r;
            if (!(i instanceof wn)) return;
            if (i.uses_arguments) return;
            if (i.pinned()) return;
            if (n && n.indexOf(i) < 0) return;
            var a = e.args;
            if (!hn(a, function(e) {
                return !(e instanceof $n);
            })) return;
            var o = i.argnames;
            var s = i === r && !i.name;
            if (i.rest) {
                if (!(s && t.option("rests"))) return;
                var f = o.length;
                a = a.slice(0, f);
                while (a.length < f) a.push(Fe(Gr, e).optimize(t));
                a.push(Fe(jn, e, {
                    elements: e.args.slice(f)
                }));
                o = o.concat(i.rest);
                i.rest = null;
            } else {
                a = a.slice();
                o = o.slice();
            }
            var u = 0, c = 0;
            var l = s && t.option("default_values");
            var p = s && t.drop_fargs(i, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof yr) {
                    return e.elements.length == 0 && !e.rest && n instanceof jn;
                }
                if (e instanceof xr) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.unused;
            } : ln;
            var d = [];
            for (var h = 0; h < a.length; h++) {
                var v = o[h];
                if (l && v instanceof Sn && a[h].is_defined(t)) {
                    o[h] = v = v.name;
                }
                if (!v || v.unused !== undefined) {
                    var m = a[h].drop_side_effect_free(t);
                    if (p(v)) {
                        if (v) o.splice(h, 1);
                        a.splice(h, 1);
                        if (m) d.push(m);
                        h--;
                        continue;
                    } else if (m) {
                        d.push(m);
                        a[u++] = Pe(e, d);
                        d = [];
                    } else if (v) {
                        if (d.length) {
                            a[u++] = Pe(e, d);
                            d = [];
                        } else {
                            a[u++] = Fe(Ln, a[h], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (p(v, a[h])) {
                    var m = a[h].drop_side_effect_free(t);
                    o.splice(h, 1);
                    a.splice(h, 1);
                    if (m) d.push(m);
                    h--;
                    continue;
                } else {
                    d.push(a[h]);
                    a[u++] = Pe(e, d);
                    d = [];
                }
                c = u;
            }
            for (;h < o.length; h++) {
                if (p(o[h])) o.splice(h--, 1);
            }
            i.argnames = o;
            a.length = c;
            e.args = a;
            if (!d.length) return;
            var _ = Pe(e, d);
            a.push(a.length < o.length ? Fe(Cn, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        function ve(e, n) {
            if (!n) n = e.find_parent(yn);
            var t = [];
            if (St(n) || n instanceof yt && e.option("module")) {
                t.push("await");
            }
            if (Tt(n)) t.push("yield");
            return t.length && dn(t);
        }
        function Ee(t, r) {
            if (!r) return true;
            var i = true;
            var a = new Un(function(e) {
                if (!i) return true;
                if (e instanceof yn) {
                    if (e === t) return;
                    if (Et(e)) {
                        for (var n = 0; i && n < e.argnames.length; n++) e.argnames[n].walk(a);
                    } else if (e instanceof Mt && r[e.name.name]) {
                        i = false;
                    }
                    return true;
                }
                if (e instanceof Dr && r[e.name] && e !== t.name) i = false;
            });
            t.walk(a);
            return i;
        }
        function Se(e, n) {
            return e.in_strict_mode(n) || !n.has_directive("use strict");
        }
        e(Tn, function(p, c) {
            var a = p.expression;
            var P = xe(p, c);
            if (P) return P;
            if (c.option("sequences")) {
                if (a instanceof Dn) {
                    var e = he(a, c);
                    if (e !== a) {
                        var n = p.clone();
                        n.expression = e.expressions.pop();
                        e.expressions.push(n);
                        return e.optimize(c);
                    }
                } else if (!_e(a.tail_node())) {
                    var e = he(p, c);
                    if (e !== p) return e.optimize(c);
                }
            }
            if (c.option("unused")) ke(p, c);
            if (c.option("unsafe")) {
                if (Ne(a)) switch (a.name) {
                  case "Array":
                    if (p.args.length == 1) {
                        var t = p.args[0];
                        if (t instanceof Ln) try {
                            var r = t.value;
                            if (r > 6) break;
                            var i = Array(r);
                            for (var o = 0; o < r; o++) i[o] = Fe(Jr, p);
                            return Fe(jn, p, {
                                elements: i
                            });
                        } catch (e) {
                            mn.warn("Invalid array length: {length} [{start}]", {
                                length: r,
                                start: p.start
                            });
                            break;
                        }
                        if (!t.is_boolean(c) && !t.is_string(c)) break;
                    }
                    return Fe(jn, p, {
                        elements: p.args
                    });

                  case "Object":
                    if (p.args.length == 0) return Fe(In, p, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (p.args.length == 0) return Fe(Bn, p, {
                        value: ""
                    });
                    if (p.args.length == 1) return Fe(Mn, p, {
                        operator: "+",
                        left: Fe(Bn, p, {
                            value: ""
                        }),
                        right: p.args[0]
                    }).optimize(c);
                    break;

                  case "Number":
                    if (p.args.length == 0) return Fe(Ln, p, {
                        value: 0
                    });
                    if (p.args.length == 1) return Fe(Cn, p, {
                        operator: "+",
                        expression: Fe(Mn, p, {
                            operator: "+",
                            left: Fe(Bn, p, {
                                value: ""
                            }),
                            right: p.args[0]
                        })
                    }).optimize(c);
                    break;

                  case "Boolean":
                    if (p.args.length == 0) return Fe(Qr, p).optimize(c);
                    if (p.args.length == 1) return Fe(Cn, p, {
                        operator: "!",
                        expression: Fe(Cn, p, {
                            operator: "!",
                            expression: p.args[0]
                        })
                    }).optimize(c);
                    break;

                  case "RegExp":
                    var j = [];
                    if (hn(p.args, function(e) {
                        var n = e.evaluate(c);
                        j.unshift(n);
                        return e !== n;
                    })) try {
                        return pe(c, p, Fe(Ur, p, {
                            value: RegExp.apply(RegExp, j)
                        }));
                    } catch (e) {
                        mn.warn("Error converting {this} [{start}]", p);
                    }
                    break;
                } else if (a instanceof qn) switch (a.property) {
                  case "toString":
                    var s = a.expression;
                    if (p.args.length == 0 && !(s.may_throw_on_access(c) || s instanceof Hr)) {
                        return Fe(Mn, p, {
                            operator: "+",
                            left: Fe(Bn, p, {
                                value: ""
                            }),
                            right: s
                        }).optimize(c);
                    }
                    break;

                  case "join":
                    if (a.expression instanceof jn && p.args.length < 2) e: {
                        var f = p.args[0];
                        if (a.expression.elements.length == 0 && !(f instanceof $n)) {
                            return f ? Pe(p, [ f, Fe(Bn, p, {
                                value: ""
                            }) ]).optimize(c) : Fe(Bn, p, {
                                value: ""
                            });
                        }
                        if (f) {
                            f = f.evaluate(c);
                            if (f instanceof mn) break e;
                        }
                        var i = [];
                        var u = [];
                        for (var o = 0; o < a.expression.elements.length; o++) {
                            var l = a.expression.elements[o];
                            var d = l.evaluate(c);
                            if (d !== l) {
                                u.push(d);
                            } else if (l instanceof $n) {
                                break e;
                            } else {
                                if (u.length > 0) {
                                    i.push(Fe(Bn, p, {
                                        value: u.join(f)
                                    }));
                                    u.length = 0;
                                }
                                i.push(l);
                            }
                        }
                        if (u.length > 0) i.push(Fe(Bn, p, {
                            value: u.join(f)
                        }));
                        if (i.length == 1) {
                            if (i[0].is_string(c)) return i[0];
                            return Fe(Mn, i[0], {
                                operator: "+",
                                left: Fe(Bn, p, {
                                    value: ""
                                }),
                                right: i[0]
                            });
                        }
                        if (f == "") {
                            var t;
                            if (i[0].is_string(c) || i[1].is_string(c)) {
                                t = i.shift();
                            } else {
                                t = Fe(Bn, p, {
                                    value: ""
                                });
                            }
                            return i.reduce(function(e, n) {
                                return Fe(Mn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, t).optimize(c);
                        }
                        var h = p.clone();
                        h.expression = h.expression.clone();
                        h.expression.expression = h.expression.expression.clone();
                        h.expression.expression.elements = i;
                        return pe(c, p, h);
                    }
                    break;

                  case "charAt":
                    if (p.args.length < 2) {
                        var h = Fe(Mn, p, {
                            operator: "||",
                            left: Fe(On, p, {
                                expression: a.expression,
                                property: p.args.length ? Fe(Mn, p.args[0], {
                                    operator: "|",
                                    left: Fe(Ln, p, {
                                        value: 0
                                    }),
                                    right: p.args[0]
                                }) : Fe(Ln, p, {
                                    value: 0
                                })
                            }).optimize(c),
                            right: Fe(Bn, p, {
                                value: ""
                            })
                        });
                        h.is_string = pn;
                        return h.optimize(c);
                    }
                    break;

                  case "apply":
                    if (p.args.length == 2 && p.args[1] instanceof jn) {
                        var v = p.args[1].elements.slice();
                        v.unshift(p.args[0]);
                        return Fe(Tn, p, {
                            expression: Fe(qn, a, {
                                expression: a.expression,
                                property: "call"
                            }),
                            args: v
                        }).optimize(c);
                    }
                    break;

                  case "call":
                    var m = a.expression;
                    if (m instanceof Yn) {
                        m = m.fixed_value();
                    }
                    if (m instanceof wn && !m.contains_this()) {
                        return (p.args.length ? Pe(p, [ p.args[0], Fe(Tn, p, {
                            expression: a.expression,
                            args: p.args.slice(1)
                        }) ]) : Fe(Tn, p, {
                            expression: a.expression,
                            args: []
                        })).optimize(c);
                    }
                    break;
                } else if (c.option("side_effects") && a instanceof Tn && a.args.length == 1 && Ne(a.expression) && a.expression.name == "Object") {
                    var n = p.clone();
                    n.expression = je(p, a, a.args[0]);
                    return n.optimize(c);
                }
            }
            if (c.option("unsafe_Function") && Ne(a) && a.name == "Function") {
                if (p.args.length == 0) return Fe(zt, p, {
                    argnames: [],
                    body: []
                }).init_vars(a.scope);
                if (hn(p.args, function(e) {
                    return e instanceof Bn;
                })) {
                    try {
                        var _ = "n(function(" + p.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + p.args[p.args.length - 1].value + "})";
                        var g = oi(_);
                        var b = {
                            ie: c.option("ie")
                        };
                        g.figure_out_scope(b);
                        var N = new ci(c.options);
                        g = g.transform(N);
                        g.figure_out_scope(b);
                        g.compute_char_frequency(b);
                        g.mangle_names(b);
                        var y;
                        g.walk(new Un(function(e) {
                            if (y) return true;
                            if (e instanceof wn) {
                                y = e;
                                return true;
                            }
                        }));
                        var _ = li();
                        bn.prototype._codegen.call(y, _);
                        p.args = [ Fe(Bn, p, {
                            value: y.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), Fe(Bn, p.args[p.args.length - 1], {
                            value: _.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return p;
                    } catch (e) {
                        if (e instanceof ri) {
                            mn.warn("Error parsing code passed to new Function [{start}]", p.args[p.args.length - 1]);
                            mn.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var w = a instanceof Yn ? a.fixed_value() : a;
            var x = c.parent(), k = c.self();
            var E = w instanceof wn && (!St(w) || c.option("awaits") && x instanceof gr) && (!Tt(w) || c.option("yields") && k instanceof br && k.nested);
            var S = E && w.first_statement();
            var T = 0, A = false;
            var D = !hn(p.args, function(e) {
                return !(e instanceof $n);
            });
            var I = E && hn(w.argnames, function(e, n) {
                if (T == 1 && p.args[n] instanceof $n) T = 2;
                if (e instanceof Sn) {
                    if (!T) T = 1;
                    var t = T == 1 && p.args[n];
                    if (!Ie(t)) T = 2;
                    if (fn(w, e.value)) return false;
                    e = e.name;
                }
                if (e instanceof Nn) {
                    A = true;
                    if (fn(w, e)) return false;
                }
                return true;
            }) && !(w.rest instanceof Nn && fn(w, w.rest));
            var H = I && c.option("inline") && !p.is_expr_pure(c) && (a === w || Se(w, c));
            if (H && S instanceof xn) {
                var d = S.value;
                if (a === w && !w.name && (!d || d.is_constant_expression()) && Ee(w, ve(c))) {
                    return Pe(p, G(d)).optimize(c);
                }
            }
            if (E && !w.contains_this()) {
                var q, d, O = false;
                if (H && !w.uses_arguments && !w.pinned() && !(w.name && w instanceof kt) && (a === w || !Ke(c, q = a.definition(), w) && w.is_constant_expression(Me(c))) && (d = K(S))) {
                    var Y = a === w || q.single_use && q.references.length - q.replaced == 1;
                    if (Z()) {
                        var v = p.args.slice();
                        var R = [];
                        var B = d.clone(true).transform(new ei(function(e) {
                            if (e instanceof Yn) {
                                var n = e.definition();
                                if (w.variables.get(e.name) !== n) {
                                    R.push(e);
                                    return e;
                                }
                                var t = Q(n);
                                var r = v[t];
                                if (!r) return Fe(Gr, p);
                                v[t] = null;
                                var i = this.parent();
                                return i ? je(i, e, r) : r;
                            }
                        }));
                        var L = w.inlined;
                        if (a !== w) w.inlined = true;
                        var U = [];
                        v.forEach(function(e) {
                            if (!e) return;
                            e = e.clone(true);
                            e.walk(new Un(function(e) {
                                if (e instanceof Yn) R.push(e);
                            }));
                            U.push(e);
                        }, []);
                        U.push(B);
                        var h = Pe(p, U).optimize(c);
                        w.inlined = L;
                        h = je(x, k, h);
                        if (Y || le(h, p) === h) {
                            R.forEach(function(e) {
                                e.scope = a === w ? w.parent_scope : a.scope;
                                e.reference();
                                var n = e.definition();
                                if (Y) n.replaced++;
                                n.single_use = false;
                            });
                            return h;
                        } else if (!h.has_side_effects(c)) {
                            p.drop_side_effect_free = function(e, n) {
                                var t = this;
                                var r = t.args.slice();
                                r.unshift(t.expression);
                                return Pe(t, r).drop_side_effect_free(e, n);
                            };
                        }
                    }
                    var $, V, z, C;
                    if (Y && re()) {
                        w._squeezed = true;
                        if (a !== w) w.parent_scope = a.scope;
                        var h = Pe(p, se()).optimize(c);
                        return je(x, k, h);
                    }
                }
                if (c.option("side_effects") && I && hn(w.body, ue) && (w === a ? we(w, c) : !T && !A && !w.rest) && !(Et(w) && w.value) && Ee(w, ve(c))) {
                    return Pe(p, G()).optimize(c);
                }
            }
            if (c.option("drop_console")) {
                if (a instanceof Dn) {
                    var M = a.expression;
                    while (M.expression) {
                        M = M.expression;
                    }
                    if (Ne(M) && M.name == "console") {
                        return Fe(Gr, p).optimize(c);
                    }
                }
            }
            if (c.option("negate_iife") && x instanceof gn && ge(k)) {
                return p.negate(c, true);
            }
            return de(c, p);
            function W(e) {
                return Fe(On, e, {
                    expression: Fe(jn, e, {
                        elements: []
                    }),
                    property: Fe(Ln, e, {
                        value: 0
                    })
                });
            }
            function G(e) {
                var n = p.args.slice();
                var t = T > 1 || A || w.rest;
                if (t || D) n = [ Fe(jn, p, {
                    elements: n
                }) ];
                if (t) {
                    var o = new ei(function(r, e) {
                        if (r instanceof Sn) return Fe(Sn, r, {
                            name: r.name.transform(o) || W(r),
                            value: r.value
                        });
                        if (r instanceof yr) {
                            var t = [];
                            r.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            be(r, t);
                            return Fe(yr, r, {
                                elements: t
                            });
                        }
                        if (r instanceof xr) {
                            var i = [], a = [];
                            r.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    if (a.length) {
                                        if (!(n instanceof mn)) n = fe(n, e);
                                        a.push(n);
                                        n = Pe(r, a);
                                        a = [];
                                    }
                                    i.push(Fe(wr, e, {
                                        key: n,
                                        value: t
                                    }));
                                } else if (n instanceof mn) {
                                    a.push(n);
                                }
                            });
                            if (a.length) i.push(Fe(wr, r, {
                                key: Pe(r, a),
                                value: W(r)
                            }));
                            return Fe(xr, r, {
                                properties: i
                            });
                        }
                        if (r instanceof Hn) return null;
                    });
                    var r = [];
                    w.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) r[n] = e;
                    });
                    var i = w.rest && w.rest.transform(o);
                    if (i) r.length = w.argnames.length;
                    be(w, r);
                    n[0] = Fe(Pn, p, {
                        operator: "=",
                        left: Fe(yr, w, {
                            elements: r,
                            rest: i
                        }),
                        right: n[0]
                    });
                } else w.argnames.forEach(function(e) {
                    if (e instanceof Sn) n.push(e.value);
                });
                n.push(e || Fe(Gr, p));
                return n;
            }
            function J() {
                return p.call_only ? Fe(Ln, p, {
                    value: 0
                }) : Fe(Gr, p);
            }
            function X(e) {
                if (!e) return J();
                if (e instanceof xn) return e.value || J();
                if (e instanceof gn) {
                    return p.call_only ? e.body : Fe(Cn, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function K(e) {
                var n = w.body.length;
                if (n < 2) {
                    e = X(e);
                    if (e) return e;
                }
                if (c.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var r = w.body[t];
                    if (r instanceof cr) {
                        if (O) {
                            if (!e) continue;
                            if (!(e instanceof gn)) return false;
                            if (!ce(r)) e = null;
                        } else if (!ce(r)) {
                            if (e && !(e instanceof gn)) return false;
                            e = null;
                            O = true;
                        }
                    } else if (r instanceof Ft || r instanceof jt || r instanceof _n) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = r;
                    }
                }
                return X(e);
            }
            function Q(e) {
                for (var n = w.argnames.length; --n >= 0; ) {
                    if (w.argnames[n].definition() === e) return n;
                }
            }
            function Z() {
                if (T || A || D || O || w.rest) return;
                if (c.option("inline") < 2 && w.argnames.length) return;
                if (!w.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof Hn;
                })) return;
                var n = c.find_parent(yn);
                var i = false;
                var a = ve(c, n);
                var o;
                var s = [];
                var f = false;
                var u = new Un(function(e, n) {
                    if (i) return true;
                    if (e instanceof Mn && He[e.operator] || e instanceof Fn) {
                        s = null;
                        return;
                    }
                    if (e instanceof yn) return i = true;
                    if (a && e instanceof Dr && a[e.name]) return i = true;
                    if (e instanceof Yn) {
                        var t = e.definition();
                        if (w.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof Mt) return i = true;
                        if (ui(e, u.parent())) return i = true;
                        var r = Q(t);
                        if (!(o < r)) o = r;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(w.argnames[r]);
                        }
                        return;
                    }
                    if (f) return;
                    if (e instanceof Pn && e.left instanceof Dn) {
                        e.left.expression.walk(u);
                        if (e.left instanceof On) e.left.property.walk(u);
                        e.right.walk(u);
                        f = true;
                        return true;
                    }
                    if (e.has_side_effects(c)) {
                        n();
                        f = true;
                        return true;
                    }
                });
                d.walk(u);
                if (i) return;
                var e = p.args.length;
                if (s && w.argnames.length >= e) {
                    e = w.argnames.length;
                    while (e-- > o && w.argnames[e] === s.pop());
                    e++;
                }
                return e <= o || hn(p.args.slice(o, e), f && !s ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(c);
                });
            }
            function ee(e, n) {
                return e.has(n) || me[n] || C.var_names().has(n);
            }
            function ne(n, t) {
                var r = false;
                w.each_argname(function(e) {
                    if (r) return;
                    if (e.unused) return;
                    if (!t || ee(n, e.name)) return r = true;
                    $.set(e.name, true);
                    if (z) z.push(e.definition());
                });
                return !r;
            }
            function te(n, e) {
                for (var t = 0; t < w.body.length; t++) {
                    var r = w.body[t];
                    if (r instanceof Mt) {
                        var i = r.name;
                        if (!e) return false;
                        if ($.has(i.name)) return false;
                        if (ee(n, i.name)) return false;
                        if (!hn(r.enclosed, function(e) {
                            return e.scope === C || e.scope === r || !n.has(e.name);
                        })) return false;
                        if (z) z.push(i.definition());
                        continue;
                    }
                    if (!(r instanceof cr)) continue;
                    if (!e) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var i = r.definitions[a].name;
                        if (ee(n, i.name)) return false;
                        if (z) z.push(i.definition());
                    }
                }
                return true;
            }
            function re() {
                var n = new vn();
                var e = 0, t;
                C = k;
                do {
                    if (C.variables) C.variables.each(function(e) {
                        n.set(e.name, true);
                    });
                    t = C;
                    C = c.parent(e++);
                    if (C instanceof Bt) {
                        if (!C.static) return false;
                    } else if (C instanceof pt) {
                        z = [];
                    } else if (C instanceof vt) {
                        if (C.init === t) continue;
                        z = [];
                    } else if (C instanceof mt) {
                        if (C.init === t) continue;
                        if (C.object === t) continue;
                        z = [];
                    }
                } while (!(C instanceof yn));
                V = C.body.indexOf(t) + 1;
                if (!V) return false;
                if (!Ee(w, ve(c, C))) return false;
                var r = (a !== w || w.parent_scope.resolve() === C) && !C.pinned();
                if (C instanceof yt) {
                    if (c.toplevel.vars) {
                        n.set("arguments", true);
                    } else {
                        r = false;
                    }
                }
                $ = new vn();
                var i = c.option("inline");
                if (!ne(n, i >= 2 && r)) return false;
                if (!te(n, i >= 3 && r)) return false;
                return !z || z.length == 0 || !nn(w, z);
            }
            function F(e, n, t, r) {
                var i = t.definition();
                if (!C.var_names().has(t.name)) {
                    C.var_names().set(t.name, true);
                    e.push(Fe(En, t, {
                        name: t,
                        value: null
                    }));
                }
                C.variables.set(t.name, i);
                C.enclosed.push(i);
                if (!r) return;
                var a = Fe(Yn, t);
                i.assignments++;
                i.references.push(a);
                n.push(Fe(Pn, p, {
                    operator: "=",
                    left: a,
                    right: r
                }));
            }
            function ie(e, n) {
                var t = w.argnames.length;
                for (var r = p.args.length; --r >= t; ) {
                    n.push(p.args[r]);
                }
                var i = [];
                for (r = t; --r >= 0; ) {
                    var a = w.argnames[r];
                    var o;
                    if (a instanceof Sn) {
                        i.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = p.args[r];
                    if (o.unused || C.var_names().has(o.name)) {
                        if (s) n.push(s);
                    } else {
                        var f = Fe(Cr, o);
                        var u = o.definition();
                        u.orig.push(f);
                        u.eliminated++;
                        if (o.unused !== undefined) {
                            F(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && a === o && (z || o.name == "arguments" && !Et(w) && Et(C))) {
                                s = Fe(Gr, p);
                            }
                            F(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (r = i.length; --r >= 0; ) {
                    var c = i[r];
                    if (c.name.unused !== undefined) {
                        n.push(c.value);
                    } else {
                        var l = Fe(Yn, c.name);
                        c.name.definition().references.push(l);
                        n.push(Fe(Pn, c, {
                            operator: "=",
                            left: l,
                            right: c.value
                        }));
                    }
                }
            }
            function ae(i, a) {
                a.push(Fe(Pn, p, {
                    operator: "=",
                    left: Fe(yr, p, {
                        elements: w.argnames.map(function(e) {
                            if (e.unused) return Fe(Jr, e);
                            return e.convert_symbol(Yn, n);
                        }),
                        rest: w.rest && w.rest.convert_symbol(Yn, n)
                    }),
                    right: Fe(jn, p, {
                        elements: p.args.slice()
                    })
                }));
                function n(e, n) {
                    if (n.unused) return W(n);
                    var t = n.definition();
                    t.assignments++;
                    t.references.push(e);
                    var r = Fe(Cr, n);
                    t.orig.push(r);
                    t.eliminated++;
                    F(i, a, r);
                }
            }
            function oe(r, e) {
                var t = [ V, 0 ];
                var a = [], i = [], o = [], s = [], f = [];
                w.body.filter(z ? function(e) {
                    if (!(e instanceof Mt)) return true;
                    var n = Fe(Cr, sn(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    F(r, i, n, ye(e, true));
                    return false;
                } : function(e) {
                    if (!(e instanceof Mt)) return true;
                    var n = e.name.definition();
                    C.functions.set(n.name, n);
                    C.variables.set(n.name, n);
                    C.enclosed.push(n);
                    C.var_names().set(n.name, true);
                    t.push(e);
                    return false;
                }).forEach(function(e) {
                    if (!(e instanceof cr)) {
                        if (e instanceof gn) f.push(e.body);
                        return;
                    }
                    for (var n = 0; n < e.definitions.length; n++) {
                        var t = e.definitions[n];
                        var r = sn(t.name);
                        var i = t.value;
                        if (i && f.length > 0) {
                            f.push(i);
                            i = Pe(t, f);
                            f = [];
                        }
                        F(a, o, r, i);
                        if (!z) continue;
                        if ($.has(r.name)) continue;
                        if (r.definition().orig.length == 1 && w.functions.has(r.name)) continue;
                        s.push(cn(c, r));
                    }
                });
                [].push.apply(r, a);
                [].push.apply(e, s);
                [].push.apply(e, i);
                [].push.apply(e, o);
                return t;
            }
            function se() {
                var e = [];
                var n = [];
                if (T > 1 || A || D || w.rest) {
                    ae(e, n);
                } else {
                    ie(e, n);
                }
                var t = oe(e, n);
                n.push(d);
                if (e.length) t.push(Fe(cr, w, {
                    definitions: e
                }));
                [].splice.apply(C.body, t);
                w.enclosed.forEach(function(e) {
                    if (C.var_names().has(e.name)) return;
                    C.enclosed.push(e);
                    C.var_names().set(e.name, true);
                });
                return n;
            }
        });
        e(vr, function(e, n) {
            if (n.option("unsafe")) {
                var t = e.expression;
                if (Ne(t)) switch (t.name) {
                  case "Array":
                  case "Error":
                  case "Function":
                  case "Object":
                  case "RegExp":
                    return Fe(Tn, e).transform(n);
                }
            }
            if (n.option("sequences")) {
                var r = he(e, n);
                if (r !== e) return r.optimize(n);
            }
            if (n.option("unused")) ke(e, n);
            return e;
        });
        function ae(t, r, e, n) {
            if (!(n instanceof Mn)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof Pn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof Yn)) return;
            if (n.right.left.definition() !== r) return;
            if (e.has_side_effects(t)) return;
            if (!i(n.left)) return;
            if (!i(n.right.right)) return;
            r.replaced++;
            return n.operator == "&&" ? Fe(Fn, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : Fe(Fn, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function i(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Un(function(e) {
                    if (n) return true;
                    if (e instanceof Yn && e.definition() === r) return n = true;
                }));
                return !n;
            }
        }
        e(An, function(e, a) {
            var o = n();
            var s = o.length - 1;
            r();
            t();
            if (s == 0) {
                e = je(a.parent(), a.self(), o[0]);
                if (!(e instanceof An)) e = e.optimize(a);
                return e;
            }
            e.expressions = o;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var r = tt(a);
                var i = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < i) e = e.drop_side_effect_free(a, r);
                    if (e) {
                        k(t, e);
                        r = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (s > 0 && Ie(o[s], a)) s--;
                if (s < o.length - 1) {
                    o[s] = Fe(Cn, e, {
                        operator: "void",
                        expression: o[s]
                    });
                    o.length = s + 1;
                }
            }
            function f(e) {
                return e instanceof Pn && e.operator == "=" && e.left instanceof Yn && e.left.definition();
            }
            function r() {
                for (var e = 1; e < s; e++) {
                    var n = o[e - 1];
                    var t = f(n);
                    if (!t) continue;
                    var r = o[e];
                    if (a.option("conditionals")) {
                        var i = ae(a, t, n.right, r);
                        if (i) {
                            n.right = i;
                            o.splice(e--, 1);
                            s--;
                            continue;
                        }
                    }
                    if (a.option("dead_code") && f(r) === t && r.right.is_constant_expression(t.scope.resolve())) {
                        o[--e] = n.right;
                    }
                }
            }
        });
        e(_r, function(e, n) {
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            return de(n, e);
        });
        var oe = dn("+ -");
        var se = dn("* / %");
        e(Cn, function(e, n) {
            var t = e.operator;
            var r = e.expression;
            if (n.option("sequences") && u()) {
                var i = he(e, n);
                if (i !== e) return i.optimize(n);
            }
            switch (t) {
              case "+":
                if (!n.option("evaluate")) break;
                if (!r.is_number(n, true)) break;
                var a = n.parent();
                if (a instanceof Cn && a.operator == "delete") break;
                return r;

              case "-":
                if (r instanceof Xr) r = r.transform(n);
                if (r instanceof Ln || r instanceof Xr) return e;
                break;

              case "!":
                if (!n.option("booleans")) break;
                if (r.is_truthy()) return Pe(e, [ r, Fe(Qr, e) ]).optimize(n);
                if (n.in_boolean_context()) {
                    if (r instanceof Cn && r.operator == "!") return r.expression;
                    if (r instanceof Mn) {
                        var o = tt(n);
                        e = (o ? A : le)(e, r.negate(n, o));
                    }
                }
                break;

              case "delete":
                if (!n.option("evaluate")) break;
                if (f(r)) break;
                return Pe(e, [ r, Fe(Zr, e) ]).optimize(n);

              case "typeof":
                if (!n.option("booleans")) break;
                if (!n.in_boolean_context()) break;
                mn.warn("Boolean expression always true [{start}]", e);
                var s = [ Fe(Zr, e) ];
                if (!(r instanceof Yn && Ce(r, n))) s.unshift(r);
                return Pe(e, s).optimize(n);

              case "void":
                if (!n.option("side_effects")) break;
                r = r.drop_side_effect_free(n);
                if (!r) return Fe(Gr, e).optimize(n);
                e.expression = r;
                return e;
            }
            if (n.option("evaluate") && r instanceof Mn && oe[t] && se[r.operator] && (r.left.is_constant() || !r.right.has_side_effects(n))) {
                return Fe(Mn, e, {
                    operator: r.operator,
                    left: Fe(Cn, r.left, {
                        operator: t,
                        expression: r.left
                    }),
                    right: r.right
                });
            }
            return de(n, e);
            function f(e) {
                return e instanceof Xr || e instanceof Wr || e instanceof Rr || e instanceof Dn || e instanceof Yn || e instanceof Gr;
            }
            function u() {
                switch (t) {
                  case "delete":
                    return !f(r.tail_node());

                  case "typeof":
                    return !Ne(r.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(gr, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var r = e.expression;
                if (r instanceof gr) return r.optimize(n);
                if (r instanceof Cn && r.expression instanceof gr) return r.optimize(n);
                for (var i = 0, a = e, o; o = n.parent(i++); a = o) {
                    if (Et(o)) {
                        if (o.value === a) return r.optimize(n);
                    } else if (o instanceof xn) {
                        var s = true;
                        do {
                            a = o;
                            o = n.parent(i++);
                            if (o instanceof ir && (o.bfinally || o.bcatch) !== a) {
                                s = false;
                                break;
                            }
                        } while (o && !(o instanceof yn));
                        if (s) return r.optimize(n);
                    } else if (o instanceof An) {
                        if (o.tail_node() === a) continue;
                    }
                    break;
                }
            }
            return e;
        });
        e(br, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = he(e, n);
                if (t !== e) return t.optimize(n);
            }
            var r = e.expression;
            if (e.nested && r.TYPE == "Call") {
                var i = r.clone().optimize(n);
                if (i.TYPE != "Call") return i;
            }
            return e;
        });
        Mn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Dn) {
                if (!(this.left.expression instanceof An)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return Pe(this, n);
            }
            if (this.left instanceof An) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return Pe(this, n);
            }
            if (this.right instanceof An) {
                if (this.left.has_side_effects(e)) return this;
                var r = this.operator == "=" && this.left instanceof Yn;
                var n = this.right.expressions;
                var i = n.length - 1;
                for (var a = 0; a < i; a++) {
                    if (!r && n[a].has_side_effects(e)) break;
                }
                if (a == i) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return Pe(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = Pe(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return Pe(this, n);
                }
            }
            return this;
        });
        var Te = dn("indexOf lastIndexOf");
        var Ae = dn("== === != !== * & | ^");
        function F(e, n) {
            if (e instanceof Pn) return !n && e.operator == "=" && F(e.right);
            if (e instanceof vr) return !n;
            if (e instanceof An) return F(e.tail_node(), n);
            if (e instanceof Yn) return !n && F(e.fixed_value());
            return e instanceof jn || e instanceof It || e instanceof wn || e instanceof In;
        }
        function Xe(e, n, t) {
            switch (e) {
              case "in":
                return F(n) || t && t.option("unsafe_comps");

              case "instanceof":
                if (n instanceof Yn) n = n.fixed_value();
                return z(n) || t && t.option("unsafe_comps");

              default:
                return true;
            }
        }
        function x(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof Pn) return n.operator != "=" || x(e, n.right);
            if (n instanceof Mn) {
                return !He[n.operator] || x(e, n.left) && x(e, n.right);
            }
            if (n instanceof Tn) return St(n.expression);
            if (n instanceof Fn) {
                return x(e, n.consequent) && x(e, n.alternative);
            }
            if (n instanceof An) return x(e, n.tail_node());
            if (n instanceof Yn) {
                var t = n.fixed_value();
                return t && x(e, t);
            }
            if (n instanceof Br) return !n.tag || Oe(e, n.tag);
            if (n instanceof zn) return true;
        }
        function De(e, n) {
            if (n instanceof qn) return De(e, n.expression);
            if (n instanceof On) {
                return De(e, n.expression) && De(e, n.property);
            }
            if (n instanceof Dr) return true;
            return !n.has_side_effects(e);
        }
        function qe(e, n) {
            var t = e.right;
            e.left = Fe(Mn, e, {
                operator: e.operator,
                left: e.left,
                right: t.left,
                start: e.left.start,
                end: t.left.end
            });
            e.right = t.right;
            if (n) {
                e.left = e.left.transform(n);
            } else if (e.operator == t.left.operator) {
                qe(e.left);
            }
        }
        e(Mn, function(r, i) {
            if (Ae[r.operator] && r.right.is_constant() && !r.left.is_constant() && !(r.left instanceof Mn && ai[r.left.operator] >= ai[r.operator])) {
                $();
            }
            if (i.option("sequences")) {
                var e = r.lift_sequences(i);
                if (e !== r) return e.optimize(i);
            }
            if (i.option("assignments") && He[r.operator]) {
                var n = r.right;
                if (r.left instanceof Yn && n instanceof Pn && n.operator == "=" && r.left.equals(n.left)) {
                    var t = n.left.clone();
                    var a = Fe(Pn, r, {
                        operator: "=",
                        left: t,
                        right: Fe(Mn, r, {
                            operator: r.operator,
                            left: r.left,
                            right: n.right
                        })
                    });
                    if (t.fixed) {
                        t.fixed = function() {
                            return a.right;
                        };
                        t.fixed.assigns = [ a ];
                    }
                    var o = t.definition();
                    o.references.push(t);
                    o.replaced++;
                    return a.optimize(i);
                }
            }
            if (i.option("comparisons")) switch (r.operator) {
              case "===":
              case "!==":
                if (Ie(r.left, i) && r.right.is_defined(i)) {
                    mn.warn("Expression always defined [{start}]", r);
                    return Pe(r, [ r.right, Fe(r.operator == "===" ? Qr : Zr, r) ]).optimize(i);
                }
                var s = true;
                if (r.left.is_string(i) && r.right.is_string(i) || r.left.is_number(i) && r.right.is_number(i) || r.left.is_boolean(i) && r.right.is_boolean(i) || De(i, r.left) && r.left.equals(r.right)) {
                    r.operator = r.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!s && Ie(r.left, i)) {
                    r.left = Fe(Vr, r.left);
                } else if (i.option("typeofs") && r.left instanceof Bn && r.left.value == "undefined" && r.right instanceof Cn && r.right.operator == "typeof") {
                    var f = r.right.expression;
                    if (f instanceof Yn ? f.is_declared(i) : !(f instanceof Dn && i.option("ie"))) {
                        r.right = f;
                        r.left = Fe(Gr, r.left).optimize(i);
                        if (r.operator.length == 2) r.operator += "=";
                    }
                } else if (r.left instanceof Yn && r.right instanceof Yn && r.left.definition() === r.right.definition() && F(r.left)) {
                    return Fe(r.operator[0] == "=" ? Zr : Qr, r).optimize(i);
                }
                break;

              case "&&":
              case "||":
                var u = r.left;
                if (u.operator == r.operator) u = u.right;
                var f = u.right;
                if (f instanceof Pn && f.operator == "=") f = f.left;
                if (u instanceof Mn && u.operator == (r.operator == "&&" ? "!==" : "===") && r.right instanceof Mn && u.operator == r.right.operator && (Ie(u.left, i) && r.right.left instanceof Vr || u.left instanceof Vr && Ie(r.right.left, i)) && !f.has_side_effects(i) && f.equals(r.right.right)) {
                    u.operator = u.operator.slice(0, -1);
                    u.left = Fe(Vr, r);
                    return r.left;
                }
                break;
            }
            var c = false;
            var l = i.parent();
            if (i.option("booleans")) {
                var u = r.left;
                if (He[r.operator] && !u.has_side_effects(i)) {
                    if (u.equals(r.right)) {
                        return je(l, i.self(), u).optimize(i);
                    }
                    X(i, u);
                }
                c = i.in_boolean_context();
            }
            if (c) switch (r.operator) {
              case "+":
                var p = r.left.evaluate(i, true);
                if (p && typeof p == "string" || (p = r.right.evaluate(i, true)) && typeof p == "string") {
                    mn.warn("+ in boolean context always true [{start}]", r);
                    var d = [];
                    if (r.left.evaluate(i) instanceof mn) d.push(r.left);
                    if (r.right.evaluate(i) instanceof mn) d.push(r.right);
                    if (d.length < 2) {
                        d.push(Fe(Zr, r));
                        return Pe(r, d).optimize(i);
                    }
                    r.truthy = true;
                }
                break;

              case "==":
                if (r.left instanceof Bn && r.left.value == "" && r.right.is_string(i)) {
                    return Fe(Cn, r, {
                        operator: "!",
                        expression: r.right
                    }).optimize(i);
                }
                break;

              case "!=":
                if (r.left instanceof Bn && r.left.value == "" && r.right.is_string(i)) {
                    return r.right.optimize(i);
                }
                break;
            }
            if (i.option("comparisons") && r.is_boolean(i)) {
                if (l.TYPE != "Binary") {
                    var h = Fe(Cn, r, {
                        operator: "!",
                        expression: r.negate(i)
                    });
                    if (pe(i, r, h) === h) return h;
                }
                switch (r.operator) {
                  case ">":
                    $("<");
                    break;

                  case ">=":
                    $("<=");
                    break;
                }
            }
            if (i.option("conditionals") && He[r.operator] && r.right instanceof Mn && r.operator == r.right.operator) {
                qe(r, i);
            }
            if (i.option("strings") && r.operator == "+") {
                if (r.right instanceof Bn && r.right.value == "" && r.left.is_string(i)) {
                    return r.left.optimize(i);
                }
                if (r.left instanceof Bn && r.left.value == "" && r.right.is_string(i)) {
                    return r.right.optimize(i);
                }
                if (r.left instanceof Mn && r.left.operator == "+" && r.left.left instanceof Bn && r.left.left.value == "" && r.right.is_string(i) && (r.left.right.is_constant() || !r.right.has_side_effects(i))) {
                    r.left = r.left.right;
                    return r.optimize(i);
                }
                if (r.right instanceof Mn && r.operator == r.right.operator && (r.left.is_string(i) && r.right.is_string(i) || r.right.left.is_string(i) && (r.left.is_constant() || !r.right.right.has_side_effects(i)))) {
                    qe(r, i);
                }
            }
            if (i.option("evaluate")) {
                var v = true;
                switch (r.operator) {
                  case "&&":
                    var m = M(i, r.left);
                    if (!m) {
                        mn.warn("Condition left of && always false [{start}]", r);
                        return je(l, i.self(), r.left).optimize(i);
                    } else if (!(m instanceof mn)) {
                        mn.warn("Condition left of && always true [{start}]", r);
                        return Pe(r, [ r.left, r.right ]).optimize(i);
                    }
                    if (!r.right.evaluate(i, true)) {
                        if (c && !(r.right.evaluate(i) instanceof mn)) {
                            mn.warn("Boolean && always false [{start}]", r);
                            return Pe(r, [ r.left, Fe(Qr, r) ]).optimize(i);
                        } else r.falsy = true;
                    } else if ((c || l.operator == "&&" && l.left === i.self()) && !(r.right.evaluate(i) instanceof mn)) {
                        mn.warn("Dropping side-effect-free && [{start}]", r);
                        return r.left.optimize(i);
                    }
                    if (r.left.operator == "||") {
                        var _ = M(i, r.left.right);
                        if (!_) return Fe(Fn, r, {
                            condition: r.left.left,
                            consequent: r.right,
                            alternative: r.left.right
                        }).optimize(i);
                    }
                    break;

                  case "??":
                    var g = true;

                  case "||":
                    var m = M(i, r.left, g);
                    if (g ? m == null : !m) {
                        mn.warn("Condition left of {operator} always {value} [{start}]", {
                            operator: r.operator,
                            value: g ? "nulish" : "false",
                            start: r.start
                        });
                        return Pe(r, [ r.left, r.right ]).optimize(i);
                    } else if (!(m instanceof mn)) {
                        mn.warn("Condition left of {operator} always {value} [{start}]", {
                            operator: r.operator,
                            value: g ? "defined" : "true",
                            start: r.start
                        });
                        return je(l, i.self(), r.left).optimize(i);
                    }
                    var b;
                    if (!g && (b = r.right.evaluate(i, true)) && !(b instanceof mn)) {
                        if (c && !(r.right.evaluate(i) instanceof mn)) {
                            mn.warn("Boolean || always true [{start}]", r);
                            return Pe(r, [ r.left, Fe(Zr, r) ]).optimize(i);
                        } else r.truthy = true;
                    } else if ((c || l.operator == "||" && l.left === i.self()) && !r.right.evaluate(i)) {
                        mn.warn("Dropping side-effect-free {operator} [{start}]", r);
                        return r.left.optimize(i);
                    }
                    if (!g && r.left.operator == "&&") {
                        var _ = M(i, r.left.right);
                        if (_ && !(_ instanceof mn)) return Fe(Fn, r, {
                            condition: r.left.left,
                            consequent: r.left.right,
                            alternative: r.right
                        }).optimize(i);
                    }
                    break;

                  case "+":
                    if (r.left instanceof Rn && r.right instanceof Mn && r.right.operator == "+" && r.right.left instanceof Rn && r.right.is_string(i)) {
                        r = Fe(Mn, r, {
                            operator: "+",
                            left: Fe(Bn, r.left, {
                                value: "" + r.left.value + r.right.left.value,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                    }
                    if (r.right instanceof Rn && r.left instanceof Mn && r.left.operator == "+" && r.left.right instanceof Rn && r.left.is_string(i)) {
                        r = Fe(Mn, r, {
                            operator: "+",
                            left: r.left.left,
                            right: Fe(Bn, r.right, {
                                value: "" + r.left.right.value + r.right.value,
                                start: r.left.right.start,
                                end: r.right.end
                            })
                        });
                    }
                    if (r.right instanceof Cn && r.right.operator == "-" && r.left.is_number(i)) {
                        r = Fe(Mn, r, {
                            operator: "-",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }
                    if (r.left instanceof Cn && r.left.operator == "-" && O() && r.right.is_number(i)) {
                        r = Fe(Mn, r, {
                            operator: "-",
                            left: r.right,
                            right: r.left.expression
                        });
                        break;
                    }
                    if (i.option("unsafe_math") && r.left instanceof Mn && ai[r.left.operator] == ai[r.operator] && r.right.is_constant() && (r.right.is_boolean(i) || r.right.is_number(i)) && r.left.is_number(i) && !r.left.right.is_constant() && (r.left.left.is_boolean(i) || r.left.left.is_number(i))) {
                        r = Fe(Mn, r, {
                            operator: r.left.operator,
                            left: Fe(Mn, r, {
                                operator: r.operator,
                                left: r.right,
                                right: r.left.left
                            }),
                            right: r.left.right
                        });
                        break;
                    }

                  case "-":
                    if (r.right instanceof Cn && r.right.operator == "-" && r.left.is_number(i) && r.right.expression.is_number(i)) {
                        r = Fe(Mn, r, {
                            operator: "+",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    v = i.option("unsafe_math");
                    if (r.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = r[e];
                        if (n instanceof Cn && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(i) || t.is_number(i) || t.is_string(i)) {
                                r[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (r.operator != "-" && r.operator != "/" && (r.left.is_boolean(i) || r.left.is_number(i)) && (r.right.is_boolean(i) || r.right.is_number(i)) && O() && !(r.left instanceof Mn && r.left.operator != r.operator && ai[r.left.operator] >= ai[r.operator])) {
                        r = pe(i, r, Fe(Mn, r, {
                            operator: r.operator,
                            left: r.right,
                            right: r.left
                        }), r.right instanceof Rn && !(r.left instanceof Rn));
                    }
                    if (!v || !r.is_number(i)) break;
                    if (r.right instanceof Mn && r.right.operator != "%" && ai[r.right.operator] == ai[r.operator] && r.right.is_number(i) && (r.operator != "+" || r.right.left.is_boolean(i) || r.right.left.is_number(i)) && (r.operator != "-" || !r.left.is_negative_zero()) && (r.right.left.is_constant_expression() || !r.right.right.has_side_effects(i)) && !S(r.right.right)) {
                        r = Fe(Mn, r, {
                            operator: T(r.operator, r.right.operator),
                            left: Fe(Mn, r.left, {
                                operator: r.operator,
                                left: r.left,
                                right: r.right.left,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                        if (r.operator == "+" && !r.right.is_boolean(i) && !r.right.is_number(i)) {
                            r.right = Fe(Cn, r.right, {
                                operator: "+",
                                expression: r.right
                            });
                        }
                    }
                    if (r.right instanceof Rn && r.left instanceof Mn && r.left.operator != "%" && ai[r.left.operator] == ai[r.operator] && r.left.is_number(i)) {
                        if (r.left.left instanceof Rn) {
                            var u = A(r.operator, r.left.left, r.right, {
                                start: r.left.left.start,
                                end: r.right.end
                            });
                            r = A(r.left.operator, de(i, u), r.left.right, r);
                        } else if (r.left.right instanceof Rn) {
                            var y = T(r.left.operator, r.operator);
                            var w = de(i, A(y, r.left.right, r.right, r.left));
                            if (w.is_constant() && !(r.left.operator == "-" && r.right.value != 0 && +w.value == 0 && r.left.left.is_negative_zero())) {
                                r = A(r.left.operator, r.left.left, w, r);
                            }
                        }
                    }
                    break;

                  case "instanceof":
                    if (z(r.right)) return Pe(r, [ r, Fe(Qr, r) ]).optimize(i);
                    break;
                }
                if (!(l instanceof Cn && l.operator == "delete")) {
                    if (r.left instanceof Ln && !r.right.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.left.value == 0) {
                            if (r.right.is_boolean(i)) return Fe(Cn, r, {
                                operator: "+",
                                expression: r.right
                            }).optimize(i);
                            if (r.right.is_number(i) && !r.right.is_negative_zero()) return r.right;
                        }
                        break;

                      case "*":
                        if (r.left.value == 1) return Fe(Cn, r, {
                            operator: "+",
                            expression: r.right
                        }).optimize(i);
                        break;
                    }
                    if (r.right instanceof Ln && !r.left.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.right.value == 0) {
                            if (r.left.is_boolean(i)) return Fe(Cn, r, {
                                operator: "+",
                                expression: r.left
                            }).optimize(i);
                            if (r.left.is_number(i) && !r.left.is_negative_zero()) return r.left;
                        }
                        break;

                      case "-":
                        if (r.right.value == 0) return Fe(Cn, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(i);
                        break;

                      case "/":
                        if (r.right.value == 1) return Fe(Cn, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(i);
                        break;
                    }
                }
            }
            if (i.option("typeofs")) switch (r.operator) {
              case "&&":
                U(r.left, r.right, null);
                break;

              case "||":
                U(r.left, null, r.right);
                break;
            }
            if (i.option("unsafe")) {
                var x = D(r.right);
                if (c && x && (r.operator == "==" || r.operator == "!=") && r.left instanceof Ln && r.left.value == 0) {
                    return (r.operator == "==" ? Fe(Cn, r, {
                        operator: "!",
                        expression: r.right
                    }) : r.right).optimize(i);
                }
                var k = D(r.left);
                if (i.option("comparisons") && q()) {
                    var E = Fe(Cn, r, {
                        operator: "!",
                        expression: Fe(Cn, r, {
                            operator: "~",
                            expression: k ? r.left : r.right
                        })
                    });
                    switch (r.operator) {
                      case "<":
                        if (k) break;

                      case "<=":
                      case "!=":
                        E = Fe(Cn, r, {
                            operator: "!",
                            expression: E
                        });
                        break;
                    }
                    return E.optimize(i);
                }
            }
            return de(i, r);
            function S(e) {
                var n = false;
                e.walk(new Un(function(e) {
                    if (n) return true;
                    if (e instanceof Pn) {
                        if (e.left instanceof Dn) return n = true;
                    } else if (e instanceof zn) {
                        if (fi[e.operator] && e.expression instanceof Dn) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function T(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function A(e, n, t, r) {
                if (e == "+") {
                    if (!n.is_boolean(i) && !n.is_number(i)) {
                        n = Fe(Cn, n, {
                            operator: "+",
                            expression: n
                        });
                    }
                    if (!t.is_boolean(i) && !t.is_number(i)) {
                        t = Fe(Cn, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                }
                return Fe(Mn, r, {
                    operator: e,
                    left: n,
                    right: t
                });
            }
            function D(e) {
                return e.TYPE == "Call" && e.expression instanceof qn && Te[e.expression.property];
            }
            function q() {
                switch (r.operator) {
                  case "<=":
                    return x && r.left instanceof Ln && r.left.value == 0;

                  case "<":
                    if (k && r.right instanceof Ln && r.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!x) return false;
                    return r.left instanceof Ln && r.left.value == -1 || r.left instanceof Cn && r.left.operator == "-" && r.left.expression instanceof Ln && r.left.expression.value == 1;
                }
            }
            function O() {
                return r.left.is_constant() || r.right.is_constant() || !r.left.has_side_effects(i) && !r.right.has_side_effects(i);
            }
            function $(e) {
                if (O()) {
                    if (e) r.operator = e;
                    var n = r.left;
                    r.left = r.right;
                    r.right = n;
                }
            }
        });
        e(Nr, function(e) {
            return e;
        });
        function Ke(e, n, t) {
            var r = 0, i = e.self();
            do {
                if (i === t) return i;
                if (z(i) && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(r++));
        }
        function Qe(e) {
            var n = e.scope.resolve();
            return hn(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(Yn, function(t, e) {
            if (!e.option("ie") && Ne(t) && !(t.scope.resolve().uses_with && e.find_parent(bt))) {
                switch (t.name) {
                  case "undefined":
                    return Fe(Gr, t).optimize(e);

                  case "NaN":
                    return Fe(Wr, t).optimize(e);

                  case "Infinity":
                    return Fe(Xr, t).optimize(e);
                }
            }
            var n = e.parent();
            if (e.option("reduce_vars") && ui(e.self(), n) !== e.self()) {
                var r = t.definition();
                var i = t.fixed_value();
                var a = r.single_use && !(n instanceof Tn && n.is_expr_pure(e));
                if (a) {
                    if (z(i)) {
                        if ((r.scope !== t.scope.resolve() || r.in_loop) && (!e.option("reduce_funcs") || r.escaped.depth == 1 || i.inlined)) {
                            a = false;
                        } else if (r.redefined()) {
                            a = false;
                        } else if (Ke(e, r, i)) {
                            a = false;
                        } else if (i.name && i.name.definition() !== r) {
                            a = false;
                        } else if (i.parent_scope !== t.scope || si(r)) {
                            if (!Se(i, e)) {
                                a = false;
                            } else if ((a = i.is_constant_expression(t.scope)) == "f") {
                                var o = t.scope;
                                do {
                                    if (o instanceof Mt || o instanceof kt) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        } else if (i.name && (i.name.name == "await" && St(i) || i.name.name == "yield" && Tt(i))) {
                            a = false;
                        } else if (i.has_side_effects(e)) {
                            a = false;
                        } else if (e.option("ie") && i instanceof It) {
                            a = false;
                        }
                        if (a) i.parent_scope = t.scope;
                    } else if (!i || r.recursive_refs > 0 || !i.is_constant_expression() || i.drop_side_effect_free(e)) {
                        a = false;
                    }
                }
                if (a) {
                    r.single_use = false;
                    i._squeezed = true;
                    i.single_use = true;
                    if (i instanceof Ht) i = re(i);
                    if (i instanceof Mt) i = ye(i);
                    if (z(i)) {
                        var s = [];
                        var o = t.scope;
                        do {
                            s.push(o);
                            if (o === r.scope) break;
                        } while (o = o.parent_scope);
                        i.enclosed.forEach(function(e) {
                            if (i.variables.has(e.name)) return;
                            for (var n = 0; n < s.length; n++) {
                                var t = s[n];
                                if (!Qn(t.enclosed, e)) return;
                                t.var_names().set(e.name, true);
                            }
                        });
                    }
                    var f;
                    if (r.recursive_refs > 0) {
                        f = i.clone(true);
                        var u = f.name.definition();
                        var c = f.variables.get(f.name.name);
                        var l = c && c.orig[0];
                        var p, d;
                        if (f instanceof It) {
                            p = "def_function";
                            d = Pr;
                        } else {
                            p = "def_variable";
                            d = Fr;
                        }
                        if (!(l instanceof d)) {
                            l = Fe(d, f.name);
                            l.scope = f;
                            f.name = l;
                            c = f[p](l);
                            c.recursive_refs = r.recursive_refs;
                        }
                        f.walk(new Un(function(e) {
                            if (e instanceof qr) {
                                if (e !== l) {
                                    var n = e.definition();
                                    n.orig.push(e);
                                    n.eliminated++;
                                }
                                return;
                            }
                            if (!(e instanceof Yn)) return;
                            var n = e.definition();
                            if (n === u) {
                                e.thedef = n = c;
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if (z(t) && t.name && t.name.definition() === n && n.scope === t.name.scope && i.variables.get(t.name.name) === n) {
                                    t.name = t.name.clone();
                                    e.thedef = n = f.variables.get(t.name.name) || f[p](t.name);
                                }
                            }
                            n.references.push(e);
                        }));
                    } else {
                        if (i instanceof yn) {
                            e.push(i);
                            f = i.optimize(e);
                            e.pop();
                        } else {
                            f = i.optimize(e);
                        }
                        f = f.transform(new ei(function(e, n) {
                            if (e instanceof yn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    r.replaced++;
                    return f;
                }
                var h;
                if (i && (h = t.fixed || r.fixed).should_replace !== false) {
                    var v, m;
                    if (i instanceof Yr) {
                        if (!si(r) && Qe(r) && !y(r)) m = i;
                    } else if ((v = i.evaluate(e, true)) !== i && typeof v != "function" && (v === null || typeof v != "object" || e.option("unsafe_regexp") && v instanceof RegExp && !r.cross_loop && Qe(r))) {
                        m = fe(v, i);
                    }
                    if (m) {
                        if (h.should_replace === undefined) {
                            var _ = m.optimize(e).print_to_string().length;
                            if (!w(i)) {
                                _ = Math.min(_, i.print_to_string().length);
                            }
                            var g = r.name.length;
                            if (e.option("unused") && !e.exposed(r)) {
                                var b = r.references.length - r.replaced - r.assignments;
                                b = Math.min(b, r.references.filter(function(e) {
                                    return e.fixed === h;
                                }).length);
                                g += (g + 2 + _) / Math.max(1, b);
                            }
                            h.should_replace = _ - Math.floor(g) < e.eval_threshold;
                        }
                        if (h.should_replace) {
                            var f;
                            if (w(i)) {
                                f = m.optimize(e);
                                if (f === m) f = f.clone(true);
                            } else {
                                f = le(m.optimize(e), i);
                                if (f === m || f === i) f = f.clone(true);
                            }
                            r.replaced++;
                            return f;
                        }
                    }
                }
            }
            return t;
            function y(e) {
                var n = t.scope;
                while (n !== e.scope) {
                    if (n instanceof It) return true;
                    n = n.parent_scope;
                }
            }
            function w(e) {
                var n;
                e.walk(new Un(function(e) {
                    if (e instanceof Yn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Oe(e, n) {
            return e.option("unsafe") && n instanceof qn && n.property == "raw" && Ne(n.expression) && n.expression.name == "String";
        }
        function Ze(e) {
            var r = false;
            e = e.replace(/\\(u\{[^{}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                var t = ti(n);
                if (typeof t == "string") return t;
                r = true;
            });
            if (!r) return e;
        }
        e(Br, function(e, t) {
            if (!t.option("templates")) return e;
            var r = e.tag;
            if (!r || Oe(t, r)) {
                var n = [];
                var i = [];
                for (var a = 0, o; a < e.strings.length; a++) {
                    var s = e.strings[a];
                    if (!r) {
                        var f = Ze(s);
                        if (f) s = v(f);
                    }
                    if (a > 0) {
                        var u = e.expressions[a - 1];
                        var c = m(u);
                        if (c) {
                            var l = i[i.length - 1];
                            var p = l + c + s;
                            var d;
                            if (r || typeof (d = Ze(p)) == o) {
                                i[i.length - 1] = d ? v(d) : p;
                                continue;
                            }
                        }
                        n.push(u);
                    }
                    i.push(s);
                    if (!r) o = typeof f;
                }
                if (!r && i.length > 1) {
                    if (i[i.length - 1] == "") return Fe(Mn, e, {
                        operator: "+",
                        left: Fe(Br, e, {
                            expressions: n.slice(0, -1),
                            strings: i.slice(0, -1)
                        }).transform(t),
                        right: n[n.length - 1]
                    }).optimize(t);
                    if (i[0] == "") {
                        var h = Fe(Mn, e, {
                            operator: "+",
                            left: Fe(Bn, e, {
                                value: ""
                            }),
                            right: n[0]
                        });
                        for (var a = 1; i[a] == "" && a < n.length; a++) {
                            h = Fe(Mn, e, {
                                operator: "+",
                                left: h,
                                right: n[a]
                            });
                        }
                        return pe(t, e, Fe(Mn, e, {
                            operator: "+",
                            left: h.transform(t),
                            right: Fe(Br, e, {
                                expressions: n.slice(a),
                                strings: i.slice(a)
                            }).transform(t)
                        }).optimize(t));
                    }
                }
                e.expressions = n;
                e.strings = i;
            }
            return de(t, e);
            function v(e) {
                return e.replace(/\r|\\|`|\${/g, function(e) {
                    return "\\" + (e == "\r" ? "r" : e);
                });
            }
            function m(e) {
                var n = e.evaluate(t);
                if (n === e) return;
                if (r && /\r|\\|`/.test(n)) return;
                n = v("" + n);
                if (n.length > e.print_to_string().length + "${}".length) return;
                return n;
            }
        });
        function en(e, n) {
            return e instanceof Yn || e.TYPE === n.TYPE;
        }
        e(Gr, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = Me(n).find_variable("undefined");
                if (t) {
                    var r = Fe(Yn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    r.is_undefined = true;
                    return r;
                }
            }
            var i = ui(n.self(), n.parent());
            if (i && en(i, e)) return e;
            return Fe(Cn, e, {
                operator: "void",
                expression: Fe(Ln, e, {
                    value: 0
                })
            });
        });
        e(Xr, function(e, n) {
            var t = ui(n.self(), n.parent());
            if (t && en(t, e)) return e;
            if (n.option("keep_infinity") && !t && !Me(n).find_variable("Infinity")) {
                return e;
            }
            return Fe(Mn, e, {
                operator: "/",
                left: Fe(Ln, e, {
                    value: 1
                }),
                right: Fe(Ln, e, {
                    value: 0
                })
            });
        });
        e(Wr, function(e, n) {
            var t = ui(n.self(), n.parent());
            if (t && en(t, e)) return e;
            if (!t && !Me(n).find_variable("NaN")) return e;
            return Fe(Mn, e, {
                operator: "/",
                left: Fe(Ln, e, {
                    value: 0
                }),
                right: Fe(Ln, e, {
                    value: 0
                })
            });
        });
        function nn(t, n) {
            var r = false;
            var i = new Un(function(e) {
                if (r) return true;
                if (e instanceof Yn && Vn(e.definition(), n)) return r = true;
            });
            var a = new Un(function(e) {
                if (r) return true;
                if (e instanceof wn && e !== t) {
                    if (!(e.name || St(e) || Tt(e))) {
                        var n = a.parent();
                        if (n instanceof Tn && n.expression === e) return;
                    }
                    e.walk(i);
                    return true;
                }
            });
            t.walk(a);
            return r;
        }
        var tn = dn("+ - * / % >> << >>> | ^ &");
        var rn = dn("* | ^ &");
        e(Pn, function(a, o) {
            if (o.option("dead_code")) {
                if (a.left instanceof Dn) {
                    if (a.operator == "=") {
                        if (a.redundant) {
                            var e = [ a.left.expression ];
                            if (a.left instanceof On) e.push(a.left.property);
                            e.push(a.right);
                            return Pe(a, e).optimize(o);
                        }
                        if (a.left.equals(a.right) && !a.left.has_side_effects(o)) {
                            return a.right;
                        }
                        var n = a.left.expression;
                        if (n instanceof wn || !o.has_directive("use strict") && n instanceof Rn && !n.may_throw_on_access(o)) {
                            return a.left instanceof qn ? a.right : Pe(a, [ a.left.property, a.right ]).optimize(o);
                        }
                    }
                } else if (a.left instanceof Yn && Ce(a.left, o)) {
                    var t;
                    if (a.operator == "=" && a.left.equals(a.right) && !((t = o.parent()) instanceof Cn && t.operator == "delete")) {
                        return a.right;
                    }
                    if (a.left.is_immutable()) return _();
                    var r = a.left.definition();
                    var s = r.scope.resolve();
                    var i = s === o.find_parent(wn);
                    var f = 0, u;
                    t = o.self();
                    if (!(s.uses_arguments && si(r)) || o.has_directive("use strict")) do {
                        u = t;
                        t = o.parent(f++);
                        if (t instanceof Pn) {
                            if (t.left instanceof Yn && t.left.definition() === r) {
                                if (m(f, t, !i)) break;
                                return _(r);
                            }
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof Dn) return true;
                            })) break;
                            continue;
                        }
                        if (t instanceof Jt) {
                            if (!i) break;
                            if (m(f, t)) break;
                            if (nn(s, [ r ])) break;
                            return _(r);
                        }
                        if (t instanceof gn) {
                            if (!i) break;
                            if (nn(s, [ r ])) break;
                            var c;
                            do {
                                c = t;
                                t = o.parent(f++);
                                if (t === s && T(t.body, c)) return _(r);
                            } while (v(c, t));
                            break;
                        }
                        if (t instanceof En) {
                            if (!(t.name instanceof qr)) continue;
                            if (t.name.definition() !== r) continue;
                            if (m(f, t)) break;
                            return _(r);
                        }
                    } while (h(u, t));
                }
            }
            if (o.option("sequences")) {
                var l = a.lift_sequences(o);
                if (l !== a) return l.optimize(o);
            }
            if (o.option("assignments")) {
                if (a.operator == "=" && a.left instanceof Yn && a.right instanceof Mn) {
                    var p;
                    if ((p = a.right.left) instanceof Yn && p.name == a.left.name && tn[a.right.operator]) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return p;
                        };
                        return Fe(Pn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.right
                        });
                    }
                    if ((p = a.right.right) instanceof Yn && p.name == a.left.name && rn[a.right.operator] && !a.right.left.has_side_effects(o)) {
                        if (a.left.fixed) a.left.fixed.to_binary = function() {
                            return p;
                        };
                        return Fe(Pn, a, {
                            operator: a.right.operator + "=",
                            left: a.left,
                            right: a.right.left
                        });
                    }
                }
                if ((a.operator == "-=" || a.operator == "+=" && (a.left.is_boolean(o) || a.left.is_number(o))) && a.right instanceof Ln && a.right.value == 1) {
                    var d = a.operator.slice(0, -1);
                    return Fe(Cn, a, {
                        operator: d + d,
                        expression: a.left
                    });
                }
            }
            return de(o, a);
            function h(e, n) {
                if (n instanceof Mn) switch (e) {
                  case n.left:
                    return n.right.is_constant_expression(s);

                  case n.right:
                    return true;

                  default:
                    return false;
                }
                if (n instanceof Fn) switch (e) {
                  case n.condition:
                    return n.consequent.is_constant_expression(s) && n.alternative.is_constant_expression(s);

                  case n.consequent:
                  case n.alternative:
                    return true;

                  default:
                    return false;
                }
                if (n instanceof An) {
                    var t = n.expressions;
                    var r = t.indexOf(e);
                    if (r < 0) return false;
                    for (var i = t.length; --i > r; ) {
                        if (!t[i].is_constant_expression(s)) return false;
                    }
                    return true;
                }
                return n instanceof Cn;
            }
            function v(e, n) {
                if (n instanceof bn) return T(n.body, e);
                if (n instanceof ar) return T(n.body, e);
                if (n instanceof or) return T(n.body, e);
                if (n instanceof kn) return n.body === e || n.alternative === e;
                if (n instanceof ir) return n.bfinally ? n.bfinally === e : n.bcatch === e;
            }
            function m(e, n, t) {
                var r = a.right;
                a.right = Fe(Vr, r);
                var i = n.may_throw(o);
                a.right = r;
                return Le(o, e, n, s, i, t);
            }
            function _(e) {
                if (e) e.fixed = false;
                return (a.operator != "=" ? Fe(Mn, a, {
                    operator: a.operator.slice(0, -1),
                    left: a.left,
                    right: a.right
                }) : je(o.parent(), a, a.right)).optimize(o);
            }
        });
        e(Fn, function(u, n) {
            if (n.option("sequences") && u.condition instanceof An) {
                var e = u.condition.expressions.slice();
                var t = u.clone();
                t.condition = e.pop();
                e.push(t);
                return Pe(u, e).optimize(n);
            }
            if (!n.option("conditionals")) return u;
            var c = u.condition;
            if (n.option("booleans") && !c.has_side_effects(n)) {
                X(n, c);
            }
            c = M(n, c);
            if (!c) {
                mn.warn("Condition always false [{start}]", u);
                return Pe(u, [ u.condition, u.alternative ]).optimize(n);
            } else if (!(c instanceof mn)) {
                mn.warn("Condition always true [{start}]", u);
                return Pe(u, [ u.condition, u.consequent ]).optimize(n);
            }
            var r = tt(n);
            var i = c.negate(n, r);
            if ((r ? A : le)(c, i) === i) {
                u = Fe(Fn, u, {
                    condition: i,
                    consequent: u.alternative,
                    alternative: u.consequent
                });
                i = c;
                c = u.condition;
            }
            var a = u.consequent;
            var o = u.alternative;
            if (De(n, c)) {
                if (c.equals(a)) return Fe(Mn, u, {
                    operator: "||",
                    left: c,
                    right: o
                }).optimize(n);
                if (c.equals(o)) return Fe(Mn, u, {
                    operator: "&&",
                    left: c,
                    right: a
                }).optimize(n);
            }
            var s = a.tail_node();
            if (s instanceof Pn) {
                var f = s.operator == "=";
                var l = f ? o.tail_node() : o;
                if ((f || a === s) && l instanceof Pn && s.operator == l.operator && s.left.equals(l.left) && (f && s.left instanceof Yn || !c.has_side_effects(n) && k(a) && k(o))) {
                    return Fe(Pn, u, {
                        operator: s.operator,
                        left: s.left,
                        right: Fe(Fn, u, {
                            condition: c,
                            consequent: E(a),
                            alternative: E(o)
                        })
                    });
                }
            }
            var l = o.tail_node();
            if (s.equals(l)) return Pe(u, a.equals(o) ? [ c, a ] : [ Fe(Fn, u, {
                condition: c,
                consequent: S(a),
                alternative: S(o)
            }), l ]).optimize(n);
            var p = x(a, o, true);
            if (p) return p;
            var d;
            if (a instanceof Tn && o.TYPE == a.TYPE && (d = b(a, o)) >= 0 && a.expression.equals(o.expression) && !c.has_side_effects(n) && !a.expression.has_side_effects(n)) {
                var t = a.clone();
                var h = a.args[d];
                t.args[d] = h instanceof $n ? Fe($n, u, {
                    expression: Fe(Fn, u, {
                        condition: c,
                        consequent: h.expression,
                        alternative: o.args[d].expression
                    })
                }) : Fe(Fn, u, {
                    condition: c,
                    consequent: h,
                    alternative: o.args[d]
                });
                return t;
            }
            if (s instanceof Fn && s.alternative.equals(o)) {
                return Fe(Fn, u, {
                    condition: Fe(Mn, u, {
                        left: c,
                        operator: "&&",
                        right: y(a, s, "condition")
                    }),
                    consequent: s.consequent,
                    alternative: R(s.alternative, o)
                });
            }
            if (s instanceof Fn && s.consequent.equals(o)) {
                return Fe(Fn, u, {
                    condition: Fe(Mn, u, {
                        left: i,
                        operator: "||",
                        right: y(a, s, "condition")
                    }),
                    consequent: R(s.consequent, o),
                    alternative: s.alternative
                });
            }
            if (l instanceof Fn && a.equals(l.consequent)) {
                return Fe(Fn, u, {
                    condition: Fe(Mn, u, {
                        left: c,
                        operator: "||",
                        right: y(o, l, "condition")
                    }),
                    consequent: R(a, l.consequent),
                    alternative: l.alternative
                });
            }
            if (l instanceof Fn && a.equals(l.alternative)) {
                return Fe(Fn, u, {
                    condition: Fe(Mn, u, {
                        left: i,
                        operator: "&&",
                        right: y(o, l, "condition")
                    }),
                    consequent: l.consequent,
                    alternative: R(a, l.alternative)
                });
            }
            if (s instanceof Mn && s.operator == "&&" && s.right.equals(o)) {
                return Fe(Mn, u, {
                    operator: "&&",
                    left: Fe(Mn, u, {
                        operator: "||",
                        left: i,
                        right: y(a, s, "left")
                    }),
                    right: R(s.right, o)
                }).optimize(n);
            }
            if (s instanceof Mn && s.operator == "||" && s.right.equals(o)) {
                return Fe(Mn, u, {
                    operator: "||",
                    left: Fe(Mn, u, {
                        operator: "&&",
                        left: c,
                        right: y(a, s, "left")
                    }),
                    right: R(s.right, o)
                }).optimize(n);
            }
            if (l instanceof Mn && l.operator == "&&" && l.right.equals(a)) {
                return Fe(Mn, u, {
                    operator: "&&",
                    left: Fe(Mn, u, {
                        operator: "||",
                        left: c,
                        right: y(o, l, "left")
                    }),
                    right: R(a, l.right)
                }).optimize(n);
            }
            if (l instanceof Mn && l.operator == "||" && l.right.equals(a)) {
                return Fe(Mn, u, {
                    operator: "||",
                    left: Fe(Mn, u, {
                        operator: "&&",
                        left: i,
                        right: y(o, l, "left")
                    }),
                    right: R(a, l.right)
                }).optimize(n);
            }
            var v = n.option("booleans") && n.in_boolean_context();
            if (_(a)) {
                if (g(o)) return m(c);
                return Fe(Mn, u, {
                    operator: "||",
                    left: m(c),
                    right: o
                });
            }
            if (g(a)) {
                if (_(o)) return m(c.negate(n));
                return Fe(Mn, u, {
                    operator: "&&",
                    left: m(c.negate(n)),
                    right: o
                });
            }
            if (_(o)) return Fe(Mn, u, {
                operator: "||",
                left: m(c.negate(n)),
                right: a
            });
            if (g(o)) return Fe(Mn, u, {
                operator: "&&",
                left: m(c),
                right: a
            });
            if (n.option("typeofs")) U(c, a, o);
            return u;
            function m(e) {
                if (e.is_boolean(n)) return e;
                return Fe(Cn, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function _(e) {
                return e instanceof Zr || v && e instanceof Rn && e.value || e instanceof Cn && e.operator == "!" && e.expression instanceof Rn && !e.expression.value;
            }
            function g(e) {
                return e instanceof Qr || v && (e instanceof Rn && !e.value || e instanceof Cn && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof Cn && e.operator == "!" && e.expression instanceof Rn && e.expression.value;
            }
            function b(e, n) {
                var t = e.args;
                var r = n.args;
                var i = t.length;
                if (i != r.length) return -2;
                for (var a = 0; a < i; a++) {
                    if (!t[a].equals(r[a])) {
                        if (t[a] instanceof $n !== r[a] instanceof $n) return -3;
                        for (var o = a + 1; o < i; o++) {
                            if (!t[o].equals(r[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function y(e, n, t) {
                if (e === n) return n[t];
                var r = e.expressions.slice(0, -1);
                r.push(n[t]);
                return Pe(e, r);
            }
            function w(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e.optional != n.optional) return;
                if (e instanceof Tn) {
                    if (b(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Dn || n.expression instanceof Dn) || w(e.expression, n.expression);
                }
                if (!(e instanceof Dn)) return;
                var t = e.property;
                var r = n.property;
                return (t instanceof mn ? t.equals(r) : t == r) && !(e.expression instanceof Hr || n.expression instanceof Hr);
            }
            function x(e, n, t) {
                var r = e.tail_node();
                var i = n.tail_node();
                if (!w(r, i)) return !t && Fe(Fn, u, {
                    condition: c,
                    consequent: e,
                    alternative: n
                });
                var a = r.clone();
                var o = y(e, r, "expression");
                var s = y(n, i, "expression");
                var f = x(o, s);
                if (r.expression instanceof An) {
                    f = je(r, r.expression, f);
                }
                a.expression = f;
                return a;
            }
            function k(e) {
                return e === e.tail_node() || hn(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function E(e) {
                if (!(e instanceof An)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return Pe(e, n);
            }
            function S(e) {
                if (!(e instanceof An)) return Fe(Ln, e, {
                    value: 0
                });
                return Pe(e, e.expressions.slice(0, -1));
            }
        });
        e(Kr, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return Fe(Ln, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof Mn && (t.operator == "==" || t.operator == "!=")) {
                mn.warn("Non-strict equality against boolean: {operator} {value} [{start}]", {
                    operator: t.operator,
                    value: e.value,
                    start: t.start
                });
                return Fe(Ln, e, {
                    value: +e.value
                });
            }
            return Fe(Cn, e, {
                operator: "!",
                expression: Fe(Ln, e, {
                    value: 1 - e.value
                })
            });
        });
        e($n, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof jn && !(n.parent() instanceof In)) {
                return Kn.splice(t.elements.map(function(e) {
                    return e instanceof Jr ? Fe(Gr, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function an(e, n) {
            if (!e) return false;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            if (e instanceof Yn) {
                e = e.fixed_value();
                if (!e) return false;
            }
            return e instanceof wn && !e.contains_this();
        }
        e(On, function(e, t) {
            var n = e.expression;
            var r = e.property;
            var i = xe(e, t);
            if (i) return i;
            if (t.option("properties")) {
                var a = r.evaluate(t);
                if (a !== r) {
                    if (typeof a == "string") {
                        if (a == "undefined") {
                            a = undefined;
                        } else {
                            var o = parseFloat(a);
                            if (o.toString() == a) {
                                a = o;
                            }
                        }
                    }
                    r = e.property = le(r, fe(a, r).transform(t));
                    var s = "" + a;
                    if (ni(s) && s.length <= r.print_to_string().length + 1) {
                        return Fe(qn, e, {
                            optional: e.optional,
                            expression: n,
                            property: s,
                            quoted: true
                        }).optimize(t);
                    }
                }
            }
            var f = t.parent();
            var u = ui(t.self(), f);
            var c, l, p, d;
            if (t.option("arguments") && n instanceof Yn && ze(c = n.definition()) && !n.in_arg && r instanceof Ln && Math.floor(d = r.value) == d && (l = c.scope) === S() && l.uses_arguments < (u ? 2 : 3)) {
                if (f instanceof Cn && f.operator == "delete") {
                    if (!c.deleted) c.deleted = [];
                    c.deleted[d] = true;
                }
                var h = l.argnames[d];
                if (c.deleted && c.deleted[d]) {
                    h = null;
                } else if (h) {
                    var v;
                    if (!(h instanceof Hn) || h.name == "await" || n.scope.find_variable(h.name) !== (v = h.definition())) {
                        h = null;
                    } else if (t.has_directive("use strict") || l.name || l.rest || !(p instanceof Tn && d < p.args.length && hn(p.args.slice(0, d + 1), function(e) {
                        return !(e instanceof $n);
                    })) || !hn(l.argnames, function(e) {
                        return e instanceof Hn;
                    })) {
                        if (T() || v.assignments || v.orig.length > 1) h = null;
                    }
                } else if ((u || !T()) && d < l.argnames.length + 5 && t.drop_fargs(l, p) && !l.rest) {
                    while (d >= l.argnames.length) {
                        h = l.make_var(Hn, l, "argument_" + l.argnames.length);
                        l.argnames.push(h);
                    }
                }
                if (h && Wn(function(e) {
                    return e.name === h.name;
                }, l.argnames) === h) {
                    if (u) c.reassigned--;
                    var m = Fe(Yn, h);
                    m.reference();
                    h.unused = undefined;
                    return m;
                }
            }
            if (u) return e;
            if (t.option("sequences") && f.TYPE != "Call" && !(f instanceof mt && f.init === e)) {
                var _ = he(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (a !== r) {
                var g = e.flatten_object(s, t);
                if (g) {
                    n = e.expression = g.expression;
                    r = e.property = g.property;
                }
            }
            var b;
            if (t.option("properties") && t.option("side_effects") && r instanceof Ln && n instanceof jn && hn(b = n.elements, function(e) {
                return !(e instanceof $n);
            })) {
                var d = r.value;
                var y = b[d];
                if (an(y, t)) {
                    var w = y instanceof Jr;
                    var x = !w;
                    var k = [];
                    for (var E = b.length; --E > d; ) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                            if (x && o.has_side_effects(t)) x = false;
                        }
                    }
                    if (!x) k.unshift(y);
                    while (--E >= 0) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                        } else if (w) {
                            k.unshift(Fe(Jr, b[E]));
                        } else {
                            d--;
                        }
                    }
                    if (x) {
                        k.push(y);
                        return Pe(e, k).optimize(t);
                    }
                    return Fe(On, e, {
                        expression: Fe(jn, n, {
                            elements: k
                        }),
                        property: Fe(Ln, r, {
                            value: d
                        })
                    });
                }
            }
            return de(t, e);
            function S() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof wn) {
                        if (n instanceof xt) return;
                        if (Et(n)) continue;
                        p = t.parent(e);
                        return n;
                    }
                }
            }
            function T() {
                return !t.option("reduce_vars") || c.reassigned;
            }
        });
        kt.DEFMETHOD("contains_super", function() {
            var n = false;
            var t = this;
            t.walk(new Un(function(e) {
                if (n) return true;
                if (e instanceof Hr) return n = true;
                if (e !== t && e instanceof yn && !Et(e)) return true;
            }));
            return n;
        });
        (function(e) {
            e(Dt, ln);
            e(qt, ln);
            e(mn, function() {
                var n = false;
                var t = this;
                t.walk(new Un(function(e) {
                    if (n) return true;
                    if (e instanceof Yr) return n = true;
                    if (e !== t && e instanceof yn && !Et(e)) return true;
                }));
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("contains_this", n);
        });
        function on(e) {
            return e instanceof Er && typeof e.key == "string" && !(e instanceof Sr && e.value.contains_super());
        }
        Dn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            if (e === "__proto__") return;
            var t = this;
            var r = t.expression;
            if (!(r instanceof In)) return;
            var i = r.properties;
            for (var a = i.length; --a >= 0; ) {
                var o = i[a];
                if (o.key !== e) continue;
                if (!hn(i, on)) return;
                if (!an(o.value, n)) return;
                var s, f, u = [];
                for (var c = 0; c < i.length; c++) {
                    var l = i[c].value;
                    if (i[c] instanceof Sr) {
                        var p = !(l.uses_arguments || Tt(l) || l.contains_this());
                        if (p) {
                            if (!f) f = n.find_parent(yn);
                            var d = ve(n, f);
                            l.each_argname(function(e) {
                                if (d[e.name]) p = false;
                            });
                        }
                        var h;
                        if (p) {
                            h = St(l) ? qt : Dt;
                        } else if (a != c || (s = n.parent()) instanceof Tn && s.expression === t) {
                            h = l.CTOR;
                        } else {
                            return;
                        }
                        l = Fe(h, l);
                    }
                    u.push(l);
                }
                return Fe(On, t, {
                    expression: Fe(jn, r, {
                        elements: u
                    }),
                    property: Fe(Ln, t, {
                        value: a
                    })
                });
            }
        });
        e(qn, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                mn.warn("Function.prototype.{property} not supported [{start}]", e);
            }
            var t = n.parent();
            if (ui(n.self(), t)) return e;
            var r = xe(e, n);
            if (r) return r;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof mt && t.init === e)) {
                var i = he(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof qn && e.expression.property == "prototype") {
                var a = e.expression.expression;
                if (Ne(a)) switch (a.name) {
                  case "Array":
                    e.expression = Fe(jn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = Fe(zt, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(a.scope);
                    break;

                  case "Number":
                    e.expression = Fe(Ln, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = Fe(In, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = Fe(Ur, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = Fe(Bn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return de(n, e);
        });
        e(yr, function(e, n) {
            if (n.option("rests") && e.rest instanceof yr) {
                return Fe(yr, e, {
                    elements: e.elements.concat(e.rest.elements),
                    rest: e.rest.rest
                });
            }
            return e;
        });
        e(wr, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof mn) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(In, function(r, i) {
            if (!i.option("objects")) return r;
            var a = false;
            var t = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = [];
            var u = new vn();
            var c = [];
            r.properties.forEach(function(e) {
                if (!(e instanceof $n)) return p(e);
                t = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof In && hn(n.properties, function(e) {
                    if (e instanceof Ar) return false;
                    if (e instanceof $n) return false;
                    if (e.key !== "__proto__") return true;
                    if (e instanceof Tr) return true;
                    return !e.value.has_side_effects(i);
                })) {
                    a = true;
                    n.properties.forEach(function(e) {
                        var n = e.key;
                        var t = e instanceof Tr;
                        if (n === "__proto__") {
                            if (!t) return;
                            n = fe(n, e);
                        }
                        p(t ? Fe(Er, e, {
                            key: n,
                            value: Fe(Gr, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    l();
                    c.push(e);
                }
            });
            l();
            if (!a) return r;
            if (t && o && c.length == 1) {
                var e = c[0];
                if (e instanceof kr && e.key instanceof Ln) {
                    e.key = "" + e.key.value;
                }
            }
            return Fe(In, r, {
                properties: c
            });
            function l() {
                f.forEach(function(e) {
                    var n = u.get(e);
                    switch (n.length) {
                      case 0:
                        return;

                      case 1:
                        return c.push(n[0]);
                    }
                    a = true;
                    var t = s && !o && n.pop();
                    c.push(n.length == 1 ? n[0] : Fe(Er, r, {
                        key: n[0].key,
                        value: Pe(r, n.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (t) c.push(t);
                    n.length = 0;
                });
                f = [];
                u = new vn();
            }
            function p(e) {
                var n = e.key;
                if (n instanceof mn) {
                    t = true;
                    n = n.evaluate(i);
                    if (n === e.key || n === "__proto__") {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (on(e)) {
                    if (e.value.has_side_effects(i)) l();
                    f.push(n);
                    u.add(n, e);
                } else {
                    l();
                    c.push(e);
                }
                if (t && !o && typeof n == "string" && P.test(n)) {
                    o = true;
                    if (u.has(n)) e = u.get(n)[0];
                    e.key = Fe(Ln, e, {
                        value: +n
                    });
                }
            }
        });
        function sn(e) {
            var n = e.definition().redefined();
            if (n) {
                e = e.clone();
                e.thedef = n;
            }
            return e;
        }
        function fn(n, e) {
            var t = false;
            e.walk(new Un(function(e) {
                if (t) return true;
                if (e instanceof Yn && n.variables.get(e.name) === e.definition()) {
                    return t = true;
                }
            }));
            return t;
        }
        function un(e, t) {
            var r = [];
            e.references.forEach(function(e) {
                var n = e.fixed;
                if (!n || !Qn(r, n)) return;
                if (n.assigns) {
                    n.assigns.unshift(t);
                } else {
                    n.assigns = [ t ];
                }
            });
        }
        function cn(e, n) {
            var t = Fe(Yn, n);
            var r = Fe(Pn, n, {
                operator: "=",
                left: t,
                right: Fe(Gr, n).transform(e)
            });
            var i = n.definition();
            if (i.fixed) {
                t.fixed = function() {
                    return r.right;
                };
                t.fixed.assigns = [ r ];
                un(i, r);
            }
            i.assignments++;
            i.references.push(t);
            return r;
        }
        (function(e) {
            e(mn, Gn);
            e(Pn, Gn);
            e(gr, function(t, e, n, r) {
                if (!t.option("awaits")) return;
                var i = this;
                var a = i.expression.try_inline(t, e, n, r, true);
                if (!a) return;
                if (!n) y(a, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (n instanceof gr) return;
                    e.value = Fe(gr, i, {
                        expression: n || Fe(Gr, e).transform(t)
                    });
                });
                return L(a) ? a : Fe(bn, i, {
                    body: [ a, Fe(gn, i, {
                        body: Fe(gr, i, {
                            expression: Fe(Ln, i, {
                                value: 0
                            })
                        })
                    }) ]
                });
            });
            e(Mn, function(n, e, t, r, i) {
                if (t === undefined) return;
                var a = this;
                var o = a.operator;
                if (!He[o]) return;
                var s = a.right.try_inline(n, e, t, r, i);
                if (!s) return;
                return Fe(kn, a, {
                    condition: f(a.left),
                    body: s,
                    alternative: t ? null : Fe(xn, a, {
                        value: Fe(Gr, a).transform(n)
                    })
                });
                function f(e) {
                    switch (o) {
                      case "&&":
                        return e;

                      case "||":
                        return e.negate(n);

                      case "??":
                        return Fe(Mn, a, {
                            operator: "==",
                            left: Fe(Vr, a),
                            right: e
                        });
                    }
                }
            });
            e(bn, function(e, n, t, r) {
                if (t) return;
                if (!this.variables) return;
                var i = this.body;
                var a = i.length - 1;
                if (a < 0) return;
                var o = i[a].try_inline(e, this, t, r);
                if (!o) return;
                i[a] = o;
                return this;
            });
            e(Tn, function(r, i, e, a, n) {
                if (r.option("inline") < 4) return;
                var o = this;
                if (o.is_expr_pure(r)) return;
                var s = o.expression;
                if (!(s instanceof kt)) return;
                if (s.name) return;
                if (s.uses_arguments) return;
                if (s.pinned()) return;
                if (Tt(s)) return;
                var f = Et(s);
                if (f && s.value) return;
                if (s.body[0] instanceof at) return;
                if (s.contains_this()) return;
                if (!i) i = Me(r);
                var t = new vn();
                t.set("NaN", true);
                while (!(i instanceof yn)) {
                    i.variables.each(function(e) {
                        t.set(e.name, true);
                    });
                    i = i.parent_scope;
                }
                if (!Vn(i, r.stack)) return;
                if (i.pinned() && s.variables.size() > (f ? 0 : 1)) return;
                if (i instanceof yt) {
                    if (s.variables.size() > (f ? 0 : 1)) {
                        if (!r.toplevel.vars) return;
                        if (s.functions.size() > 0 && !r.toplevel.funcs) return;
                    }
                    t.set("arguments", true);
                }
                var u = !n && St(s);
                if (u) {
                    if (!r.option("awaits")) return;
                    if (!St(i)) return;
                    if (o.may_throw(r)) return;
                }
                var c = i.var_names();
                if (a) a = [];
                if (!s.variables.all(function(e, n) {
                    if (a) a.push(e);
                    if (!t.has(n) && !c.has(n)) return true;
                    return !f && n == "arguments" && e.orig.length == 1;
                })) return;
                if (a && a.length > 0 && nn(s, a)) return;
                var l = true;
                if (!hn(s.argnames, function(e) {
                    var n = false;
                    var t = new Un(function(e) {
                        if (n) return true;
                        if (e instanceof Sn) {
                            if (fn(s, e.value)) return n = true;
                            e.name.walk(t);
                            return true;
                        }
                        if (e instanceof wr) {
                            if (e.key instanceof mn && fn(s, e.key)) return n = true;
                            e.value.walk(t);
                            return true;
                        }
                        if (e instanceof Hn && !hn(e.definition().orig, function(e) {
                            return !(e instanceof Mr);
                        })) return n = true;
                    });
                    e.walk(t);
                    if (n) return false;
                    if (!(e instanceof Hn)) l = false;
                    return true;
                })) return;
                if (s.rest) {
                    if (fn(s, s.rest)) return;
                    l = false;
                }
                var p;
                if (e) {
                    p = function(e) {
                        var n = false;
                        e.walk(new Un(function(e) {
                            if (n) return true;
                            if (u && e instanceof gr || e instanceof xn) return n = true;
                            if (e instanceof yn) return true;
                        }));
                        return !n;
                    };
                } else if (n || St(s) || Y(i)) {
                    p = function(e) {
                        var n = false;
                        var t = new Un(function(e) {
                            if (n) return true;
                            if (e instanceof xn) return n = true;
                            if (e instanceof yn) return true;
                        });
                        e.walk(new Un(function(e) {
                            if (n) return true;
                            if (e instanceof ir) {
                                if (e.bfinally && hn(e.body, function(e) {
                                    e.walk(t);
                                    return !n;
                                }) && e.bcatch) e.bcatch.walk(t);
                                return true;
                            }
                            if (e instanceof yn) return true;
                        }));
                        return !n;
                    };
                }
                if (p && !hn(s.body, p)) return;
                if (!Ee(s, ve(r, i))) return;
                s.functions.each(function(e, n) {
                    i.functions.set(n, e);
                });
                var d = [];
                s.variables.each(function(n, e) {
                    if (!f && e == "arguments" && n.orig.length == 1) return;
                    c.set(e, true);
                    i.enclosed.push(n);
                    i.variables.set(e, n);
                    n.single_use = false;
                    if (!a) return;
                    if (n.references.length == n.replaced) return;
                    if (n.orig.length == n.eliminated) return;
                    if (n.orig.length == 1 && s.functions.has(e)) return;
                    if (!hn(n.orig, function(e) {
                        if (e instanceof Or) return false;
                        if (e instanceof Hn) return !e.unused && n.scope.resolve() !== s;
                        if (e instanceof zr) return false;
                        return true;
                    })) return;
                    var t = n.orig[0];
                    if (t instanceof jr) return;
                    d.push(Fe(gn, t, {
                        body: cn(r, sn(t))
                    }));
                });
                var h = Object.create(null), v = new vn();
                if (l && hn(o.args, function(e) {
                    return !(e instanceof $n);
                })) {
                    var m = o.args.slice();
                    s.argnames.forEach(function(e) {
                        var n = m.shift();
                        if (e.unused) {
                            if (n) d.push(Fe(gn, o, {
                                body: n
                            }));
                            return;
                        }
                        var t = Fe(En, o, {
                            name: e.convert_symbol(Cr, g),
                            value: n || Fe(Gr, o).transform(r)
                        });
                        if (e instanceof Hn) un(e.definition(), t);
                        d.push(Fe(cr, o, {
                            definitions: [ t ]
                        }));
                    });
                    if (m.length) d.push(Fe(gn, o, {
                        body: Pe(o, m)
                    }));
                } else {
                    d.push(Fe(cr, o, {
                        definitions: [ Fe(En, o, {
                            name: Fe(yr, o, {
                                elements: s.argnames.map(function(e) {
                                    if (e.unused) return Fe(Jr, e);
                                    return e.convert_symbol(Cr, g);
                                }),
                                rest: s.rest && s.rest.convert_symbol(Cr, g)
                            }),
                            value: Fe(jn, o, {
                                elements: o.args.slice()
                            })
                        }) ]
                    }));
                }
                v.each(function(e, n) {
                    var t = h[n];
                    [].unshift.apply(t.orig, e);
                    t.eliminated += e.length;
                });
                [].push.apply(d, a ? s.body.filter(function(e) {
                    if (!(e instanceof Mt)) return true;
                    var n = Fe(Cr, sn(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    d.push(Fe(cr, e, {
                        definitions: [ Fe(En, e, {
                            name: n,
                            value: ye(e, true)
                        }) ]
                    }));
                    return false;
                }) : s.body);
                var _ = Fe(bn, o, {
                    body: d
                });
                if (!e) {
                    if (u) y(_, function(e) {
                        var n = e.value;
                        if (Ie(n)) return;
                        e.value = Fe(gr, o, {
                            expression: n
                        });
                    });
                    d.push(Fe(xn, o, {
                        value: Y(i) ? Fe(Gr, o).transform(r) : null
                    }));
                }
                return _;
                function g(e, n) {
                    var t = n.definition();
                    h[t.id] = t;
                    v.add(t.id, e);
                }
            });
            e(Fn, function(e, n, t, r, i) {
                var a = this;
                var o = a.consequent.try_inline(e, n, t, r, i);
                var s = a.alternative.try_inline(e, n, t, r, i);
                if (!o && !s) return;
                return Fe(kn, a, {
                    condition: a.condition,
                    body: o || f(a.consequent),
                    alternative: s || f(a.alternative)
                });
                function f(e) {
                    if (t) return Fe(gn, e, {
                        body: e
                    });
                    return Fe(xn, e, {
                        value: e
                    });
                }
            });
            e(vt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.init;
                if (a) {
                    a = a.try_inline(e, n, true, r);
                    if (a) {
                        this.init = null;
                        if (a instanceof bn) {
                            a.body.push(this);
                            return a;
                        }
                        return Fe(bn, a, {
                            body: [ a, this ]
                        });
                    }
                }
                return i && this;
            });
            e(mt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.object;
                if (a instanceof An) {
                    var o = f(e, n, true, r, false, a, 1);
                    if (o) {
                        this.object = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(kn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.alternative;
                if (a) {
                    a = a.try_inline(e, n, t, r);
                    if (a) this.alternative = a;
                }
                var o = this.condition;
                if (o instanceof An) {
                    var s = f(e, n, true, r, false, o, 1);
                    if (s) {
                        this.condition = o.tail_node();
                        s.body.push(this);
                        return s;
                    }
                }
                return (i || a) && this;
            });
            e(lt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (!i) return;
                this.body = i;
                return this;
            });
            e(ct, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (!i) return;
                if (this.body instanceof lt && i instanceof bn) {
                    var a = i.body.pop();
                    this.body = a;
                    i.body.push(this);
                    return i;
                }
                this.body = i;
                return this;
            });
            e(vr, Gn);
            e(xn, function(e, n, t, r) {
                var i = this.value;
                return i && i.try_inline(e, n, undefined, r === "try");
            });
            function f(e, n, t, r, i, a, o) {
                var s = [], f = a.expressions, u = t;
                for (var c = f.length - (o || 0), l = c; --c >= 0; u = true, i = false) {
                    var p = f[c].try_inline(e, n, u, r, i);
                    if (!p) continue;
                    d();
                    s.push(p);
                }
                if (s.length == 0) return;
                d();
                if (!t && s[0] instanceof gn) {
                    s[0] = Fe(xn, a, {
                        value: s[0].body
                    });
                }
                return Fe(bn, a, {
                    body: s.reverse()
                });
                function d() {
                    if (l > c + 1) s.push(Fe(gn, a, {
                        body: Pe(a, f.slice(c + 1, l))
                    }));
                    l = c;
                }
            }
            e(An, function(e, n, t, r, i) {
                return f(e, n, t, r, i, this);
            });
            e(gn, function(e, n, t, r) {
                var i = this.body;
                while (i instanceof Cn) {
                    var a = i.operator;
                    if (fi[a]) break;
                    if (a == "void") break;
                    i = i.expression;
                }
                if (!t && !Ie(i)) i = Fe(Cn, this, {
                    operator: "void",
                    expression: i
                });
                return i.try_inline(e, n, t || false, r);
            });
            e(Cn, function(t, e, n, r, i) {
                var a = this;
                var o = a.operator;
                if (fi[o]) return;
                if (!n && o == "void") n = false;
                var s = a.expression.try_inline(t, e, n, r, i);
                if (!s) return;
                if (!n) y(s, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (o == "void" && Ie(n)) return;
                    e.value = Fe(Cn, a, {
                        operator: o,
                        expression: n || Fe(Gr, e).transform(t)
                    });
                });
                return s;
            });
            e(bt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.expression;
                if (a instanceof An) {
                    var o = f(e, n, true, r, false, a, 1);
                    if (o) {
                        this.expression = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(br, function(e, n, t, r) {
                if (!e.option("yields")) return;
                if (!this.nested) return;
                var i = this.expression;
                if (i.TYPE != "Call") return;
                var a = i.expression;
                switch (a.CTOR) {
                  case $t:
                    a = Fe(Ot, a);
                    break;

                  case Ct:
                    a = Fe(zt, a);
                    break;

                  default:
                    return;
                }
                i = i.clone();
                i.expression = a;
                return i.try_inline(e, n, t, r);
            });
        })(function(e, n) {
            e.DEFMETHOD("try_inline", n);
        });
        e(xn, function(e, n) {
            var t = e.value;
            if (t && n.option("side_effects") && Ie(t, n) && !Y(n.find_parent(yn))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, r) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = r(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function oe(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function li(f) {
        f = we(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            extendscript: false,
            galio: false,
            ie: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = ln;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = oe;
            } else {
                u = pn;
            }
        }
        function t(e) {
            if (typeof e == "number") return new Array(e + 1).join(" ");
            if (!e) return "";
            if (!/^\s*$/.test(e)) throw new Error("unsupported indentation: " + JSON.stringify("" + e));
            return e;
        }
        var c = 0;
        var l = 1;
        var r = t(f.indent_start);
        var i = t(f.indent_level);
        var P = i.length + 1 >> 1;
        var o;
        var s = 0;
        var p = true;
        var d = f.source_map && [];
        var h;
        var v;
        var m;
        var _;
        var g = false;
        var b = false;
        var y;
        var a;
        var w = "";
        function x() {
            o = "";
            m = false;
            _ = false;
            a = [];
            var e = y;
            y = "";
            return e;
        }
        x();
        var k = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, r = 0; t < e.length; t++) {
                var i = e.charCodeAt(t);
                if (re(i)) {
                    if (ie(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ie(i)) {
                    continue;
                }
                n += e.slice(r, t) + "\\u" + i.toString(16);
                r = t + 1;
            }
            return r == 0 ? e : n + e.slice(r);
        };
        function E(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function S(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var j = [ null, E, S, function(e, n) {
            return n == "'" ? E(e) : S(e);
        } ][f.quote_style] || function(e, n, t, r) {
            return t > r ? E(e) : S(e);
        };
        function T(t, e) {
            var r = 0, i = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++r;
                    return '"';

                  case "'":
                    ++i;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return j(k(t), e, r, i);
        }
        var N = d ? function(n, t) {
            d.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Gn;
        var A = d ? function() {
            d.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            d = [];
        } : Gn;
        function D(e) {
            w += y.slice(0, s);
            y = y.slice(s);
            var n = y.length;
            N(e, n - c);
            l += e;
            c = n;
            while (e--) w += "\n";
        }
        var q = f.max_line_len ? function(e) {
            if (p) {
                if (c > f.max_line_len) {
                    mn.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (c > f.max_line_len) {
                D(1);
                p = true;
            }
            if (p || e) A();
        } : Gn;
        var I = dn("( [ + * / - , .");
        function O(e, n, t) {
            return ae(e) && (ae(n) || n == "\\") || n == "/" && n == e || (n == "+" || n == "-") && n == o || o == "--" && n == ">" || o == "!" && t == "--" || e == "/" && (t == "in" || t == "instanceof");
        }
        var $ = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (g && n) {
                g = false;
                if (n != "\n") {
                    $("\n");
                    C();
                }
            }
            if (b && n) {
                b = false;
                if (!/[\s;})]/.test(n)) {
                    z();
                }
            }
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || t != ";" && (!n || ";}".indexOf(n) < 0)) {
                    var r = I[n];
                    if (r || f.semicolons) {
                        y += ";";
                        c++;
                        if (!p) {
                            q();
                            if (p && !r && y == ";") {
                                y = "";
                                c = 0;
                            }
                        }
                        if (s == y.length - 1) s++;
                    } else {
                        q();
                        y += "\n";
                        l++;
                        c = 0;
                        if (/^\s+$/.test(e)) _ = true;
                    }
                    if (!f.beautify) m = false;
                }
            }
            if (m) {
                if (O(t, n, e)) {
                    y += " ";
                    c++;
                }
                if (t != "<" || e != "!") m = false;
            }
            if (v) {
                d.push({
                    token: v,
                    name: h,
                    line: l,
                    col: c
                });
                v = false;
                if (p) A();
            }
            y += e;
            var i = e.split(/\r?\n/), a = i.length - 1;
            l += a;
            c += i[0].length;
            if (a > 0) {
                q();
                c = i[a].length;
            }
            o = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    y += ";";
                    m = false;
                }
            }
            if (m) {
                if (O(t, n, e)) y += " ";
                if (t != "<" || e != "!") m = false;
            }
            y += e;
            o = e;
        };
        var z = f.beautify ? function() {
            $(" ");
        } : function() {
            m = true;
        };
        var C = f.beautify ? function(e) {
            if (g) $("\n");
            $(e ? r.slice(0, -P) : r);
        } : Gn;
        var H = f.beautify ? function(e) {
            var n = r;
            r += i;
            e();
            r = n;
        } : function(e) {
            e();
        };
        var M = f.max_line_len || f.preserve_line ? function() {
            q();
            s = y.length;
            p = false;
        } : Gn;
        var Y = f.beautify ? function() {
            $("\n");
            s = y.length;
        } : M;
        var R = f.beautify ? function() {
            $(";");
        } : function() {
            _ = true;
        };
        function B() {
            if (_) $(";");
            $(";");
        }
        function L(e, n) {
            $("{");
            Y();
            H(e);
            J(n);
            C();
            $("}");
        }
        function U(e) {
            $("(");
            M();
            e();
            M();
            $(")");
        }
        function V(e) {
            $("[");
            M();
            e();
            M();
            $("]");
        }
        function W() {
            M();
            $(",");
            M();
            z();
        }
        function G() {
            $(":");
            z();
        }
        var J = d ? function(e, n) {
            v = e;
            h = n;
        } : Gn;
        function X() {
            if (!p) q(true);
            return w + y;
        }
        function K() {
            return /(^|\n) *$/.test(y);
        }
        function F(e, n) {
            if (g) return;
            if (e.nlb && (n || !K())) {
                g = true;
            } else if (n) {
                b = true;
            }
        }
        function Q(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                $("//" + n);
                g = true;
            } else if (e.type == "comment2") {
                $("/*" + n + "*/");
            }
            return true;
        }
        function Z(e, n) {
            if (n instanceof Mn) return n.left === e;
            if (n.TYPE == "Call") return n.expression === e;
            if (n instanceof Fn) return n.condition === e;
            if (n instanceof qn) return n.expression === e;
            if (n instanceof Jt) return true;
            if (n instanceof An) return n.expressions[0] === e;
            if (n instanceof On) return n.expression === e;
            if (n instanceof _r) return true;
            if (n instanceof br) return true;
        }
        function ee(e) {
            var r = this;
            var i;
            if (e instanceof Jt) {
                i = e.value;
            } else if (e instanceof br) {
                i = e.expression;
            }
            var t = s(e);
            if (!t) t = [];
            if (i) {
                var a = new Un(function(e) {
                    if (!Z(e, a.parent())) return true;
                    var n = s(e);
                    if (n) t = t.concat(n);
                });
                a.push(e);
                i.walk(a);
            }
            if (l == 1 && c == 0) {
                if (t.length > 0 && f.shebang && t[0].type == "comment5") {
                    $("#!" + t.shift().value + "\n");
                    C();
                }
                var n = f.preamble;
                if (n) $(n.replace(/\r\n?|\u2028|\u2029|(^|\S)\s*$/g, "$1\n"));
            }
            t = t.filter(u, e);
            var o = false;
            t.forEach(function(e, n) {
                F(e, n);
                if (Q(e)) o = true;
            });
            if (o) F(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!i) return;
                    e.start = n = new te();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!i) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === r) return;
                t._dumped = r;
                return t;
            }
        }
        function ne(e, t) {
            var n = this;
            var r = e.end;
            if (!r) return;
            var i = r[t ? "comments_before" : "comments_after"];
            if (!i || i._dumped === n) return;
            if (!(e instanceof rt || hn(i, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            i._dumped = n;
            i.filter(u, e).forEach(function(e, n) {
                F(e, n || !t);
                Q(e);
            });
        }
        return {
            get: X,
            reset: x,
            indent: C,
            should_break: f.beautify && f.width ? function() {
                return c >= f.width;
            } : ln,
            has_parens: function() {
                return o.slice(-1) == "(";
            },
            newline: Y,
            print: $,
            space: z,
            comma: W,
            colon: G,
            last: function() {
                return o;
            },
            semicolon: R,
            force_semicolon: B,
            to_utf8: k,
            print_name: function(e) {
                $(k(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = T(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                $(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                $(T(e, n));
            },
            with_indent: H,
            with_block: L,
            with_parens: U,
            with_square: V,
            add_mapping: J,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? ee : Gn,
            append_comments: f.comments ? ne : Gn,
            push_node: function(e) {
                a.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = a.pop();
                if (e.start && e.start.line > l) {
                    D(e.start.line - l);
                }
            } : function() {
                a.pop();
            },
            parent: function(e) {
                return a[a.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        mn.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var t = li({
            inline_script: false,
            shebang: false,
            width: false
        });
        mn.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = li(e);
                this.print(n);
                return n.get();
            }
            this.print(t);
            return t.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(mn, ln);
        function r(e) {
            var n = e.parent();
            if (!e.has_parens() && tt(e, false, true)) {
                return this.name || !(n instanceof pr);
            }
            if (e.option("webkit") && n instanceof Dn && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof Tn && n.expression === this) return true;
        }
        n(Ot, r);
        n($t, r);
        n(Yt, r);
        n(zt, r);
        n(Ct, r);
        function i(e) {
            return !e.has_parens() && tt(e, true);
        }
        n(In, i);
        function a(e) {
            var n = e.parent();
            if (n instanceof Mn) return n.operator == "**" && n.left === this;
            if (n instanceof Tn) return n.expression === this;
            if (n instanceof It) return true;
            if (n instanceof Dn) return n.expression === this;
            if (n instanceof Br) return n.tag === this;
        }
        n(gr, a);
        n(zn, a);
        n(An, function(e) {
            var n = e.parent();
            return n instanceof jn || Et(n) && n.value === this || n instanceof gr || n instanceof Mn || n instanceof Tn || n instanceof It || n instanceof Rt || n instanceof Fn || n instanceof Sn || n instanceof wr || n instanceof pr || n instanceof xe || n instanceof kr || n instanceof Dn && n.expression === this || n instanceof $n || n instanceof Br && n.tag === this || n instanceof zn || n instanceof En || n instanceof br;
        });
        n(Mn, function(e) {
            var n = e.parent();
            if (n instanceof gr) return true;
            if (n instanceof Mn) {
                var t = n.operator, r = ai[t];
                var i = this.operator, a = ai[i];
                return r > a || t == "??" && (i == "&&" || i == "||") || r == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof Tn) return n.expression === this;
            if (n instanceof It) return true;
            if (n instanceof Dn) return n.expression === this;
            if (n instanceof Br) return n.tag === this;
            if (n instanceof zn) return true;
        });
        function o(e, n) {
            if (!e.terminal) return false;
            if (!(n instanceof Tn || n instanceof Dn)) return false;
            return n.expression === e;
        }
        n(Dn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof vr && t.expression === n && mr(n).TYPE == "Call") return true;
            return o(n, t);
        });
        n(Tn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof vr) return t.expression === n;
            if (e.option("webkit") && n.expression instanceof zt && t instanceof Dn && t.expression === n) {
                var r = e.parent(1);
                if (r instanceof Pn && r.left === t) return true;
            }
            return o(n, t);
        });
        n(vr, function(e) {
            if (z(this, e)) return false;
            var n = e.parent();
            if (n instanceof Tn) return n.expression === this;
            if (n instanceof Dn) return true;
            if (n instanceof Br) return n.tag === this;
        });
        n(Ln, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof Dn && n.expression === this && /^0/.test(C(this.value));
        });
        function f(e, n) {
            var t = n.parent();
            if (t instanceof gr) return true;
            if (t instanceof Mn) return !(t instanceof Pn);
            if (t instanceof Tn) return t.expression === e;
            if (t instanceof It) return true;
            if (t instanceof Fn) return t.condition === e;
            if (t instanceof Dn) return t.expression === e;
            if (t instanceof Br) return t.tag === e;
            if (t instanceof zn) return true;
        }
        n(Dt, function(e) {
            return f(this, e);
        });
        n(Pn, function(e) {
            if (f(this, e)) return true;
            if (e.option("v8")) return this.left instanceof Nn;
            if (this.left instanceof xr) return i(e);
        });
        n(qt, function(e) {
            return f(this, e);
        });
        n(Fn, function(e) {
            return f(this, e) || e.option("extendscript") && e.parent() instanceof Fn;
        });
        n(br, function(e) {
            return f(this, e);
        });
        e(at, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(it, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function u(e, t, r, n) {
            var i = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof at) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof _n)) {
                        if (e instanceof gn && e.body instanceof Bn) {
                            r.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof _n) return;
                r.indent();
                e.print(r);
                if (n == i && t) return;
                r.newline();
                if (t) r.newline();
            });
            s = o;
        }
        e(yt, function(e) {
            u(this.body, true, e, true);
            e.print("");
        });
        e(ct, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(gn, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function c(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function l(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    u(e.body, false, n, t);
                }, e.end);
            } else c(e, n);
        }
        e(bn, function(e) {
            l(this, e);
        });
        e(_n, function(e) {
            e.semicolon();
        });
        e(dt, function(e) {
            var n = this;
            e.print("do");
            M(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(ht, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            $(n.body, e);
        });
        e(vt, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof sr) {
                        n.init.print(e);
                    } else {
                        E(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            $(n.body, e);
        });
        function p(t, r) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(r);
                    e.space();
                    n.object.print(e);
                });
                $(n.body, e);
            };
        }
        e(gt, p("for await", "of"));
        e(_t, p("for", "in"));
        e(xe, p("for", "of"));
        e(bt, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            $(n.body, e);
        });
        e(lr, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(pr, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof Yt) {
                if (!n.name) return;
            }
            if (n instanceof Ht) return;
            if (n instanceof Mt) return;
            if (n instanceof kt) {
                if (!n.name && !Et(n)) return;
            }
            e.semicolon();
        });
        function d(e, n) {
            var t = e.value;
            if (t == "*" || ni(t)) {
                n.print_name(t);
            } else {
                n.print_string(t, e.quote);
            }
        }
        e(ke, function(r) {
            var i = this;
            r.print("export");
            r.space();
            var n = i.keys.length;
            if (n == 0) {
                c(i, r);
            } else if (i.keys[0].value == "*") {
                t(0);
            } else r.with_block(function() {
                r.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    r.print(",");
                    r.newline();
                    r.indent();
                    t(e);
                }
                r.newline();
            }, i.end);
            r.space();
            r.print("from");
            r.space();
            i.path.print(r);
            r.semicolon();
            function t(e) {
                var n = i.aliases[e];
                var t = i.keys[e];
                d(t, r);
                if (n.value != t.value) {
                    r.space();
                    r.print("as");
                    r.space();
                    d(n, r);
                }
            }
        });
        e(dr, function(e) {
            var n = this;
            e.print("export");
            e.space();
            A(n, e);
            e.semicolon();
        });
        e(hr, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                A(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            n.path.print(e);
            e.semicolon();
        });
        function h(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function v(e, n) {
            var t = e.argnames.length == 1 && !e.rest && e.argnames[0];
            if (t instanceof Hn && t.name != "yield") {
                t.print(n);
            } else {
                h(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                l(e, n, true);
            }
        }
        e(Dt, function(e) {
            v(this, e);
        });
        e(qt, function(e) {
            e.print("async");
            e.space();
            v(this, e);
        });
        function m(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            h(e, n);
            n.space();
            l(e, n, true);
        }
        e(wn, function(e) {
            e.print("function");
            m(this, e);
        });
        function _(e) {
            e.print("async");
            e.space();
            e.print("function");
            m(this, e);
        }
        e(Ft, _);
        e(Ot, _);
        function g(e) {
            e.print("async");
            e.space();
            e.print("function*");
            m(this, e);
        }
        e(Pt, g);
        e($t, g);
        function b(e) {
            e.print("function*");
            m(this, e);
        }
        e(Nt, b);
        e(Ct, b);
        e(It, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            A(n, e, true);
        });
        e(Bt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            D(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(Lt, q("get"));
        e(Ut, q("set"));
        function y(e, n) {
            var t = e.value;
            if (St(t)) {
                n.print("async");
                n.space();
            }
            if (Tt(t)) n.print("*");
            D(e, n);
            m(e.value, n);
        }
        e(Vt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            y(n, e);
        });
        e(Wt, function(e) {
            e.print("static");
            e.space();
            l(this.value, e);
        });
        function w(t, r) {
            return function(e) {
                e.print(t);
                var n = this[r];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(xn, w("return", "value"));
        e(Xt, w("throw", "value"));
        e(Qt, w("break", "label"));
        e(Zt, w("continue", "label"));
        function P(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof fr || t instanceof ur) || n.option("ie") && t instanceof dt) return M(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof kn) {
                    if (!t.alternative) {
                        M(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof N) {
                    t = t.body;
                } else break;
            }
            $(e.body, n);
        }
        e(kn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            if (n.alternative) {
                P(n, e);
                e.space();
                e.print("else");
                if (n.alternative instanceof kn) {
                    e.space();
                    n.alternative.print(e);
                } else {
                    $(n.alternative, e);
                }
            } else {
                $(n.body, e);
            }
        });
        e(er, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var r = e.body.length - 1;
            if (r < 0) c(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < r && e.body.length > 0) t.newline();
                });
            }, e.end);
        });
        function x(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(tr, function(e) {
            e.print("default:");
            x(this, e);
        });
        e(rr, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            x(n, e);
        });
        e(ir, function(e) {
            var n = this;
            e.print("try");
            e.space();
            l(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(ar, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            l(n, e);
        });
        e(or, function(e) {
            e.print("finally");
            e.space();
            l(this, e);
        });
        function k(r) {
            return function(t) {
                var e = this;
                t.print(r);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof lt && n.init === e)) t.semicolon();
            };
        }
        e(fr, k("const"));
        e(ur, k("let"));
        e(cr, k("var"));
        function E(e, n, t) {
            var r = false;
            if (t) e.walk(new Un(function(e) {
                if (r) return true;
                if (e instanceof Mn && e.operator == "in") return r = true;
                if (e instanceof yn && !(Et(e) && e.value)) return true;
            }));
            e.print(n, r);
        }
        e(En, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var r = t instanceof vt || t instanceof mt;
                E(n.value, e, r);
            }
        });
        e(Sn, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function S(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, r = e, i;
            do {
                i = r;
                r = n.parent(t++);
                if (r instanceof Tn && r.expression === i) return;
            } while (r instanceof Dn && r.expression === i);
            n.print("/*@__PURE__*/");
        }
        function T(e, t) {
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                t.add_mapping(e.end);
            });
        }
        e(Tn, function(e) {
            var n = this;
            S(n, e);
            n.expression.print(e);
            if (n.optional) e.print("?.");
            T(n, e);
        });
        e(vr, function(e) {
            var n = this;
            S(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (z(n, e)) T(n, e);
        });
        e(An, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(qn, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var r = n.property;
            if (e.option("ie") && I[r] || n.quoted && e.option("keep_quoted_props")) {
                if (n.optional) e.print("?.");
                e.with_square(function() {
                    e.add_mapping(n.end);
                    e.print_string(r);
                });
            } else {
                if (t instanceof Ln && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(n.optional ? "?." : ".");
                e.add_mapping(n.end);
                e.print_name(r);
            }
        });
        e(On, function(e) {
            var n = this;
            n.expression.print(e);
            if (n.optional) e.print("?.");
            e.with_square(function() {
                n.property.print(e);
            });
        });
        e($n, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e(Cn, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof Cn && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(_r, function(e) {
            var n = this;
            n.expression.print(e);
            e.add_mapping(n.end);
            e.print(n.operator);
        });
        e(Mn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(Fn, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(gr, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(br, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(jn, function(t) {
            var e = this.elements, r = e.length;
            t.with_square(r > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === r - 1 && e instanceof Jr) t.comma();
                });
                t.space();
            } : Gn);
        });
        e(yr, function(t) {
            var e = this.elements, n = e.length, r = this.rest;
            t.with_square(n || r ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (r) {
                    if (n) t.comma();
                    t.print("...");
                    r.print(t);
                } else if (e[n - 1] instanceof Jr) {
                    t.comma();
                }
                t.space();
            } : Gn);
        });
        e(wr, function(e) {
            var n = this;
            var t = D(n, e);
            var r = n.value;
            if (t) {
                if (r instanceof Sn) {
                    if (r.name instanceof Dr && t == O(r.name)) {
                        e.space();
                        e.print("=");
                        e.space();
                        r.value.print(e);
                        return;
                    }
                } else if (r instanceof Dr) {
                    if (t == O(r)) return;
                }
            }
            e.colon();
            r.print(e);
        });
        e(xr, function(t) {
            var e = this;
            var n = e.properties, r = n.length, i = e.rest;
            if (r || i) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (i) {
                    if (r) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    i.print(t);
                }
                t.newline();
            }, e.end); else c(e, t);
        });
        function A(e, t, r) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!r) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }, e.end); else c(e, t);
        }
        e(In, function(e) {
            A(this, e);
        });
        function D(e, n) {
            var t = e.key;
            if (t instanceof mn) return n.with_square(function() {
                t.print(n);
            });
            var r = e.start && e.start.quote;
            if (n.option("quote_keys") || r && n.option("keep_quoted_props")) {
                n.print_string(t, r);
            } else if ("" + +t == t && t >= 0) {
                n.print(C(t));
            } else if (e.private) {
                n.print_name(t);
            } else if (I[t] ? !n.option("ie") : ni(t)) {
                n.print_name(t);
                return t;
            } else {
                n.print_string(t, r);
            }
        }
        e(Er, function(e) {
            var n = this;
            D(n, e);
            e.colon();
            n.value.print(e);
        });
        e(Sr, function(e) {
            y(this, e);
        });
        function q(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                D(n, e);
                m(n.value, e);
            };
        }
        e(Ar, q("get"));
        e(Tr, q("set"));
        function O(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(Dr, function(e) {
            e.print_name(O(this));
        });
        e(Nr, function(e) {
            var n = this;
            var t = O(n);
            e.print_name(t);
            var r = n.alias;
            if (r.value != t) {
                e.space();
                e.print("as");
                e.space();
                d(r, e);
            }
        });
        e($r, function(e) {
            var n = this;
            var t = O(n);
            var r = n.key;
            if (r.value && r.value != t) {
                d(r, e);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(Jr, Gn);
        e(Br, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(Rn, function(e) {
            e.print("" + this.value);
        });
        e(Bn, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(Ln, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(C(this.value));
            }
        });
        e(Ur, function(e) {
            var n = this.value;
            var t = n.toString();
            var r = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(r);
            } else if (r == 1) {
                t = "/(?:)" + t.slice(r);
            } else if (t.indexOf("/", 1) < r) {
                t = "/" + t.slice(1, r).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(r);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
        });
        function $(e, n) {
            if (n.option("braces") && !(e instanceof fr || e instanceof ur)) {
                M(e, n);
            } else if (e instanceof _n) {
                n.force_semicolon();
            } else {
                n.space();
                e.print(n);
            }
        }
        function z(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function j(e) {
            var n = e[0], t = n.length;
            for (var r = 1; r < e.length; ++r) {
                if (e[r].length < t) {
                    n = e[r];
                    t = n.length;
                }
            }
            return n;
        }
        function C(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var r, i, a;
            if (r = /^\.0+/.exec(n)) {
                i = r[0].length;
                a = n.slice(i);
                t.push(a + "e-" + (a.length + i - 1));
            } else if (r = /[^0]0+$/.exec(n)) {
                i = r[0].length - 1;
                t.push(n.slice(0, -i) + "e" + i);
            } else if (r = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(r[1] + r[2] + "e" + (r[3] - r[2].length));
            }
            return j(t);
        }
        function M(e, n) {
            n.space();
            if (e instanceof _n) {
                c(e, n);
            } else if (e instanceof bn) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            }, e.end);
        }
        function F(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        F([ mn, ct ], Gn);
        F([ jn, gr, bn, ar, Rn, it, sr, Nn, at, or, Gt, wn, vr, In, $n, N, Dr, er, nr, ir, Cn, br ], function(e) {
            e.add_mapping(this.start);
        });
        F([ Rt, wr, kr ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var D = n("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var q = D.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function O(e, n) {
        var t = 0;
        var r = 0;
        for (var i = 0, a = 0; i < n.length; i++) {
            var o = q[n[i]];
            t += (o & 31) << r;
            if (o & 32) {
                r += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = r = 0;
            }
        }
        return a;
    }
    function $(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += D[t];
        } while (e);
        return n;
    }
    function z() {
        var t = new vn();
        var r = [];
        r.index = function(e) {
            var n = t.get(e);
            if (!(n >= 0)) {
                n = r.length;
                r.push(e);
                t.set(e, n);
            }
            return n;
        };
        return r;
    }
    function W(l) {
        var f = z();
        var a = l.includeSources && new vn();
        var u = z();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, O(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var r = 0; r < n.sources.length; r++) {
                var i = n.sourcesContent[r];
                if (i) a.set(n.sources[r], i);
            }
        });
        var p;
        var d = 1;
        var h = 0;
        var v = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, r, i, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[r - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (i >= c) f = s[u];
                        if (i <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        r = f[2];
                        i = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, r, i, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!a.has(e)) {
                    a.set(e, n);
                }
            } : Gn,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a.get(e) || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, r, i, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                h = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += $(t - h);
            h = t;
            if (e == null) return;
            var o = f.index(e);
            c += $(o - v);
            v = o;
            c += $(r - m);
            m = r;
            c += $(i - _);
            _ = i;
            if (l.names && a != null) {
                var s = u.index(a);
                c += $(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        var r = {
            Program: function(e) {
                return new yt({
                    start: s(e),
                    end: f(e),
                    body: a(e.body.map(l))
                });
            },
            ArrowFunctionExpression: function(e) {
                var n = [], t = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                var r = new (e.async ? qt : Dt)({
                    start: s(e),
                    end: f(e),
                    argnames: n,
                    rest: t
                });
                var i = l(e.body);
                if (i instanceof bn) {
                    r.body = a(i.body);
                    r.value = null;
                } else {
                    r.body = [];
                    r.value = i;
                }
                return r;
            },
            FunctionDeclaration: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Pt : Ft;
                } else {
                    n = e.generator ? Nt : jt;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? $t : Ot;
                } else {
                    n = e.generator ? Ct : zt;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            ClassDeclaration: function(e) {
                return new Ht({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            ClassExpression: function(e) {
                return new Yt({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            MethodDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                var r = Vt, i = l(e.value);
                switch (e.kind) {
                  case "get":
                    r = Lt;
                    i = new xt(i);
                    break;

                  case "set":
                    r = Ut;
                    i = new xt(i);
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: i
                });
            },
            PropertyDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                return new Bt({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: l(e.value)
                });
            },
            StaticBlock: function(e) {
                var n = s(e);
                var t = f(e);
                return new Wt({
                    start: n,
                    end: t,
                    value: new wt({
                        start: n,
                        end: t,
                        body: a(e.body.map(l))
                    })
                });
            },
            ForOfStatement: function(e) {
                return new (e.await ? gt : xe)({
                    start: s(e),
                    end: f(e),
                    init: l(e.left),
                    object: l(e.right),
                    body: l(e.body)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new ir({
                    start: s(e),
                    end: f(e),
                    body: l(e.block).body,
                    bcatch: l(n[0]),
                    bfinally: e.finalizer ? new or(l(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.computed ? l(e.key) : o(e.key);
                var t = {
                    start: s(e),
                    end: f(e),
                    key: n,
                    value: l(e.value)
                };
                if (e.kind == "init") return new (e.method ? Sr : Er)(t);
                t.value = new xt(t.value);
                if (e.kind == "get") return new Ar(t);
                if (e.kind == "set") return new Tr(t);
            },
            ArrayExpression: function(e) {
                return new jn({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Jr() : l(e);
                    })
                });
            },
            ArrayPattern: function(e) {
                var n = [], t = null;
                e.elements.forEach(function(e) {
                    if (e === null) {
                        n.push(new Jr());
                    } else if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                return new yr({
                    start: s(e),
                    end: f(e),
                    elements: n,
                    rest: t
                });
            },
            ObjectPattern: function(e) {
                var n = [], t = null;
                e.properties.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(new wr(l(e)));
                    }
                });
                return new xr({
                    start: s(e),
                    end: f(e),
                    properties: n,
                    rest: t
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? On : qn)({
                    start: s(e),
                    end: f(e),
                    optional: e.optional,
                    expression: l(e.object),
                    property: e.computed ? l(e.property) : e.property.name
                });
            },
            MetaProperty: function(e) {
                var n = l(e.meta);
                var t = o(e.property);
                if (n.name == "new" && t == "target") return new Rr({
                    start: s(e),
                    end: f(e),
                    name: "new.target"
                });
                return new qn({
                    start: s(e),
                    end: f(e),
                    expression: n,
                    property: t
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? rr : tr)({
                    start: s(e),
                    end: f(e),
                    expression: l(e.test),
                    body: e.consequent.map(l)
                });
            },
            ExportAllDeclaration: function(e) {
                var n = s(e);
                var t = f(e);
                return new ke({
                    start: n,
                    end: t,
                    aliases: [ e.exported ? p(e.exported) : new Bn({
                        start: n,
                        value: "*",
                        end: t
                    }) ],
                    keys: [ new Bn({
                        start: n,
                        value: "*",
                        end: t
                    }) ],
                    path: l(e.source)
                });
            },
            ExportDefaultDeclaration: function(e) {
                var n = l(e.declaration);
                if (!n.name) switch (n.CTOR) {
                  case Ft:
                    n = new Ot(n);
                    break;

                  case Pt:
                    n = new $t(n);
                    break;

                  case Ht:
                    n = new Yt(n);
                    break;

                  case jt:
                    n = new zt(n);
                    break;

                  case Nt:
                    n = new Ct(n);
                    break;
                }
                return new pr({
                    start: s(e),
                    end: f(e),
                    body: n
                });
            },
            ExportNamedDeclaration: function(e) {
                if (e.declaration) return new lr({
                    start: s(e),
                    end: f(e),
                    body: l(e.declaration)
                });
                if (e.source) {
                    var n = [], t = [];
                    e.specifiers.forEach(function(e) {
                        n.push(p(e.exported));
                        t.push(p(e.local));
                    });
                    return new ke({
                        start: s(e),
                        end: f(e),
                        aliases: n,
                        keys: t,
                        path: l(e.source)
                    });
                }
                return new dr({
                    start: s(e),
                    end: f(e),
                    properties: e.specifiers.map(function(e) {
                        var n = new Nr(l(e.local));
                        n.alias = p(e.exported);
                        return n;
                    })
                });
            },
            ImportDeclaration: function(e) {
                var t = s(e);
                var r = f(e);
                var i = null, a = null, o = null;
                e.specifiers.forEach(function(e) {
                    var n = new $r(l(e.local));
                    switch (e.type) {
                      case "ImportDefaultSpecifier":
                        a = n;
                        a.key = new Bn({
                            start: t,
                            value: "",
                            end: r
                        });
                        break;

                      case "ImportNamespaceSpecifier":
                        i = n;
                        i.key = new Bn({
                            start: t,
                            value: "*",
                            end: r
                        });
                        break;

                      default:
                        n.key = p(e.imported);
                        if (!o) o = [];
                        o.push(n);
                        break;
                    }
                });
                return new hr({
                    start: t,
                    end: r,
                    all: i,
                    default: a,
                    properties: o,
                    path: l(e.source)
                });
            },
            ImportExpression: function(e) {
                var n = s(e);
                var t = l(e.source);
                return new Tn({
                    start: n,
                    end: f(e),
                    expression: new Yn({
                        start: n,
                        end: t.start,
                        name: "import"
                    }),
                    args: [ t ]
                });
            },
            VariableDeclaration: function(e) {
                return new ({
                    const: fr,
                    let: ur
                }[e.kind] || cr)({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(l)
                });
            },
            Literal: function(e) {
                var n = {
                    start: s(e),
                    end: f(e)
                };
                if (e.bigint) {
                    n.value = e.bigint.toLowerCase() + "n";
                    return new Lr(n);
                }
                var t = e.value;
                if (t === null) return new Vr(n);
                var r = e.regex;
                if (r && r.pattern) {
                    n.value = new RegExp(r.pattern, r.flags);
                    n.value.raw_source = r.pattern;
                    return new Ur(n);
                } else if (r) {
                    n.value = e.regex && e.raw ? e.raw : t;
                    return new Ur(n);
                }
                switch (typeof t) {
                  case "string":
                    n.value = t;
                    return new Bn(n);

                  case "number":
                    if (isNaN(t)) return new Wr(n);
                    var i, a;
                    if (isFinite(t)) {
                        i = 1 / t < 0;
                        n.value = i ? -t : t;
                        a = new Ln(n);
                    } else {
                        i = t < 0;
                        a = new Xr(n);
                    }
                    return i ? new Cn({
                        start: n.start,
                        end: n.end,
                        operator: "-",
                        expression: a
                    }) : a;

                  case "boolean":
                    return new (t ? Zr : Qr)(n);
                }
            },
            TemplateLiteral: function(e) {
                return new Br({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(l),
                    strings: e.quasis.map(function(e) {
                        return e.value.raw;
                    })
                });
            },
            TaggedTemplateExpression: function(e) {
                var n = l(e.quasi);
                n.start = s(e);
                n.end = f(e);
                n.tag = l(e.tag);
                return n;
            },
            Identifier: function(e) {
                var n, t = c.length - 1;
                do {
                    n = c[--t];
                } while (n.type == "ArrayPattern" || n.type == "AssignmentPattern" && n.left === c[t + 1] || n.type == "ObjectPattern" || n.type == "Property" && n.value === c[t + 1] || n.type == "VariableDeclarator" && n.id === c[t + 1]);
                var r = Yn;
                switch (n.type) {
                  case "ArrowFunctionExpression":
                    if (n.body !== c[t + 1]) r = Hn;
                    break;

                  case "BreakStatement":
                  case "ContinueStatement":
                    r = Te;
                    break;

                  case "CatchClause":
                    r = jr;
                    break;

                  case "ClassDeclaration":
                    if (n.id === c[t + 1]) r = Ee;
                    break;

                  case "ClassExpression":
                    if (n.id === c[t + 1]) r = Pr;
                    break;

                  case "FunctionDeclaration":
                    r = n.id === c[t + 1] ? Mr : Hn;
                    break;

                  case "FunctionExpression":
                    r = n.id === c[t + 1] ? Fr : Hn;
                    break;

                  case "LabeledStatement":
                    r = Se;
                    break;

                  case "VariableDeclaration":
                    r = {
                        const: Or,
                        let: zr
                    }[n.kind] || Cr;
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            Super: function(e) {
                return new Hr({
                    start: s(e),
                    end: f(e),
                    name: "super"
                });
            },
            ThisExpression: function(e) {
                return new Yr({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            },
            ParenthesizedExpression: function(e) {
                var n = l(e.expression);
                if (!n.start.parens) n.start.parens = [];
                n.start.parens.push(s(e));
                if (!n.end.parens) n.end.parens = [];
                n.end.parens.push(f(e));
                return n;
            },
            ChainExpression: function(e) {
                var n = l(e.expression);
                n.terminal = true;
                return n;
            }
        };
        r.UpdateExpression = r.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? Cn : _r)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: l(n.argument)
            });
        };
        u("EmptyStatement", _n);
        u("ExpressionStatement", gn, "expression>body");
        u("BlockStatement", bn, "body@body");
        u("IfStatement", kn, "test>condition, consequent>body, alternate>alternative");
        u("LabeledStatement", ct, "label>label, body>body");
        u("BreakStatement", Qt, "label>label");
        u("ContinueStatement", Zt, "label>label");
        u("WithStatement", bt, "object>expression, body>body");
        u("SwitchStatement", er, "discriminant>expression, cases@body");
        u("ReturnStatement", xn, "argument>value");
        u("ThrowStatement", Xt, "argument>value");
        u("WhileStatement", ht, "test>condition, body>body");
        u("DoWhileStatement", dt, "test>condition, body>body");
        u("ForStatement", vt, "init>init, test>condition, update>step, body>body");
        u("ForInStatement", _t, "left>init, right>object, body>body");
        u("DebuggerStatement", it);
        u("VariableDeclarator", En, "id>name, init>value");
        u("CatchClause", ar, "param>argname, body%body");
        u("BinaryExpression", Mn, "operator=operator, left>left, right>right");
        u("LogicalExpression", Mn, "operator=operator, left>left, right>right");
        u("AssignmentExpression", Pn, "operator=operator, left>left, right>right");
        u("AssignmentPattern", Sn, "left>name, right>value");
        u("ConditionalExpression", Fn, "test>condition, consequent>consequent, alternate>alternative");
        u("NewExpression", vr, "callee>expression, arguments@args, pure=pure");
        u("CallExpression", Tn, "callee>expression, arguments@args, optional=optional, pure=pure");
        u("SequenceExpression", An, "expressions@expressions");
        u("SpreadElement", $n, "argument>expression");
        u("ObjectExpression", In, "properties@properties");
        u("AwaitExpression", gr, "argument>expression");
        u("YieldExpression", br, "argument>expression, delegate=nested");
        h(yt, function e(n) {
            return g("Program", n);
        });
        h(Mt, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "FunctionDeclaration",
                id: v(n.name),
                async: St(n),
                generator: Tt(n),
                params: t,
                body: g("BlockStatement", n)
            };
        });
        h(wn, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            if (Et(n)) return {
                type: "ArrowFunctionExpression",
                async: St(n),
                params: t,
                body: n.value ? v(n.value) : g("BlockStatement", n)
            };
            return {
                type: "FunctionExpression",
                id: v(n.name),
                async: St(n),
                generator: Tt(n),
                params: t,
                body: g("BlockStatement", n)
            };
        });
        h(Ht, function e(n) {
            return {
                type: "ClassDeclaration",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        h(Yt, function e(n) {
            return {
                type: "ClassExpression",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        function e(r) {
            return function(e) {
                var n = e.key instanceof mn;
                var t = n ? v(e.key) : e.private ? {
                    type: "PrivateIdentifier",
                    name: e.key.slice(1)
                } : {
                    type: "Literal",
                    value: e.key
                };
                return {
                    type: "MethodDefinition",
                    kind: r,
                    computed: n,
                    key: t,
                    static: e.static,
                    value: v(e.value)
                };
            };
        }
        h(Lt, e("get"));
        h(Ut, e("set"));
        h(Vt, e("method"));
        h(Bt, function e(n) {
            var t = n.key instanceof mn;
            var r = t ? v(n.key) : n.private ? {
                type: "PrivateIdentifier",
                name: n.key.slice(1)
            } : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "PropertyDefinition",
                computed: t,
                key: r,
                static: n.static,
                value: v(n.value)
            };
        });
        h(Wt, function e(n) {
            return g("StaticBlock", n.value);
        });
        function n(n) {
            return function(e) {
                return {
                    type: "ForOfStatement",
                    await: n,
                    left: v(e.init),
                    right: v(e.object),
                    body: v(e.body)
                };
            };
        }
        h(gt, n(true));
        h(xe, n(false));
        h(at, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: d(n, {
                    type: "Literal",
                    value: n.value
                })
            };
        });
        h(nr, function e(n) {
            return {
                type: "SwitchCase",
                test: v(n.expression),
                consequent: n.body.map(v)
            };
        });
        h(ir, function e(n) {
            return {
                type: "TryStatement",
                block: _(n),
                handler: v(n.bcatch),
                guardedHandlers: [],
                finalizer: v(n.bfinally)
            };
        });
        h(ar, function e(n) {
            return {
                type: "CatchClause",
                param: v(n.argname),
                guard: null,
                body: _(n)
            };
        });
        h(lr, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                declaration: v(n.body)
            };
        });
        h(pr, function e(n) {
            return {
                type: "ExportDefaultDeclaration",
                declaration: v(n.body)
            };
        });
        h(ke, function e(n) {
            if (n.keys[0].value == "*") return {
                type: "ExportAllDeclaration",
                exported: n.aliases[0].value == "*" ? null : m(n.aliases[0]),
                source: v(n.path)
            };
            var t = [];
            for (var r = 0; r < n.aliases.length; r++) {
                t.push(d({
                    start: n.keys[r].start,
                    end: n.aliases[r].end
                }, {
                    type: "ExportSpecifier",
                    local: m(n.keys[r]),
                    exported: m(n.aliases[r])
                }));
            }
            return {
                type: "ExportNamedDeclaration",
                specifiers: t,
                source: v(n.path)
            };
        });
        h(dr, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                specifiers: n.properties.map(function(e) {
                    return d({
                        start: e.start,
                        end: e.alias.end
                    }, {
                        type: "ExportSpecifier",
                        local: v(e),
                        exported: m(e.alias)
                    });
                })
            };
        });
        h(hr, function e(n) {
            var t = n.properties ? n.properties.map(function(e) {
                return d({
                    start: e.key.start,
                    end: e.end
                }, {
                    type: "ImportSpecifier",
                    local: v(e),
                    imported: m(e.key)
                });
            }) : [];
            if (n.all) t.unshift(d(n.all, {
                type: "ImportNamespaceSpecifier",
                local: v(n.all)
            }));
            if (n.default) t.unshift(d(n.default, {
                type: "ImportDefaultSpecifier",
                local: v(n.default)
            }));
            return {
                type: "ImportDeclaration",
                specifiers: t,
                source: v(n.path)
            };
        });
        h(sr, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: n.TYPE.toLowerCase(),
                declarations: n.definitions.map(v)
            };
        });
        h(Dn, function e(n) {
            var t = n instanceof On;
            var r = {
                type: "MemberExpression",
                object: v(n.expression),
                computed: t,
                optional: n.optional,
                property: t ? v(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
            return n.terminal ? {
                type: "ChainExpression",
                expression: r
            } : r;
        });
        h(zn, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof Cn,
                argument: v(n.expression)
            };
        });
        h(Mn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: v(n.left),
                operator: n.operator,
                right: v(n.right)
            };
        });
        h(jn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(v)
            };
        });
        h(yr, function e(n) {
            var t = n.elements.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ArrayPattern",
                elements: t
            };
        });
        h(wr, function e(n) {
            var t = n.key instanceof mn;
            var r = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "Property",
                kind: "init",
                computed: t,
                key: r,
                value: v(n.value)
            };
        });
        h(xr, function e(n) {
            var t = n.properties.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ObjectPattern",
                properties: t
            };
        });
        h(kr, function e(n) {
            var t = n.key instanceof mn;
            var r = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof Er) {
                i = "init";
            } else if (n instanceof Ar) {
                i = "get";
            } else if (n instanceof Tr) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                computed: t,
                method: n instanceof Sr,
                key: r,
                value: v(n.value)
            };
        });
        h(Dr, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        h(Hr, function e() {
            return {
                type: "Super"
            };
        });
        h(Yr, function e() {
            return {
                type: "ThisExpression"
            };
        });
        h(Rr, function e() {
            return {
                type: "MetaProperty",
                meta: {
                    type: "Identifier",
                    name: "new"
                },
                property: {
                    type: "Identifier",
                    name: "target"
                }
            };
        });
        h(Ur, function e(n) {
            var t = n.value.toString().match(/\/([gimuy]*)$/)[1];
            var r = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: r,
                raw: r,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        h(Lr, function e(n) {
            var t = n.value;
            return {
                type: "Literal",
                bigint: t.slice(0, -1),
                raw: t
            };
        });
        function t(e) {
            var n = e.value;
            if (typeof n === "number" && (n < 0 || n === 0 && 1 / n < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -n,
                        raw: e.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: n,
                raw: e.start.raw
            };
        }
        h(Kr, t);
        h(Rn, t);
        h(Vr, t);
        h(y, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        h(Br, function e(n) {
            var t = n.strings.length - 1;
            var r = {
                type: "TemplateLiteral",
                expressions: n.expressions.map(v),
                quasis: n.strings.map(function(e, n) {
                    return {
                        type: "TemplateElement",
                        tail: n == t,
                        value: {
                            raw: e
                        }
                    };
                })
            };
            if (!n.tag) return r;
            return {
                type: "TaggedTemplateExpression",
                tag: v(n.tag),
                quasi: r
            };
        });
        ut.DEFMETHOD("to_mozilla_ast", bn.prototype.to_mozilla_ast);
        Jr.DEFMETHOD("to_mozilla_ast", Xn);
        mn.DEFMETHOD("to_mozilla_ast", function() {
            throw new Error("Cannot convert AST_" + this.TYPE);
        });
        function a(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof gn)) break;
                var r = t.body;
                if (!(r instanceof Bn)) break;
                if (t.start.pos !== r.start.pos) break;
                e[n] = new at(r);
            }
            return e;
        }
        function i(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var r = e.range;
            return new te({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[0] : e.start,
                raw: i(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var r = e.range;
            return new te({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[1] : e.end,
                raw: i(e)
            });
        }
        function o(e) {
            return "" + e[e.type == "Identifier" ? "name" : "value"];
        }
        function u(e, n, t) {
            var a = [ "start: my_start_token(M)", "end: my_end_token(M)" ];
            var o = [ "type: " + JSON.stringify(e) ];
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], r = n[2], i = n[3];
                switch (r) {
                  case "@":
                    a.push(i + ": M." + t + ".map(from_moz)");
                    o.push(t + ": M." + i + ".map(to_moz)");
                    break;

                  case ">":
                    a.push(i + ": from_moz(M." + t + ")");
                    o.push(t + ": to_moz(M." + i + ")");
                    break;

                  case "=":
                    a.push(i + ": M." + t);
                    o.push(t + ": M." + i);
                    break;

                  case "%":
                    a.push(i + ": from_moz(M." + t + ").body");
                    o.push(t + ": to_moz_block(M)");
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            r[e] = new Function("U2", "my_start_token", "my_end_token", "from_moz", [ "return function From_Moz_" + e + "(M) {", "    return new U2.AST_" + n.TYPE + "({", a.join(",\n"), "    });", "};" ].join("\n"))(b, s, f, l);
            h(n, new Function("to_moz", "to_moz_block", "to_moz_scope", [ "return function To_Moz_" + e + "(M) {", "    return {", o.join(",\n"), "    };", "};" ].join("\n"))(v, _, g));
        }
        var c = null;
        function l(e) {
            c.push(e);
            var n = null;
            if (e) {
                if (!nt(r, e.type)) throw new Error("Unsupported type: " + e.type);
                n = r[e.type](e);
            }
            c.pop();
            return n;
        }
        function p(e) {
            return new Bn({
                start: s(e),
                value: o(e),
                end: f(e)
            });
        }
        mn.from_mozilla_ast = function(e) {
            var n = c;
            c = [];
            var t = l(e);
            c = n;
            t.walk(new Un(function(e) {
                if (e instanceof Te) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof yn) break;
                        if (t instanceof ct && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var r = e.start;
                        qe("Undefined label " + e.name, r.file, r.line, r.col, r.pos);
                    }
                }
            }));
            return t;
        };
        function d(e, n) {
            var t = e.start;
            var r = e.end;
            if (t.pos != null && r.endpos != null) {
                n.range = [ t.pos, r.endpos ];
            }
            if (t.line) {
                n.loc = {
                    start: {
                        line: t.line,
                        column: t.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (t.file) {
                    n.loc.source = t.file;
                }
            }
            return n;
        }
        function h(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return d(this, n(this));
            });
        }
        function v(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function m(e) {
            return ni(e.value) ? d(e, {
                type: "Identifier",
                name: e.value
            }) : v(e);
        }
        function _(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(v)
            };
        }
        function g(e, n) {
            var t = n.body.map(v);
            if (n.body[0] instanceof gn && n.body[0].body instanceof Bn) {
                t.unshift(v(new _n(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function G() {
        var n = new vn();
        [ "NaN", "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(r);
        [ "encodeURI", "encodeURIComponent", "escape", "eval", "decodeURI", "decodeURIComponent", "isFinite", "isNaN", "parseFloat", "parseInt", "unescape" ].forEach(r);
        var t = Function("return this")();
        [ "Array", "ArrayBuffer", "Atomics", "BigInt", "Boolean", "console", "DataView", "Date", "Error", "Function", "Int8Array", "Intl", "JSON", "Map", "Math", "Number", "Object", "Promise", "Proxy", "Reflect", "RegExp", "Set", "String", "Symbol", "WebAssembly" ].forEach(function(e) {
            r(e);
            var n = t[e];
            if (!n) return;
            Object.getOwnPropertyNames(n).map(r);
            if (typeof n != "function") return;
            if (n.__proto__) Object.getOwnPropertyNames(n.__proto__).map(r);
            if (n.prototype) Object.getOwnPropertyNames(n.prototype).map(r);
            try {
                Object.getOwnPropertyNames(new n()).map(r);
            } catch (e) {
                try {
                    Object.getOwnPropertyNames(n()).map(r);
                } catch (e) {}
            }
        });
        return (G = function() {
            return n.clone();
        })();
        function r(e) {
            n.set(e, true);
        }
    }
    function J(e, n) {
        e.walk(new Un(function(e) {
            if (e instanceof Rt) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof qn) {
                if (e.quoted) t(e.property);
            } else if (e instanceof kr) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof On) {
                X(e.property, t);
            }
        }));
        function t(e) {
            Qn(n, e);
        }
    }
    function X(e, n) {
        if (e instanceof Fn) {
            X(e.consequent, n);
            X(e.alternative, n);
        } else if (e instanceof An) {
            X(e.tail_node(), n);
        } else if (e instanceof Bn) {
            n(e.value);
        }
    }
    function K(e, t) {
        t = we(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = t.builtins ? new vn() : G();
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n.set(e, true);
        });
        var r = -1;
        var i;
        if (t.cache) {
            i = t.cache.props;
            i.each(function(e) {
                n.set(e, true);
            });
        } else {
            i = new vn();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = new vn();
        var u = n.clone();
        e.walk(new Un(function(e) {
            if (e instanceof Mn) {
                if (e.operator == "in") X(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof qn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Yn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    X(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    X(e.args[0], p);
                    break;
                }
            } else if (e instanceof Rt) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof qn) {
                p(e.property);
            } else if (e instanceof kr) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof On) {
                X(e.property, p);
            }
        }));
        e.walk(new Un(function(e) {
            if (e instanceof Mn) {
                if (e.operator == "in") h(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof qn) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Yn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    h(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    h(e.args[0]);
                    break;
                }
            } else if (e instanceof Rt) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof qn) {
                e.property = d(e.property);
            } else if (e instanceof kr) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof On) {
                if (!t.keep_quoted) h(e.property);
            }
        }));
        function c(e) {
            if (u.has(e)) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n.has(e)) {
                mn.info("Preserving reserved property {this}", e);
                return false;
            }
            if (a && !a.test(e)) {
                mn.info("Preserving excluded property {this}", e);
                return false;
            }
            return i.has(e) || f.has(e);
        }
        function p(e) {
            if (c(e)) f.set(e, true);
            if (!l(e)) u.set(e, true);
        }
        function d(e) {
            if (!l(e)) return e;
            var n = i.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = A(++r);
                } while (!c(n));
                if (/^#/.test(e)) n = "#" + n;
                i.set(e, n);
            }
            mn.info("Mapping property {name} to {mangled}", {
                mangled: n,
                name: e
            });
            return n;
        }
        function h(e) {
            if (e instanceof An) {
                h(e.expressions.tail_node());
            } else if (e instanceof Bn) {
                e.value = d(e.value);
            } else if (e instanceof Fn) {
                h(e.consequent);
                h(e.alternative);
            }
        }
    }
    "use strict";
    var Q, Z;
    if (typeof Buffer == "undefined") {
        Q = atob;
        Z = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        Q = function(e) {
            return new Buffer(e, "base64").toString();
        };
        Z = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        Q = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        Z = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function ee(e, n) {
        var t = n.end.comments_after;
        for (var r = t.length; --r >= 0; ) {
            var i = t[r];
            if (i.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(i.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,([^,]+)$/.exec(a[2]);
                if (!a) break;
                return Q(a[2]);
            }
        }
        mn.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function ne(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function se(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function fe(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new vn();
        } else if (!(e.props instanceof vn)) {
            e.props = vn.fromObject(e.props);
        }
    }
    function ue(e) {
        return {
            props: e.props.toObject()
        };
    }
    function ce(r, i) {
        try {
            i = we(i, {
                annotations: undefined,
                compress: {},
                enclose: false,
                expression: false,
                ie: false,
                ie8: false,
                keep_fargs: false,
                keep_fnames: false,
                mangle: {},
                module: false,
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: !!(i && i["module"]),
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (i.validate) mn.enable_validation();
            var e = i.timings && {
                start: Date.now()
            };
            if (i.annotations !== undefined) se("annotations", i, [ "compress", "output" ]);
            if (i.expression) se("expression", i, [ "compress", "parse" ]);
            if (i.ie8) i.ie = i.ie || i.ie8;
            if (i.ie) se("ie", i, [ "compress", "mangle", "output", "rename" ]);
            if (i.keep_fargs) se("keep_fargs", i, [ "compress", "mangle", "rename" ]);
            if (i.keep_fnames) se("keep_fnames", i, [ "compress", "mangle", "rename" ]);
            if (i.module) se("module", i, [ "compress", "parse" ]);
            if (i.toplevel) se("toplevel", i, [ "compress", "mangle", "rename" ]);
            if (i.v8) se("v8", i, [ "mangle", "output", "rename" ]);
            if (i.webkit) se("webkit", i, [ "compress", "mangle", "output", "rename" ]);
            var n;
            if (i.mangle) {
                i.mangle = we(i.mangle, {
                    cache: i.nameCache && (i.nameCache.vars || {}),
                    eval: false,
                    ie: false,
                    keep_fargs: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (i.mangle.properties) {
                    if (typeof i.mangle.properties != "object") {
                        i.mangle.properties = {};
                    }
                    if (i.mangle.properties.keep_quoted) {
                        n = i.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        i.mangle.properties.reserved = n;
                    }
                    if (i.nameCache && !("cache" in i.mangle.properties)) {
                        i.mangle.properties.cache = i.nameCache.props || {};
                    }
                }
                fe(i.mangle.cache);
                fe(i.mangle.properties.cache);
            }
            if (i.rename === undefined) i.rename = i.compress && i.mangle;
            if (i.sourceMap) {
                i.sourceMap = we(i.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (i.warnings) mn.log_function(function(e) {
                t.push(e);
            }, i.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            i.parse = i.parse || {};
            if (r instanceof mn) {
                a = r;
            } else {
                if (typeof r == "string") r = [ r ];
                i.parse.toplevel = null;
                var o = i.sourceMap && i.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = ne(o);
                }
                if (o) i.sourceMap.orig = Object.create(null);
                for (var s in r) if (nt(r, s)) {
                    i.parse.filename = s;
                    i.parse.toplevel = a = oi(r[s], i.parse);
                    if (o == "inline") {
                        var f = ee(s, a);
                        if (f) i.sourceMap.orig[s] = ne(f);
                    } else if (o) {
                        i.sourceMap.orig[s] = o;
                    }
                }
            }
            if (i.parse.expression) a = a.wrap_expression();
            if (n) J(a, n);
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = i[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                r[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (i.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (i.rename) {
                a.figure_out_scope(i.rename);
                a.expand_names(i.rename);
            }
            if (e) e.compress = Date.now();
            if (i.compress) {
                a = new ci(i.compress).compress(a);
                if (i.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (i.mangle) a.figure_out_scope(i.mangle);
            if (e) e.mangle = Date.now();
            if (i.mangle) {
                a.compute_char_frequency(i.mangle);
                a.mangle_names(i.mangle);
            }
            if (e) e.properties = Date.now();
            if (n) J(a, n);
            if (i.mangle && i.mangle.properties) K(a, i.mangle.properties);
            if (i.parse.expression) a = a.unwrap_expression();
            if (e) e.output = Date.now();
            var u = {};
            var c = we(i.output, {
                ast: false,
                code: true
            });
            if (c.ast) u.ast = a;
            if (c.code) {
                if (i.sourceMap) {
                    c.source_map = W(i.sourceMap);
                    if (i.sourceMap.includeSources) {
                        if (r instanceof yt) {
                            throw new Error("original source content unavailable");
                        } else for (var s in r) if (nt(r, s)) {
                            c.source_map.setSourceContent(s, r[s]);
                        }
                    }
                }
                delete c.ast;
                delete c.code;
                var l = li(c);
                a.print(l);
                u.code = l.get();
                if (i.sourceMap) {
                    u.map = c.source_map.toString();
                    var p = i.sourceMap.url;
                    if (p) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + Z(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (i.nameCache && i.mangle) {
                if (i.mangle.cache) i.nameCache.vars = ue(i.mangle.cache);
                if (i.mangle.properties && i.mangle.properties.cache) {
                    i.nameCache.props = ue(i.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            mn.log_function();
            mn.disable_validation();
        }
    }
    b["Dictionary"] = vn;
    b["is_statement"] = ot;
    b["List"] = Kn;
    b["minify"] = ce;
    b["parse"] = oi;
    b["push_uniq"] = Qn;
    b["TreeTransformer"] = ei;
    b["TreeWalker"] = Un;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
